// -----------------------------------------------------------------------------
//  Copyright (c) 2001 Roar Kilaas
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// -----------------------------------------------------------------------------


#include <stdlib.h>
#include <string.h>

	int XTics = 0 , YTics = 0 ;
class PeakMotifDialog : public TDialog {
	public:
		PeakMotifDialog();
		void	DefineDialog() ;
		void	SetDialogData() ;
		void	GetDialogData() ;
		void	DoKeyDownInObject(TObject *) ;
		void	DoMouseDownInObject(TObject *,Point *) ;
		void	DoMouseUpInObject(TObject *,Point *) ;
		//virtual	void	DoCommand(TCommand command,Boolean *hasBeenHandled) ;

    private:
		TEditText	*mSaturationF;
		TEditText	*mOffTolF;
		TEditText	*mTooLowF;
		TEditText   *mPsizerF;
		TEditText   *mRadSizeF;
		TEditText   *mCensorF;
		TEditText	*mBiwtItersF;
		TEditText	*mRadTotF;
		TEditText   *mPixPurgeF;
	        TEditText   *mXTicsF, *mYTicsF ;
		TCheckBox   *mQuadLattice;
		TCheckBox	*mCubeLattice;
		TCheckBox   *mUseBiweight;
		TCheckBox	*mDiffDebug;
		TButton	*mExpertHelp;
		float		mSaturation ;
		float		mOffTol ;
		float		mTooLow ;
		float		mPsizer ;
		float		mRadSize ;
		float	      mCensor ;
		float		mBiwtIters ;
		float		mRadTot ;
	      float	      mPixPurge ;
		int	      mXTics, mYTics;
} ;
void	PeakMotifDialog::DefineDialog() {

	TGroupBox	*theBox ;
	//TStaticText	*theText ;
	short wbox = 18 ;
	short adder= 25 ;
	theBox = new TGroupBox(10,8,260,165+50+30+wbox+3*adder,"Adjustable Parameters"); // Was 50+30
	AddObject(theBox) ;

	mCancelButton = new TButton(102,175+42+wbox+3*adder,164,195+42+wbox+3*adder,"Cancel");
	AddObject(mCancelButton) ;
	mExpertHelp = new TButton(30,175+42+wbox+3*adder,92,195+42+wbox+3*adder,"Help");
	AddObject(mExpertHelp) ;
	mOKButton = new TButton(174,175+42+wbox+3*adder,236,195+42+wbox+3*adder,"Set");
	AddObject(mOKButton) ;

	Rect theRect ;
	theRect.right = 240 ;
	theRect.left = 140 ;
	theRect.top = 18 ;
	theRect.bottom = 38 ;
	short woffset = 25 ;
	SetRect(&theRect,theRect.left,theRect.top,theRect.right,theRect.bottom) ;

	mSaturationF = new TEditText(&theRect,"Saturation Value","255");		


	OffsetRect(&theRect,0,woffset) ;
	mOffTolF = new TEditText(&theRect,"Max Displacement (Pixels)","20");		

	OffsetRect(&theRect,0,woffset) ;
	mTooLowF = new TEditText(&theRect,"XCF Motif Base Level","4");
		
	OffsetRect(&theRect,0,woffset) ;
	mPsizerF = new TEditText(&theRect,"Fractional Motif Size","1");

	OffsetRect(&theRect,0,woffset) ;
	mRadSizeF = new TEditText(&theRect,"Fractional Mask Size","1");

	OffsetRect(&theRect,0,woffset) ;
	mCensorF = new TEditText(&theRect,"Biweight Censor Value","4.685");

	OffsetRect(&theRect,0,woffset) ;
	mBiwtItersF = new TEditText(&theRect,"Biweight Iterations","15");

	OffsetRect(&theRect,0,woffset) ;
	mRadTotF = new TEditText(&theRect,"Search Radius (Pixels)","10000");

	OffsetRect(&theRect,0,woffset) ;
	mPixPurgeF = new TEditText(&theRect,"Maximum Purge Fraction","0.80");

	OffsetRect(&theRect,0,woffset) ;
	theRect.right = 130 ; theRect.left = 110 ;
	mXTicsF = new TEditText(&theRect,"Label every X","3");

	theRect.right = 240 ; theRect.left=220 ;
	mYTicsF = new TEditText(&theRect,"Label every Y","3");

//	Add in reverse order so tabs work!
	AddTextEditObject(mYTicsF) ;
	AddTextEditObject(mXTicsF) ;
	AddTextEditObject(mPixPurgeF) ;
	AddTextEditObject(mRadTotF) ;
	AddTextEditObject(mBiwtItersF) ;
	AddTextEditObject(mCensorF) ;
	AddTextEditObject(mRadSizeF) ;
	AddTextEditObject(mPsizerF) ;
	AddTextEditObject(mTooLowF) ;
	AddTextEditObject(mOffTolF) ;
	AddTextEditObject(mSaturationF) ;	

	theRect.right = 130 ; theRect.left=30 ;
	woffset= 18 ;
	OffsetRect(&theRect,0,woffset+3) ;
	if(QuadraticFit) {
		mQuadLattice = new TCheckBox(&theRect,"Quadratic Lattice",true) ;
	}
	else {
		mQuadLattice = new TCheckBox(&theRect,"Quadratic Lattice",false) ;
	}
	AddObject(mQuadLattice) ;
	theRect.right = 240 ; theRect.left=140 ;
	if(CubicFit) {
		mCubeLattice = new TCheckBox(&theRect,"Cubic Lattice",true) ;
	}
	else {
		mCubeLattice = new TCheckBox(&theRect,"Cubic Lattice",false) ;
	}
	AddObject(mCubeLattice) ;

	theRect.right = 130 ; theRect.left=30 ;
	OffsetRect(&theRect,0,woffset) ;
	if(DiffDebug) {
		mDiffDebug = new TCheckBox(&theRect,"Debug",true) ;
	}
	else {
		mDiffDebug = new TCheckBox(&theRect,"Debug",false) ;
	}
	AddObject(mDiffDebug) ;
	theRect.right = 240 ; theRect.left=140 ;
	if(UseBiweight) {
		mUseBiweight = new TCheckBox(&theRect,"Biweights",true) ;
	}
	else {
		mUseBiweight = new TCheckBox(&theRect,"Biweights",false) ;
	}
	AddObject(mUseBiweight) ;

	mDefaultButton = mOKButton ;
}

PeakMotifDialog::PeakMotifDialog() 
	: TDialog(kDialogPosX,kDialogPosY,272,202+50+18+75,"Measurement Controls") {
	DefineDialog() ;
}

//void PeakMotifDialog::DoCommand(TCommand command,Boolean *hasBeenHandled) {
//	switch(command) {	
//		case kHelp:
//			OnCommandHelp() ;		
//			*hasBeenHandled = true ;
//			break ;
//		default:
//			break ;
//	}
//}
void	PeakMotifDialog::DoKeyDownInObject(TObject *obj) {
	char	text[256] ;
	if (obj == mSaturationF) {
		mSaturationF->GetEditText(text) ;
		mSaturation = atof(text) ;
		}
	else if (obj == mTooLowF) {
		mTooLowF->GetEditText(text) ;
		mTooLow = atof(text) ;
		}
	else if (obj == mOffTolF) {
		mOffTolF->GetEditText(text) ;
		mOffTol = atof(text) ;
		}
	else if (obj == mPsizerF) {
		mPsizerF->GetEditText(text) ;
		mPsizer = atof(text) ;
		}
	else if (obj == mRadSizeF) {
		mRadSizeF->GetEditText(text) ;
		mRadSize = atof(text) ;
	}
	else if (obj == mCensorF) {
		mCensorF->GetEditText(text) ;
		mCensor  = atof(text) ;
	}
	else if (obj == mBiwtItersF) {
		mBiwtItersF->GetEditText(text) ;
		mBiwtIters = atof(text) ;
	}
	else if (obj == mRadTotF) {
		mRadTotF->GetEditText(text) ;
		mRadTot = atof(text) ;
	}
	else if (obj == mPixPurgeF) {
		mPixPurgeF->GetEditText(text) ;
		mPixPurge = atof(text) ;
	}
	else if (obj == mXTicsF) {
		mXTicsF->GetEditText(text) ;
		mXTics = atoi(text) ;
	}
	else if (obj == mYTicsF) {
		mYTicsF->GetEditText(text) ;
		mYTics = atoi(text) ;
	}
}

void	PeakMotifDialog::DoMouseDownInObject(TObject *obj,Point *pt) {
	if (mQuadLattice->GetState()) {
		QuadraticFit = true ;
		CubicFit = false ;
	}
	else if(mCubeLattice->GetState()) {
		QuadraticFit = false ;
		CubicFit = true ;
	}
	else
	{
		QuadraticFit = false ;
		CubicFit = false ;
	}
	DiffDebug=mDiffDebug->GetState();
	UseBiweight=mUseBiweight->GetState();
	if (pt != nil)
		if (!obj->DoMouseDown(pt)) return ;
	//char	text[256] ;
	if (obj == mOKButton) {
		mDone = true ;
		mDialogReturnCode = kDialogOK ;
		}
	else if (obj == mQuadLattice) {
		if (mQuadLattice->GetState()) {
			QuadraticFit = true ;
			mCubeLattice->SetState(false) ;
			CubicFit = false ;
		}
		else {
			QuadraticFit = false ;
		}
	}
	else if (obj == mCubeLattice) {
		if (mCubeLattice->GetState()) {
			CubicFit = true ;
			mQuadLattice->SetState(false) ;
			QuadraticFit = false ;
		}
		else {
			CubicFit = false ;
		}
	}
	else if (obj == mCancelButton) {
		mDone = true ;
		mDialogReturnCode = kDialogCancel ;
		}
	else if (obj == mExpertHelp) {
		EDMHelp((char *)"ExpertMode") ;
	}
}

void PeakMotifDialog::GetDialogData() {
	// Get the data from the dialog
	char text[256] ;
		mSaturationF->GetEditText(text) ;		mSaturation = atof(text) ;
		mTooLowF->GetEditText(text) ;		    	mTooLow = atof(text) ;
		mOffTolF->GetEditText(text) ;			mOffTol = atof(text) ;
		mPsizerF->GetEditText(text) ;			mPsizer = atof(text) ;
		mRadSizeF->GetEditText(text) ;			mRadSize = atof(text) ;
	        mCensorF->GetEditText(text) ;			mCensor = atof(text) ;
		mBiwtItersF->GetEditText(text) ;		mBiwtIters = atof(text) ;
		mRadTotF->GetEditText(text) ;			mRadTot = atof(text) ;
		mPixPurgeF->GetEditText(text) ;			mPixPurge = atof(text) ;
	       mXTicsF->GetEditText(text)	;			mXTics = atoi(text) ;
		mYTicsF->GetEditText(text)	;			mYTics = atoi(text) ;

		PeakIsSaturated = mSaturation ;
		PeakTooLow = mTooLow ;
		PeakOffTol = mOffTol*mOffTol ;
		Psizer  = mPsizer ;
		RadSize = mRadSize ;
		Btune = mCensor ; Btune2 = 1./(Btune*Btune) ;
		NumbBiwt = near(mBiwtIters) ;
		PixPurge = 1.-mPixPurge ;
		XTics = mXTics ; YTics = mYTics ;

		//Do some traps
		if(PeakTooLow < 0.25 ) PeakTooLow = 0.25;
		if(NumbBiwt < 10 ) NumbBiwt = 10 ;
		if(NumbBiwt > 50 ) NumbBiwt = 50 ;
		if(PeakOffTol < 4 ) {
			PeakOffTol = 4;
			mOffTol = 2;
		}
		if(Psizer > 3.25 ) Psizer = 3.25 ;
		if(RadSize < 0.01 ) RadSize = 0.01 ;
		if(PeakMuchTooLow*5 > PeakTooLow) PeakMuchTooLow=PeakTooLow*0.2 ;
		if(mRadTot < 100) mRadTot = 100 ;
                mTooLow = PeakTooLow ;
                mRadSize = RadSize ;
                mPsizer = Psizer ;
                mOffTol = sqrt(PeakOffTol) ;
		DiffDebug=mDiffDebug->GetState();
		UseBiweight=mUseBiweight->GetState();
		mBiwtIters = NumbBiwt ;
		RadTot = mRadTot ;
	}

float ReturnOffTol() {
	return (float) sqrt(PeakOffTol) ;
}
void  SetOffTol(float Tol) {
		PeakOffTol = Tol*Tol ;
}
bool  ReturnQuadFit() {
	return QuadraticFit ;
}
bool  ReturnCubicFit() {
	return CubicFit ;
}
int  ReturnXTics() {
	return XTics ;
}
int  ReturnYTics() {
	return YTics ;
}
void PeakMotifDialog::SetDialogData() {
	char text[256] ;
	mSaturation = PeakIsSaturated ;
	mTooLow = PeakTooLow ;
	mOffTol = sqrt(PeakOffTol) ;
	mPsizer = Psizer ;
	mRadSize = RadSize ;
        mCensor = Btune ;
	mBiwtIters = NumbBiwt ;
	mRadTot = RadTot ;
	mPixPurge = 1.-PixPurge ;
	mXTics = XTics ; mYTics = YTics ;
	sprintf(text,"%.3f",mSaturation)	; mSaturationF->SetEditText(text);
	sprintf(text,"%.3f",mTooLow)		; mTooLowF->SetEditText(text);
	sprintf(text,"%.3f",mOffTol)		; mOffTolF->SetEditText(text);
	sprintf(text,"%.3f",mPsizer)		; mPsizerF->SetEditText(text);
	sprintf(text,"%.3f",mRadSize)		; mRadSizeF->SetEditText(text);
	sprintf(text,"%.3f",mCensor)		; mCensorF->SetEditText(text);
	sprintf(text,"%.3f",mBiwtIters)		; mBiwtItersF->SetEditText(text);
	sprintf(text,"%.2f",mRadTot)		; mRadTotF->SetEditText(text);
	sprintf(text,"%.2f",mPixPurge)		; mPixPurgeF->SetEditText(text);
	sprintf(text,"%d",mXTics)           ; mXTicsF->SetEditText(text);
	sprintf(text,"%d",mYTics)           ; mYTicsF->SetEditText(text);
}


