#ifndef Plateau_h
#define Plateau_h
#include "types.h"

typedef struct Pixel {
	short h ;
	short v ;
} Pixel ;

typedef struct PixelLink {
	Pixel pixel ;
	struct PixelLink *nextLink ;
} PixelLink ;

typedef struct 	PixelList {
	short numPixels ;
	PixelLink	*pixLink ;
} PixelList ;

typedef struct Plateau {
	short plateauNumber ;
	short cmx ;
	short cmy ;
	struct PixelList *pixelList ;
} Plateau ;

typedef struct PlateauLink {
	Plateau	*plateau ;
	struct PlateauLink *nextLink ;
} PlateauLink ;

typedef struct PlateauList {
	short	numPlateaus ;
	PlateauLink *plateauLink ;
} PlateauList ;

PlateauList 	*NewPlateauList() ;
Boolean		AddPlateau(PlateauList *plateaulist,Plateau *plateau) ;
void		RemovePlateau(PlateauList *plateaulist,Plateau *plateau) ;
Boolean		AssignPixelToPlateau(PlateauList *plateaulist,Pixel *pixel,
				float *pixaddress,short width) ;
Plateau		*FindPlateau(PlateauList *list,Pixel *pixel) ;
Plateau		*NewPlateau(Pixel *pixel,short number) ;
Boolean		AddPixelToPlateau(Plateau *plateau,Pixel *pixel) ;
void		AddPlateauToPlateau(Plateau *,Plateau *) ;
void 		ReducePlateaus(PlateauList *list,float *imagedata,short Width) ;
Plateau		*FindPlateauFromNumber(PlateauList *plateaulist,short number) ;
Boolean		IsPlateau(Pixel *pixel,float *pixaddress,long Width,long Height) ;
void		DeletePlateauList(PlateauList *list) ;
void		DeletePlateau(Plateau *plateau) ;
void 		FreePlateau(Plateau *plateau) ;

#endif // Plateau_h
