#ifndef __TApplication
#define __TApplication

#include <forms.h>
#include "TWindowList.h"
#include "TWindow.h"
class	TApplicationWindow ;
class TApplication {

	public:
		TApplication(int argc,char *argv[]) ;
		~TApplication() ;
		
		virtual void	Initialize() ;
		virtual void	MainLoop() ;
		void			Terminate() { mDone = true ; } ;
		void			ProcessModalEvent(XEvent *event) ;
		virtual void	AddWindow(TWindow *theWindow) ;
		virtual void	RemoveWindow(TWindow *theWindow) ;
		TWindow 		*FindWindow(Window window)  { return mWindowList->GetWindow(window) ; } ;
		TWindow 		*GetTargetWindow() { return mCurrentTargetWindow ; } ;
		void 			SetTargetWindow(TWindow *win) ;
		TWindowList		*GetWindowList() { return mWindowList ; } ;
		
	protected:
	
		virtual void	ProcessEvents() ;

		Boolean		mDone ;
		Point		mMouseLoc ;
    	
		// List of Open windows
		TWindowList	*mWindowList ;
		TWindow		*mCurrentTargetWindow ;
		TWindow		*mLastTargetWindow ;
		
		TApplicationWindow	*mApplicationWindow ;

		virtual	void DoIdle() ;
		virtual	void CleanUp() ;
		virtual	void SetupColors() ;
		virtual	void DefineColors(XColor *color,unsigned long *pixel,unsigned long numColors) ;
				
		virtual		void SelectCursor() ;	
		virtual		long GetToolIndex() { return -1 ; } ;
		void		GetVisual(Boolean forcePseudoColor,XVisualInfo *vinfo) ;
		
		
	    /* Run */
		virtual	void 	DoKeyDown(XEvent *event)  ;
		virtual	void 	DoKeyUp(XEvent *event)  ;
		virtual	void 	DoMouseDown(XEvent *event) ;
		virtual	void 	DoUpdate(XEvent *event)  ;
		virtual	void 	DoConfigureNotify(XEvent *event) ;
		virtual void	DoClientMessage(XEvent *event) ;

		void			DoEnterNotify(XEvent *event) ;
		void			DoLeaveNotify(XEvent *event) ;
		void			DoFocusIn(XEvent *event) ;
		void			DoFocusOut(XEvent *event) ;
		
		void			DoMapNotify(XEvent *event) ;
		void			DoUnmapNotify(XEvent *event) ;
		
		virtual	void	DefineXForms() {} ;
		virtual	void	DefineWindows() {} ;
		virtual	void	ShowXForms() {} ;
	    		
} ;


#endif
