#ifndef __TCrystalDiffractionDataTable_h__
#define __TCrystalDiffractionDataTable_h__
#include "TImageWindow.h"
#include "TTable.h"
#include "TRefinementSet.h"
#ifndef __SortKey
#define __SortKey
typedef enum {kSortOnG,kSortOnAmplitude} SortKey ;
#endif

class TCrystalDiffractionDataTable : public TTable {
	public:
		TCrystalDiffractionDataTable(char *title,TDiffractionPeaks *diffractionPeaks,short planeGroup) ;
		~TCrystalDiffractionDataTable() ;
		
		void	DoCommand(TCommand command,Boolean *hasBeenHandled) ;
		void	GetCommandStatus(TCommand,Boolean *isEnabled,Boolean *isChecked) ;
		void 	DrawCellValue(TableCellT &inCell,Rect &cellFrame) ;
		void 	DrawColLabel(Int16 colNumber) ;
		void	DrawRowLabelText(Int16 rowNumber) ;
		void	DrawColLabelText(Int16 colNumber) ;
		void	Save() ;
		void 	EditCell(TableCellT &inCell) ;
		void	SortOnAmpitude() ;
		void	SortOnG() ;
		void	GroupSymmetryRelatedReflections() ;
		void 	ClickCell(TableCellT &inCell) ;
		void	ClickColLabel(Int16 inCol) ;
		
		void	OnCommandHelp() { EDMHelp("TCrystalDiffractionData") ; } ;
		void	RemoveRefinementSet()  { mRefinementSet = nil ; } ;
		
	private:
		friend	class	TRefinementSet ;
		TRefinementSet	*mRefinementSet ;
		
		void	DoPaste() ;
		void	DoCopy() ;

		void	CreateImageFromDiffractionData() ;
		
		long	mNumReflections ;
		float	*mGVector ;
		float	*mAmplitude ;
		float	*mPhase ;
		short	*mH ;
		short	*mK ;
		short	*mIndex ;
		float	mA ;
		float	mB ;
		float	mGamma ;
		CalibrationUnit	mCalibrationUnit ;
		short	mPlaneGroup ;
		SortKey	mSortKey ;

} ;

#endif
