#ifndef __TDMApplicationWindow__
#define __TDMApplicationWindow__
#include "TApplicationWindow.h"

#include "TBrightnessControl.h"
#include "TContrastControl.h"

class TDMApplicationWindow : public TApplicationWindow {
	public:
		TDMApplicationWindow(short xloc,short yloc,short width,short height,
			short depth,char *title) ;
		~TDMApplicationWindow() ;

		void	ActivateListener(TWindow *win) ;
		void	SetupMenuBar() ;
		void	DoCommand(TCommand,Boolean *) ;
		void	GetCommandStatus(TCommand num,Boolean *isEnabled,Boolean *isChecked) ;

		void	OnCommandHelp() { EDMHelp((char *)"TDMApplicationWindow") ; } ;
} ;



class	TMainPane : public TPane {
	public:
		TMainPane(TPane *parent,short xloc,short yloc,short width,short height);
		TMainPane(TPane *parent,Rect *rect) ;	
		virtual	void	Draw()  ;

		TPushButton	*mPointerTool ;
		TPushButton	*mSelectionTool ;
		TPushButton	*mRulerTool ;
		TPushButton	*mZoomTool ;
		TPushButton	*mHandTool ;
		TPushButton	*mSpotMaskTool ;
		TPushButton	*mCircleMaskTool ;
		TPushButton	*mLatticeMaskTool ;
		TPushButton	*mWedgeMaskTool ;
		TPushButton	*mLineMaskTool ;
		TPushButton	*mAddSpot ;
		TCheckBox   *mUseZero ;
		TPushButton	*mRemoveSpot ;
        TPushButton *mTestSpot ;
		TButton     *mMotifPars ;

		TPushButton	*mTEMSetUTool ;
		TPushButton	*mTEMSetVTool ;
		TButton		*mTEMCalculateFFT ;
		TPushButton	*mTEMSetApertureTool ;
		TButton		*mTEMRefineLattice ;
		TButton		*mTEMFindMotif ;
		TButton		*mTEMDeleteLattice ;
		TCheckBox	*mTEMShowHideLattice ;

		TEditText	*mTEMUh ;
		TEditText	*mTEMUk ;
		TEditText	*mTEMVh ;
		TEditText	*mTEMVk ;

		TStaticText	*mU ;

		TPushButton	*mEDDSetG1Tool ;
		TPushButton	*mEDDSetG2Tool ;
		TPushButton	*mEDDSetG3Tool ;
		TButton		*mEDDFindLattice ;
		TButton		*mEDDDeleteLattice ;
		TCheckBox	*mEDDShowHideLattice ;
		TCheckBox	*mEDDUseFriedel ;
		TCheckBox	*mEDDShowSymmetrizedPattern ;
		TButton		*mEDMTestSymmetry ;
		TButton		*mEDDFindPeaks ;
		TButton		*mEDDDeletePeaks ;
		TCheckBox	*mShowHidePeaks ;
		TCheckBox	*mShowPeakMotif ;
		TButton		*mEDDSymmetrizeReflections ;
		TEditText	*mThresholdPeaks ;
		TIconButton	*mEDDFindMotif ;
		TStaticText	*mEDDU ;

		TEditText	*mEDDG1h ;
		TEditText	*mEDDG1k ;
		TEditText	*mEDDG2h ;
		TEditText	*mEDDG2k ;
		TEditText	*mEDDG3h ;
		TEditText	*mEDDG3k ;
		
		Rect		mObjectInfoRect ;
		char		mObjectInfoString[256] ;
		void		WriteObjectInfo(char *text) ;
		void		WriteObjectInfoString() ;
		TContrastControl *mContrastBar ;
		TBrightnessControl *mBrightnessBar ;
		TCheckBox	*mDisplayOnLogScale ;
		
		TCenteredPopupMenu	*mSpacegroupMenuButton ;
		TPopupMenu	*mPeakCriteriaMenuButton ;
		TPopupMenu	*mPeakIntensityMethodMenuButton ;

		
} ;

extern	TMainPane	*gTheMainPane ;

#endif
