#ifndef __TRunMEMDialog_h
#define	__TRunMEMDialog_h
#include "TDialog.h"
#include "TImageWindow.h"
#include "TMenu.h"

typedef enum {kUseNoiseFromWienerFilter,kUsePercentageNoise,kUseNoiseImage }
	MEMNoiseType ;

typedef struct {
	TImageWindow	*window ; 
	float	voltage ;
	float	cs ;
	float	defocus ;
	float	delta ;
	float 	divergence ;
	float	percentage ;
	float	lagrangeMultiplier ;
	float	totalFlux ;
	float	errorAllowance ;
	float	targetChiSQ ;
	short	numIterations ;
	short	numConjugateSteps ;
	MEMNoiseType	noiseType ;
	char	noiseImageName[256] ;
	short	noiseImageWindowListIndex ;
	bool	showCTFImage ;
	bool	showNoiseImage ;
} MEMRecord ;

class TRunMEMDialog : public TDialog {
	public:
		TRunMEMDialog(MEMRecord &memRecord,TWindowList *windowList) ;
		~TRunMEMDialog() ;
		
		void		GetDialogData(void *data) ;
		void		DoKeyDownInObject(TObject *) ;
		void		DoMouseDownInObject(TObject *,Point *) ;
		
		void	OnCommandHelp() { EDMHelp("TRunMEMDialog") ; } ;
	protected:
		
		TEditText		*mVoltageText ;
		TEditText		*mCsText ;		
		TEditText		*mDefocusText ;		
		TEditText		*mDeltaText;		
		TEditText		*mDivergenceText;		
		TEditText		*mPercentageText;		
		TEditText		*mLagrangeMultiplierText ;	
		TEditText		*mNumIterationsText;		
		TEditText		*mNumConjugateStepsText;		
		
		TRadioButton	*mNoiseWienerFilter ;
		TRadioButton	*mNoisePercentage ;
		TRadioButton	*mNoiseImage ;
		
		TPopupMenu		*mNoiseImageMenu ;	
		
		TCheckBox		*mShowCTFImage ;	
		TCheckBox		*mShowNoiseImage ;	
		
		short			mNoiseImageMenuChoice ;	
		short			*mWindowListIndex ;

} ;


#endif
