        subroutine bulk_adj(symm)
C       Return the natom non-equivalent sites, taking into
C       account translations
        dimension i(100),ib(800),xa(100),ya(100),za(100)
        dimension xbt(800),ybt(800),zbt(800),xe(20),ye(20)
        dimension iok(800)
        logical dist2D
        character*4 symm
        character*80 line
      integer ncont(20)
      dimension cell(6),tempf(20)
C      common /sfcom1/tempf,ncont,natomq,cell
        real*8 ddx,ddy
        INCLUDE 'base_atoms.h'
C       Get the displacements from rods.hkl
        open(unit=17,file='rods.hkl')
        read(17,*)zsub,ddx,ddy
        close(unit=17)
C       Get atomic positions from bulk.at
        open(unit=18,file='bulk.at')
C       Cell
        read(18,*,err=999,end=999)cell
C       Number of atoms
        read(18,*,err=999,end=999)natm
C       Read atoms, type then x,y,z 
        zmax=0
        do j=1,natm
                read(18,1,err=999,end=999)line
1               format(a)
                read(line(5:80),*)iq,xa(j),ya(j),za(j)
                call cleaner(xa,ya,symm,0.5)
                if(za(j).gt.zmax)zmax=za(j)
                i(j)=iq
        enddo
        close(unit=18)
C       Create large set, including displacements, if < 1.5 Angstroms from top
11      m=0
        do j=1,natm
                dz=abs(zmax-za(j))*cell(3)
                if(dz.le.1.5)then
                        call asymm(xa(j),ya(j),ne,xe,ye,symm)
                        do k=1,ne
                                m=m+1
                                xbt(m)=xe(k)+ddx
                                ybt(m)=ye(k)+ddy
                                zbt(m)=za(j)
                                ib(m)=i(j)
                                iok(m)=1
                                if(xbt(j).gt.1)xbt(j)=xbt(j)-1
                                if(xbt(j).lt.0)xbt(j)=xbt(j)+1
                                if(ybt(j).gt.1)ybt(j)=ybt(j)-1
                                if(ybt(j).lt.0)ybt(j)=ybt(j)+1
                                if(zbt(j).gt.1)zbt(j)=zbt(j)-1
                                if(zbt(j).lt.0)zbt(j)=zbt(j)+1
                        enddo
                endif
        enddo
C       Purge the list of duplicates
        do j=1,m-1
                if(iok(j).lt.0)goto 20
                call asymm(xbt(j),ybt(j),ne,xe,ye,symm)
                do k=j+1,m
                        if(iok(k).lt.0)goto 10
                        dz=(zbt(j)-zbt(k))*cell(3)
                        if(abs(dz).gt.1e-1)goto 10
                        do je=1,ne
                        dx=xbt(k)-xe(je)
                        dy=ybt(k)-ye(je)
                        dx=dx-nint(dx)
                        dy=dy-nint(dy)
                        if (dist2D(dx,dy,0.5))iok(k)=-1
                enddo
10              continue
                enddo
20      continue
        enddo
C       Copy then
        nbase=0
        write(10,*)'Generated base atoms'
        do j=1,m
                if(iok(j).gt.0)then
                        nbase=nbase+1
                        xb(nbase)=xbt(j)
                        yb(nbase)=ybt(j)
                        zb(nbase)=zbt(j)
                        itypeb(nbase)=ib(j)
                        write(10,100)nbase,ib(j),xbt(j),ybt(j),zbt(j)
                endif
        enddo
100     format(2i4,3f10.5)
C       Force base_atom to be true
        base_atom=.true.
C       Trap
        if(nbase.eq.0)then
                write(10,*)'Bug - no base atoms!'
                write(6,*)'Bug - no base atoms!'
                base_atom=.false.
        endif
        return
999     base_atom=.false.
        write(10,*)'ERROR, error reading rods atoms'
        write(6,*)'ERROR, error reading rods atoms'
        return
        end

                
