        subroutine dcoord(natom,itype,bcord)
        include 'newbonds.h'
C       Generate the co-ordination constraint
        dimension itype(*)
        real*8 bcord,sc,tover(20)
        bcord=0
        if(.not.coord)return
        call dcorder(natom,itype)
        do j1=1,natom
                k1=itype(j1)
                if(numcord(k1).le.1.)goto 10
C       How many are co-ordinated to this atom ?
                numc=0
                do j=1,nei(j1)
                        if(dcordx(j,j1).lt.1e-4)then
                                numc=numc+1
                                tover(numc)=doverx(j,j1)
                                dcordx(j,j1)=999
                        endif
                enddo
                if(numc.gt.numbond(k1).and.overbond)then
C               Remove the closest (largest) ones
                        do j=1,numbond(k1)
                                sc=-1
                                ij=1
                                do jj=1,numc
                                        if(tover(jj).gt.sc)then
                                                sc=tover(jj)
                                                ij=jj
                                        endif
                                enddo
                                tover(ij)=-2
                        enddo
                        do jj=1,numc
                          if(tover(jj).gt.1e-3)bcord=bcord+tover(jj)
                        enddo
                endif
                if(numc.ge.numcord(k1))goto 10
                do j2=numc+1,numcord(k1)
C       Crummy search
                sc=25
                ij=1
                if(nei(j1).gt.0)then
                        do j=1,nei(j1)
                                if(dcordx(j,j1).lt.sc)then
                                        sc=dcordx(j,j1)
                                        ij=j
                                endif
                        enddo
                        dcordx(ij,j1)=999
                endif
                bcord=bcord+sc
                enddo
10              continue
        enddo
        return
        end
        subroutine scoord(natom,itype,bcord)
        include 'newbonds.h'
C       Generate the co-ordination constraint
        dimension itype(*)
        real bcord,sc,tover(20)
        bcord=0
        if(.not.coord)return
        call scorder(natom,itype)
        do j1=1,natom
                k1=itype(j1)
                if(numcord(k1).le.1.)goto 10
C       How many are co-ordinated to this atom ?
                numc=0
                do j=1,nei(j1)
                        if(scordx(j,j1).lt.1e-4)then
                                numc=numc+1
                                tover(numc)=soverx(j,j1)
                                scordx(j,j1)=999
                        endif
                enddo
                if(numc.gt.numbond(k1).and.overbond)then
C               Remove the closest (largest) ones
                        do j=1,numbond(k1)
                           sc=-1
                           ij=1
                           do jj=1,numc
                              if(tover(jj).gt.sc)then
                                sc=tover(jj)
                                ij=jj
                              endif
                           enddo
                           tover(ij)=-2
                        enddo
                        do jj=1,numc
                           if(tover(jj).gt.1e-3)bcord=bcord+tover(jj)
                        enddo
                endif
                if(numc.ge.numcord(k1))goto 10
                do j2=numc+1,numcord(k1)
C       Crummy search
                sc=25
                ij=1
                if(nei(j1).gt.0)then
                        do j=1,nei(j1)
                                if(scordx(j,j1).lt.sc)then
                                        sc=scordx(j,j1)
                                        ij=j
                                endif
                        enddo
                        scordx(ij,j1)=999
                endif
                bcord=bcord+sc
                enddo
10              continue
        enddo
        return
        end

        subroutine dcorder(natom,itype)
C       Setup a matrix for the co-ordination constraint
        include 'newbonds.h'
        real*8 r,tol,toll
        integer itype(*)
        if(.not.coord)return
        do j1=1,natom
                k1=itype(j1)
                if(numcord(k1).le.1)goto 10
                do j=1,numcord(k1)
                        dcordx(j,j1)=999
                enddo
                if(nei(j1).lt.1)goto 10
C               write(6,*)'Check ',j1,' neigh ',nei(j1)
                do j=1,nei(j1)
                        r=dcord(j,j1)
                        j2=itn(j,j1)
                        k2=itype(j2)
                        dcordx(j,j1)=0
                        tol=bonda(k1,k2)
C       Trap tol < 0.25 to mean no bonding
                        if(tol.lt.0.25)then
                                dcordx(j,j1)=25
                        else if(r.gt.tol)then
                                toll=(r-tol)/tol
                                dcordx(j,j1)=toll*toll
                        endif
C                       Overbonding?
                        if(overbond)then
                                if(r.le.tol)then
                                        tol=(r-tol)/tol
                                        doverx(j,j1)=tol*tol
                                else
                                        doverx(j,j1)=0
                                endif
                        endif
                enddo
10              continue
        enddo
C       write(6,*)'Set bond constraint matrix'
        return
        end
        subroutine scorder(natom,itype)
C       Setup a matrix for the co-ordination constraint
        include 'newbonds.h'
        real r,tol
        integer itype(*)
        if(.not.coord)return
        do j1=1,natom
                k1=itype(j1)
                if(numcord(k1).le.1)goto 10
                do j=1,numcord(k1)
                        scordx(j,j1)=999
                enddo
                if(nei(j1).lt.1)goto 10
                do j=1,nei(j1)
                        r=scord(j,j1)
                        j2=itn(j,j1)
                        k2=itype(j2)
                        scordx(j,j1)=0
                        tol=bonda(k1,k2)
C       Trap tol < 0.25 to mean no bonding
                        if(tol.lt.0.25)then
                                scordx(j,j1)=25
                        else if(r.gt.tol)then
                                toll=(r-tol)/tol
                                scordx(j,j1)=toll*toll
                        endif
C                       Overbonding?
                        if(overbond)then
                                if(r.le.tol)then
                                        tol=(r-tol)/tol
                                        soverx(j,j1)=tol*tol
                                else
                                        soverx(j,j1)=0
                                endif
                        endif
                enddo
10              continue
        enddo
C       write(6,*)'Set bond constraint matrix'
        return
        end
        subroutine scordset(x,y,z,symm,natom)
C       Setup a matrix for the minimum distance of each atom to the 
C       expanded set of symmetry equivalent atoms
        include 'newbonds.h'
        character*4 symm
        real*4 dx,dy,dz,bb,dxx,dyy
        real*4 x(*),y(*),z(*),xe(12),ye(12)
      integer ncont(20)
      dimension cell(6),tempf(20)
      common /sfcom1/tempf,ncont,natomq,cell
      Include 'Atoms.h'
      dimension xeq(20,natf),yeq(20,natf),neq(natf)
C     Preset equivalences
      do j=1,natom
         call asymm(x(j),y(j),ne,xe,ye,symm)
         neq(j)=ne
         do n=1,ne
            xeq(n,j)=xe(n)
            yeq(n,j)=ye(n)
         enddo
      enddo
        do j1=1,natom
        nne=0
        do j2=1,natom
C               dz=(z(j1)-z(j2))*cell(3)
C               dz=dz*dz
                dz=0
                if(dz.gt.16)goto 10
                n0=1
                if(j1.eq.j2)n0=2
                do n=n0,neq(j2)
                        dxx=x(j1)-xeq(n,j2)
                        dyy=y(j1)-yeq(n,j2)
                        do iy=-1,1
                                dy=(dyy+iy)*cell(2)
                                dy=dy*dy+dz
                                if(dy.gt.16.0)goto 11
                                do ix=-1,1
                                   dx=(dxx+ix)*cell(1)
                                   bb=dx*dx+dy
C       Values for co-ordination checking
                                   if(bb.lt.16.0)then
                                        if(bb.gt.1e-2)bb=sqrt(bb)
                                        nne=nne+1
C       Bug?
C       if(nne.gt.40)then
C               write(6,*)'nne too large, atoms ',j1,j2,ne
C               call exit(0)
C       endif
                                        scord(nne,j1)=bb
                                        itn(nne,j1)=j2
                                   endif
                                enddo
11                              continue
                        enddo
                enddo
10              continue
        enddo
        nei(j1)=nne
        enddo
C       write(6,*)'Set bond distance matrix'
        return
        end
        subroutine dcordset(x,y,z,symm,natom)
C       Setup a matrix for the minimum distance of each atom to the 
C       expanded set of symmetry equivalent atoms
        include 'newbonds.h'
        character*4 symm
        real*8 dx,dy,dz,bb,dxx,dyy,a,b,c
        real*8 x(*),y(*),z(*),xe(12),ye(12)
      integer ncont(20)
      dimension cell(6),tempf(20)
      common /sfcom1/tempf,ncont,natomq,cell
      include 'Atoms.h'
      real*8 xeq(20,natf),yeq(20,natf)
      integer neq(natf)
C     Preset equivalences
      do j=1,natom
         call asymmd(x(j),y(j),ne,xe,ye,symm)
         neq(j)=ne
         do n=1,ne
            xeq(n,j)=xe(n)
            yeq(n,j)=ye(n)
         enddo
      enddo

        a=cell(1)
        b=cell(2)
        c=cell(3)
        do j1=1,natom
        nne=0
        do j2=1,natom
C               dz=(z(j1)-z(j2))*c
C               dz=dz*dz
                dz=0
                if(dz.gt.16d0)goto 10
                n0=1
                if(j1.eq.j2)n0=2
C               do n=n0,ne
C                       dxx=x(j2)-xe(n)
C                       dyy=y(j2)-ye(n)
                do n=n0,neq(j2)
                        dxx=x(j1)-xeq(n,j2)
                        dyy=y(j1)-yeq(n,j2)
                        do iy=-1,1
                                dy=(dyy+iy)*b
                                dy=dy*dy+dz
                                if(dy.gt.16d0)goto 11
                                do ix=-1,1
                                  dx=(dxx+ix)*a
                                  bb=dx*dx+dy
C       Values for co-ordination checking
                                  if(bb.lt.16d0)then
                                        if(bb.gt.1d-5)bb=sqrt(bb)
                                        nne=nne+1
C       Bug?
C       if(nne.gt.40)then
C               write(6,*)'nne too large, atoms ',j1,j2,ne
C               call exit(0)
C       endif
                                        dcord(nne,j1)=bb
                                        itn(nne,j1)=j2
                                  endif
                                enddo
11                              continue
                        enddo
                enddo
10              continue
        enddo
        nei(j1)=nne
        enddo
C       write(6,*)'Set bond distance matrix'
        return
        end

