        Subroutine LimitDMIX(Y,Y2,YY,YY2,S2,SY2,F,MAXMIX,MEMALL,MEMORY,
     X                       ascl1, qmx_input, dmix_last, qmx, dmixout,
     X                       NoLocal,Nplane, PM1, PM2, PM3, PM4, rtrap)
!
        implicit real*4 (a-h,o-z)
        dimension F(MAXMIX,MEMALL)
        dimension Y(MAXMIX,MEMORY), Y2(MAXMIX,MEMORY)
        dimension YY(MEMORY,MEMORY),YY2(MEMORY,MEMORY)
        dimension S2(MAXMIX,MEMORY),SY2(MEMORY,MEMORY)
        dimension dmixout(4)
        logical NoLocal

!--------------------------------------------------------------------
!       Limit based upon improvement
        PWLast   = 0
        PWThis   = 0
        DO J=1,MAXMIX
              PWLAST=PWLAST+F(J,MEMORY)*F(J,MEMORY)
              PWTHIS=PWTHIS+F(J,MEMALL)*F(J,MEMALL)
        ENDDO

        RatioPW  = sqrt(PWThis*PWLast/(PWLast*PWLast+1D-50))
        RatioCLM = RatioPW
        HowMuch =  sqrt((RatioCLM**2 + RatioPW**2)/2)
!
!       Limit based upon improvement
        fudge=1.5D0
        qlimit1 = min(fudge,1.D0/Howmuch)
        qlimit1 = max(1.d0/fudge,qlimit1)
        qlimit1 = max(dmix_last*qlimit1,0.025)
!
!       Limit based upon prior history
        qlimit2 = ascl1
!
!       No Local, use qmx_input
        qlimit3=qmx
        if(NoLocal)qlimit3=qmx_input
!
!       Combine the hard limits qlimit2, qlimit3
        dmix=min(qlimit1,qlimit2,qlimit3)
21      format(a,6D14.5)
!
!       Look at projected fractions for No Free Lunch Control
        PM1= Fproject (Y, F(1,MEMALL),YY,MAXMIX,MEMORY)
        PM2= Fproject (Y2,F(1,MEMALL),YY2,MAXMIX,MEMORY)
        PM3= BBProject(Y2,S2,YY2,F(1,MEMALL),MAXMIX,MEMORY)
        PM4= GBMProject(Y2,S2,SY2,F(1,MEMALL),MAXMIX,MEMORY)
!
        dmixout(1)=min(dmix,rtrap/max(PM1,0.001D0))
        dmixout(2)=min(dmix,rtrap/max(PM2,0.001D0))
        dmixout(3)=min(dmix,rtrap/max(PM3,0.001D0))
!       dmixout(4)=min(dmix,rtrap/max(PM4,0.001D0))
!
!       For good-Broyden, find it differently
        dmixg=dmix
30      rout=GBProject(Y,S,SY,SS,F,MAXMIX,MEMORY,DMIXG,IFAIL)
        if(rout .gt. rtrap)then
                dmixg=dmixg*0.9
                goto 30
        endif
        dmixout(4)=dmixg
!       
        write(21,21)':DIRE ',qlimit1,qlimit2,qlimit3,
     X           rtrap/max(PM1,0.001D0),dmixout(1)
        do N=1,4
                t=max(dmixout(N),0.025D0)
                dmixout(N)=t
        enddo
        return
        end
