      subroutine MSEC1(Y,S,YY,F,STEP,MAXMIX,MEMORY,DMIX,IFAIL,DELTA)
           implicit real*4 (a-h,o-z)
           dimension STEP(MAXMIX),F(MAXMIX)
           dimension Y(MAXMIX,MEMORY),S(MAXMIX,MEMORY)
           dimension YY(MEMORY,MEMORY)
           real*4 YYINV(MEMORY,MEMORY),YPROJ(MEMORY),YTG(MEMORY),
     X           YT(MEMORY,MEMORY)
!--------------------------------------------------------------------
!          No Free Lunch MultiSecant Update
!
!          Input Parameters
!          MAXMIX:         Length of the variable vector
!          MEMORY:         Total number of memory values to use
!                          Most recent is last
!          Y,S:            Conventional Y and S arrays
!          YY:             Matrix of Y*Y values
!          F:              -Grad(MAXMIX) at the current point (residue)
!          DMIX:           Scaler for initial matrix
!
!          Output
!          STEP            Multi-Secant Step
!
!       Delta: Term to add to Diagonal for inverse
!        Parameter (Delta=1D-6)
!
!--------------------------------------------------------------------
!        allocate (YYINV(MEMORY,MEMORY),YPROJ(MEMORY),YTG(MEMORY))
!        allocate (YT(MEMORY,MEMORY) )
!       Invert YY
        ninverts=0
        DO N=1,MEMORY
         DO M=1,MEMORY
           YT(M,N)=YY(M,N)
         ENDDO
         YT(N,N)=YY(N,N)+Delta
        ENDDO
!
        ADD=1D-4
1000    continue
        DO N=1,MEMORY
         DO M=1,MEMORY
           YYINV(M,N)=YT(M,N)
         ENDDO
        ENDDO
        call minverse(YYINV,MEMORY,MEMORY,IFAIL)
!       If the matrix is singular, add a diagonal component to it
        if(ifail .lt. 0)then
                  ninverts=ninverts+1
                  do J=1,MEMORY
                     YT(J,J)=YT(J,J)+ADD
                  enddo
                  ADD=ADD*2.D0
                  if(ninverts .lt. 10)goto 1000
!                 Bomb to Pratt
                  IFAIL=-1
                  goto 100
        endif
!
        ntries=0
2000    continue
        DO N=1,MEMORY
!       Dot product Y_T . F
                YTG(N)=0
                DO K=1,MAXMIX
                   YTG(N)=YTG(N)+Y(K,N)*F(K)
                ENDDO
        ENDDO
!       Multiply by YYINV
        DO N=1,MEMORY
           YPROJ(N)=0
           DO K=1,MEMORY
              YPROJ(N)=YPROJ(N)+YTG(K)*YYINV(K,N)
           ENDDO
        ENDDO
!       Create the step
        DO J=1,MAXMIX
!          New Position
           ST = 0
           SP = F(J)
           DO N=1,MEMORY
              ST = ST - S(J,N)*YPROJ(N)
              SP = SP - Y(J,N)*YPROJ(N)
           ENDDO
           STEP(J)  =ST+DMIX*SP
        ENDDO

        IFAIL=0
100     continue !deallocate (YYINV, YTG, YPROJ, YT )
        RETURN
        END

