        SUBROUTINE PhaseMixer(P,F,NB,MEM,FOLD,FNEW,SB,
     X  dmix,dmix_last,NITER,NN)
        IMPLICIT REAL*4 (A-H,O-Z)
!
        CHARACTER*5 MIX
        real*4 P(NB,NN),Y(NB,NN),S(NB,MEM),F(NB,NN)
        real*4 YY(MEM,MEM),SC1(MEM),SC2(MEM),SC3(MEM),SC4(MEM)
        real*4 Y2(NB,MEM),S2(NB,MEM),YY2(NB,MEM),SS2(NB,MEM),SY2(NB,MEM)
        real*4 SS(MEM,MEM),SY(MEM,MEM)
	real*4 GB(NB), BB(NB), MSEC(NB),MSC2(NB),SB(NB)
	real*4 FOLD(NB),FNEW(NB)
        logical there
        logical DoBB, DoMSec, DoGB, DOMSec2, IdidBetter
        parameter (ACUT=138.6D0, ONE=1.D0, ZERO=0.0D0)
!                                                                       
!
!       Read debug controls
        qmx=dmix
        qmx_input=dmix
        DoMSec =.true.
        DoBB   =.false.
        DoGB   =.false.
        DoMSec2=.false.
        rtrap=0.15
        IDSCALE=2
        iuse=0
        inquire(file='Tester', exist=there)
        if(there)then
                open(unit=1,file='Tester')
                read(1,*,err=983,end=983)IBB,IGB,IUse,rtrap,delta
                close(unit=1)
                if(IBB .gt. 0)DoBB=.true.
                if(IGB .gt. 0)DoGB=.true.
                goto 984
983             DoMSec=.true.
                DoBB  =.false.
                DoGB  =.false.
                DoMSec2=.true.
                IUSE  =0
                rtrap =0.15
984             continue
                read(1,*,err=985,end=985)IDTMP
                IDSCALE=IDTMP
985             continue
        endif
!       Traps for consistency (and later)
        if     (iuse .eq. 1)then
                DoBB  =.true.           !BB     Mode
        else if(iuse .eq. 0)then
                DoMSec=.true.           !MSEC   Mode
        else if(iuse .eq. 2)then
                DoGB  =.true.           !GB     Mode
        else if(iuse .eq. 3)then
                DoBB  =.true.           !BB-MSec Hybrid
                DOMSec=.true.
        else if(iuse .eq. 4)then
                DoMSec2=.true.          !MSEC2  Mode
        else if(iuse .ge. 5)then
                DOMSec2=.true.          !Both MSECS
                DOMSEC =.true.
        endif
!
!       Apply general bounds based upon residues and type of atoms
        qmx=1
        qmx_input=1
!       call stepbound(sreduction,nat,zz,qmx_input,qmx,qtot,splane,scharge)
!
!--------------------------------------------------------------------
!       Start Collecting History about previous steps
!--------------------------------------------------------------------
!
!        read(31,err=6001,end=6001)dmix,niter,modus
!        dmix_last=dmix
!        goto 6002
!6001    niter=0
!6002    niter=niter+1
        MEMALL=MEM+1
!        ISKIP=NITER-MEMALL
!        allocate (F(NB,MEMALL),P(NB,MEMALL))
!        write(6,*)'Before first',memall,mem,nb
        IF(NITER .gt. MEMALL)then
           DO N=1,MEM
           DO J=1,NB
              P(J,N)=P(J,N+1)
              F(J,N)=F(J,N+1)
           enddo
           enddo
        endif
        DO J=1,NB
           P(J,MEMALL)=FOLD(J)
           F(J,MEMALL)=FNEW(J)-FOLD(J)
           FNEW(J)=F(J,MEMALL)
        ENDDO
!
        if(MEM .eq. 0)goto 119
!
!--------------------------------------------------------------------
!       Start Generating the S & Y vectors
!--------------------------------------------------------------------
!
        do J=1,MEM
           T1=0.
           T2=0.
!
!       Define S, Y from the current point (mode=1) or as increments
!       At least for the multisecant mode, this is much better
!       For conventional Bad Broyden definition from the most recent is better
!
           DO K=1,NB
                S(K,J)=P(K,MEMALL)-P(K,J)
                Y(K,J)=F(K,MEMALL)-F(K,J)
                T1=T1+Y(K,J)*Y(K,J)
                S2(K,J)=P(K,J+1)-P(K,J)
                Y2(K,J)=F(K,J+1)-F(K,J)
                T2=T2+Y2(K,J)*Y2(K,J)
           enddo
!       Save Step History information
!       Renormalize
           T1=1.D0/sqrt(T1)
           T2=1.D0/sqrt(T2)
!           write(6,*)'Scales ',j,t1,t2
           DO K=1,NB
                S(K,J)=S(K,J)*T1
                Y(K,J)=Y(K,J)*T1
                S2(K,J)=S2(K,J)*T2
                Y2(K,J)=Y2(K,J)*T2
           ENDDO
!
        enddo
!--------------------------------------------------------------------
!       End Generating the S & Y vectors
!--------------------------------------------------------------------
!
!--------------------------------------------------------------------
!       Generate the MEM x MEM Matrices
!       Also generate scaling information
!--------------------------------------------------------------------
!
        SYSUM1=0.0
        SYSUM2=0.0
        YYSUM1=0.0
        YYSUM2=0.0
        DO J=1,MEM
          DO K=1,MEM
                SS(J,K)=0
                YY(J,K)=0
                SY(J,K)=0
                SS2(J,K)=0
                YY2(J,K)=0
                SY2(J,K)=0
                DO M=1,NB
                SS(J,K) =SS(J,K) +S (M,J)*S (M,K)
                YY(J,K) =YY(J,K) +Y (M,J)*Y (M,K)
                SY(J,K) =SY(J,K) +S (M,J)*Y (M,K)
                SS2(J,K)=SS2(J,K)+S2(M,J)*S2(M,K)
                YY2(J,K)=YY2(J,K)+Y2(M,J)*Y2(M,K)
                SY2(J,K)=SY2(J,K)+S2(M,J)*Y2(M,K)
                ENDDO
          enddo
!
!       Some scaling type material, not yet completely used
!       These measure how well previous steps have performed
!       1D-30 term added to avoid divisions by zero
!
          SC1(J)=sqrt(SS(J,J)*YY(J,J)/(YY(J,J)*YY(J,J)+1D-30))
          SC2(J)=-SY(J,J)*YY(J,J)/(YY(J,J)*YY(J,J)+1D-30)
          SC3(J)=sqrt(SS2(J,J)*YY2(J,J)/(YY2(J,J)*YY2(J,J)+1D-30))
          SC4(J)=-SY2(J,J)*YY2(J,J)/(YY2(J,J)*YY2(J,J)+1D-30)

          SYSUM1=SYSUM1+SY (J,J)
          SYSUM2=SYSUM2+SY2(J,J)
          YYSUM1=YYSUM1+YY (J,J)
          YYSUM2=YYSUM2+YY2(J,J)
!          write(6,*)j,sc1(j),sc2(j),sc3(j),sc4(j)
!       Running averages
          if(J .eq. 1)then
                ASCL1=SC1(J)
                ASCL2=SC2(J)
                ASCL3=SC3(J)
                ASCL4=SC4(J)
          else
                ASCL1=(ASCL1*2+SC1(J))/3.D0
                ASCL2=(ASCL2*2+SC2(J))/3.D0
                ASCL3=(ASCL3*2+SC3(J))/3.D0
                ASCL4=(ASCL4*2+SC4(J))/3.D0
          endif
        enddo
!
!       Look at the seperate Plane and RMT progress scalings

        YRM=YY(MEM,MEM)
        SRM=SS(MEM,MEM)
        YPL=YRM
        SPL=SRM
        SCR=sqrt(SRM*YRM/(YRM*YRM+1D-50))
        SCP=SRM
!        DELTA=1D-4
!
!       Look at projected fractions for No Free Lunch Control
        PM1= Fproject (Y, FNEW,YY,NB,MEM,DELTA)
        PM2= Fproject (Y2,FNEW,YY2,NB,MEM,DELTA)
        PM3= BBProject(Y2,S2,YY2,FNEW,NB,MEM,DELTA)
        PM4= GBMProject(Y2,S2,SY2,FNEW,NB,MEM,DELTA)
!        write(6,*)'After projects ',PM1,PM2,PM3,PM4
!--------------------------------------------------------------------
!
!       Limit based upon improvement
        PWLast=0
        PWThis=0
        DO J=1,NB
              PWLAST=PWLAST+F(J,MEM)*F(J,MEM)
              PWTHIS=PWTHIS+F(J,MEMALL)*F(J,MEMALL)
        ENDDO
        RatioPW  = sqrt(PWThis*PWLast/(PWLast*PWLast+1D-20))
!
!       Limit the step so we don't suddenly use a big one
!       qmx is the user input value
!       Skip the stepbounds control if |idscale| > 10 -- not so good
        if(abs(idscale) .gt. 10)then
!               How much
                HowMuch = RatioPW**2
                qmx=qmx_input
                if(qmx.lt.dmix) then
                        dmix=qmx
                else
!                       Smaller of a weighted average and an increase of the prior step
!                       Rather a classic "Trust Region" approach
                        DMIX=Min(dmix/HowMuch,(dmix+qmx)*0.5D0,
     X                   (dmix*0.25+ascl1*0.75),qmx,2.0D0)
!                       Force to qmx if that is close enough
                        if(abs(dmix-qmx) .lt. 0.001D0)dmix=qmx
                endif        
                DMIX=max(DMIX,0.025D0)        
        else
!       Normal case, limit using last step and qmx from stepbounds
                if(qmx.lt.dmix) then
                        dmix=qmx
                else
!                       Smaller of a weighted average and twice the prior step
!                       Rather a classic "Trust Region" approach
                        DMIX=Min(2.d0*dmix,dmix*0.5+qmx*0.5,qmx)
!                       Force to qmx if that is close enough
                        if(abs(dmix-qmx) .lt. 0.001D0)dmix=qmx
                endif
        endif
!
!       Mutual Fund Constraint
!       Here we limit the initial Hessian term based upon prior performance
!       Alas, just like a Mutual Fund, this may not work
!
!       Scaling based upon last step
        wscl=min(sc1(MEM),sc3(MEM),ascl1,ascl3,scp,scr,2.D0)
!        write(6,*)wscl,ascl1,ascl3,scp,scr,dmix,qmx
!
        if((IDSCALE .eq. 2).or.(IDSCALE .lt. -20))then
!       This one seems reliable. Scale using a running average of prior performance
                dmix=min(ascl1,2.D0,dmix)
        else if(IDSCALE .gt. 0)then
                dmix=min(dmix,wscl)
        endif
!
!       Limit based upon improvement
!        IdidBetter=.false.
!       if(RatioPW .lt. 0.95D0)
!    X                   IdidBetter=.true.
!       if(MEM .le. 2)IdidBetter=.true.
!       If we did not do better, don't increase dmix
!       if( .not. IdidBetter) then
!               dmix=min(dmix,dmix_last)
!                write(10,*)' Not Better   ',RatioPW
!       else
!                write(10,*)' Did Better   ',RatioPW
!       endif
!
!       Limit based upon projected step, No Free Lunch Control
!       We want to ensure that the step along the component of the residual which
!       does not project upon the prior information is not too large
!
        DMIXM=DMIX
        DMIX2=DMIX
        DMIXB=DMIX
        DMIXG=DMIX
        if(rtrap .gt. 0)then
                DM1=rtrap/max(PM1,0.001D0)
                DM2=rtrap/max(PM2,0.001D0)
                DM3=rtrap/max(PM3,0.001D0)
                DM4=rtrap/max(PM4,0.001D0)
                DM1=max(DM1,0.05D0)
                DM2=max(DM2,0.05D0)
                DM3=max(DM3,0.05D0)
                DM4=max(DM4,0.05D0)
                DMIXM=min(DMIXM,DM1)
                DMIX2=min(DMIX2,DM4)
                DMIX2=min(DMIXM,DMIX2*PM1/PM4)
                DMIXB=min(DMIXB,DM3)
                DMIXB=min(DMIXM,DMIXB*PM1/PM3)
                DMIXG=DMIXB
        endif
        DMIXM=max(DMIXM,0.025D0)
        DMIXB=max(DMIXB,0.025D0)
        DMIX2=max(DMIX2,0.025D0)
        DMIXG=DMIXB
        DMIX =max(DMIX,0.025D0)       
        qmx=dmix
!      DMIXM=2
!      DMIXB=2
!      DMIX1=2
!      DMIXG=2
!
!--------------------------------------------------------------------
!       Calculate the New Steps, currently with 3 modes             
!
!
       if(DoMSec)then
!          allocate(MSec(NB))
!          Note: Y and S referenced to current position here -- works better
           call  MSEC1(Y,S,YY,FNEW,MSEC,NB,MEM,DMIXM,IFAIL,DELTA)
!          Inversion bombed, use Bad Broyden or go to Pratt
           if(IFAIL .ne. 0)then
                    write(10,*)'Inverse bombed'
                    goto 119
           endif
       endif
!      Need to patch DMIX control for other modes
!
       if(DoBB)then
!          allocate (BB(NB))
!          Note: Use conventional Y & S here
           call  BBLuke(Y2,S2,YY2,FNEW,BB,NB,MEM,DMIXM,DELTA)
      endif
!
      if(DoGB)then
!          allocate(GB(NB))
!          Note: Use conventional Y & S here
           call  GBLDM(Y2,S2,SY2,SS2,FNEW,GB,NB,MEM,DMIXM,IFAIL,DELTA)
           if(ifail .ne. 0)then
                    DO N=1,NB
                       GB(N)=BB(N)
                    ENDDO
           endif
       endif
!
       if(DoMSec2)then
!          allocate(MSC2(NB))
!          Note: Use conventional Y & S here
           call  MSEC2(Y,S,SY,FNEW,MSC2,NB,MEM,DMIXM,IFAIL,DELTA)
           if(ifail .ne. 0)then
                    DO N=1,NB
                       MSC2(N)=MSEC(N)
                    ENDDO
           endif
       endif
!
!
       if(DoBB .and. DoMSec)then
            write(10,*)' DMIXM, DMIXB, & Projections  ',
     X      DMIXM,DMIXB,PM1,PM2,PM3
       else
            write(10,*)' DMIXM and Projections   ',DMIXM,PM1,PM2,PM3
       endif
!
!       Which one to use -- default MSEC1
        MIX='MSEC1'
        DO N=1,NB
           SB(N)=FOLD(N)+MSEC(N)
        ENDDO
        DMIXUSED=DMIXM
!
        if(IUSE .eq. 1)then
!       Bad Broyden
                DO N=1,NB
                   SB(N)=FOLD(N)+BB(N)
                ENDDO
                MIX='BBROY'
                DMIXUSED=DMIXB
        else if(IUSE .eq. 2)then
!       Good Broyden
                DO N=1,NB
                   SB(N)=FOLD(N)+GB(N)
                ENDDO
                MIX='GBROY'
                DMIXUSED=DMIXG
        else if( (IUSE .eq. 3) .and. (2*(NITER/2) .eq. NITER))then
!       Alternate BB & MSEC
                DO N=1,NB
                   SB(N)=FOLD(N)+BB(N)
                ENDDO
                MIX='BBROY'
                DMIXUSED=DMIXB
        else if(IUSE .eq. 4)then
!       MSEC2
                DO N=1,NB
                   SB(N)=FOLD(N)+MSC2(N)
                ENDDO
                MIX='MSEC2'
                DMIXUSED=DMIX2
        else if( (IUSE .eq. 5) .and. (2*(NITER/2) .eq. NITER))then
!       Alternate MSECs,
                DO N=1,NB
                   SB(N)=FOLD(N)+MSC2(N)
                ENDDO
                MIX='MSEC2'
                DMIXUSED=DMIX2
        else if( IUSE .eq. 6)then
!       Best projection
                if(PM4 .lt. PM1)then
                        DO N=1,NB
                          SB(N)=FOLD(N)+MSC2(N)
                        ENDDO
                        MIX='MSEC2'
                        DMIXUSED=DMIX2
                endif
!        else if( IUSE .eq. 7)then
!       Best condition number
!               if(CondYY2 .lt. CondYY )then
!                       DO N=1,NB
!                         SB(N)=FOLD(N)+MSC2(N)
!                       ENDDO
!                       MIX='MSEC2'
!                       DMIXUSED=DMIX2
!               endif
        endif
        DMIX=DMIXUSED
        QMX=DMIX
!
!       Look at Dot Products between different modes
!        if(DoMSec .and. DoBB)then
!                T1=dot_product(BB,MSec)
!                T2=dot_product(BB,BB)
!                T3=dot_product(MSec,MSec)
!                T=T1/sqrt(T2*T3)
!                write(21,2100)'MSec & BB Dot ',T,sqrt(T3),sqrt(T2)
!        endif
!        if(DoMSec .and. DoGB)then
!                T1=dot_product(GB,MSec)
!                T2=dot_product(GB,GB)
!                T3=dot_product(MSec,MSec)
!                T=T1/sqrt(T2*T3)
!                write(21,2100)'MSec & GB Dot ',T,sqrt(T3),sqrt(T2)
!        endif
!        if(DoBB .and. DoGB)then
!                T1=dot_product(GB,BB)
!                T2=dot_product(GB,GB)
!                T3=dot_product(BB,BB)
!                T=T1/sqrt(T2*T3)
!                write(21,2100)'BB & GB Dot ',T,sqrt(T3),sqrt(T2)
!        endif
!        if(DoMSec .and. DoMSec2)then
!                T1=dot_product(MSC2,MSec)
!                T2=dot_product(MSC2,MSC2)
!                T3=dot_product(MSec,MSec)
!                T=T1/sqrt(T2*T3)
!                write(21,2100)'MSec & MSec2 Dot ',T,sqrt(T3),sqrt(T2)
!        endif
!
!--------------------------------------------------------------------
!       Done with calculating the updates
!
!       Consistency check
        nreduce=0
        reduction=1.D0
120     DOT=0
        BMOD=0
        PMOD=0
!
!       Calculate the angle between the Pratt & Broyden Steps
!       Also calculate the relative sizes
!        write(6,*)'YYY ',NB
        DO K=1,NB
                SPRATT=(fnew(k)-fold(k))*DMIX
                SBROY=(SB(K)-fold(k))
                DOT=SPRATT*SBROY+DOT
                BMOD=BMOD+SBROY*SBROY
                PMOD=PMOD+SPRATT*SPRATT
        enddo
!       Adjust to put plane waves on appropriate scale
        DOTP=DOT 
        BMODP=BMOD 
        PMODP=PMOD 
        DTTP=DOT/sqrt(BMOD*PMOD)
        if(DTTP .gt. 1.0D0)then
                DTTP=0.0D0
        else if(DTTP .lt. -1.0D0) then
                DTTP=180.D0
        else
                DTTP=acos(DTTP)*90./asin(1.D0)
        endif
        
!       Traps based upon the relative sizes and the angle
!
!       Test the angle
!       If it is too big Broyden method may have collapsed
        BMOD=sqrt(BMOD)
        PMOD=sqrt(PMOD)
        DTT=DOT/(BMOD*PMOD)
        if(DTT .gt. 1.0D0)then
                DTT=0.0D0
        else if(DTT .lt. -1.0D0) then
                DTT=180.D0
        else
                DTT=acos(DTT)*90./asin(1.D0)
        endif
!                       Write(10,*)'Step Info',BMOD,PMOD,DTT
!
        IF(abs(DTT).GT.ACUT.and.niter.ge.4)Then

                        QMX=DMIX*MIN(2.D0*BMOD/PMOD,2.D0)
                        QMX=min(QMX,0.075D0) !*exp(-1.5*SPLANE)
                        Goto 119
        endif

!       Too large a step; use information about fraction projected onto Prior (PROJL)
!       to help control this.
        SBOUND=EXP(-2.d0*PM1)
        BOUND1=SBOUND*PMOD/dmix                  ! 0.5 of the full step
        BOUND2=PMOD*10.D0*SBOUND                 ! 5 times the current reduced Pratt step
!
!       First Bound, the smaller of these
        BLIMIT=min(BOUND1,BOUND2)
!
!       If the user has a large step, be reasonable about trying it
        BLIMIT=max(BLIMIT, PMOD*3.D0)
!
!       Ensure that we don't go too small
        BLIMIT=max(BLIMIT,2.5D-2)
!
!       Skip trap if broyden is very small
!       if(bmod .lt. 1.D-4)goto 122
!
!        if(BMOD .gt. BLIMIT)then
!                       Reduce the step
!                       nreduce=nreduce+1
!                       In case something went wrong
!                       if(nreduce .gt. 1)then
!                               X1=0.95D0
!                       else
!                               X1=0.99999999D0*BLIMIT/BMOD
!                       endif
!                       X2=(1.D0-X1)
!                       reduction=reduction*X1
!                       do K=1,NB
!                               SB(K)=SB(K)*X1+FOLD(K)*X2
!                       enddo
!                       goto 120
!       endif
!
!       Done with traps, move to convert values back
122     continue
!        if(reduction .lt. 0.9)then
!            Write(10,*)'Info 2',BMOD,PMOD,DTT,reduction
!        else
!            Write(10,*) 'Info 1',BMOD,PMOD,DTT
!        endif

!--------------------------------------------------------------------
!       Put positions back into the arrays that they came from
!--------------------------------------------------------------------
!
100     CONTINUE
!        rewind 31
!        write(31)DMIX,NITER,VERSION

        GOTO 121
!                                                          
!--------------------------------------------------------------------
!       PRATT MIXING FOR FIRST ITERATION, after angle gets too big
!       or something else goes wrong
!--------------------------------------------------------------------
!                                  
119     CONTINUE
!       Note: We are resetting here, but this might not always be right
!       If we get here via a trap on the angle perhaps we should not reset
!
        niter=1
        DMIX=min(QMX,0.075D0) !*exp(-1.5*SPLANE))
        DMIX=max(DMIX,0.01D0)
        MIX='PRATT'
        QMX=DMIX
        DMIXUSED=DMIX
!
        DO K=1,NB
                SB(K)=FOLD(K)+DMIX*(FNEW(K)-FOLD(K))
        ENDDO
!       Jump back to main output code
        GOTO 100                                     

121     CONTINUE                                                          
!       Set QMX for output
        DMIX=DMIXUSED
        QMX =DMIX
!        write(6,*)'Done with PhaseMixer'
        RETURN                                                            
!                                                                       
        END
