C
C  Copyright (c) 1998 L. D. Marks
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
C
       SUBROUTINE LattCon (H, K,  F, SYMM, NREF )
C
C      Search for reflections which are connected by (unknown) bulk
C      Spots. If many strong spots are connected, there is a danger
C      that the Babinet solution may be produced
         INTEGER LAT(2)
         COMMON /CLAT/LAT
         INTEGER H(*), K(*)
         DIMENSION  F(*)
         CHARACTER*4 SYMM
         INTEGER HE1(20), KE1(20), ISE1(20)
         INTEGER HE2(20), KE2(20), ISE2(20)
         INTEGER HE3(20), KE3(20), ISE3(20)
         PARAMETER (ELOW=2.)
C
         CALL StrongSigma (H, K,  F, SYMM, NREF )
C
         IF((LAT(1) .LT. 0) .OR. (LAT(2) .LT. 0)) RETURN
C        First Point
         WRITE (10, 300) LAT(1),LAT(2)
300      Format(/'Testing for a Bulk Lattice of ', i3, ' x ', i3/
     X           'If there are many connections, particularly 180/360',
     X           'phasese'/
     X           'You may have strong, unmeasured reflections and ',
     X           'issues'/'In this case analyze by hand!')
         DO 10 J=1,NREF-1
           IF ((H(J) .EQ. 0) .AND. (K(J) .EQ. 0)) goto 10
C          Limit to E > ELOW
           ifound=0
           IF( F(J) .LT. ELOW ) goto 10
           CALL EQUIV2 (HE1,KE1,ISE1,H(J),K(J),NE1,SYMM)
           NE1=1
C            Second Point
             DO 20 J1=1,J-1
                IF((H(J1) .EQ. 0) .AND. (K(J1) .EQ. 0)) GOTO 20
                IF( F(J1) .LT. ELOW ) goto 20
                IF(J .EQ. J1) goto 20
                CALL EQUIV2(HE2,KE2,ISE2,H(J1),K(J1),NE2,SYMM)
C               Loop over equivalents
                DO N1=1,NE1
                   DO N2=1,NE2
                     I1= HE1(N1)+HE2(N2)
                     I2= KE1(N1)+KE2(N2)
                     IF ( ((I1/ LAT(1))* LAT(1) .EQ. I1) .AND.
     X                    ((I2 /LAT(2))* LAT(2) .EQ. I2)) THEN
C                      Connected by a bulk spot, make output clean
                       CALL EQUIV2(HE3,KE3,ISE3,I1,I2,NE3,SYMM)
                       HLOW=I1
                       KLOW=I2
                       DO   JJ=1,NE3
                        IF(abs(KE3(JJ)) .LT. KLOW)THEN
                                KLOW=KE3(JJ)
                                HLOW=HE3(JJ)
                        ELSE IF(ABS(KE3(JJ)) .EQ. KLOW)THEN
                                IF(ABS(HE3(JJ)) .LT. HLOW)THEN
                                        KLOW=KE3(JJ)
                                        HLOW=HE3(JJ)
                                ELSE IF(ABS(HE3(JJ)) .EQ. HLOW)THEN
                                   IF(HE3(JJ) .GT. 0)THEN
                                        KLOW=KE3(JJ)
                                        HLOW=HE3(JJ)
                                   ENDIF
                                ELSE IF(KE3(JJ) .GT. 0)then
                                        KLOW=KE3(JJ)
                                        HLOW=HE3(JJ)
                                ENDIF
                        ENDIF
                      END DO
                      I1=HLOW
                      I2=KLOW
                       IF(ISE3(1) .EQ. 3)THEN
                         WRITE(10,100)H(J),K(J),F(J),H(J1),K(J1),F(J1),
     X                   I1,I2
                         IFOUND=1
                       ELSE
                         WRITE(10,200)H(J),K(J),F(J),H(J1),K(J1),F(J1),
     X                   I1,I2
                         IFOUND=1
                       ENDIF
                     ENDIF
                   ENDDO
                ENDDO
   20      CONTINUE
           IF(IFOUND .EQ. 1)write(10,*)' '
           IFOUND=0
   10      CONTINUE

200        FORMAT('Beam ',2I3,' E=',F10.5,' & Beam ',2I3,' E=',F10.5,
     X     ' Connected by Bulk Lattice ',2I3)
100        FORMAT('Beam ',2I3,' E=',F10.5,' & Beam ',2I3,' E=',F10.5,
     X     ' Connected by Bulk Lattice ',2I3,' <<<< 180/360')
         write(10,*)' '
         RETURN
       END
C
C
       SUBROUTINE StrongSigma (H, K,  F, SYMM, NREF )
C
C      Search for strong triplets
         INTEGER LAT(2)
         COMMON /CLAT/LAT
         INTEGER H(*), K(*)
         DIMENSION  F(*)
         CHARACTER*4 SYMM
         INTEGER HE2(20), KE2(20), ISE2(20)
         INTEGER HE3(20), KE3(20), ISE3(20)
         parameter (ELOW=2.0)
C
         WRITE (10, 300)
300      Format(/'Analysing Strong Sigma-2 Relationships')
         DO 10 J=1,NREF
           IF ((H(J) .EQ. 0) .AND. (K(J) .EQ. 0)) goto 10
C          Limit to E > 1.5
           IFOUND=0
           IF( F(J) .LT. ELOW ) goto 10
C            Second Point
             DO 20 J1=1,J-1
                IF((H(J1) .EQ. 0) .AND. (K(J1) .EQ. 0)) GOTO 20
                IF( F(J1) .LT. ELOW ) goto 20
                CALL EQUIV2(HE2,KE2,ISE2,H(J1),K(J1),NE2,SYMM)
C               Loop over equivalents
                   DO N2=1,NE2
                     I1= -(H(J)+HE2(N2))
                     I2= -(K(J)+KE2(N2))
                     if((i1.eq.0).and.(i2.eq.0))goto 100
C                    Find this point
                     CALL EQUIV2(HE3,KE3,ISE3,I1,I2,NE3,SYMM)
                     do N3=1,ne3
                        KF1=HE3(N3)
                        KF2=KE3(N3)
                        DO L=1,NREF
                        IF((KF1.EQ.H(L)).and.(KF2.eq.K(L)))then
                            if((L.eq.J).or.(L.eq.J1))goto 100
                            if(F(L) .gt. ELOW)
     X                WRITE(10,200)H(J),K(J),F(J),HE2(N2),KE2(N2),F(J1)
     X                ,ise2(N2)
     X                ,KF1,KF2,F(L),ise3(N3)
                            ifound=1
                            goto 100
                        ENDIF
                        ENDDO
                     ENDDO
100                CONTINUE
                   ENDDO
20           CONTINUE
             if(ifound .eq. 1)write(10,*)' '
10       CONTINUE

200        FORMAT('Beam ',2I3,' E=',F10.5,' & Beam ',2I3,' E=',F10.5,
     X     ' OP ',i2,' Connected to ',2I3,' E=',F10.5,' OP ',i2)
         write(10,*)' '
         RETURN
       END
