C
C  Copyright (c) 1998 L. D. Marks
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
C
       SUBROUTINE ORIGC (H, K, FHK, I1, I2, SYMM, NREF )
C     defines origin for cntrd 2D unit cells
C     from convergence data
         INTEGER H(*), K(*)
         DIMENSION FHK(*)
         CHARACTER*4 SYMM
         INTEGER A, B, C, D, DET
         REAL RR1
         LOGICAL LL1
 
         I1 = (-1)
         I2 = (-1)
         UBEST = (-99.)
C     For the moment, skip p6mm cases
         IF (SYMM .EQ. 'p3mt' .OR. SYMM(1:2) .EQ. 'p6') RETURN
         LL1 = SYMM .EQ. 'cm  ' .OR. SYMM .EQ. 'c2mm'
         DO 100 J=1,NREF
 
C     centred unit cells only require one reflection to be fixed
C     even-odd and odd-even reflections are symmetry-forbidden
C     so an odd-odd reflection must be used to define the origin
           IF (LL1) THEN
             IF ((H(J) / 2) * 2 .NE. H(J)) THEN
               I1 = J
               RETURN
             END IF
           END IF
 
C     for 2D structures with a center of symmetry, determinant of the
C     2x2 matrix formed must equal 1 or -1 if reflections are allowed
C     to fix origin, reduced down to odd/even (1/0) values
           A = 0
           B = 0
           IF ((H(J) / 2) * 2 .NE. H(J)) A = 1
           IF ((K(J) / 2) * 2 .NE. K(J)) B = 1
 
           IF (A .NE. 0 .OR. B .NE. 0) THEN
             RR1 = FHK(J)
 
 
             DO 10 I=1,NREF
               IF (H(I) .NE. 0 .OR. K(I) .NE. 0) THEN
                 IF (I .NE. J) THEN
                   C = 0
                   D = 0
                   IF ((H(I) / 2) * 2 .NE. H(I)) C = 1
                   IF ((K(I) / 2) * 2 .NE. K(I)) D = 1
                   DET = A * D - B * C
                   IF ( ABS(DET) .eq. 1 ) THEN
                     UU = FHK(I) * RR1
                     IF (UU .GT. UBEST) THEN
                       UBEST = UU
                       I1 = J
                       I2 = I
                     END IF
                   END IF
                 END IF
               END IF
   10        END DO
           END IF
  100    END DO
         RETURN
       END
 
