C
C  Copyright (c) 1998 L. D. Marks
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
C
       SUBROUTINE STATER
         PARAMETER (NPT = 20000)
         REAL KURT
         DOUBLEPRECISION DD1, DD2, DD3, DD4
         PARAMETER (DD1 = 1.D0 / 20000., DD2 = 1.D0 / 20000., DD3 = 1.D0
     X       / 20000., DD4 = 1.D0 / 20000.)
C     Double check statistics
         write (6,*) 'Probing Statistics: use with great care or ignore'
         write (10,*)'Probing Statistics: use with great care or ignore'
         WRITE (6, *) '**********Ideal Symmetric Case***************'
         WRITE (10, *) '**********Ideal Symmetric Case***************'
         FMEAN = 0.
         SQUARE = 0.
         S1 = 0.
         DO   J=1,20000
           E = FLOAT (J) * 10.D0 * DD1
           IF (E .LT. 8.D0) THEN
             P = EXP (-E * E * 0.5D0)
             FMEAN = FMEAN + P * E
             SQUARE = SQUARE + P * E * E
             S1 = S1 + P
           END IF
         END DO
         FMEAN = FMEAN / S1
         SQUARE = SQRT (SQUARE / S1)
 
C     Get the STD, cube and fourth power
         STD = 0.
         CUBE = 0.
         FOURTH = 0.
         DO   J=1,20000
           E = FLOAT (J) * 10.D0 * DD2
           IF (E .LT. 8.D0) THEN
             P = EXP (-E * E * 0.5D0)
             DIFF = E - FMEAN
             STD = STD + DIFF * DIFF * P
             CUBE = CUBE + DIFF * DIFF * DIFF * P
             FOURTH = FOURTH + DIFF * DIFF * DIFF * DIFF * P
           END IF
         END DO
         STD = SQRT (STD / S1)
         SKEW = CUBE / ((STD * STD * STD) * S1)
         KURT = (-3.D0) + FOURTH / ((STD * STD * STD * STD) * S1)
         WRITE (6, 2) FMEAN, FMEAN / SQUARE
         WRITE (10, 2) FMEAN, FMEAN / SQUARE
    2    FORMAT(' Initial mean ',F12.5,' Mean of E        ',F9.4)
         WRITE (6, 3) STD, STD / SQUARE
         WRITE (10, 3) STD, STD / SQUARE
    3    FORMAT(' Initial std  ',F12.5,' Mean of STD of E ',F9.4)
         WRITE (6, 4) 'Skew', SKEW
         WRITE (6, 4) 'Kurtosis', KURT
         WRITE (10, 4) 'Skew', SKEW
         WRITE (10, 4) 'Kurtosis', KURT
    4    FORMAT(' Value of ',A,F9.4)
 
C     Double check statistics
C     Asymmetric Exponential case
         WRITE (6, *) '**********Ideal Asymmetric Case***************'
         WRITE (10, *) '**********Ideal Asymmetric Case***************'
         FMEAN = 0.
         SQUARE = 0.
         S1 = 0.
         DO   J=1,20000
           E = FLOAT (J) * 10.D0 * DD3
           IF (E .LT. 8) THEN
             P = E * EXP (-E * E)
             FMEAN = FMEAN + P * E
             SQUARE = SQUARE + P * E * E
             S1 = S1 + P
           END IF
         END DO
         FMEAN = FMEAN / S1
         SQUARE = SQRT (SQUARE / S1)
 
C     Get the STD, cube and fourth power
         STD = 0.
         CUBE = 0.
         FOURTH = 0.
         DO   J=1,20000
           E = FLOAT (J) * 10.D0 * DD4
           IF (E .LT. 8) THEN
             P = E * EXP (-E * E)
             DIFF = E - FMEAN
             STD = STD + DIFF * DIFF * P
             CUBE = CUBE + DIFF * DIFF * DIFF * P
             FOURTH = FOURTH + DIFF * DIFF * DIFF * DIFF * P
           END IF
         END DO
         STD = SQRT (STD / S1)
         SKEW = CUBE / ((STD * STD * STD) * S1)
         KURT = (-3.D0) + FOURTH / ((STD * STD * STD * STD) * S1)
         WRITE (6, 2) FMEAN, FMEAN / SQUARE
         WRITE (6, 3) STD, STD / SQUARE
         WRITE (6, 4) 'Skew', SKEW
         WRITE (6, 4) 'Kurtosis', KURT
         WRITE (10, 2) FMEAN, FMEAN / SQUARE
         WRITE (10, 3) STD, STD / SQUARE
         WRITE (10, 4) 'Skew', SKEW
         WRITE (10, 4) 'Kurtosis', KURT
         RETURN
       END
 
 
