      double precision function rpcale(fhk,fcalc,nref,i,rf)
C     Intensity Fix
C     Use approach that works in refinements, i.e. sum fcalc**2*wt/fobs**2*wt
C     This reduces emphasis on strong, badly measured reflections
      dimension fhk(*),fcalc(*)
      include 'RefineWts.h'
      double precision t1,t2,s1,s2,s3,s4,s5,scl,err
        logical robnod,rob_fit,dwref,robfm,nodd5
        common /fscom55/robnod,rob_fit,dwref,robfm,nodd5
      integer rh(2000),rk(2000),rl(2000)
      common /rscom4/rh,rk,rl
      integer ncont(20)
      dimension cell(6),tempf(20),aocc(20),zatom(20)
      common /sfcom2/aocc,zatom,forig,brownf,dmult,dmlt
      common /sfcom1/tempf,ncont,natomq,cell
      include 'Sfacts.h'
      double precision so1,so2,so3,so4,sc2
        COMMON /COPT/ATNUM, PATTC, ACTERM, FOM2
        real*8 sclwt(2000)
C
C       Calculate error-fit with constaint on intensity
       Include 'Conservep.h'

        err=0
        rf=0
        rsum1=0
        rsum2=0
        do j=1,nref
                t1=fhk(j)*fhk(j)
                t2=fcalc(j)*scl
                rf=rf+abs(t1-t2)*sclwt(j)
                rsum1=rsum1+t1*sclwt(j)
                rsum2=rsum2+t1*sclwt(j)
                err=err+abs(t1-t2)*sclwt(j)
      enddo
C       Intensity R1
        rf=rf/rsum1
        rpcale=err/rsum2
C
C       Second pass to print data out      
      open(unit=13,file='rbfit.dat')
      open(unit=33,file='rfit.dat')
      fmax=fmax/10.
      fmax=max(fmax,1e-4)
      write(13,*)'Output of fitted data, scaled by ',1./fmax
      if(ferr)then
         write(13,982)
      else
         write(13,98)
      endif
      write(33,*)'Output of fitted data, scaled by ',1./fmax
      write(33,981)
        ssm=0
        ss2=0
        ss3=0
        ss4=0
        ss1=0
      do j=1,nref
        t1=fhk(j)*fhk(j)
        t2=fcalc(j)*scl
        err=t2-t1
C        
      write(13,96)rh(j),rk(j),rl(j),t1/fmax,t2/fmax,
     1  err/fmax,err*rewt(j),1./rewt(j)/fmax
        q1=t1/fmax
        q2=t2/fmax
        if(.not.ferr)then
           q1=sqrt(q1)
           q2=sqrt(q2)
        endif
        qmax=max(q1,qmax)
        qmax=max(q2,qmax)
        write(33,96)rh(j),rk(j),rl(j),q1,q2,q1-q2
        err=err*rewt(j)
        ssm=ssm+err
        ss1=ss1+abs(err)
        t1=err*err
        ss2=ss2+t1
        ss3=ss3+t1*err
        ss4=ss4+t1*t1
      enddo
      write(33,96)0,0,0,qmax,qmax,0.
      close(unit=33)
C       Mean
        ssm=ssm/nref
C       Standard Deviation
        ss2=sqrt(ss2/nref)
C       Sum of absolute errors
        ss1=ss1/nref
        iss=1
        if(ss3.lt.1e-8)iss=-1
        ss3=iss*((abs(ss3)/nref)**(1./3.)/ss2)
C       Kurtosis
        ss4=(ss4/nref)**0.25/ss2-3
        write(13,99)'Mean ',ssm,' Abs ',ss1,' STD ',ss2,' Skew ',ss3,
     1 ' Kurt ',        ss4
99      format(a,f8.4,a,f8.4,a,f8.4,a,f8.4,a,f8.4,a,f8.4)

      write(13,97)'Intensity R1',rpcale,' R1 ',rf,' Scale ',scl
      if(dwref)then
      ndw=1
      do j=1,20
         if(zatom(j).gt.-0.1)then
         tempf(j)=tempf(1)
         write(13,92)'DW for atom ',sfacts(j),' is ',tempf(j)
         endif
      enddo
      endif
C      close(unit=13)
      return
92      format(a,a,a,f12.5)
96      format(3i4,12f12.6)
97      format(a,f12.5,a,f12.5,a,2f12.5)
98    format('   H   K   L      Iobs        Icalc       Diff',
     1       '      Diff/Sig      Sig')
981   format('   H   K   L      Fobs        Fcalc       Diff')
982   format('   H   K   L      Fobs        Fcalc       Diff',
     1       '      Diff/Sig      Sig')
       end
