C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
C
       PROGRAM MUTATE
 
C  mparam: maximal number of parameters
C  mnbits: maximal number of bits allowed to describe one parameter
C  mindiv: maximal number of chromosomes per population
C         PARAMETER (MPARAM = 80, MNBITS = 4, MINDIV = 1000)
        INCLUDE 'CrossPars.h'
C
C  Current limits
C     mparam to 30 - may need to be increased
C     mnbits to 10 - Increased from 8 to 10 for multislice use
C     Number of members 100 - Decreased from 120 to 100 to avoid
C                 memory problems after increasing mnbits
 
C  nndiv: number of chromosomes in one population
C  nchild: number of children
C  nndivc: number of chromosomes in one child population
C  totbit: total number of bits describing one chromosome
C  tnbit: total number of bits in the whole child generation
C  mrate: mutation rate (tnbit/mrate bits are mutated)
C  nmut: number of bits to be mutated
C  nparam: number of parameters
C  bitc(i,j): bit j in chromosome i in child generation
C  pind , pbit: pointer
C  fitc(i): fitness of chromosome i in child generation
C  dummy: dummy character
         INTEGER NCHILD, NNDIV, NNDIVC, TOTBIT, TNBIT, MRATE, NMUT
         INTEGER NPARAM
         INTEGER*2 BITC(4000,320)
         INTEGER PIND, PBIT
         REAL FITC(1000000)
         CHARACTER DUMMY*2
         REAL R(97), R1
         INTEGER IDUM, IX1, IX2, IX3, IFF
         REAL RR1, RR2
 
         OPEN (1, FILE='bithelp', STATUS='old')
         OPEN (2, FILE='lpop', STATUS='old')
C      open (3,file='prot',status='unknown')
         OPEN (9, FILE='mpop', STATUS='unknown')
         OPEN (5, FILE='control', STATUS='old')
         OPEN (12, FILE='random.hold')
 
   10    FORMAT(I4)
   20    FORMAT(F15.4,A2,200I1)
 
C======================================================================
C read in random number generator parameters from file 'random.hold'
C======================================================================
         READ (12, *) IX1, IX2, IX3, IDUM, IFF
         DO   I=0,31
           READ (12, *) (R(J), J=(I*3+1),(I*3+3))
         END DO
         READ (12, *) R(97)
 
C======================================================================
C read needed information from file 'bithelp'
C======================================================================
 
C      write (3,*)
C      write (3,*)
C      write (3,*) 'PROT file of program mutate'
C      write (3,*) '==========================='
C      write (3,*)
 
C total number of bits for one chromosome?
         READ (1, 10) TOTBIT
 
C total number of chromosomes in one population?
         READ (1, 10) NNDIV
 
C======================================================================
C read fitness and bitcode for all chromosomes of child generation
C======================================================================
 
C first read number of children and mutation rate from file 'control'
         READ (5, 10) NPARAM
         DO 150 I=1,NPARAM+3
           READ (5, *)
  150      CONTINUE
         READ (5, 10) NCHILD
         READ (5, 10) MRATE
 
 
         DO 100 I=1,NCHILD
           READ (2, 20) FITC(I), DUMMY, (BITC(I,J), J=1,TOTBIT)
  100      CONTINUE
         TNBIT = MAX0 (NCHILD, 1) * TOTBIT
 
 
C======================================================================
C perform mutation
C======================================================================
 
 
         IF (MRATE .NE. 0) THEN
C        no mutation if equal to zero
           RR1 = REAL (NCHILD)
           RR2 = REAL (TOTBIT)
 
C======================================================================
C start mutation loop
C 1/MRATE is the total mutation probability/individual
           DO 200 M=1,NCHILD,MRATE

C       Random number, 0-1
             CALL RANC1 (IX1,IX2,IX3,IDUM,IFF,R,R1)
C       Which individual
             PIND = 1 + AINT (R1 * RR1)
             PIND = MIN (PIND,NCHILD) 
C       Random number
             CALL RANC1 (IX1,IX2,IX3,IDUM,IFF,R,R1)
 
C       Random bit in individual
             PBIT = 1 + AINT (R1 * RR2)
             PBIT = MIN (PIND, TOTBIT) 
C       invert bit number pbit in chromosome number pind
             BITC(PIND,PBIT) = ABS (BITC(PIND,PBIT) - 1)
 
C end mutation loop
  200        CONTINUE
         END IF
C======================================================================
 
 
C======================================================================
C write mutated child population to file 'mpop'
C======================================================================
 
         DO 400 I=1,NCHILD
           WRITE (9, 20) FITC(I), DUMMY, (BITC(I,J), J=1,TOTBIT)
  400      CONTINUE
 
C======================================================================
C Save numbers for random number generator
C======================================================================
         REWIND (12)
         WRITE (12, *) IX1, IX2, IX3, IDUM, IFF
         DO   I=0,31
           WRITE (12, *) (R(J), J=(I*3+1),(I*3+3))
         END DO
         WRITE (12, *) R(97)
 
       END
 
 
C subroutine ranc1() is a random number generator care Numerical Recepies Book
C      double precision function ranc1(idum)
       SUBROUTINE RANC1 (IX1, IX2, IX3, IDUM, IFF, R, RANDOM )
         REAL R(97), RANDOM
         INTEGER IX1, IX2, IX3
         PARAMETER (M1 = 259200, IA1 = 7141, IC1 = 54773, RM1 = 1.D0 /
     X      259200)
         PARAMETER (M2 = 134456, IA2 = 8121, IC2 = 28411, RM2 = 1.D0 /
     X      134456)
         PARAMETER (M3 = 243000, IA3 = 4561, IC3 = 51349)
         IF (IDUM .LT. 0 .OR. IFF .EQ. 0) THEN
           IFF = 1
           IX1 = MOD (MOD (54773 - IDUM, 259200) * 7141 + 54773, 259200)
           IX2 = MOD (IX1, 134456)
           IX1 = MOD (IX1 * 7141 + 54773, 259200)
           IX3 = MOD (IX1, 243000)
           DO   J=1,97
             IX1 = MOD (IX1 * 7141 + 54773, 259200)
             IX2 = MOD (IX2 * 8121 + 28411, 134456)
             R(J) = (FLOAT (IX1) + FLOAT (IX2) * RM2) * RM1
           END DO
           IDUM = 1
         END IF
         IX1 = MOD (IX1 * 7141 + 54773, 259200)
         IX2 = MOD (IX2 * 8121 + 28411, 134456)
         IX3 = MOD (IX3 * 4561 + 51349, 243000)
         J = (IX3 * 97) / 243000 + 1
         IF (J .GT. 97 .OR. J .LT. 1) THEN
           WRITE (6, *) 'J is out of range, value ', J
C          PAUSE
         END IF
         RANDOM = R(J)
         IF (R(J) .GT. 1.D0) RANDOM = R(J) - INT (R(J))
         R(J) = (FLOAT (IX1) + FLOAT (IX2) * RM2) * RM1
         RETURN
       END
