c  This program is free software; you can redistribute it and/or modify
c  it under the terms of the GNU General Public License as published by
c  the Free Software Foundation; either version 2 of the License, or
c  (at your option) any later version.
c 
c  This program is distributed in the hope that it will be useful,
c  but WITHOUT ANY WARRANTY; without even the implied warranty of
c  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c  GNU General Public License for more details.
c 
c  You should have received a copy of the GNU General Public License
c  along with this program; if not, write to the Free Software
c  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
c 
c
c program sconf generates the start configuration for a genetic algorithm

      program randpop
C  mparam: maximal number of parameters
C  mnbits: maximal number of bits allowed to describe one parameter
C  mindiv: maximal number of chromosomes per population
C      parameter (mparam = 80 , mnbits =3 , mind2 =2000,mindiv=2000)
        INCLUDE 'CrossPars.h'
      parameter (ntry1 = 12)
         PARAMETER (M1 = 259200, IA1 = 7141, IC1 = 54773, RM1 = 1.D0 /
     X      259200)
         PARAMETER (M2 = 134456, IA2 = 8121, IC2 = 28411, RM2 = 1.D0 /
     X      134456)
         PARAMETER (M3 = 243000, IA3 = 4561, IC3 = 51349)

C
C  Current limits
C     mparam to 30 - may need to be increased
C     mnbits to 10 - Increased from 8 to 10 for multislice use
C     Number of members 100 - Decreased from 120 to 100 to avoid
C                 memory problems after increasing mnbits

c  nparam: number of parameters
c  nbits(i): number of bits describing parameter i
c  nindiv: number of chromosomes in one population
c  mbits: maximal number of bits describing one parameter
c  totbits: total number of bits describing all parameters in one chromosome
c  pow2(i): powers of 2
c  bit(i,j): bit no. j in parameter i of a chromosome
c  brange(i), erange(i): beginning and end of parameter range of parameter i
c  r1: number to initialize random number generation
c  actval , crit: help variables
      integer nparam  , nindiv , mbits , pow2(0:mnbits-1)
      integer bit(mparam*mnbits),bhold(mparam*mnbits,MINDIV*3)
      integer idist(MINDIV*3),bit2(mparam*mnbits) , nbits(mparam)
      integer totbits 
      integer itmp2(MINDIV*3),itmp(MINDIV*3)
      real brange(mparam) , erange(mparam)
      real r1 , randi(mparam) , actval , crit
      real r(97)
      integer*4 idum,ix1,ix2,ix3,iff
      dimension pzero(mparam*mnbits),izero(mparam*mnbits),
     1 ione(mparam*mnbits)
      integer ihold(mparam,mindiv*3),ibit2(mparam),ibit(mparam*mnbits)
      dimension xcf(-64:64)
      dimension rdist(mindiv*3)
      dimension rtmp2(mindiv*3),rtmp(mindiv*3)
      logical imode
      parameter (imode=.false.)
C      imode=.true.
C     Ring
      pi2=2.*acos(-1.0)
      do j=-64,64
C               This is the xcf distance/2 per parameter
                xcf(j)= (1-cos(j*pi2/16.))
      enddo


      open (1,file='control',status='old')
      open (2,file='population',status='unknown')
      open (11,file='bithelp',status='unknown')
      open (12,file='random.hold')

   10 format (i4,2f12.8)
   20 format (17a1,600i1)

c======================================================================
c readin needed information from file 'control'
c======================================================================

c number of parameters?
      read (1,10) nparam
 
c number of bits, range of every parameter?
      mbits = 0
      totbits = 0
      do 100 i=1,nparam
         read (1,10) nbits(i) , brange(i) , erange(i)
         if (nbits(i) .gt. mbits) then
            mbits = nbits(i)
         endif
         totbits = totbits + nbits(i)
100   continue

      write(11,10) totbits
      dest=sqrt(float(totbits))
      rrand=sqrt(float(nparam))


c number of chromosomes in one population?
      read (1,10) nindiv
c      write (3,*) 'number of chromosomes in one population ',nindiv

c initial value for random number generation
      read (1,*) idum
c skip a line, then read number of children - overwrite nindiv with this here
      read (1,*) junk
      read (1,*)nchild
      nindiv=nchild
C
C       Seed the random number generator
         READ (12, *) IX1, IX2, IX3, IDUM, IFF
         DO   I=0,31
           READ (12, *) (R(J), J=(I*3+1),(I*3+3))
         END DO
         READ (12, *) R(97)
C         IF (IDUM .LT. 0 .OR. IFF .EQ. 0) THEN
           IFF = 1
           IX1 = MOD (MOD (54773 - IDUM, 259200) * 7141 + 54773, 259200)
           IX2 = MOD (IX1, 134456)
           IX1 = MOD (IX1 * 7141 + 54773, 259200)
           IX3 = MOD (IX1, 243000)
           DO   J=1,97
             IX1 = MOD (IX1 * 7141 + 54773, 259200)
             IX2 = MOD (IX2 * 8121 + 28411, 134456)
             R(J) = (FLOAT (IX1) + FLOAT (IX2) * RM2) * RM1
           END DO
           IDUM = 1
C         END IF
        do j=1,totbits
                pzero(j)=0.5
                ione(j)=0
        enddo
        nmem=nindiv*3
c run loop over different chromosomes
        do 205 jq=1,nmem
        idist(jq)=5000
        rdist(jq)=5000
c       create a random number for every parameter
c       and translate the resulting parameter into a digital code
            do i=1,totbits
                        CALL RANC1 (IX1,IX2,IX3,IDUM,IFF,R,R1)
                        if(r1.gt.pzero(i))then
                                bhold(i,jq)=1
                                ione(i)=ione(i)+1
                        else
                                bhold(i,jq)=0
                        endif 
                        pzero(i)=float(ione(i))/float(jq)
                        ibit(i)=bhold(i,jq)
            enddo
C       Convert to integer and save
            call BitToInt(ibit,ibit2,nparam,nbits)
            do i=1,nparam
                        ihold(i,jq)=ibit2(i)
            enddo
C            write(77,777)(ibit2(i),i=1,nparam)
C777     format(80i2)
205   continue
C       Look at distance
        sum=0
        sumx=0
        if(nparam.gt.6)nparam2=nparam/2
        do jq=1,nmem-1
        do jk=jq+1,nmem
                ii=0
                do i=1,totbits
                if(bhold(i,jq).ne.bhold(i,jk))ii=ii+1
                enddo
                if(ii.lt.idist(jk))idist(jk)=ii
                if(ii.lt.idist(jq))idist(jq)=ii
                rd=0
                do i=1,nparam
                        ix=ihold(i,jq)-ihold(i,jk)
                        rd=rd+xcf(ix)
                enddo
                if(rd.lt.rdist(jk))rdist(jk)=rd
                if(rd.lt.rdist(jq))rdist(jq)=rd
        enddo
        sum=sum+idist(jq)
        sumx=sumx+rdist(jq)
C       write(17,*)sum/float(jq),idist(jq)
        enddo
        sum=sum+idist(nmem)
        sumx=sumx+rdist(nmem)
        destr=sumx/float(nmem)
        destn=sum/float(nmem)
        dtarg=min(destn+4,destn*1.3)*1.025
        dtarg=max(dest,dtarg)
        destr=sumx/float(nmem)
        drarg=max(rrand,drarg)
        drarg=min(destr+5,destr*1.5)*1.25

69      format(a,2F12.5)
68      format(30X,'    Bits        Angle'/a,2F12.5)
C        write(6,68)'R.M.S  population dispersion',dest,rrand
        write(6,68)'Random population dispersion',destn,destr
        write(6,69)'Estimated dispersion target ',dtarg,drarg
C        write(6,*)'Random population dispersion',destn,destr
C        write(6,*)'Estimated dispersion target ',dtarg
        dest=dtarg
C        destn=dtarg
        destr=drarg

c======================================================================
c create population
c======================================================================
        do j=1,totbits
                pzero(j)=0.5
                ione(j)=0
        enddo
        nmem=nindiv*3
        do j=1,nmem
                idist(j)=5000
                rdist(j)=5000
        enddo
        ngzerA=max(10,nmem/100)
        ngzerB=ngzerA*2
c run loop over different chromosomes
        ngot=0
C         ngf=0
C         inn=1
        do 200 jq=1,3
        if(jq.eq.1)then
                open(unit=2,file='pop_1')
        else if(jq.eq.2)then
                open(unit=2,file='pop_2')
        else
                open(unit=2,file='pop_3')
        endif
      do 200 j=1,nindiv
c         write (3,*) 'starting values for chromosome no. ',j
        itries=0
        ifound=0
        rfound=0

c       create a random number for every parameter
c       and translate the resulting parameter into a digital code
1001        ii=0
            do 210 i=1,totbits
                        CALL RANC1 (IX1,IX2,IX3,IDUM,IFF,R,R1)
                        if(r1.gt.pzero(i))then
                                bit(i)=1
                        else
                                bit(i)=0
                        endif                 
210         continue
C       Convert to integer
            call BitToInt(bit,ibit2,nparam,nbits)
            if(itries .eq. 0)then
                      do k=1,totbits
                         bit2(k)=bit(k)
                      enddo
            endif

C       Check this against previous members
        if(ngot.gt.0)then
                imn=1000
                rmn=1000
C               Calculate closest previous point
                do jt=1,ngot
                   rd=0
                   do k=1,nparam
                        ix=ibit2(k)-ihold(k,jt)
                        rd=rd+xcf(ix)
                   enddo
                   if(rd.lt.rmn)rmn=rd
                enddo
                itries=itries+1
C
C       Hold on to the best to date
          if(rmn.gt.rfound)then
                do k=1,totbits
                        bit2(k)=bit(k)
                enddo
                rfound=rmn
          endif
CI        if(imode)then
CI              if(imn.lt.dest+4.and.itries.lt.ntry1  )goto 1001
CI              if(imn.lt.dest+2.and.itries.lt.ntry1*2)goto 1001
CI                if(imn.lt.dest+1.and.itries.lt.ntry1*4)goto 1001
CI              if(imn.lt.dest  .and.itries.lt.ntry1*8)goto 1001
CI                if(imn.lt.dest-1.and.itries.lt.ntry1*16)goto 1001
CI        else
                a1=6
                a2=4
                n1m=15
                if(j .gt. 4000)then
                        a1=4
                        a2=2.5
                        n1m=8
                else if(j .gt. 2000)then
                        a1=5
                        a2=3
                        n1m=10
                endif         
C               Have we done enough ?
                if(rmn.lt.destr+a1.and.itries.lt.ntry1    )goto 1001
                if(rmn.lt.destr+a2.and.itries.lt.ntry1*2  )goto 1001
                if(rmn.lt.destr+2 .and.itries.lt.ntry1*4  )goto 1001
                if(rmn.lt.destr+1 .and.itries.lt.ntry1*6  )goto 1001
                if(rmn.lt.destr   .and.itries.lt.ntry1*8  )goto 1001
                if(rmn.lt.destr-1 .and.itries.lt.ntry1*n1m)goto 1001
CI        endif
        endif
C       Good enough, accept it
        if(ngot.gt.0)then
                do k=1,totbits
                        bit(k)=bit2(k)
                enddo
                rmn=rfound
        else
                rmn=5000
        endif

C        write(17,1701)'Accepted ',ngot+1,' distance ',imn,itries
C       Copy, and update counters
        ngot=ngot+1
        do k=1,totbits
                bhold(k,ngot)=bit(k)
                if(bit(k).eq.1)ione(k)=ione(k)+1
                pzero(k)=float(ione(k)+ngzerA)/float(ngot+ngzerB)
        enddo
        call BitToInt(bit,ibit2,nparam,nbits)
        do k=1,nparam
                ihold(k,ngot)=ibit2(k)
        enddo
c     write bit chain for present chromosome to file 'population'
         write (2,20) (' ',l=1,17),(bit(k),k=1,totbits)

200   continue
C       write(17,*)(ione(ii),ii=1,totbits)

1000  continue
C
C       Look at distance
        sum=0
        sumx=0
        do jq=1,nmen
           idist(jq)=5000
           rdist(jq)=5000
        enddo
        do jq=1,nmem-1
        do jk=jq+1,nmem
                ii=0
                do i=1,totbits
                if(bhold(i,jq).ne.bhold(i,jk))ii=ii+1
                enddo
                if(ii.lt.idist(jk))idist(jk)=ii
                if(ii.lt.idist(jq))idist(jq)=ii
                rd=0
                do i=1,nparam
                        ix=ihold(i,jq)-ihold(i,jk)
                        rd=rd+xcf(ix)
                enddo
                if(rd.lt.rdist(jk))rdist(jk)=rd
                if(rd.lt.rdist(jq))rdist(jq)=rd
        enddo
        sum=sum+idist(jq)
        sumx=sumx+rdist(jq)
C       write(17,*)sum/float(jq),idist(jq)
        enddo
        sum=sum+idist(nmem)
        sumx=sumx+rdist(nmem)
        rt=1./float(ngot)
        write(6,69)'Dispersion achieved         ',sum*rt,sumx*rt
C        write(6,*)'Dispersion achieved         ',sum/float(ngot)
C     Save parameters for random # generator (ix1,ix2,ix3,idum,iff,r(97))
         REWIND (UNIT=12)
         WRITE (12, *) IX1, IX2, IX3, IDUM, IFF
         DO   I=0,31
           WRITE (12, *) (R(J), J=(I*3+1),(I*3+3))
         END DO
         WRITE (12, *) R(97)
      end

       SUBROUTINE RANC1 (IX1, IX2, IX3, IDUM, IFF, R, RANDOM )
         REAL R(97), RANDOM
         INTEGER IX1, IX2, IX3
         PARAMETER (M1 = 259200, IA1 = 7141, IC1 = 54773, RM1 = 1.D0 /
     X      259200)
         PARAMETER (M2 = 134456, IA2 = 8121, IC2 = 28411, RM2 = 1.D0 /
     X      134456)
         PARAMETER (M3 = 243000, IA3 = 4561, IC3 = 51349)
C         IF (IDUM .LT. 0 .OR. IFF .EQ. 0) THEN
C           IFF = 1
C           IX1 = MOD (MOD (54773 - IDUM, 259200) * 7141 + 54773, 259200)
C           IX2 = MOD (IX1, 134456)
C           IX1 = MOD (IX1 * 7141 + 54773, 259200)
C           IX3 = MOD (IX1, 243000)
C           DO   J=1,97
C             IX1 = MOD (IX1 * 7141 + 54773, 259200)
C             IX2 = MOD (IX2 * 8121 + 28411, 134456)
C             R(J) = (FLOAT (IX1) + FLOAT (IX2) * RM2) * RM1
C           END DO
C           IDUM = 1
C         END IF
         IX1 = MOD (IX1 * 7141 + 54773, 259200)
         IX2 = MOD (IX2 * 8121 + 28411, 134456)
         IX3 = MOD (IX3 * 4561 + 51349, 243000)
         J = (IX3 * 97) / 243000 + 1
C         IF (J .GT. 97 .OR. J .LT. 1) THEN
C           WRITE (6, *) 'J is out of range, value ', J
C           PAUSE
C         END IF
         RANDOM = R(J)
         IF (R(J) .GT. 1.) RANDOM = R(J) - INT (R(J))
         R(J) = (FLOAT (IX1) + FLOAT (IX2) * RM2) * RM1
         RETURN
       END
C
        subroutine BitToInt(bit,ibit,nparam,nbit)
        integer bit(*),ibit(*),nbit(*)
c       Convert bit-string to a number between 0-15
        kk=0
        do k=1,nparam
           iactval = 0
           ii=1
           do j=nbit(k),1,-1
                  iactval = iactval + bit(j+kk)*ii
                  ii=ii*2
           enddo
           kk=kk+nbit(k)
           ibit(k)=iactval*16/ii
        enddo
        return
        end

