        subroutine trapdiv(bit,pmark1,pmark2,dmark,totbit,iflag)
C
C  Copyright (c) 2003 L. D. Marks
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
        integer pmark1,pmark2,dmark,totbit
C  mparam: maximal number of parameters
C  mnbits: maximal number of bits allowed to describe one parameter
C  mindiv: maximal number of chromosomes per population
C      parameter (mparam = 80 , mnbits =4 , mind2 =2000,mindiv=2000)
        INCLUDE 'CrossPars.h'
C
C  Current limits
C     mparam to 30 - may need to be increased
C     mnbits to 10 - Increased from 8 to 10 for multislice use
C     Number of members 100 - Decreased from 120 to 100 to avoid
C                 memory problems after increasing mnbits

        integer bit(mindiv,mparam*mnbits)
        logical before, after
        iflag=0
        before=.false.
        after=.false.
c       First, check that bits before/after are different
        do j=1,dmark
                if(bit(pmark1,j).ne.bit(pmark2,j))then
                        before=.true.
                        goto 10
                endif
        enddo 
10      do j=dmark+1,totbit
                if(bit(pmark1,j).ne.bit(pmark2,j))then
                        after=.true.
                        goto 20
                endif
        enddo
20      continue
c       If both before and after are different, OK to cross
        if(before.and.after)return
c       If both are the same, get a different parent
        if((.not.before).and.(.not.after))then
                iflag=2
        else
c       Only one is different, so get another dividing point
                iflag=1
        endif
        return
        end
