C
C  Copyright (c) 1998 L. D. Marks
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
C
       PROGRAM DIV2D
C
C     This code tries to do a divergence test with the strongest beams
C
C
C         PARAMETER (NBEAMS = 256, NHK = 900, NBB = 80)
         Include 'Nbeams.h'
         include 'NewIncludes.h'
         include 'NewStuff.h'
         include 'TModel.h'
         include 'Xray.h'
         DIMENSION LL(9), M(3), L(900)
         COMMON /TDATA/LL, NDIMM, MDIMM, AB, D2, THETA, NSLICE
         COMMON /DBTERM/BTEMP
         include 'Nlimit.h'
C         PARAMETER (NHK2 = 900, NLIMIT = 65536)
         LOGICAL PRINTF
         COMMON /PRINTS/PRINTF
         DIMENSION WINWTS(NHK2)
         COMMON /FOM5/WINWTS
         LOGICAL PWMASK, EOPT, PWACC, PMACC
         COMMON /WALSH/PWMASK, EOPT, PWACC, PMACC
         LOGICAL CENTRO
         COMMON /CCENTR/CENTRO
C     data centro /.false./
         COMMON /ERRTRY/NWOPT
         COMMON /ENTC2D/RAD1, RAD2
 
C     For tuning
         LOGICAL TLOG(6)
         DIMENSION FTUNE(4)
         COMMON /TUNING/TLOG, FTUNE
         LOGICAL WTSON, WT2ON, TESTP3
         DIMENSION WTS(NHK2), EWTS(NHK2), MULTI(NHK2)
         DIMENSION WPOS(NHK2)
         COMMON /WPOSC/WPOS
         COMMON /WCOM/WTS, WTSON, MODE
         COMMON /WCOM2/EWTS, WT2ON
         COMMON /MPCOMM/MULTI
         COMMON /ECALC/SFERR1, ANGERR, SFERR2
         COMMON /PADCMM/NPAD
         COMMON /FOMALL/ER1, EI1, EC1, F0PASS
         INTEGER NCONT(20)
         DIMENSION CELL(6), TEMPF(20), AOCC(20), ZATOM(20)
         LOGICAL FORIG, FSEMP, BROWNF, DMULT, DMLT, FOM2
         Include 'Sfacts.h'
         COMMON /SFCOM1/TEMPF, NCONT, NATOM, CELL
         COMMON /SFCOM2/AOCC, ZATOM, FORIG, BROWNF, DMULT, DMLT
         COMMON /MVIS/WIDTH, HEIGHT, TIMES, FSEMP
         COMMON /COPT/ATNUM, PATTC, ACTERM, FOM2
         DIMENSION FSTEST(20)
         COMMON /COPT2/FSTEST
         INTEGER LAT(2)
         COMMON /CLAT/LAT
 
         PARAMETER (NMAX = nlimit)
         DIMENSION VV(nmax*2), F(nmax*2)
         DIMENSION S(1), IS(1)
         INTEGER HE(20), KE(20), ISE(20)
 
         DIMENSION IH(NHK2),K(NHK2),WORK(NHK2),WTSS(NHK2),FHK(NHK2),AHK(
     X     NHK2),AIN(NHK2),BWT(NHK2),LNEW(NHK2), IND(NHK2), NSTATS(10),
     X      ASTORE(NHK2),WNEW(NHK2),MULT(NHK2),IHNEW(NHK2),KNEW(NHK2),
     X      FNEW(NHK2),ENEW(NHK2), ANEW(NHK2)
         CHARACTER*80 CDNAME
         DIMENSION F2(6000)
         CHARACTER*4 SYMM
         LOGICAL FLAGS, FNORM, PMASK
         CHARACTER*50 FORMT
         SAVE F2, ANEW, ENEW, KNEW, IHNEW, LNEW, AIN, K, IH, F, /COPT2/
     X      , /COPT/ , /MVIS/ , /SFCOM2/ , /SFCOM1/ , /FOMALL
     X      / , /MPCOMM/ , /WCOM2/ , /WCOM/ , /FOM5/
         DOUBLEPRECISION DD1, DD2, DD3, DD4, DD5, DD6, DD7, DD8
         PARAMETER (DD1 = -0.5D0, DD2 = -0.5D0, DD3 = -0.5D0, DD4 = -
     X      0.5D0, DD5 = -0.5D0)
         PARAMETER (DD6 = -0.5D0, DD7 = 1.D0 / 8.D0, DD8 = 1.D0 / 8.D0)
C         INTEGER II1, II2, II3
C         REAL RR1, RR2, RR3, RR4
         DOUBLE PRECISION DD9
         LOGICAL LL1, LL2, LL3, LL4
         DIMENSION R(97)
C
         FORMT = '((20f9.5))     '
 
C     get the input as arguement
         CALL UOPEN2 (3)
 
C      READ(2,5) CDNAME
    5    FORMAT(A)
   55    FORMAT(A,A)
         CALL BOPT (PCOR,SYMM,MODE,IOPT,PMASK,PCORM,XRAY,CDNAME,NCON,
     X      CVAR)
         WRITE (10, 501)  'Title is: ',CDNAME
501     format(5a)
 
C      read(2,5)symm
C      READ(2,*)NREF,NCON,cvar,nsam,nlow,pcor,expand
  140    FORMAT(6I6,1X,A20)
  141    FORMAT(A)
C     cflag, to control retaining values
         IF (CVAR .GT. 0) THEN
           WRITE (10, *) 'Changing all values except 0,0'
         ELSE
           WRITE (10, *) 'Changing only unknowns'
         END IF
 
         WTSON = .FALSE.
 
C      WRITE(10,27)NREF
C      WRITE(6,27)NREF
   27    FORMAT(/'NUMBER OF REFLECTIONS IS ',I5/)
 
         CENTRO = .FALSE.
C      printf=.true.
         ACONV = 90.D0 / ASIN (1.D0)
         IF (SYMM .EQ. 'p3mt') SYMM = 'p6mm'
         IF (PRINTF) WRITE (10, 48)
         IF (PRINTF) WRITE (6, 48)
   48    FORMAT('Input Data:'/,'    H    K    L    FHK        Angle')
C  Do an unformatted read of the data
         I0 = (-1)
         NREF = 0
         DO   I=1,9999
           EWTS(I) = 0.
           IF( WT2ON ) THEN
           READ (2, *, END=1777, ERR=1777) IH(I), K(I), L(I), FHK(I),
     X        AIN(I),EWTS(I)
           ELSE
           READ (2, *, END=1777, ERR=1777) IH(I), K(I), L(I), FHK(I),
     X        AIN(I)
           ENDIF
           NREF = NREF + 1
           IF (IH(I) .EQ. 0 .AND. K(I) .EQ. 0) I0 = I
           AHK(I) = AIN(I)
           IF (PRINTF) WRITE (10, 49) IH(I), K(I), L(I), FHK(I), AHK(I)
           IF (PRINTF) WRITE (6, 49) IH(I), K(I), L(I), FHK(I), AHK(I)
           AHK(I) = AHK(I) / ACONV
         END DO
 1777    IF (I0 .LT. 0) THEN
           I0 = NREF + 1
           NREF = NREF + 1
           IH(NREF) = 0
           K(NREF) = 0
           L(NREF) = 0
           FHK(NREF) = 1.
           AHK(NREF) = 360.D0 / ACONV
         END IF
   49    FORMAT(3I5,5F11.5,F10.4,5F11.5)
C     For p3 cases, reduce h,k
         IF (SYMM(1:2) .EQ. 'p3' .OR. SYMM(1:2) .EQ. 'p6') THEN
           DO   J=1,NREF
             KLOW = 9999
             INDD = 1
             CALL EQUIV2 (HE,KE,ISE,IH(J),K(J),NE,SYMM)
             DO   JJ=1,NE
               IF (ISE(JJ) .GT. 0) THEN
                 IF (ABS (KE(JJ)) .LT. KLOW) THEN
                   KLOW = ABS (KE(JJ))
                   INDD = JJ
                 ELSE IF (ABS (KE(JJ)) .EQ. KLOW) THEN
                   IF (HE(JJ) .GT. HE(INDD)) INDD = JJ
                 END IF
               END IF
             END DO
             IH(J) = HE(INDD)
             K(J) = KE(INDD)
           END DO
         END IF
 
C     General Normalization Code for X-ray or Electrons
C     Ensure that power=1 for divergence
      power=-1
 
C     write(10,*)' '
C           Normalization
C     Note: get scaler here
         ISCALE = 1
         IF (IH(1) .EQ. 0 .AND. K(1) .EQ. 0) ISCALE = 2
 9901    CONTINUE
         IF (FHK(ISCALE) .LT. 1D-8) THEN
           ISCALE = ISCALE + 1
           GO TO 9901
         END IF
C
        INCLUDE 'NewNorm.h' 
C 
         F0PASS = SQRT (F0)
C     if(fstest(15).gt.0)call  tpos2D(IH,K,symm,vv,m)
 
C     Debug
         WRITE (6, *) 'Sorting data on F(H,K) with multiplicity'
C     Sort, including multiplicity, on Straight F(H,K)
         ANGV = 90.D0 / ASIN (1.D0)
C         IF (ANGV .NE. 0.) THEN
           DD9 = 360.D0 / ANGV
C         END IF
         DO   J=1,NREF
C     trap -- make 0,0 360 for later
           IF (IH(J) .EQ. 0 .AND. K(J) .EQ. 0) THEN
             AHK(J) = DD9
           END IF
           CALL EQUIV2 (HE,KE,ISE,IH(J),K(J),NE,SYMM)
           WORK(J) = FHK(J) * WTS(J) !*NE
           MULTI(J) = NE
         END DO
         NRR = NREF
         CALL SFHK (WORK,NHK2,VV,IND,NRR,NSTATS)
         LL1 = PCOR .GT. 1D-3
C     angle conversion back to degrees
 
C     Output in decreasing order including multiplicity etc
C       WRITE(9,55)CDNAME(1:60),' -- F(H,K) Sorted'
C      write(9,5)symm
C      write(9,*)NREF,NCON,cvar,nsam,nlow,pcor,expand
         DO   J=1,NREF
           IF (IH(IND(J)) .NE. 0 .OR. K(IND(J)) .NE. 0) THEN
             AUSE = AHK(IND(J)) * ANGV
             IAUSE = NINT(AUSE)
             IF (abs(AUSE-IAUSE).lt.1d-5)AUSE=IAUSE
             IF (LL1) THEN
               WRITE (9, 91) IH(IND(J)), K(IND(J)), L(IND(J)), FHK(IND(J
     X            )) * WTS(IND(J)), AUSE
             ELSE
               WRITE (9, 91) IH(IND(J)), K(IND(J)), L(IND(J)), FHK(IND(J
     X            )), AHK(IND(J)) * AUSE
             END IF
           END IF
         END DO
 
C     Sort, including multiplicity, now on E values with window
         WRITE (6, *) 'Sorting data on E(H,K) '
         DO   J=1,NREF
           CALL EQUIV2 (HE,KE,ISE,IH(J),K(J),NE,SYMM)
           if(divu2)then
                WORK(J) = FHK(J)
           else if (divu)then
                work(j) = FHK(J)*WINWTS(J)
           else
                WORK(J) = FHK(J)* NE
           endif
           MULTI(J) = NE
         END DO
         NRR = NREF
         CALL SFHK (WORK,NHK2,VV,IND,NRR,NSTATS)
C     angle conversion back to degrees
         ANGV = 90.D0 / ASIN (1.D0)
 
C     Output in decreasing order including multiplicity etc
C      WRITE(8,55)CDNAME(1:60),' -- U(H,K) Sorted'
C      write(8,5)symm
C      write(8,*)NREF,NCON,cvar,nsam,nlow,pcor,expand
         IF (WT2ON) THEN
           LL2 = PCOR .GT. 1D-3
           DO   J=1,NREF
             IF (IH(IND(J)) .NE. 0 .OR. K(IND(J)) .NE. 0) THEN
             AUSE = AHK(IND(J)) * ANGV
             IAUSE = NINT(AUSE)
             IF (abs(AUSE-IAUSE).lt.1d-5)AUSE=IAUSE
               IF (LL2) THEN
                 WRITE (8, 91) IH(IND(J)), K(IND(J)), L(IND(J)), FHK(IND
     X              (J)) * WTS(IND(J)), AUSE, 1.D0 / EWTS(
     X              IND(J))
               ELSE
                 WRITE (8, 91) IH(IND(J)), K(IND(J)), L(IND(J)), FHK(IND
     X              (J)), AUSE, 1.D0 / EWTS(IND(J))
               END IF
             END IF
           END DO
         ELSE
           LL3 = PCOR .GT. 1D-3
           DO   J=1,NREF
             IF (IH(IND(J)) .NE. 0 .OR. K(IND(J)) .NE. 0) THEN
             AUSE = AHK(IND(J)) * ANGV
             IAUSE = NINT(AUSE)
             IF (abs(AUSE-IAUSE).lt.1d-5)AUSE=IAUSE
               IF (LL3) THEN
                 WRITE (8, 91) IH(IND(J)), K(IND(J)), L(IND(J)), FHK(IND
     X              (J)) * WTS(IND(J)), AUSE
               ELSE
                 WRITE (8, 91) IH(IND(J)), K(IND(J)), L(IND(J)), FHK(IND
     X              (J)), AUSE
               END IF
             END IF
           END DO
         END IF
 
C     Remove the window here
         DO   J=1,NREF
           IHNEW(J) = IH(IND(J))
           KNEW(J) = K(IND(J))
           LNEW(J) = L(IND(J))
           FNEW(J) = FHK(IND(J)) * WINWTS(IND(J))
           ANEW(J) = AHK(IND(J))
           WNEW(J) = WTS(IND(J))
           ASTORE(J) = MULTI(IND(J))
           ENEW(J) = EWTS(IND(J))
         END DO
 
         DO   J=NREF+1,NPAD
           II1 = IH(J)
           II2 = K(J)
           II3 = MULTI(J)
           IHNEW(J) = II1
           KNEW(J) = II2
           LNEW(J) = 0
           FNEW(J) = 0.
           ANEW(J) = 0.
           ASTORE(J) = II3
         END DO
 
 

C     Let's try some analysis of the data
         OPEN (UNIT=10, FILE='Divergence.log')
         WRITE (6, *) 'Looking at statistics....'
         CALL ECONT (FNEW,ASTORE,IHNEW,KNEW,NREF,SYMM)
C     Debug
         WRITE (6, *) 'Looking for Sigma-1 relationships.....'
         CALL SIGMA1 (ASTORE,IHNEW,KNEW,NREF,SYMM,VV)
         WRITE (6, *) 'Looking for Missing Beam Sigma-1.....'
         CALL SGM1M (ASTORE,IHNEW,KNEW,NREF,SYMM,VV)
         CALL LattCon(IHNEW, KNEW, ASTORE, SYMM, NREF)

C     Debug
         WRITE (6, *) 'Looking at divergence map.....(slow)'
         CALL CNTRD (SYMM)
C       Some parameters to calculate the spacings
         PF = ASIN (1.D0) / 90.d0
C       Axis angle in radians
         GAMMA = (180-CELL(6)) * PF
C       Reciprocal lattice vectors
         ASTAR= 1./(CELL(1)*SIN(GAMMA))
         BSTAR= 1./(CELL(2)*SIN(GAMMA))
         D11=ASTAR*ASTAR
         D22=BSTAR*BSTAR
         D12=ASTAR*BSTAR*2.*COS(GAMMA)
C         write(77,*)astar,bstar,d11,d12,d22
         DO   J=1,NREF
           FNEW(J) = FHK(IND(J))
           IHNEW(J) = IH(IND(J))
           KNEW(J) = K(IND(J))
           LNEW(J) = L(IND(J))
           ANEW(J) = AHK(IND(J))
           CALL EQUIV2 (HE,KE,ISE,IH(IND(J)),K(IND(J)),NE,SYMM)
           BWT(J) = 1.
C       Multiplicity weighting
           if(divne)BWT(J) = SQRT ( FLOAT(NE))
C       Prefer 180/360 beams
           if((dsym).and.(ISE(1).eq.3))BWT(J)=BWT(J)*1.5
C       Reciprocal spacing
           RVAL = IHNEW(J)*IHNEW(J)*D11 + KNEW(J)*KNEW(J)*D22
     1          + IHNEW(J)*KNEW(J)*D12
C       Prefer spacings around 2.25 Angstroms
           RTMP1 = 0.2
           DECAY = 2.0
           Base1=0.25
           Base2=2.0
C       Test 1, prefer spacings up to 1 Angstroms
           IF(DIVT1) then
                Base1=0.25
                Base2=1.0
                DECAY=0
           endif
C       Test 2, more emphasis on lower values
           if(divt2)then
                base1=0.0
                base2=3.0
                DECAY=5.0
                rtmp1=0.1
           endif 
           RVAL1 = max(rval-RTMP1,0.)
           RVAL2 = BASE1 + BASE2*exp (-DECAY*RVAL1)
C           write(27,*)IHNEW(J),KNEW(J),RVAL,RVAL1,RVAL2,BWT(J)
           BWT(J)=BWT(J)*RVAL2
C           write(77,*)ihnew(j),knew(j),rval2,rval
C
C           IF (DMLT) BWT(J) = SQRT (FLOAT (NE))
C           IF (ISE(1) .EQ. 3 .AND. DMULT) BWT(J) = BWT(J) * 2.
         END DO
         IF (BROWNF) THEN
           CALL BRWNIE (IHNEW,KNEW,BWT,FNEW,SYMM,NREF,NPAD)
         ELSE IF ((LAT(1) .GT. 0) .AND. (LAT(2) .GT. 0)) THEN
           CALL BRNLAT (IHNEW,KNEW,BWT,FNEW,SYMM,NREF,NPAD)
         END IF

C         CALL CMAPR (VV,S,IS,M,IOPT,256,65536,FNEW,IHNEW,KNEW,NREF,SYMM,
C     X      IND,ANEW,BWT,F0,ICONT)
         IF(DIVU) THEN
         CALL CMAPS (VV,S,IS,M,IOPT,256,nmax,FNEW,IHNEW,KNEW,NREF,SYMM,
     X      IND,ANEW,BWT,F0,ICONT)
         IT1=0
         IT2=NREF+1
         DO I=1,NREF
                IF(abs(ANEW(I)) .gt. 1e-2)then
                   IT2=IT2-1     
                   IND(IT2)=I
                ELSE
                   IT1=IT1+1
                   IND(IT1)=I
                ENDIF
C                write(99,*)i,iHNEW(I),KNEW(I),IND(I)
         ENDDO
         ELSE
         CALL CMAPR (VV,S,IS,M,IOPT,256,65536,FNEW,IHNEW,KNEW,NREF,SYMM,
     X      IND,ANEW,BWT,F0,ICONT)
         ENDIF
C        IF (ICONT .LT. 10) ICONT = MIN(10,NREF)
C     Debug
C     Output in decreasing order including multiplicity etc
         ABASE = (-4.)
C      WRITE(7,55)CDNAME(1:60),' -- Divergence Sort'
C      write(7,5)symm
C      write(7,*)NREF,NCON,cvar,nsam,nlow,pcor,expand
C      Initialize random number
         IDUM=-1
         OPEN (UNIT=11, FILE='control.frame')
         OPEN (UNIT=12, FILE='control.suggested')
         NBIT = 0
         WRITE (12, 103) ICONT, '       nparam: number of parameters '
         LL4 = PCOR .GT. 1D-3
         DO   J=1,NREF
C           ICC=1
C           III=IND(J)
C           write(98,*)J,III,IHNEW(III),KNEW(III)
           ANG = ANEW(IND(J)) * ANGV
             IAUSE = NINT(ANG)
             IF (abs(ANG-IAUSE).lt.1d-5)ANG=IAUSE
           IF (ABS ((-360.D0) + ANEW(IND(J)) * ANGV) .LT. 0.1D0) ANG =
     X        360.
           IF (ABS (ANG) .LT. 0.1D0) ANG = 0.
           IF (IHNEW(IND(J)) .NE. 0 .OR. KNEW(IND(J)) .NE. 0) THEN
             IF (LL4) THEN
               WRITE (7, 91) IHNEW(IND(J)), KNEW(IND(J)), LNEW(IND(J)),
     X            FNEW(IND(J)) * WNEW(IND(J)), ANG !, ENEW(IND(J))
             ELSE
               WRITE (7, 91) IHNEW(IND(J)), KNEW(IND(J)), LNEW(IND(J)),
     X            FNEW(IND(J)), ANG
             END IF
             IF (J .LE. 80) THEN
               CALL EQUIV2 (HE,KE,ISE,IHNEW(IND(J)),KNEW(IND(J)),NE,SYMM
     X            )
               IF (ISE(1) .EQ. 3) THEN
                 NBIT = NBIT + 1
                 WRITE (11, 101) IHNEW(IND(J)), KNEW(IND(J)), LNEW(IND(J
     X              )), NBIT
                 IF (J .LE. ICONT) THEN
                   WRITE (12, 101) IHNEW(IND(J)), KNEW(IND(J)), LNEW(IND
     X                (J)), NBIT
                   ICC = NBIT
                 END IF
               ELSE
                 AUP = 315.
                 NBIT = NBIT + 3
                 ABASE = 9 + ABASE
                 IF (ABASE .GT. 42) ABASE = 5.
C                 call RANC1 (IX1, IX2, IX3, IDUM, IFF, R, RANDOM )
C                 ABASE= 5+RANDOM*45.0
C                 ABASE = NINT (ABASE)
C     Specify enantiomorph ?
                 IF (FORIG .AND. (SYMM(1:3) .EQ. 'p3 ' .OR. SYMM
     X               .EQ. 'p3m1')) THEN
                   JJ=IND(J)
                   CALL EQUIV2 (HE,KE,ISE,IHNEW(JJ),KNEW(JJ),NE,
     X               SYMM)
                   TEST1 = IHNEW(JJ)/3.+KNEW(JJ)*2./3.
                   TEST2 = IHNEW(JJ)*2./3.+KNEW(JJ)/3.
                   IT1 = NINT(TEST1)
                   IT2 = NINT(TEST2)
                   TESTP3=.TRUE.
C                   write(6,*)Test1,test2,testp3,ise(1),ihnew(
                   IF((abs(IT1-TEST1).LT.1E-4) .and.
     x                  (ABS(IT2-TEST2).LT.1E-4))TESTP3=.FALSE.
                   IF((ISE(1) .NE. 3) .AND. TESTP3) THEN
                     NBIT = NBIT - 2
                     AUP = 30.
                     ABASE = 360-45.
                     FORIG = .FALSE.
                   END IF
                 END IF
                 IF (AUP .GT. 140) THEN
                   WRITE (11, 102) ABASE, ABASE + AUP, IHNEW(IND(J)),
     X                KNEW(IND(J)), LNEW(IND(J)), NBIT
                   IF (J .LE. ICONT) THEN
                     WRITE (12, 102) ABASE, ABASE + AUP, IHNEW(IND(J)),
     X                  KNEW(IND(J)), LNEW(IND(J)), NBIT
                     ICC = NBIT
                   END IF
                 ELSE
                   WRITE (11, 192) ABASE, ABASE + AUP, IHNEW(IND(J)),
     X                KNEW(IND(J)), LNEW(IND(J)), NBIT
                   IF (J .LE. ICONT) THEN
                     WRITE (12, 192) ABASE, ABASE + AUP, IHNEW(IND(J)),
     X                  KNEW(IND(J)), LNEW(IND(J)), NBIT
                     ICC = NBIT
                   END IF
                 END IF
               END IF
             END IF
           END IF
         END DO
C         IF (CENTRO) THEN
C           NNDIV = ICONT * 15
C         ELSE
           NNDIV = ICONT * 8 + 200 + ICONT*ICONT/5
           IF(ICONT .LT. 10) NNDIV=ICONT*15
           if (.not.centro) NNDIV = NNDIV + ICC*3
C         END IF
         NNDIV = NINT (NNDIV /9.d0) * 10
         NNDIV = MIN (NNDIV, 990)
C        Use maximum number
         IF(DBIG)NNDIV = 990
         NSURV = NINT(NNDIV/7.)
C         if(.not.centro)NSURV=NINT(NNDIV/10.)
         NSURV = (NSURV/10)*10+10
         NSURV = MAX(20,NSURV)
         NSEED = NSURV
         WRITE (12, 103) NNDIV, '       nindiv: # of individuals'
         WRITE (12, 104) '  -1       idum:     Random Number Seed'
         IF(ICONT .LT. 10)then
           ICC=MAX(20,NSURV/2)
           write (12, 104)
     X        '  24       npop:   # number of populations'
         ELSE IF (CENTRO) THEN
           ICC=max(ICONT*2,15)
           WRITE (12, 104)
     X        '  36       npop:   # number of populations'
         ELSE
           ICC=max(ICONT*2,30)
C           NSURV=MAX(20,NSURV/2)
           NSEED=NSURV
           WRITE (12, 104)
     X        '  36       npop:     maximum # of populations'
         END IF
         NSAVE=200
C        Mutation rate, 2.5%
         ICC=40
         WRITE (12, 103) NNDIV, '       nchild: # children'
         WRITE (12, 103) 40, '       mrate:  # Probability/member 2.5%'
         WRITE (12, 103) NSURV, '       nsurv:  # survivors'
         WRITE (12, 104) ' 1.0       tension:  weight for children'
         WRITE (12, 103) NSEED, '       seed:     Re-seeding rate'
         WRITE (12, 103) NSAVE, '       nsave:  # of solutions to keep'
  104    FORMAT(A)
 
 
         STOP
   91    FORMAT(2X,3I5,2X,F12.8,2X,2F11.6)
  191    FORMAT(2X,3(I5,' , '),F12.6,' , ',F12.6)
  101    FORMAT('   1180.0000    360.0000      Beam ',3I4,' bits ',I3)
  102    FORMAT('   3',F8.4,'    ',F8.4,'      Beam ',3I4,' bits ',I3)
  103    FORMAT(I4,A)
  192    FORMAT('   1',F8.4,'    ',F8.4,'      Beam ',3I4,' bits ',I3)
 9002    FORMAT(A,3('(',I2,',',I2,')'),A,I3,A,F12.8)
       END
       INCLUDE '../Genf77new/ranc1.f'
 
