C 
C  Copyright (c) 1998 L. D. Marks
C 
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C 
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C 
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C 
C
      subroutine scattf5(cx,xi,yi,zz,csymb,nscatt)
C     Adapted from LAZY-PULVERIX                                             
C     The purpose of this program is to calculate the x-ray                     
C     atomic scattering factors from the Cromer and Mann constants              
C     in Table 2.2 B, vol. 4 of the International Tables of X-ray               
C     Crystallography 1974 Edition.   In addition the anomalous                 
C     dispersion coefficients for common x-ray tube energies can                
C     also be calculated. 
      integer asymb                                         
      CHARACTER*4 CHARSB,csymb                                               
      character*1 test(4)
      DIMENSION FA(4,8), FB(4,8), FC(8)
      real*8 xi(5),yi(5),sum,zz,cx
      COMMON /SCAT/ FA,FB,FC                                                    
      equivalence (asymb,test(1))
      equivalence (asymb,CHARSB)
      real xn(5),yn(5)
C
	CHARSB=csymb
C	Convert to upper case
	call upcase(CHARSB,4)
C	Do we have an ion ?
	ion=0
	do j=1,4
		if(charsb(j:j).eq.'+')ion=1
		if(charsb(j:j).eq.'-')ion=1
	enddo
C	Arun's added cases
	if(charsb(3:4).eq.'IN')ion=1	
	nscatt=5
C	Retrieve 5-parameter fit 
	call readsf(xn,yn,cxray,CHARSB,ifail)
C-----RETRIEVE CROMER-MANN COEFFICIENTS 
	if(ifail.eq.0)CHARSB(3:4)='  '
   	CALL FSC (ASYMB,1,zizz)
      	sum=0.d0
	if(ifail.lt.0)then
		nscatt=4                                     
      		do j=1,4
      			xi(j)=fa(j,1)
      			yi(j)=fb(j,1)
    			sum=sum+xi(j)
    		enddo
    	else
    		do j=1,5
      			xi(j)=xn(j)
      			yi(j)=yn(j)
    			sum=sum+xn(j)
    		enddo
		nscatt=5
 	endif                                                   
C
	zz=dble(nint(zizz))
C	Ensure neutrality here (not right for ions)
	if(ion.eq.0)then
C		write(6,*)'Correction cx for ',csymb
		cx=zz-sum
	else
C		write(6,*)'Found ion ',csymb
		cx=cxray
	endif
C
      return
C
C
      end                                                                       
