C 
C  Copyright (c) 1998 L. D. Marks
C 
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C 
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C 
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C 
C
      subroutine scattfi(cx,xi,yi,zz,csymb,charge)
C        Adapted from LAZY-PULVERIX                                             
C     The purpose of this program is to calculate the x-ray                     
C     atomic scattering factors from the Cromer and Mann constants              
C     in Table 2.2 B, vol. 4 of the International Tables of X-ray               
C     Crystallography 1974 Edition.   In addition the anomalous                 
C     dispersion coefficients for common x-ray tube energies can                
C     also be calculated.                                                       
      integer asymb                                         
      CHARACTER*4 CHARSB,csymb                                               
      character*1 test(4)
      DIMENSION FA(4,8), FB(4,8), FC(8),xi(4,-1:1),yi(4,-1:1),
     1 zz(-1:1),cx(-1:1)
      COMMON /SCAT/ FA,FB,FC                                                    
      equivalence (asymb,test(1))
      equivalence (asymb,CHARSB)
      logical arun,patest
      character*4 psymb(20)
      data nps/0/
      save nps,psymb
      CHARSB=csymb
      charge=0
C	Over-ride
10	open(unit=17,file=csymb)
	read(17,*)charge
	close(unit=17)
                                    
C
C-----RETRIEVE CROMER-MANN COEFFICIENTS for SI 
	CHARSB='SI  '                                       
 32   CALL FSC (ASYMB,1,zizz)                                                   
C
      sum=0.
      do 40 j=1,4
      xi(j,0)=fa(j,1)
      yi(j,0)=fb(j,1)
40    sum=sum+xi(j,0)
	cx(0)=zizz-sum
	zz(0)=zizz
C-----RETRIEVE CROMER-MANN COEFFICIENTS for AL 
	CHARSB='AL  '                                       
      CALL FSC (ASYMB,1,zizz)                                                   
C
      sum=0.
      do j=1,4
      xi(j,-1)=fa(j,1)
      yi(j,-1)=fb(j,1)
      sum=sum+xi(j,-1)
	enddo
	cx(-1)=zizz-sum
	zz(-1)=zizz
C-----RETRIEVE CROMER-MANN COEFFICIENTS for S 
	CHARSB='S   '                                       
      CALL FSC (ASYMB,1,zizz)                                                   
C
      sum=0.
      do j=1,4
      xi(j,1)=fa(j,1)
      yi(j,1)=fb(j,1)
      sum=sum+xi(j,1)
	enddo
	cx(1)=zizz-sum
	zz(1)=zizz

C
      return
C
C
      end                                                                       
