C
C  Copyright (c) 1998 L. D. Marks
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
C
       SUBROUTINE ASYMM (X, Y, NE, XT, YT, SYMM )
         CHARACTER*4 SYMM
         DIMENSION XE(12), YE(12), XT(*), YT(*)
         LOGICAL DIST
C         REAL RR1, RR2, RR3, RR4
         X = X - INT (X)
         Y = Y - INT (Y)
         IF (SYMM .EQ. 'c2mm') THEN
           CALL AC2MM (X,Y,NE,XE,YE)
         ELSE IF (SYMM .EQ. 'p2mm') THEN
           CALL AP2MM (X,Y,NE,XE,YE)
         ELSE IF (SYMM .EQ. 'pm  ' .OR. SYMM .EQ. 'p1m1') THEN
           CALL APM (X,Y,NE,XE,YE)
         ELSE IF (SYMM .EQ. 'cm  ' .OR. SYMM .EQ. 'c1m1') THEN
           CALL APM (X,Y,NE,XE,YE)
           DO   J=1,NE
C             RR1 = XE(J)
C             RR2 = YE(J)
             XE(J+NE) = XE(J) + 0.5D0
             YE(J+NE) = YE(J) + 0.5D0
           END DO
           NE = NE * 2
         ELSE IF (SYMM .EQ. 'p11m') THEN
           CALL APM (Y,X,NE,YE,XE)
         ELSE IF (SYMM .EQ. 'c11m') THEN
           CALL APM (Y,X,NE,YE,XE)
           DO   J=1,NE
C             RR3 = XE(J)
C             RR4 = YE(J)
             XE(J+NE) = XE(J) + 0.5D0
             YE(J+NE) = YE(J) + 0.5D0
           END DO
           NE = NE * 2
         ELSE IF (SYMM .EQ. 'p2  ') THEN
           CALL AP2 (X,Y,NE,XE,YE)
         ELSE IF (SYMM .EQ. 'pg  ' .OR. SYMM .EQ. 'p1g1') THEN
           CALL APG (X,Y,NE,XE,YE)
         ELSE IF (SYMM .EQ. 'p11g') THEN
           CALL APG (Y,X,NE,YE,XE)
         ELSE IF (SYMM .EQ. 'p1  ') THEN
           XE(1) = X
           YE(1) = Y
           NE = 1
         ELSE IF (SYMM .EQ. 'p2mg') THEN
           CALL AP2MG (X,Y,NE,XE,YE)
         ELSE IF (SYMM .EQ. 'p2gm') THEN
           CALL AP2MG (Y,X,NE,YE,XE)
         ELSE IF (SYMM .EQ. 'p2gg') THEN
           CALL AP2GG (Y,X,NE,YE,XE)
         ELSE IF (SYMM .EQ. 'p4  ') THEN
           CALL AP4 (X,Y,NE,XE,YE)
         ELSE IF (SYMM .EQ. 'p4mm') THEN
           CALL AP4MM (X,Y,NE,XE,YE)
         ELSE IF (SYMM .EQ. 'p4gm') THEN
           CALL AP4GM (X,Y,NE,XE,YE)
         ELSE IF (SYMM .EQ. 'p4mg') THEN
           CALL AP4GM (Y,X,NE,YE,XE)
         ELSE IF (SYMM .EQ. 'p3  ') THEN
           CALL AP3 (X,Y,NE,XE,YE)
         ELSE IF (SYMM .EQ. 'p31m') THEN
           CALL AP31M (X,Y,NE,XE,YE)
         ELSE IF (SYMM .EQ. 'p3m1') THEN
           CALL AP3M1 (X,Y,NE,XE,YE)
         ELSE IF (SYMM .EQ. 'p6mm') THEN
           CALL AP6MM (X,Y,NE,XE,YE)
         ELSE IF (SYMM .EQ. 'p6  ') THEN
           CALL AP6 (X,Y,NE,XE,YE)
         ELSE
           WRITE (6, *) 'Atom symmetry not there yet'
           CALL EXIT    (0)
         END IF
C     Safety check
         XT(1) = XE(1) - NINT (XE(1))
         YT(1) = YE(1) - NINT (YE(1))
         IF (NE .EQ. 1) RETURN
         DO   J=1,NE-1
           IF (XE(J) .GE. (-100)) THEN
             DO   K=J+1,NE
               IF (XE(K) .GE. (-100)) THEN
                 DX = XE(J) - XE(K)
                 DY = YE(J) - YE(K)
                 DX = DX - NINT (DX)
                 DY = DY - NINT (DY)
                 IF (DIST (DX,DY,0.1)) THEN
                   XE(K) = (-999.)
                   YE(K) = (-999.)
C           write(6,*)'Warning: duplicate ',xe(j),ye(j)
                 END IF
               END IF
             END DO
           END IF
         END DO
         JJ = 1
         DO   J=2,NE
           IF (XE(J) .GT. (-100)) THEN
             JJ = JJ + 1
             XT(JJ) = XE(J) - NINT (XE(J))
             YT(JJ) = YE(J) - NINT (YE(J))
           END IF
         END DO
         NE = JJ
         RETURN
       END
       SUBROUTINE ASYMM2 (X, Y, NE, XE, YE, SYMM )
         CHARACTER*4 SYMM
         DIMENSION XE(*), YE(*)
C         REAL RR1, RR2, RR3, RR4
         X = X - INT (X)
         Y = Y - INT (Y)
         IF (SYMM .EQ. 'c2mm') THEN
           CALL AC2MM (X,Y,NE,XE,YE)
         ELSE IF (SYMM .EQ. 'p2mm') THEN
           CALL AP2MM (X,Y,NE,XE,YE)
         ELSE IF (SYMM .EQ. 'pm  ' .OR. SYMM .EQ. 'p1m1') THEN
           CALL APM (X,Y,NE,XE,YE)
         ELSE IF (SYMM .EQ. 'cm  ' .OR. SYMM .EQ. 'c1m1') THEN
           CALL APM (X,Y,NE,XE,YE)
           DO   J=1,NE
C             RR1 = XE(J)
C             RR2 = YE(J)
             XE(J+NE) = XE(J) + 0.5D0
             YE(J+NE) = YE(J) + 0.5D0
           END DO
           NE = NE * 2
         ELSE IF (SYMM .EQ. 'p11m') THEN
           CALL APM (Y,X,NE,YE,XE)
         ELSE IF (SYMM .EQ. 'c11m') THEN
           CALL APM (Y,X,NE,YE,XE)
           DO   J=1,NE
C             RR3 = XE(J)
C             RR4 = YE(J)
             XE(J+NE) = XE(J) + 0.5D0
             YE(J+NE) = YE(J) + 0.5D0
           END DO
           NE = NE * 2
         ELSE IF (SYMM .EQ. 'p2  ') THEN
           CALL AP2 (X,Y,NE,XE,YE)
         ELSE IF (SYMM .EQ. 'pg  ' .OR. SYMM .EQ. 'p1g1') THEN
           CALL APG (X,Y,NE,XE,YE)
         ELSE IF (SYMM .EQ. 'p11g') THEN
           CALL APG (Y,X,NE,YE,XE)
         ELSE IF (SYMM .EQ. 'p1  ') THEN
           XE(1) = X
           YE(1) = Y
           NE = 1
         ELSE IF (SYMM .EQ. 'p2mg') THEN
           CALL AP2MG (X,Y,NE,XE,YE)
         ELSE IF (SYMM .EQ. 'p2gm') THEN
           CALL AP2MG (Y,X,NE,YE,XE)
         ELSE IF (SYMM .EQ. 'p2gg') THEN
           CALL AP2GG (Y,X,NE,YE,XE)
         ELSE IF (SYMM .EQ. 'p4  ') THEN
           CALL AP4 (X,Y,NE,XE,YE)
         ELSE IF (SYMM .EQ. 'p4mm') THEN
           CALL AP4MM (X,Y,NE,XE,YE)
         ELSE IF (SYMM .EQ. 'p4gm') THEN
           CALL AP4GM (X,Y,NE,XE,YE)
         ELSE IF (SYMM .EQ. 'p4mg') THEN
           CALL AP4GM (Y,X,NE,YE,XE)
         ELSE IF (SYMM .EQ. 'p3  ') THEN
           CALL AP3 (X,Y,NE,XE,YE)
         ELSE IF (SYMM .EQ. 'p31m') THEN
           CALL AP31M (X,Y,NE,XE,YE)
         ELSE IF (SYMM .EQ. 'p3m1') THEN
           CALL AP3M1 (X,Y,NE,XE,YE)
         ELSE IF (SYMM .EQ. 'p6mm') THEN
           CALL AP6MM (X,Y,NE,XE,YE)
         ELSE IF (SYMM .EQ. 'p6  ') THEN
           CALL AP6 (X,Y,NE,XE,YE)
         ELSE
           WRITE (6, *) 'Atom symmetry not there yet'
           CALL EXIT    (0)
         END IF
         RETURN
       END
       SUBROUTINE AP2 (X, Y, NE, XE, YE )
         DIMENSION XE(*), YE(*)
         XE(1) = X
         YE(1) = Y
         XE(2) = -X
         YE(2) = -Y
         NE = 2
       END
       SUBROUTINE APG (X, Y, NE, XE, YE )
         DIMENSION XE(*), YE(*)
         XE(1) = X
         YE(1) = Y
         XE(2) = -X
         YE(2) = 0.5D0 + Y
         NE = 2
         RETURN
       END
       SUBROUTINE APM (X, Y, NE, XE, YE )
         DIMENSION XE(*), YE(*)
         XE(1) = X
         YE(1) = Y
         XE(2) = -X
         YE(2) = Y
         NE = 2
         RETURN
       END
       SUBROUTINE AC2MM (X, Y, NE, XE, YE )
         DIMENSION XE(*), YE(*)
C         REAL RR1, RR2, RR3, RR4
         XE(1) = X
         YE(1) = Y
         XE(2) = -X
         YE(2) = Y
         NE = 2
         DO   J=1,2
C           RR1 = XE(J)
C           RR2 = YE(J)
           XE(J+2) = XE(J)
           YE(J+2) = -YE(J)
         END DO
         NE = 4
         DO   J=1,4
C           RR3 = XE(J)
C           RR4 = YE(J)
           XE(J+4) = XE(J) + 0.5D0
           YE(J+4) = YE(J) + 0.5D0
         END DO
         NE = 8
         RETURN
       END
       SUBROUTINE AP2MM (X, Y, NE, XE, YE )
         DIMENSION XE(*), YE(*)
C         REAL RR1, RR2
         XE(1) = X
         YE(1) = Y
         XE(2) = -X
         YE(2) = Y
         NE = 2
         DO   J=1,2
C           RR1 = XE(J)
C           RR2 = YE(J)
           XE(J+2) = XE(J)
           YE(J+2) = -YE(J)
         END DO
         NE = 4
         RETURN
       END
       SUBROUTINE AP2MG (X, Y, NE, XE, YE )
         DIMENSION XE(*), YE(*)
C         REAL RR1, RR2
         XE(1) = X
         YE(1) = Y
         XE(2) = -X
         YE(2) = -Y
         NE = 2
 
         DO   J=1,2
C          RR1 = XE(J)
C          RR2 = YE(J)
           XE(J+2) = 0.5D0 - XE(J)
           YE(J+2) = YE(J)
         END DO
         NE = 4
         RETURN
       END
       SUBROUTINE AP2GG (X, Y, NE, XE, YE )
         DIMENSION XE(*), YE(*)
C         REAL RR1, RR2
         XE(1) = X
         YE(1) = Y
         XE(2) = -X
         YE(2) = -Y
         NE = 2
         DO   J=1,2
C          RR1 = XE(J)
C          RR2 = YE(J)
           XE(J+2) = 0.5D0 - XE(J)
           YE(J+2) = 0.5D0 + YE(J)
         END DO
         NE = 4
         RETURN
       END
       SUBROUTINE AP3 (X, Y, NE, XE, YE )
         DIMENSION XE(*), YE(*)
         XE(1) = X
         YE(1) = Y
         XE(2) = -Y
         YE(2) = X - Y
         XE(3) = Y - X
         YE(3) = -X
         NE = 3
         RETURN
       END
       SUBROUTINE AP3M1 (X, Y, NE, XE, YE )
         DIMENSION XE(*), YE(*)
C         REAL RR1, RR2, RR3
         XE(1) = X
         YE(1) = Y
         XE(2) = -Y
         YE(2) = X - Y
         XE(3) = Y - X
         YE(3) = -X
         DO   J=1,3
C           RR1 = YE(J)
C           RR3 = XE(J)
C           RR2 = -RR1
           YE(J+3) = -XE(J)
           XE(J+3) = -YE(J)
         END DO
         NE = 6
       END
       SUBROUTINE AP31M (X, Y, NE, XE, YE )
         DIMENSION XE(*), YE(*)
C         REAL RR1, RR2, RR3
         XE(1) = X
         YE(1) = Y
         XE(2) = -Y
         YE(2) = X - Y
         XE(3) = Y - X
         YE(3) = -X
         DO   J=1,3
C           RR1 = YE(J)
C           RR3 = XE(J)
C           RR2 = RR1
           YE(J+3) = XE(J)
           XE(J+3) = YE(J)
         END DO
         NE = 6
         RETURN
       END
       SUBROUTINE AP6 (X, Y, NE, XE, YE )
         DIMENSION XE(*), YE(*)
C         REAL RR1, RR2
         XE(1) = X
         YE(1) = Y
         XE(2) = -Y
         YE(2) = X - Y
         XE(3) = Y - X
         YE(3) = -X
         DO   J=1,3
C           RR1 = XE(J)
C           RR2 = YE(J)
           XE(J+3) = -XE(J)
           YE(J+3) = -YE(J)
         END DO
         NE = 6
       END
       SUBROUTINE AP6MM (X, Y, NE, XE, YE )
         DIMENSION XE(*), YE(*)
C         REAL RR1, RR2, RR3, RR4, RR5
         XE(1) = X
         YE(1) = Y
         XE(2) = -Y
         YE(2) = X - Y
         XE(3) = Y - X
         YE(3) = -X
         DO   J=1,3
C           RR1 = XE(J)
C           RR2 = YE(J)
           XE(J+3) = -XE(J)
           YE(J+3) = -YE(J)
         END DO
         NE = 6
         DO   J=1,6
C           RR3 = YE(J)
C           RR5 = XE(J)
C           RR4 = RR3
           YE(J+6) = XE(J)
           XE(J+6) = YE(J)
         END DO
         NE = 12
         RETURN
       END
       SUBROUTINE AP4 (X, Y, NE, XE, YE )
         DIMENSION XE(*), YE(*)
         XE(1) = X
         YE(1) = Y
         XE(2) = -X
         YE(2) = -Y
         XE(3) = -Y
         YE(3) = X
         XE(4) = Y
         YE(4) = -X
         NE = 4
         RETURN
       END
       SUBROUTINE AP4MM (X, Y, NE, XE, YE )
         DIMENSION XE(*), YE(*)
C         REAL RR1, RR2
         XE(1) = X
         YE(1) = Y
         XE(2) = -X
         YE(2) = -Y
         XE(3) = -Y
         YE(3) = X
         XE(4) = Y
         YE(4) = -X
         NE = 4
         DO   J=1,4
C           RR1 = XE(J)
C           RR2 = YE(J)
           XE(J+4) = -XE(J)
           YE(J+4) = YE(J)
         END DO
         NE = 8
         RETURN
       END
       SUBROUTINE AP4GM (X, Y, NE, XE, YE )
         DIMENSION XE(*), YE(*)
C         REAL RR1, RR2
         XE(1) = X
         YE(1) = Y
         XE(2) = -X
         YE(2) = -Y
         XE(3) = -Y
         YE(3) = X
         XE(4) = Y
         YE(4) = -X
         NE = 4
         DO   J=1,4
C           RR1 = XE(J)
C           RR2 = YE(J)
           XE(J+4) = 0.5D0 - XE(J)
           YE(J+4) = YE(J) + 0.5D0
         END DO
         NE = 8
         RETURN
       END
 

