C 
C  Copyright (c) 1998 L. D. Marks
C 
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C 
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C 
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C 
C
      subroutine asymmd(x,y,ne,xt,yt,symm)
      character*4 symm
      real*8 x,y,xe(12),ye(12),xt(*),yt(*),dx,dy
      logical dist2Dd
      x=x-int(x)
      y=y-int(y)
      if(symm.eq.'c2mm')then
         call ac2mmd(x,y,ne,xe,ye)
        else if(symm.eq.'p2mm')then
                call ap2mmd(x,y,ne,xe,ye)
        else if(symm.eq.'pm  '.or.symm.eq.'p1m1')then
              call apmd(x,y,ne,xe,ye)
        else if(symm.eq.'cm  '.or.symm.eq.'c1m1')then
              call apmd(x,y,ne,xe,ye)
              do j=1,ne
                 xe(j+ne)=xe(j)+0.5d0
                 ye(j+ne)=ye(j)+0.5d0
              enddo
              ne=ne*2
        else if(symm.eq.'p11m')then
              call apmd(y,x,ne,ye,xe)
        else if(symm.eq.'c11m')then
              call apmd(y,x,ne,ye,xe)
              do j=1,ne
                 xe(j+ne)=xe(j)+0.5d0
                 ye(j+ne)=ye(j)+0.5d0
              enddo
              ne=ne*2
        else if(symm.eq.'p2  ')then
              call ap2d(x,y,ne,xe,ye)
        else if(symm.eq.'pg  '.or.symm.eq.'p1g1')then
              call apgd(x,y,ne,xe,ye)
        else if(symm.eq.'p11g')then
              call apgd(y,x,ne,ye,xe)
        else if(symm.eq.'p1  ')then
              xe(1)=x
              ye(1)=y
              ne=1
        else if(symm.eq.'p2mg')then
              call ap2mgd(x,y,ne,xe,ye)
        else if(symm.eq.'p2gm')then
              call ap2mgd(y,x,ne,ye,xe)
        else if(symm.eq.'p2gg')then
              call ap2ggd(y,x,ne,ye,xe)
        else if(symm.eq.'p4  ')then
              call ap4d(x,y,ne,xe,ye)
        else if(symm.eq.'p4mm')then
              call ap4mmd(x,y,ne,xe,ye)
        else if(symm.eq.'p4gm')then
              call ap4gmd(x,y,ne,xe,ye)
        else if(symm.eq.'p4mg')then
              call ap4gmd(y,x,ne,ye,xe)
        else if(symm.eq.'p3  ')then
              call ap3d(x,y,ne,xe,ye)
        else if(symm.eq.'p31m')then
              call ap31md(x,y,ne,xe,ye)
        else if(symm.eq.'p3m1')then
              call ap3m1d(x,y,ne,xe,ye)
        else if(symm.eq.'p6mm')then
              call ap6mmd(x,y,ne,xe,ye)
        else if(symm.eq.'p6  ')then
              call ap6d(x,y,ne,xe,ye)
      else
         write(6,*)'Atom symmetry not there yet'
         call exit(0)
      endif
C     Safety check
      xt(1)=xe(1)-int(xe(1))
      yt(1)=ye(1)-int(ye(1))
      if(ne.eq.1)return
      do j=1,ne-1
         if(xe(j).lt.-100)goto 10
         do k=j+1,ne
         if(xe(k).lt.-100)goto 20
         dx=xe(j)-xe(k)
         dy=ye(j)-ye(k)
         dx=dx-nint(dx)
         dy=dy-nint(dy)
         if(dist2Dd(dx,dy,0.25))then
                 xe(k)=-999
                 ye(k)=-999
C           write(6,*)'Warning: duplicate ',xe(j),ye(j)
              endif
20         continue
             enddo
10      continue
           enddo
           jj=1
           do j=2,ne
           if(xe(j).gt.-100)then
              jj=jj+1
              xt(jj)=xe(j)-int(xe(j))
              yt(jj)=ye(j)-int(ye(j))
           endif
           enddo
           ne=jj   
      return
      end
      subroutine asymm2d(x,y,ne,xe,ye,symm)
      character*4 symm
      real*8 x,y,xe(*),ye(*)
      x=x-nint(x)
      y=y-nint(y)
      if(symm.eq.'c2mm')then
         call ac2mmd(x,y,ne,xe,ye)
        else if(symm.eq.'p2mm')then
                call ap2mmd(x,y,ne,xe,ye)
        else if(symm.eq.'pm  '.or.symm.eq.'p1m1')then
              call apmd(x,y,ne,xe,ye)
        else if(symm.eq.'cm  '.or.symm.eq.'c1m1')then
              call apmd(x,y,ne,xe,ye)
              do j=1,ne
                 xe(j+ne)=xe(j)+0.5d0
                 ye(j+ne)=ye(j)+0.5d0
              enddo
              ne=ne*2
        else if(symm.eq.'p11m')then
              call apmd(y,x,ne,ye,xe)
        else if(symm.eq.'c11m')then
              call apmd(y,x,ne,ye,xe)
              do j=1,ne
                 xe(j+ne)=xe(j)+0.5d0
                 ye(j+ne)=ye(j)+0.5d0
              enddo
              ne=ne*2
        else if(symm.eq.'p2  ')then
              call ap2d(x,y,ne,xe,ye)
        else if(symm.eq.'pg  '.or.symm.eq.'p1g1')then
              call apgd(x,y,ne,xe,ye)
        else if(symm.eq.'p11g')then
              call apgd(y,x,ne,ye,xe)
        else if(symm.eq.'p1  ')then
              xe(1)=x
              ye(1)=y
              ne=1
        else if(symm.eq.'p2mg')then
              call ap2mgd(x,y,ne,xe,ye)
        else if(symm.eq.'p2gm')then
              call ap2mgd(y,x,ne,ye,xe)
        else if(symm.eq.'p2gg')then
              call ap2ggd(y,x,ne,ye,xe)
        else if(symm.eq.'p4  ')then
              call ap4d(x,y,ne,xe,ye)
        else if(symm.eq.'p4mm')then
              call ap4mmd(x,y,ne,xe,ye)
        else if(symm.eq.'p4gm')then
              call ap4gmd(x,y,ne,xe,ye)
        else if(symm.eq.'p4mg')then
              call ap4gmd(y,x,ne,ye,xe)
        else if(symm.eq.'p3  ')then
              call ap3d(x,y,ne,xe,ye)
        else if(symm.eq.'p31m')then
              call ap31md(x,y,ne,xe,ye)
        else if(symm.eq.'p3m1')then
              call ap3m1d(x,y,ne,xe,ye)
        else if(symm.eq.'p6mm')then
              call ap6mmd(x,y,ne,xe,ye)
        else if(symm.eq.'p6  ')then
              call ap6d(x,y,ne,xe,ye)
      else
         write(6,*)'Atom symmetry not there yet'
         call exit(0)
      endif
      return
      end
      subroutine ap2d(x,y,ne,xe,ye)
      real*8 x,y,xe(*),ye(*)
      xe(1)=x
      ye(1)=y
      xe(2)=-x
      ye(2)=-y
      ne=2
      end
      subroutine apgd(x,y,ne,xe,ye)
      real*8 x,y,xe(*),ye(*)
      xe(1)=x
      ye(1)=y
      xe(2)=-x
      ye(2)=0.5d0+y
      ne=2
      return
      end
      subroutine apmd(x,y,ne,xe,ye)
      real*8 x,y,xe(*),ye(*)
      xe(1)=x
      ye(1)=y
      xe(2)=-x
      ye(2)=y
      ne=2
      return
      end
      subroutine ac2mmd(x,y,ne,xe,ye)
      real*8 x,y,xe(*),ye(*)
      xe(1)=x
      ye(1)=y
      ne=1
        if(abs(x-0.25d0).lt.1d-4.and.abs(y-0.25d0).lt.1d-4)then
                xe(1)= 0.25d0
                ye(1)= 0.25d0
                xe(2)= 0.75d0
                ye(2)= 0.25d0
                xe(3)= 0.25d0
                ye(3)= 0.75d0
                xe(4)= 0.75d0
                ye(4)= 0.75d0
                ne=4
                return
        endif
      if(abs(x).gt.1d-4.and.abs(x-0.5).gt.1d-4)then
        xe(2)=-x
                ye(2)=y
        ne=2
        else if(abs(x).le.1d-4)then
                xe(1)=0d0
                x=0d0
        else
                xe(1)=0.5d0
                x=0.5d0
      endif
      if(abs(y).gt.1d-4.and.abs(y-0.5).gt.1d-4)then
        do j=1,ne
                        xe(j+ne)=xe(j)
                        ye(j+ne)=-ye(j)
        enddo
        ne=2*ne
        else if(abs(y).le.1d-4)then
                do j=1,ne
                        ye(j)=0d0
                enddo
                y=0d0
        else
                do j=1,ne
                        ye(j)=0.5d0
                enddo
                y=0.5d0
      endif
      do j=1,ne
         xe(j+ne)=xe(j)+0.5d0
         ye(j+ne)=ye(j)+0.5d0
      enddo
      ne=ne*2
      return
      end
        subroutine ap2mmd(x,y,ne,xe,ye)
        real*8 x,y,xe(*),ye(*)
        xe(1)=x
        ye(1)=y
        ne=1
        xe(2)=-x
        ye(2)=y
        ne=2
        do j=1,ne
                xe(j+ne)=xe(j)
                ye(j+ne)=-ye(j)
        enddo
        ne=2*ne
        return
        end
        subroutine ap2mgd(x,y,ne,xe,ye)
        real*8 x,y,xe(*),ye(*)
        xe(1)=x
        ye(1)=y
        ne=1
        xe(2)=-x
        ye(2)=-y
        ne=2

        do j=1,ne
                xe(j+ne)=0.5d0-xe(j)
                ye(j+ne)=ye(j)
        enddo
        ne=2*ne
        return
        end

        subroutine ap2ggd(x,y,ne,xe,ye)
        real*8 x,y,xe(*),ye(*)
        xe(1)=x
        ye(1)=y
        xe(2)=-x
        ye(2)=-y
        ne=2
        do j=1,ne
                xe(j+ne)=0.5d0-xe(j)
                ye(j+ne)=0.5d0+ye(j)
        enddo
        ne=2*ne
        return
        end

        subroutine ap3d(x,y,ne,xe,ye)
        real*8 x,y,xe(*),ye(*)
        xe(1)=x
        ye(1)=y
        xe(2)=-y
        ye(2)=x-y
        xe(3)=y-x
        ye(3)=-x
        ne=3
        return
        end

        subroutine ap3m1d(x,y,ne,xe,ye)
        real*8 x,y,xe(*),ye(*)
        xe(1)=x
        ye(1)=y
        xe(2)=-y
        ye(2)=x-y
        xe(3)=y-x
        ye(3)=-x
        do j=1,3
         xe(j+3)=-ye(j)
         ye(j+3)=-xe(j)
        enddo
        ne=6
        end
        subroutine ap31md(x,y,ne,xe,ye)
        real*8 x,y,xe(*),ye(*)
        xe(1)=x
        ye(1)=y
        xe(2)=-y
        ye(2)=x-y
        xe(3)=y-x
        ye(3)=-x
        do j=1,3
         xe(j+3)=ye(j)
         ye(j+3)=xe(j)
        enddo
        ne=6
        return
        end

        subroutine ap6d(x,y,ne,xe,ye)
        real*8 x,y,xe(*),ye(*)
        if(abs(x).lt.1d-7.and.abs(y).lt.1d-7)then
                xe(1)=0
                ye(1)=0
                x=0
                y=0
                ne=1
                return
      else if(abs(x-1.d0/3.d0).lt.1d-7.and.
     1     abs(y-2.d0/3.d0).lt.1d-7)then
                x=1.d0/3.d0
                y=2.d0/3.d0
                xe(1)=x
                ye(1)=y
                xe(2)=2.d0/3.d0
                ye(2)=1.d0/3.d0
                ne=2
                return
      else if(abs(x-2.d0/3.d0).lt.1d-7.and.
     1     abs(y-1.d0/3.d0).lt.1d-7)then
                x=2.d0/3.d0
                y=1.d0/3.d0
                xe(1)=x
                ye(1)=y
                xe(2)=1.d0/3.d0
                ye(2)=2.d0/3.d0
                ne=2
                return
      else if(abs(x-0.5d0).lt.1d-7.and.abs(y).lt.1d-7)then
                x=0.5d0
                y=0
                xe(1)=0.5d0
                ye(1)=0
                xe(2)=0
                ye(2)=0.5d0
                xe(3)=0.5d0
                ye(3)=0.5d0
                ne=3
                return
      else if(abs(x).lt.1d-7.and.abs(y-0.5d0).lt.1d-7)then
                x=0
                y=0.5d0
                xe(1)=0.5d0
                ye(1)=0
                xe(2)=0
                ye(2)=0.5d0
                xe(3)=0.5d0
                ye(3)=0.5d0
                ne=3
                return
      else if(abs(x-0.5d0).lt.1d-7.and.abs(y-0.5d0).lt.1d-7)then
                x=0.5d0
                y=0.5d0
                xe(1)=0.5d0
                ye(1)=0
                xe(2)=0
                ye(2)=0.5d0
                xe(3)=0.5d0
                ye(3)=0.5d0
                ne=3
                return
        endif      
        xe(1)=x
        ye(1)=y
        xe(2)=-y
        ye(2)=x-y
        xe(3)=y-x
        ye(3)=-x
      do j=1,3
         xe(j+3)=-xe(j)
         ye(j+3)=-ye(j)
      enddo
      ne=6
        end
        subroutine ap6mmd(x,y,ne,xe,ye)
        real*8 x,y,xe(*),ye(*)
        if(abs(x).lt.1d-7.and.abs(y).lt.1d-7)then
                xe(1)=0
                ye(1)=0
                x=0
                y=0
                ne=1
                return
      else if(abs(x-1.d0/3.d0).lt.1d-7.and.
     1    abs(y-2.d0/3.d0).lt.1d-7)then
                x=1.d0/3.d0
                y=2.d0/3.d0
                xe(1)=x
                ye(1)=y
                xe(2)=2.d0/3.d0
                ye(2)=1.d0/3.d0
                ne=2
                return
      else if(abs(x-2.d0/3.d0).lt.1d-7.and.
     1     abs(y-1.d0/3.d0).lt.1d-7)then
                x=2.d0/3.d0
                y=1.d0/3.d0
                xe(1)=x
                ye(1)=y
                xe(2)=1.d0/3.d0
                ye(2)=2.d0/3.d0
                ne=2
                return
      else if(abs(x-0.5d0).lt.1d-7.and.abs(y).lt.1d-7)then
                x=0.5d0
                y=0
                xe(1)=0.5d0
                ye(1)=0
                xe(2)=0
                ye(2)=0.5d0
                xe(3)=0.5d0
                ye(3)=0.5d0
                ne=3
                return
      else if(abs(x).lt.1d-7.and.abs(y-0.5d0).lt.1d-7)then
                x=0
                y=0.5d0
                xe(1)=0.5d0
                ye(1)=0
                xe(2)=0
                ye(2)=0.5d0
                xe(3)=0.5d0
                ye(3)=0.5d0
                ne=3
                return
      else if(abs(x-0.5d0).lt.1d-7.and.abs(y-0.5d0).lt.1d-7)then
                x=0.5d0
                y=0.5d0
                xe(1)=0.5d0
                ye(1)=0
                xe(2)=0
                ye(2)=0.5d0
                xe(3)=0.5d0
                ye(3)=0.5d0
                ne=3
                return
        endif      
        xe(1)=x
        ye(1)=y
        xe(2)=-y
        ye(2)=x-y
        xe(3)=y-x
        ye(3)=-x
      do j=1,3
         xe(j+3)=-xe(j)
         ye(j+3)=-ye(j)
      enddo
      ne=6
      do j=1,ne
         xe(j+ne)=ye(j)
         ye(j+ne)=xe(j)
      enddo
      ne=12
        return
        end

        subroutine ap4d(x,y,ne,xe,ye)
        real*8 x,y,xe(*),ye(*)
        xe(1)=x
        ye(1)=y
        xe(2)=-x
        ye(2)=-y
        xe(3)=-y
        ye(3)=x
        xe(4)=y
        ye(4)=-x
        ne=4
        return
        end
        subroutine ap4mmd(x,y,ne,xe,ye)
        real*8 x,y,xe(*),ye(*)
        xe(1)=x
        ye(1)=y
        xe(2)=-x
        ye(2)=-y
        xe(3)=-y
        ye(3)=x
        xe(4)=y
        ye(4)=-x
        ne=4
        do j=1,4
              xe(j+4)=-xe(j)
              ye(j+4)= ye(j)
        enddo
        ne=8
        return
        end

        subroutine ap4gmd(x,y,ne,xe,ye)
        real*8 x,y,xe(*),ye(*)
        xe(1)=x
        ye(1)=y
        xe(2)=-x
        ye(2)=-y
        xe(3)=-y
        ye(3)=x
        xe(4)=y
        ye(4)=-x
        ne=4
        do j=1,4
              xe(j+4)=-xe(j)+0.5d0
              ye(j+4)= ye(j)+0.5d0
        enddo
        ne=8
        return
        end

