C
C  Copyright (c) 1998 L. D. Marks
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
C
       SUBROUTINE PIMG2DN (C, FF, IH, K, FHK, AHK, NREF, SYMM, TITLE )
C     THIS PROGRAM EXPANDS THE PHASE OF A 2-D DATA SET TO AN IMAGE
         include 'Nlimit.h'
 
C         PARAMETER (NHK2 = 900, NLIMIT = 65536)
         LOGICAL PRINTF
         COMMON /PRINTS/PRINTF
         LOGICAL PWMASK, EOPT, PWACC, PMACC
         COMMON /WALSH/PWMASK, EOPT, PWACC, PMACC
         LOGICAL CENTRO
         COMMON /CCENTR/CENTRO
C     data centro /.false./
         COMMON /ERRTRY/NWOPT
         COMMON /ENTC2D/RAD1, RAD2
 
C     For tuning
         LOGICAL TLOG(6)
         DIMENSION FTUNE(4)
         COMMON /TUNING/TLOG, FTUNE
         LOGICAL WTSON, WT2ON
         DIMENSION WPOS(NHK2)
         COMMON /WPOSC/WPOS
         COMMON /WCOM/WTS, WTSON, MODE
         COMMON /WCOM2/EWTS, WT2ON
         COMMON /MPCOMM/MULTI
         COMMON /ECALC/SFERR1, ANGERR, SFERR2
         COMMON /PADCMM/NPAD
         COMMON /FOMALL/ER1, EI1, EC1, F0PASS
         INTEGER NCONT(20)
         DIMENSION CELL(6), TEMPF(20), AOCC(20), ZATOM(20)
         LOGICAL FORIG, FSEMP, BROWNF, DMULT, DMLT, FOM2
         Include 'Sfacts.h'
         COMMON /SFCOM1/TEMPF, NCONT, NATOM, CELL
         COMMON /SFCOM2/AOCC, ZATOM, FORIG, BROWNF, DMULT, DMLT
         COMMON /MVIS/WIDTH, HEIGHT, TIMES, FSEMP
         COMMON /COPT/ATNUM, PATTC, ACTERM, FOM2
         DIMENSION FSTEST(20)
         COMMON /COPT2/FSTEST
         INTEGER LAT(2)
         COMMON /CLAT/LAT
 
         DIMENSION IH(*), K(*), WORK(NHK2), FHK(*), AHK(*)
         INTEGER HE(30), KE(30), ISE(30), M(3), M2(3)
         COMPLEX C(*)
         DIMENSION FF(*)
         CHARACTER*4 SYMM
         CHARACTER*8 FILEN
         CHARACTER*50 FORMT
         CHARACTER*78 TITLE
         INTEGER II1, II2, II3, II4, II5
         REAL RR1
         LOGICAL LL1
         COMPLEX CC1, CC2, CC3, CC4, CC5, CC6, CC7, CC8
         DATA IFILE/0/
         IFILE = IFILE + 1
 
C     Origin for arrays (for consistency with FFT's)
         CALL FINDSZ (IH,K,NREF,SYMM,M,IOPT)
         N1 = M(1)
         N2 = M(2)
C     Pixels per Angstrom
         A = CELL(1)
         IF (SYMM(1:2) .EQ. 'p3' .OR. SYMM(1:2) .EQ. 'p6') THEN
           A = CELL(1) * SQRT (3.D0)
         END IF
         PX = FLOAT (M(1)) / A
         PY = FLOAT (M(2)) / CELL(2)
         PA = MAX (PX, PY)
         IF (ABS (TIMES - 1) .GT. 1D-2) THEN
C           write(6,*)'Magnification of ',times
           WRITE (10, *) 'Magnification of ', TIMES
           PA = PA * TIMES
         END IF
         I1 = NINT (PA * A)
         I2 = NINT (PA * CELL(2))
         CALL BESIZE (I1,I2,N1,N2)
C     write(6,*)'FFT Sizes Used for Output: ',n1,n2
         WRITE (10, *) 'FFT Sizes Used for Output: ', N1, N2
C     write(6,*)'Pixels per Angstrom ',pa
         WRITE (10, *) 'Pixels per Angstrom ', PA
         M2(1) = N1
         M2(2) = N2
         CALL PBUF2 (M2)
         DO   J=1,N1*N2
           C(J) = (0., 0.)
         END DO
 
C     setup in fo and ag the symmetry related values
         PI = ASIN (1.D0) * 2.D0
         II4 = N1 / 2
         II5 = N2 / 2
         DO   J=1,NPAD
           IHH = IH(J)
           IKK = K(J)
           CALL EQUIV2 (HE,KE,ISE,IHH,IKK,NE,SYMM)
           ANG = AHK(J)
           IF (ISE(1) .EQ. 3 .AND. ABS (AHK(J)) .GT. 1D-4) THEN
C     truncate angle to moduli pi provided that > a cutoff
C           write(10,*)'Fixing input ',ihh,ikk
             IA = NINT (AHK(J) / PI)
             IF (NINT (AHK(J) / PI) .EQ. 0) IA = 2
             ANG = PI * IA
             AHK(J) = PI * IA
           END IF
           IF (ABS (ANG) .GT. 1D-4 .OR. (IHH .EQ. 0 .AND. IKK .EQ. 0)
     X        ) THEN
 
 
C     Information about symmetry coding of phases
             LL1 = SYMM(1:2) .EQ. 'p3' .OR. SYMM(1:2) .EQ. 'p6'
             II2 = II4
             II3 = II5
             RR1 = FHK(J)
             CC1 = CMPLX (COS (ANG) * RR1, -SIN (ANG) * RR1)
             CC2 = CMPLX (COS (ANG) * RR1, 0.D0)
             CC3 = CMPLX (0.D0, SIN (ANG) * RR1)
             CC4 = CMPLX (COS (ANG) * RR1, SIN (ANG) * RR1)
             CC5 = -CC4
             CC6 = -CC1
             CC7 = -CC2
             CC8 = CMPLX (0.D0, -SIN (ANG) * RR1)
             DO   JJ=1,NE
C     trap problems with p3 symmetry to give rectangular axes
               IF (LL1) THEN
                 CALL P3EXP (IHJJ,IKJJ,HE(JJ),KE(JJ))
C             ihjj=2*he(je)+n1c
C             ikjj=2*ke(je)+he(je)+n2c
                 IHJJ = IHJJ + II2 + 1
                 IKJJ = IKJJ + II3 + 1
               ELSE
                 IHJJ = HE(JJ) + II2 + 1
                 IKJJ = KE(JJ) + II3 + 1
               END IF
               IND = (IKJJ - 1) * N1 + IHJJ
C       write(10,*)'PUT TO ',ihjj,ikjj,he(jj),ke(jj),
C     $     ihjj-n1c,ikjj-n2c,ise(jj),ind
               IF (ISE(JJ) .LT. 0) THEN
                 C(IND) = CC1
               ELSE IF (ISE(JJ) .EQ. 3) THEN
                 C(IND) = CC2
               ELSE IF (ISE(JJ) .EQ. 6) THEN
                 C(IND) = CC3
               ELSE IF (ISE(JJ) .LT. 8) THEN
                 C(IND) = CC4
               ELSE IF (ISE(JJ) .LT. 110) THEN
                 AWORK = ANG + HE(1) * PI
                 C(IND) = RR1 * CMPLX (COS (AWORK), SIN (AWORK))
 
C     X or Y-glide
               ELSE IF (ISE(JJ) .LT. 210) THEN
                 C(IND) = CC5
               ELSE IF (ISE(JJ) .EQ. 300) THEN
                 C(IND) = CC6
 
C     p2mg case
               ELSE IF (ISE(JJ) .EQ. 1000) THEN
                 C(IND) = CC7
               ELSE IF (ISE(JJ) .EQ. 2000) THEN
                 C(IND) = CC8
               END IF
C     Hack to correct orientations
               IF((symm(1:2).ne.'p3').and.(symm(1:2).ne.'p6'))
     1          C(IND)=conjg(C(IND))
             END DO
 
           END IF
         END DO
C     For p3 case, move the origin down
         IF (SYMM(1:2) .EQ. 'p3' .OR. SYMM(1:2) .EQ. 'p6') THEN
           IF ((N2 / 2 + 1) / 2 * 2 .EQ. N2 / 2 + 1) THEN
             I1 = 1
           ELSE
             I1 = 2
           END IF
           DO   J=I1,N2-2,2
             DO   JJ=(J-1)*N1+1,(J-1)*N1+N1
               C(JJ) = -C(JJ)
             END DO
           END DO
         END IF
C           J2 = N1
C           DO   J=2,N2-2,2
C             DO   JJ=1,N1
C               J2 = J2 + 1
C               C(J2) = -C(J2)
C             END DO
C             J2 = J2 + N1
C           END DO
C         END IF
C     Do a FFT
         CALL FFT2DN (C)
 
C     Reset FFT sizes
         CALL FINDSZ (IH,K,NREF,SYMM,M,IOPT)
         CALL PBUF2 (M)
 
C           Correction for the origin shift
C           Quench any imaginary component as a rounding error
C     Also find max, min and mean at the same time
         XMEAN = 0.
         XMAX = (-100.)
         XMIN = 1000.
         JK = 0
         MF = (-1)
         DO   I=1,N2
           MF = -MF
           NF = -MF
           DO   J=1,N1
             NF = -NF
             JK = JK + 1
C
             X = C(JK) * (NF )
             C(JK) = X
             XMEAN = XMEAN + X
             XMAX = MAX (X, XMAX)
             XMIN = MIN (X, XMIN)
           END DO
         END DO
 
         FORMT = '((20e10.3))     '
         XMEAN = XMEAN / FLOAT (N1 * N2)
C         write(6,*)'Image Max/Min/Mean',XMAX,XMIN,XMEAN
C     WARNING: make filen a multiple of 4 bytes long
C     Shuffle down the title a little to fit cleanly in semper
         DO   J=56,68
           TITLE(J:J) = TITLE(J + 10:J + 10)
         END DO
C         IF (IFILE .LT. 10) THEN
C           WRITE (FILEN, 200) IFILE
C           IFF = 8
C         ELSE
C           WRITE (FILEN, 201) IFILE
C           IFF = 8
C         END IF
C     WARNING: make filen a multiple of 4 bytes long
C   Different name for output file -- without incrementing
         FILEN='Iedm.tif'
         IFF=8
         WRITE (10, 202) FILEN
  202    FORMAT(' File ',A,' saved for viewing')
  200    FORMAT('Isolve0',I1)
  201    FORMAT('Isolve',I2)
         IF (FSEMP) THEN
           OPEN (UNIT=11, FILE='SemperPic')
           WRITE (11, 140) N1, N2, 1, 1, 2, 68, FORMT
           WRITE (11, 141) TITLE(1:68)
           JK = 0
           DO   I=1,N2
C     Output a line
             DO   II1=1,N1
               WORK(II1) =  C(II1+JK)/ XMEAN
             END DO
             JK = JK + N1
             WRITE (11, 30) (WORK(J), J=1,N1)
           END DO
         END IF
   30    FORMAT(20E10.3)
  140    FORMAT(6I6,1X,A20)
  141    FORMAT(A)
C
C     output a pgm magick picture
C     call pgmpic(n1,n2,c,ff,xmax,xmin,filen,iff)
C     output a gif magick picture
C *********** CHANGE PERHAPS ************************
C         OPEN (UNIT=3, FILE='index.htm', ACCESS='append')
C         FILEN(IFF + 1:IFF + 4) = '.gif'
C         WRITE (3, 301) IFILE, FILEN(1:IFF + 4)
  301    FORMAT('Image ',I3,' <img align="center" src="',A,'"><p>')
         CLOSE (UNIT=3)
C         write(6,*)'Debug ',xmax,xmin,xmean
         CALL TIFPIC (N1,N2,C,XMAX,XMIN,FILEN,FF)
         RETURN
       END
  
