C 
C  Copyright (c) 1998 L. D. Marks
C 
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C 
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C 
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C 
C
      subroutine scattf(cxray,x,y,zizz,csymb,charge)
C        Adapted from LAZY-PULVERIX                                             
C     The purpose of this program is to calculate the x-ray                     
C     atomic scattering factors from the Cromer and Mann constants              
C     in Table 2.2 B, vol. 4 of the International Tables of X-ray               
C     Crystallography 1974 Edition.   In addition the anomalous                 
C     dispersion coefficients for common x-ray tube energies can                
C     also be calculated.                                                       
      integer asymb                                         
      CHARACTER*4 CHARSB,csymb                                               
      character*1 test(4)
      DIMENSION FA(4,8), FB(4,8), FC(8),x(4),y(4)
      COMMON /SCAT/ FA,FB,FC                                                    
      equivalence (asymb,test(1))
      equivalence (asymb,CHARSB)
      logical arun,patest
      character*4 psymb(20)
      save nps,psymp
      data nps/0/
      CHARSB=csymb
      arun=.false.
      charge=0
C	Over-ride
      if(csymb(3:3).eq.'>'.or.csymb(3:3).eq.'<')then
      	arun=.true.
      	CHARSB(3:4)='  '
      	read(csymb(4:4),*,err=10)icharg
      	goto 20
10	open(unit=17,file=csymb)
	read(17,*)charge
	close(unit=17)
	goto 30
	
20      if(csymb(3:3).eq.'>')then
      		charge=0.1*float(icharg)
      	else
      		charge=-0.1*float(icharg)
      	endif
30    continue
      endif
                                    
C
C-----RETRIEVE CROMER-MANN COEFFICIENTS                                         
 32   CALL FSC (ASYMB,1,zizz)                                                   
C
C
      cxray=fc(1)
      if(cxray.eq.999.9) then
C     Die
      write(10,*)'Terminating due to invalid atom',test
      write(6,*)'Terminating due to invalid atom',test
      call exit(0)
      endif
C
      sum=0.
      do 40 j=1,4
      x(j)=fa(j,1)
      y(j)=fb(j,1)
40    sum=sum+x(j)
C
C    test whether choice is an ion
C
	patest=.false.
C	if(nps.gt.0)then
C		do jj=1,nps
C			if(csymb.eq.psymb(jj))goto 100
C		enddo
C	endif
C	New type
C	nps=nps+1
C	psymb(nps)=csymb
C	patest=.true.
100	continue
C      if(patest)write(10,*)'For type ',csymb,' discrepancy ',
C     1 zizz-sum-cxray
C      if(patest)write(10,*)'Zizz ',zizz,' cxray ',cxray,' sum ',sum
C      if(arun)then
C        if(patest)write(10,*)'Using an effective charge of ',charge
C      	cxray=zizz-sum+charge
C      	return
C      endif
C      if(test(3).ne.' ') go to 14
      cxray=zizz-sum
      return
C14    continue
C
C     for ionic case
C      icharge=nint(cxray+sum-zizz)
C      cxray=icharge-sum+zizz
C
C      return
C
C
      end                                                                       
C
      SUBROUTINE FSC (ELEMT,MN,Z)                                               
C-----RETRIEVES THE COEFFICIENTS FOR THE ATOMIC SCATTERING FUNCTIONS            
C-----COMPILED BY CROMER AND MANN   FOR THE MN TH ELEMENT ELEMT                 
C-----AND STORES THEM IN COMMON SCAT                                            
      DIMENSION A(1926)                                                         
      DIMENSION FA(4,8), FB(4,8), FC(8)                                         
      COMMON /SK/ A                                                             
      COMMON /SCAT/ FA,FB,FC 
        save iz
      integer ELEMT                                                           
        integer iz(214) /                                                   
     $   1,  1,  1,  2,  3,  3,  4,  4,  5,  6,  6,  7,  8,  8,  9,
     $   9, 10, 11, 11, 12, 12, 13, 13, 14, 14, 14, 15, 16, 17, 17,
     $  18, 19, 19, 20, 20, 21, 21, 22, 22, 22, 22, 23, 23, 23, 23,
     $  24, 24, 24, 25, 25, 25, 25, 26, 26, 26, 27, 27, 27, 28, 28,
     $  28, 29, 29, 29, 30, 30, 31, 31, 32, 32, 33, 34, 35, 35, 36,
     $  37, 37, 38, 38, 39, 39, 40, 40, 41, 41, 41, 42, 42, 42, 42,
     $  43, 44, 44, 44, 45, 45, 45, 46, 46, 46, 47, 47, 47, 48, 48,
     $  49, 49, 50, 50, 50, 51, 51, 51, 52, 53, 53, 54, 55, 55, 56,
     $  56, 57, 57, 58, 58, 58, 59, 59, 59, 60, 60, 61, 61, 62, 62,
     $  63, 63, 63, 64, 64, 65, 65, 66, 66, 67, 67, 68, 68, 69, 69,
     $  70, 70, 70, 71, 71, 72, 72, 73, 73, 74, 74, 75, 76, 76, 77,
     $  77, 77, 78, 78, 78, 79, 79, 79, 80, 80, 80, 81, 81, 81, 82,
     $  82, 82, 83, 83, 83, 84, 85, 86, 87, 88, 88, 89, 89, 90, 90,
     $  91, 92, 92, 92, 92, 93, 93, 93, 93, 94, 94, 94, 94, 95, 96,
     $  97, 98,  8, 0/
      M=MN                                                                      
C-----RETRIEVE SEQUENCE NUMBER OF ATOM TYPE                                     
      CALL SYMBF (ELEMT,IELMT)
      z=iz(ielmt)                                                  
      IS=IELMT*9-8                                                              
      IF ((IS.GT.0).AND.(IS.LT.1944)) GO TO 1                                   
      FC(M)=999.9                                                               
      RETURN                                                                    
 1    DO 2 I=1,4                                                                
      FA(I,M)=A(IS)                                                             
      FB(I,M)=A(IS+1)                                                           
      IS=IS+2                                                                   
 2    CONTINUE                                                                  
      FC(M)=A(IS)                                                               
      RETURN                                                                    
C
C
      END                                                                       
      SUBROUTINE SYMBF (ASYMB,IELMT)                                            
C-----FINDS THE SEQUENCE NUMBER IELMT OF ELEMENT ASYMB AMONG ELEMENTS           
C-----FOR WHICH SCATTERING CURVES EXIST IN ROUTINE CONFS                        
      COMMON /UNITS/ ICR,IPR,ILU                                                
      DIMENSION S(214)
      integer S,ASYMB,its1,its2
	character*4 tsym1,tsym2,C(214)
	equivalence(its1,tsym1), (its2,tsym2), (S,C)
      save C
      DATA C(1)/'H   '/,C(2)/'H.  '/,C(3)/'H1- '/,C(4)/'HE  '/,C(5)/
     1'LI  '/,C(6)/'LI1+'/,C(7)/'BE  '/,C(8)/'BE2+'/,C(9)/'B   '/
     2,C(10)/'C   '/,C(11)/'C.  '/,C(12)/'N   '/,C(13)/'O   '/,C(14)/
     3'O1- '/,C(15)/'F   '/,C(16)/'F1- '/,C(17)/'NE  '/,C(18)/'NA  '/
     4,C(19)/'NA1+'/,C(20)/'MG  '/,C(21)/'MG2+'/,C(22)/'AL  '/,C(23)/
     5'AL3+'/,C(24)/'SI  '/,C(25)/'SI. '/,C(26)/'SI4+'/,C(27)/'S   '/,
     6C(28)/'P   '/,C(29)/'CL  '/,C(30)/'CL1-'/,C(31)/'AR  '/,C(32)/
     7'K   '/,C(33)/'K1+ '/,C(34)/'CA  '/,C(35)/'CA2+'/,C(36)/'SC  '/
     8,C(37)/'SC3+'/,C(38)/'TI  '/,C(39)/'TI2+'/,C(40)/'TI3+'/
      DATA C(41)/'TI4+'/,C(42)/'V   '/,C(43)/'V2+ '/,C(44)/'V3+ '/,C(45)
     1/'V5+ '/,C(46)/'CR  '/,C(47)/'CR2+'/,C(48)/'CR3+'/,C(49)/'MN  '/,C
     2(50)/'MN2+'/,C(51)/'MN3+'/,C(52)/'MN4+'/,C(53)/'FE  '/,C(54)/
     3'FE+2'/,C(55)/'FE3+'/,C(56)/'CO  '/,C(57)/'CO2+'/,C(58)/'CO3+'/
     4,C(59)/'I  '/,C(60)/'NI2+'/,C(61)/'NI3+'/,C(62)/'CU  '/,C(63)/
     5'CU1+'/,C(64)/'CU2+'/,C(65)/'ZN  '/,C(66)/'ZN2+'/,C(67)/'GA  '/,
     6C(68)/'GA3+'/,C(69)/'GE  '/,C(70)/'GE4+'/,C(71)/'AS  '/,C(72)/
     7'SE  '/,C(73)/'BR  '/,C(74)/'BR1-'/,C(75)/'KR  '/,C(76)/'RB  '/,
     8C(77)/'RB1+'/,C(78)/'SR  '/,C(79)/'SR2+'/,C(80)/'Y   '/
      DATA C(81)/'Y3+ '/,C(82)/'ZR  '/,C(83)/'ZR4+'/,C(84)/'NB  '/,C(85)
     1/'NB3+'/,C(86)/'NB5+'/,C(87)/'MO  '/,C(88)/'MO3+'/,C(89)/'MO5+'/,
     2C(90)/'MO6+'/,C(91)/'TC  '/,C(92)/'RU  '/,C(93)/'RU3+'/,C(94)/
     3'RU+4'/,C(95)/'RH  '/,C(96)/'RH3+'/,C(97)/'RH4+'/,C(98)/'PD  '/
     4,C(99)/'PD2+'/,C(100)/'PD4+'/,C(101)/'AG  '/,C(102)/'AG1+'/,
     5C(103)/'AG2+'/,C(104)/'CD  '/,C(105)/'CD2+'/,C(106)/'IN  '/,C(107)
     6/'IN3+'/,C(108)/'SN  '/,C(109)/'SN2+'/,C(110)/'SN4+'/,C(111)/
     7'SB  '/,C(112)/'SB3+'/,C(113)/'SB5+'/,C(114)/'TE  '/,C(115)/
     8'I   '/C(116)/'I1- '/,C(117)/'XE  '/,C(118)/'CS  '/,C(119)/
     9 'CS1+'/,C(120)/'BA  '/
      DATA C(121)/'BA2+'/,C(122)/'LA  '/,C(123)/'LA3+'/,C(124)/'CE  '/,C
     1(125)/'CE3+'/,C(126)/'CE4+'/,C(127)/'PR  '/,C(128)/'PR3+'/,C(129)/
     2'PR4+'/,C(130)/'ND  '/,C(131)/'ND3+'/,C(132)/'PM  '/,C(133)/'PM3+'
     3/,C(134)/'SM  '/,C(135)/'SM3+'/,C(136)/'EU  '/,C(137)/'EU2+'/,
     4C(138)/'EU3+'/,C(139)/'GD  '/,C(140)/'GD3+'/,C(141)/'TB  '/,C(142)
     5/'TB3+'/,C(143)/'DY  '/,C(144)/'DY3+'/,C(145)/'HO  '/,C(146)/
     6'HO3+'/,C(147)/'ER  '/,C(148)/'ER3+'/,C(149)/'TM  '/,C(150)/'TM3+'
     7/,C(151)/'YB  '/,C(152)/'YB2+'/,C(153)/'YB3+'/,C(154)/'LU  '/,
     8C(155)/'LU3+'/,C(156)/'HF  '/,C(157)/'HF4+'/,C(158)/'TA  '/,
     9C(159)/'TA5+'/,C(160)/'W   '/
      DATA C(161)/'W6+ '/,C(162)/'RE  '/,C(163)/'OS  '/,C(164)/'OS4+'/,C
     1(165)/'IR  '/,C(166)/'IR3+'/,C(167)/'IR4+'/,C(168)/'PT  '/,C(169)/
     2'PT2+'/,C(170)/'PT4+'/,C(171)/'AU  '/,C(172)/'AU1+'/,C(173)/'AU3+'
     3/,C(174)/'HG  '/,C(175)/'HG1+'/,C(176)/'HG2+'/,C(177)/'TL  '/,C(1
     478)/'TL1+'/,C(179)/'TL3+'/,C(180)/'PB  '/,C(181)/'PB2+'/,C(182)/
     5'PB4+'/,C(183)/'BI  '/,C(184)/'BI3+'/,C(185)/'BI5+'/,C(186)/
     6'PO  '/,C(187)/'AT  '/,C(188)/'RN  '/,C(189)/'FR  '/,C(190)/'RA  '
     7/,C(191)/'RA2+'/,C(192)/'AC  '/,C(193)/'AC3+'/,C(194)/'TH  '/
     8,C(195)/'TH4+'/,C(196)/'PA  '/,C(197)/'U   '/,C(198)/'U3+ '/,
     9C(199)/'U4+ '/,C(200)/'U6+ '/
      DATA C(201)/'NP  '/,C(202)/'NP3+'/,C(203)/'NP4+'/,C(204)/'NP6+'/,C
     1(205)/'PU  '/,C(206)/'PU3+'/,C(207)/'PU4+'/,C(208)/'PU6+'/,C(209)/
     2'AM  '/,C(210)/'CM  '/,C(211)/'BK  '/,C(212)/'CF  '/,
     3C(213)/'O2-.'/,C(214)/'    '/
      DO 1 I=1,214                                                              
      IF (ASYMB-S(I)) 1,2,1                                                     
 1    CONTINUE                                                                  
      I=0 
C	If we get here, we did not recognize the full name
C	Maybe we have an 'A', 'B' etc identifier
C	                                                                      
	its1=asymb
	if(tsym1(3:3).eq.' ')then
		n=1
	else if(tsym1(4:4).eq.' ')then
		n=2
	else
		i=0
		goto 2
	endif
	do i=1,214
		its2=s(i)
		if(tsym1(1:n).eq.tsym2(1:n))goto 2
	enddo
	i=0
      WRITE (*,9000)                                                            
 2    IELMT=I                                                                   
 9000 FORMAT (46H NO SCATTERING FACTOR TABLES EXIST FOR ELEMENT,A4)             
      RETURN                                                                    
C
C
      END                                                                       
      BLOCK DATA BLKDT1                                                        
C-----CONTAINS SCATTERING FACTOR CONSTANTS BY CROMER AND MANN AS LISTED         
C-----IN THE INTERNATIONAL TABLES FOR X RAY CRYSTALLOGRAPHY VOL 4               
C-CDC-THIS LARGE ROUTINE MAY HAVE TO BE SPLIT INTO SMALLER ONES                 
C-----FIRST PART                                                                
      COMMON /SK/ AA(1926)                                                      
      REAL I,J,K,L,M,N                                                          
      EQUIVALENCE (AA(1),A(1)), (AA(73),B(1)), (AA(145),C(1)), (AA(217),        
     1D(1)), (AA(289),E(1)), (AA(361),F(1)), (AA(433),G(1)),   (AA(505),        
     2H(1)), (AA(577),I(1)), (AA(649),J(1)), (AA(721),K(1)),   (AA(793),        
     3L(1)), (AA(865),M(1)), (AA(937),N(1)), (AA(1009),O(1)), (AA(1081),        
     4P(1)), (AA(1153),Q(1)), (AA(1225),R(1)), (AA(1297),S(1)),                 
     5(AA(1369),T(1)), (AA(1441),U(1)), (AA(1513),V(1)),      (AA(1585),        
     6W(1)), (AA(1657),X(1)), (AA(1729),Y(1)), (AA(1801),Z(1)),                 
     7(AA(1873),Z1(1))                                                          
      DIMENSION A(72), B(72), C(72), D(72), E(72) ,F(72), G(72), H(72),         
     1I(72), J(72), K(72), L(72), M(72), N(72), O(72), P(72), Q(72),            
     2R(72), S(72), T(72), U(72), V(72), W(72), X(72), Y(72), Z(72),            
     3Z1(54)                                                                    
      DATA A(1)/.493002/,A(2)/10.5109/,A(3)/.322912/,A(4)/26.1257/,A(5)/        
     1.140191/,A(6)/3.14236/,A(7)/.040810/,A(8)/57.7997/,A(9)/.003038/,A        
     2(10)/.489918/,A(11)/20.6593/,A(12)/.262003/,A(13)/7.74039/,A(14)/.        
     3196767/,A(15)/49.5519/,A(16)/.049879/,A(17)/2.20159/,A(18)/.001305        
     4/,A(19)/.897661/,A(20)/53.1368/,A(21)/.565616/,A(22)/15.1870/,A(23        
     5)/.415815/,A(24)/186.576/,A(25)/.116973/,A(26)/3.56709/,A(27)/.002        
     6389/,A(28)/.8734/,A(29)/9.1037/,A(30)/.6309/,A(31)/3.3568/,A(32)/.        
     73112/,A(33)/22.9276/,A(34)/.1780/,A(35)/.9821/,A(36)/.0064/,A(37)/        
     81.1282/,A(38)/3.9546/,A(39)/.7508/,A(40)/1.0524/,A(41)/.6175/,A(42        
     9)/85.3905/,A(43)/.4653/,A(44)/168.261/,A(45)/.0377/,A(46)/.6968/,A        
     $(47)/4.6237/,A(48)/.7888/,A(49)/1.9557/,A(50)/.3414/,A(51)/.6316/,        
     $A(52)/.1563/,A(53)/10.0953/,A(54)/.0167/,A(55)/1.5919/,A(56)/43.64        
     $27/,A(57)/1.1278/,A(58)/1.8623/,A(59)/.5391/,A(60)/103.483/,A(61)/        
     $.7029/,A(62)/.5420/,A(63)/.0385/,A(64)/6.2603/,A(65)/.0027/,A(66)/        
     $.8849/,A(67)/.8313/,A(68)/.7993/,A(69)/2.2758/,A(70)/.1647/,A(71)/        
     $5.1146/,A(72)/-6.1092/                                                    
      DATA B(1)/2.0545/,B(2)/23.2185/,B(3)/1.3326/,B(4)/1.0210/,B(5)/1.0        
     1979/,B(6)/60.3498/,B(7)/.7068/,B(8)/.1403/,B(9)/-.1932/,B(10)/2.31        
     200/,B(11)/20.8439/,B(12)/1.0200/,B(13)/10.2075/,B(14)/1.5886/,B(15        
     3)/.5687/,B(16)/.8650/,B(17)/51.6512/,B(18)/.2156/,B(19)/2.26069/,B        
     4(20)/22.6907/,B(21)/1.56165/,B(22)/.656665/,B(23)/1.05075/,B(24)/9        
     5.75618/,B(25)/.839259/,B(26)/55.5949/,B(27)/.286977/,B(28)/12.2126        
     6/,B(29)/.0057/,B(30)/3.1322/,B(31)/9.8933/,B(32)/2.0125/,B(33)/28.        
     79975/,B(34)/1.1663/,B(35)/.5826/,B(36)/-11.529/,B(37)/3.0485/,B(38        
     8)/13.2771/,B(39)/2.2868/,B(40)/5.7011/,B(41)/1.5463/,B(42)/.3239/,        
     9B(43)/.8670/,B(44)/32.9089/,B(45)/.2508/,B(46)/4.19160/,B(47)/12.8        
     $573/,B(48)/1.63969/,B(49)/4.17236/,B(50)/1.52673/,B(51)/47.0179/,B        
     $(52)/-20.307/,B(53)/-.01404/,B(54)/21.9412/,B(55)/3.5392/,B(56)/10        
     $.2825/,B(57)/2.6412/,B(58)/4.2944/,B(59)/1.5170/,B(60)/.2615/,B(61        
     $)/1.0243/,B(62)/26.1476/,B(63)/.2776/,B(64)/3.63220/,B(65)/5.27756        
     $/,B(66)/3.51057/,B(67)/14.7353/,B(68)/1.26064/,B(69)/.442258/,B(70        
     $)/.940706/,B(71)/47.3437/,B(72)/.653396/                                  
      DATA C(1)/3.9553/,C(2)/8.4042/,C(3)/3.1125/,C(4)/3.4262/,C(5)/1.45        
     146/,C(6)/.2306/,C(7)/1.1251/,C(8)/21.7184/,C(9)/.3515/,C(10)/4.762        
     26/,C(11)/3.2850/,C(12)/3.1736/,C(13)/8.8422/,C(14)/1.2674/,C(15)/.        
     33136/,C(16)/1.1128/,C(17)/129.424/,C(18)/.6760/,C(19)/3.2565/,C(20        
     4)/2.6671/,C(21)/3.9362/,C(22)/6.1153/,C(23)/1.3998/,C(24)/.2001/,C        
     5(25)/1.0032/,C(26)/14.0390/,C(27)/.4040/,C(28)/5.4204/,C(29)/2.827        
     65/,C(30)/2.1735/,C(31)/79.2611/,C(32)/1.2269/,C(33)/.3808/,C(34)/2        
     7.3073/,C(35)/7.1937/,C(36)/.8584/,C(37)/3.4988/,C(38)/2.1676/,C(39        
     8)/3.8378/,C(40)/4.7542/,C(41)/1.3284/,C(42)/.1850/,C(43)/.8497/,C(        
     944)/10.1411/,C(45)/.4853/,C(46)/6.4202/,C(47)/3.0387/,C(48)/1.9002        
     $/,C(49)/.7426/,C(50)/1.5936/,C(51)/31.5472/,C(52)/1.9646/,C(53)/85        
     $.0886/,C(54)/1.1151/,C(55)/4.17448/,C(56)/1.93816/,C(57)/3.38760/,        
     $C(58)/4.14553/,C(59)/1.20296/,C(60)/.228753/,C(61)/.528137/,C(62)/        
     $8.28524/,C(63)/.706786/,C(64)/6.2915/,C(65)/2.4386/,C(66)/3.0353/,        
     $C(67)/32.3337/,C(68)/1.9891/,C(69)/.6785/,C(70)/1.5410/,C(71)/81.6        
     $937/,C(72)/1.1407/                                                        
      DATA D(1)/5.66269/,D(2)/2.66520/,D(3)/3.07164/,D(4)/38.6634/,D(5)/        
     12.62446/,D(6)/.916946/,D(7)/1.39320/,D(8)/93.5458/,D(9)/1.24707/,D        
     2(10)/4.43918/,D(11)/1.64167/,D(12)/3.20345/,D(13)/3.43757/,D(14)/1        
     3.19453/,D(15)/.214900/,D(16)/.416530/,D(17)/6.65365/,D(18)/.746297        
     4/,D(19)/6.9053/,D(20)/1.4679/,D(21)/5.2034/,D(22)/22.2151/,D(23)/1        
     5.4379/,D(24)/.2536/,D(25)/1.5863/,D(26)/56.1720/,D(27)/.8669/,D(28        
     6)/6.4345/,D(29)/1.9067/,D(30)/4.1791/,D(31)/27.1570/,D(32)/1.7800/        
     7,D(33)/.5260/,D(34)/1.4908/,D(35)/68.1645/,D(36)/1.1149/,D(37)/11.        
     84604/,D(38)/.0104/,D(39)/7.1964/,D(40)/1.1662/,D(41)/6.2556/,D(42)        
     9/18.5194/,D(43)/1.6455/,D(44)/47.7784/,D(45)/-9.5574/,D(46)/18.291        
     $5/,D(47)/.0066/,D(48)/7.2084/,D(49)/1.1717/,D(50)/6.5337/,D(51)/19        
     $.5424/,D(52)/2.3386/,D(53)/60.4486/,D(54)/-16.378/,D(55)/7.4845/,D        
     $(56)/.9072/,D(57)/6.7723/,D(58)/14.8407/,D(59)/.6539/,D(60)/43.898        
     $3/,D(61)/1.6442/,D(62)/33.3929/,D(63)/1.4445/,D(64)/8.2186/,D(65)/        
     $12.7949/,D(66)/7.4398/,D(67)/.7748/,D(68)/1.0519/,D(69)/213.187/,D        
     $(70)/.8659/,D(71)/41.6841/,D(72)/1.4228/                                  
      DATA E(1)/7.9578/,E(2)/12.6331/,E(3)/7.4917/,E(4)/.7674/,E(5)/6.35        
     190/,E(6)/-.0020/,E(7)/1.1915/,E(8)/31.9128/,E(9)/-4.9978/,E(10)/8.        
     26266/,E(11)/10.4421/,E(12)/7.3873/,E(13)/.6599/,E(14)/1.5899/,E(15        
     3)/85.7484/,E(16)/1.0211/,E(17)/178.437/,E(18)/1.3751/,E(19)/15.634        
     48/,E(20)/-.0074/,E(21)/7.9518/,E(22)/.6089/,E(23)/8.4372/,E(24)/10        
     5.3116/,E(25)/.8537/,E(26)/25.9905/,E(27)/-14.875/,E(28)/9.1890/,E(        
     629)/9.0213/,E(30)/7.3679/,E(31)/.5729/,E(32)/1.6409/,E(33)/136.108        
     7/,E(34)/1.4680/,E(35)/51.3531/,E(36)/1.3329/,E(37)/13.4008/,E(38)/        
     8.298540/,E(39)/8.02730/,E(40)/7.96290/,E(41)/1.65943/,E(42)/-.2860        
     94/,E(43)/1.57936/,E(44)/16.0662/,E(45)/-6.6667/,E(46)/9.7595/,E(47        
     $)/7.8508/,E(48)/7.3558/,E(49)/.5000/,E(50)/1.6991/,E(51)/35.6338/,        
     $E(52)/1.9021/,E(53)/116.105/,E(54)/1.2807/,E(55)/9.11423/,E(56)/7.        
     $52430/,E(57)/7.62174/,E(58)/.457585/,E(59)/2.27930/,E(60)/19.5361/        
     $,E(61)/.087899/,E(62)/61.6558/,E(63)/.897155/,E(64)/17.7344/,E(65)        
     $/.220610/,E(66)/8.73816/,E(67)/7.04716/,E(68)/5.25691/,E(69)/-.157        
     $62/,E(70)/1.92134/,E(71)/15.9768/,E(72)/-14.652/                          
C-----SECOND PART                                                               
      DATA F(1)/19.5114/,F(2)/.178847/,F(3)/8.23473/,F(4)/6.67018/,F(5)/        
     12.01341/,F(6)/-.29263/,F(7)/1.52080/,F(8)/12.9464/,F(9)/-13.280/,F        
     2(10)/10.2971/,F(11)/6.8657/,F(12)/7.3511/,F(13)/.4385/,F(14)/2.070        
     33/,F(15)/26.8938/,F(16)/2.0571/,F(17)/102.478/,F(18)/1.2199/,F(19)        
     4/10.1060/,F(20)/6.8818/,F(21)/7.3541/,F(22)/.4409/,F(23)/2.2884/,F        
     5(24)/20.3004/,F(25)/.0223/,F(26)/115.122/,F(27)/1.2298/,F(28)/9.43        
     6141/,F(29)/6.39535/,F(30)/7.74190/,F(31)/.383349/,F(32)/2.15343/,F        
     7(33)/15.1908/,F(34)/.016865/,F(35)/63.9690/,F(36)/.656565/,F(37)/1        
     85.6887/,F(38)/.679003/,F(39)/8.14208/,F(40)/5.40135/,F(41)/2.03081        
     9/,F(42)/9.97278/,F(43)/-9.5760/,F(44)/.940464/,F(45)/1.71430/,F(46        
     $)/10.6406/,F(47)/6.1038/,F(48)/7.3537/,F(49)/.3920/,F(50)/3.3240/,        
     $F(51)/20.2626/,F(52)/1.4922/,F(53)/98.7399/,F(54)/1.1832/,F(55)/9.        
     $54034/,F(56)/5.66078/,F(57)/7.75090/,F(58)/.344261/,F(59)/3.58274/        
     $,F(60)/13.3075/,F(61)/.509107/,F(62)/32.4224/,F(63)/.616898/,F(64)        
     $/9.68090/,F(65)/5.59463/,F(66)/7.81136/,F(67)/.334393/,F(68)/2.876        
     $03/,F(69)/12.8288/,F(70)/.113575/,F(71)/32.8761/,F(72)/.518275/           
      DATA G(1)/11.2819/,G(2)/5.3409/,G(3)/7.3573/,G(4)/.3432/,G(5)/3.01        
     193/,G(6)/17.8674/,G(7)/2.2441/,G(8)/83.7543/,G(9)/1.0896/,G(10)/10        
     2.8061/,G(11)/5.2796/,G(12)/7.3620/,G(13)/.3435/,G(14)/3.5268/,G(15        
     3)/14.3430/,G(16)/.2184/,G(17)/41.3235/,G(18)/1.0874/,G(19)/9.84521        
     4/,G(20)/4.91797/,G(21)/7.87194/,G(22)/.294393/,G(23)/3.56531/,G(24        
     5)/10.8171/,G(25)/.323613/,G(26)/24.1281/,G(27)/.393974/,G(28)/9.96        
     6253/,G(29)/4.84850/,G(30)/7.97057/,G(31)/.283303/,G(32)/2.76067/,G        
     7(33)/10.4852/,G(34)/.054447/,G(35)/27.5730/,G(36)/.251877/,G(37)/1        
     81.7695/,G(38)/4.7611/,G(39)/7.3573/,G(40)/.3072/,G(41)/3.5222/,G(4        
     92)/15.3535/,G(43)/2.3045/,G(44)/76.8805/,G(45)/1.0369/,G(46)/11.04        
     $24/,G(47)/4.6538/,G(48)/7.3740/,G(49)/.3053/,G(50)/4.1346/,G(51)/1        
     $2.0546/,G(52)/.4399/,G(53)/31.2809/,G(54)/1.0097/,G(55)/11.1764/,G        
     $(56)/4.6147/,G(57)/7.3863/,G(58)/.3005/,G(59)/3.3948/,G(60)/11.672        
     $9/,G(61)/.0724/,G(62)/38.5566/,G(63)/.9707/,G(64)/12.2841/,G(65)/4        
     $.2791/,G(66)/7.3409/,G(67)/.2784/,G(68)/4.0034/,G(69)/13.5359/,G(7        
     $0)/2.3488/,G(71)/71.1692/,G(72)/1.0118/                                   
      DATA H(1)/11.2296/,H(2)/4.1231/,H(3)/7.3883/,H(4)/.2726/,H(5)/4.73        
     193/,H(6)/10.2443/,H(7)/.7108/,H(8)/25.6466/,H(9)/.9324/,H(10)/10.3        
     2380/,H(11)/3.90969/,H(12)/7.88173/,H(13)/.238668/,H(14)/4.76795/,H        
     3(15)/8.35583/,H(16)/.725591/,H(17)/18.3491/,H(18)/.286667/,H(19)/1        
     42.8376/,H(20)/3.8785/,H(21)/7.2920/,H(22)/.2565/,H(23)/4.4438/,H(2        
     54)/12.1763/,H(25)/2.3800/,H(26)/66.3421/,H(27)/1.0341/,H(28)/11.41        
     666/,H(29)/3.6766/,H(30)/7.4005/,H(31)/.2449/,H(32)/5.3442/,H(33)/8        
     7.8730/,H(34)/.9773/,H(35)/22.1626/,H(36)/.8614/,H(37)/10.7806/,H(3        
     88)/3.54770/,H(39)/7.75868/,H(40)/.223140/,H(41)/5.22746/,H(42)/7.6        
     94468/,H(43)/.847114/,H(44)/16.9673/,H(45)/.386044/,H(46)/13.3380/,        
     $H(47)/3.5828/,H(48)/7.1676/,H(49)/.2470/,H(50)/5.6158/,H(51)/11.39        
     $66/,H(52)/1.6735/,H(53)/64.8126/,H(54)/1.1910/,H(55)/11.9475/,H(56        
     $)/3.3669/,H(57)/7.3573/,H(58)/.2274/,H(59)/6.2455/,H(60)/8.6625/,H        
     $(61)/1.5578/,H(62)/25.8487/,H(63)/.8900/,H(64)/11.8168/,H(65)/3.37        
     $484/,H(66)/7.11181/,H(67)/.244078/,H(68)/5.78135/,H(69)/7.98760/,H        
     $(70)/1.14523/,H(71)/19.8970/,H(72)/1.14431/                               
      DATA I(1)/14.0743/,I(2)/3.2655/,I(3)/7.0318/,I(4)/.2333/,I(5)/5.16        
     152/,I(6)/10.3163/,I(7)/2.4100/,I(8)/58.7097/,I(9)/1.3041/,I(10)/11        
     2.9719/,I(11)/2.9946/,I(12)/7.3862/,I(13)/.2031/,I(14)/6.4668/,I(15        
     3)/7.0826/,I(16)/1.3940/,I(17)/18.0995/,I(18)/.7807/,I(19)/15.2354/        
     4,I(20)/3.0669/,I(21)/6.7006/,I(22)/.2412/,I(23)/4.3591/,I(24)/10.7        
     5805/,I(25)/2.9623/,I(26)/61.4135/,I(27)/1.7189/,I(28)/12.6920/,I(2        
     69)/2.81262/,I(30)/6.69883/,I(31)/.227890/,I(32)/6.06692/,I(33)/6.3        
     76441/,I(34)/1.00660/,I(35)/14.4122/,I(36)/1.53545/,I(37)/16.0816/,        
     8I(38)/2.8509/,I(39)/6.3747/,I(40)/.2516/,I(41)/3.7068/,I(42)/11.44        
     968/,I(43)/3.6830/,I(44)/54.7625/,I(45)/2.1313/,I(46)/12.9172/,I(47        
     $)/2.53718/,I(48)/6.70003/,I(49)/.205855/,I(50)/6.06791/,I(51)/5.47        
     $913/,I(52)/.859041/,I(53)/11.6030/,I(54)/1.45572/,I(55)/16.6723/,I        
     $(56)/2.6345/,I(57)/6.0701/,I(58)/.2647/,I(59)/3.4313/,I(60)/12.947        
     $9/,I(61)/4.2779/,I(62)/47.7972/,I(63)/2.5310/,I(64)/17.0006/,I(65)        
     $/2.4098/,I(66)/5.8196/,I(67)/.2726/,I(68)/3.9731/,I(69)/15.2372/,I        
     $(70)/4.3543/,I(71)/43.8163/,I(72)/2.8409/                                 
      DATA J(1)/17.1789/,J(2)/2.1723/,J(3)/5.2358/,J(4)/16.5796/,J(5)/5.        
     16377/,J(6)/.2609/,J(7)/3.9851/,J(8)/41.4328/,J(9)/2.9557/,J(10)/17        
     2.1718/,J(11)/2.2059/,J(12)/6.3338/,J(13)/19.3345/,J(14)/5.5754/,J(        
     315)/.2871/,J(16)/3.7272/,J(17)/58.1535/,J(18)/3.1776/,J(19)/17.355        
     45/,J(20)/1.9384/,J(21)/6.7286/,J(22)/16.5623/,J(23)/5.5493/,J(24)/        
     5.2261/,J(25)/3.5375/,J(26)/39.3972/,J(27)/2.8250/,J(28)/17.1784/,J        
     6(29)/1.7888/,J(30)/9.6435/,J(31)/17.3151/,J(32)/5.1399/,J(33)/.274        
     78/,J(34)/1.5292/,J(35)/164.934/,J(36)/3.4873/,J(37)/17.5816/,J(38)        
     8/1.7139/,J(39)/7.6598/,J(40)/14.7957/,J(41)/5.8981/,J(42)/.1603/,J        
     9(43)/2.7817/,J(44)/31.2087/,J(45)/2.0782/,J(46)/17.5663/,J(47)/1.5        
     $564/,J(48)/9.8184/,J(49)/14.0988/,J(50)/5.4220/,J(51)/.1664/,J(52)        
     $/2.6694/,J(53)/132.376/,J(54)/2.5064/,J(55)/18.0874/,J(56)/1.4907/        
     $,J(57)/8.1373/,J(58)/12.6963/,J(59)/2.5654/,J(60)/24.5651/,J(61)/-        
     $34.193/,J(62)/-.0138/,J(63)/41.4025/,J(64)/17.7760/,J(65)/1.40290/        
     $,J(66)/10.2946/,J(67)/12.8006/,J(68)/5.72629/,J(69)/.125599/,J(70)        
     $/3.26588/,J(71)/104.354/,J(72)/1.91213/                                   
C-----THIRD PART                                                                
      DATA K(1)/17.9268/,K(2)/1.35417/,K(3)/9.15310/,K(4)/11.2145/,K(5)/        
     11.76795/,K(6)/22.6599/,K(7)/-33.108/,K(8)/-.01319/,K(9)/40.2602/,K        
     2(10)/17.8765/,K(11)/1.27618/,K(12)/10.9480/,K(13)/11.9160/,K(14)/5        
     3.41732/,K(15)/.117622/,K(16)/3.65721/,K(17)/87.6627/,K(18)/2.06929        
     4/,K(19)/18.1668/,K(20)/1.21480/,K(21)/10.0562/,K(22)/10.1483/,K(23        
     5)/1.01118/,K(24)/21.6054/,K(25)/-2.6479/,K(26)/-.10276/,K(27)/9.41        
     6454/,K(28)/17.6142/,K(29)/1.18865/,K(30)/12.0144/,K(31)/11.7660/,K        
     7(32)/4.04183/,K(33)/.204785/,K(34)/3.53346/,K(35)/69.7957/,K(36)/3        
     8.75591/,K(37)/19.8812/,K(38)/.019175/,K(39)/18.0653/,K(40)/1.13305        
     9/,K(41)/11.0177/,K(42)/10.1621/,K(43)/1.94715/,K(44)/28.3389/,K(45        
     $)/-12.912/,K(46)/17.9163/,K(47)/1.12446/,K(48)/13.3417/,K(49)/.028        
     $781/,K(50)/10.7990/,K(51)/9.28206/,K(52)/.337905/,K(53)/25.7228/,K        
     $(54)/-6.3934/,K(55)/3.7025/,K(56)/.2772/,K(57)/17.2356/,K(58)/1.09        
     $58/,K(59)/12.8876/,K(60)/11.0040/,K(61)/3.7429/,K(62)/61.6584/,K(6        
     $3)/4.3875/,K(64)/21.1664/,K(65)/.014734/,K(66)/18.2017/,K(67)/1.03        
     $031/,K(68)/11.7423/,K(69)/9.53659/,K(70)/2.30951/,K(71)/26.6307/,K        
     $(72)/-14.421/                                                             
      DATA L(1)/21.0149/,L(2)/.014345/,L(3)/18.0992/,L(4)/1.02238/,L(5)/        
     111.4632/,L(6)/8.78809/,L(7)/.740625/,L(8)/23.3452/,L(9)/-14.316/,L        
     2(10)/17.8871/,L(11)/1.03649/,L(12)/11.1750/,L(13)/8.48061/,L(14)/6        
     3.57891/,L(15)/.058881/,L(16)/0.0/,L(17)/0.0/,L(18)/.344941/,L(19)/        
     419.1301/,L(20)/.864132/,L(21)/11.0948/,L(22)/8.14487/,L(23)/4.6490        
     51/,L(24)/21.5707/,L(25)/2.71263/,L(26)/86.8472/,L(27)/5.40428/,L(2        
     68)/19.2674/,L(29)/.808520/,L(30)/12.9182/,L(31)/8.43467/,L(32)/4.8        
     76337/,L(33)/24.7997/,L(34)/1.56756/,L(35)/94.2928/,L(36)/5.37874/,        
     8L(37)/18.5638/,L(38)/.847329/,L(39)/13.2885/,L(40)/8.37164/,L(41)/        
     99.32602/,L(42)/.017662/,L(43)/3.00964/,L(44)/22.8870/,L(45)/-3.189        
     $2/,L(46)/18.5003/,L(47)/.844582/,L(48)/13.1787/,L(49)/8.12534/,L(5        
     $0)/4.71304/,L(51)/.036495/,L(52)/2.18535/,L(53)/20.8504/,L(54)/1.4        
     $2357/,L(55)/19.2957/,L(56)/.751536/,L(57)/14.3501/,L(58)/8.21758/,        
     $L(59)/4.73425/,L(60)/25.8749/,L(61)/1.28918/,L(62)/98.6062/,L(63)/        
     $5.32800/,L(64)/18.8785/,L(65)/.764252/,L(66)/14.1259/,L(67)/7.8443        
     $8/,L(68)/3.32515/,L(69)/21.2487/,L(70)/-6.1989/,L(71)/-.01036/,L(7        
     $2)/11.8678/                                                               
      DATA M(1)/18.8545/,M(2)/.760825/,M(3)/13.9806/,M(4)/7.62436/,M(5)/        
     12.53464/,M(6)/19.3317/,M(7)/-5.6526/,M(8)/-.01020/,M(9)/11.2835/,M        
     2(10)/19.3319/,M(11)/.698655/,M(12)/15.5017/,M(13)/7.98929/,M(14)/5        
     3.29537/,M(15)/25.2052/,M(16)/.605844/,M(17)/76.8986/,M(18)/5.26593        
     4/,M(19)/19.1701/,M(20)/.696219/,M(21)/15.2096/,M(22)/7.55573/,M(23        
     5)/4.32234/,M(24)/22.5057/,M(25)/0.0/,M(26)/0.0/,M(27)/5.29160/,M(2        
     68)/19.2493/,M(29)/.683839/,M(30)/14.7900/,M(31)/7.14833/,M(32)/2.8        
     79289/,M(33)/17.9144/,M(34)/-7.9492/,M(35)/.005127/,M(36)/13.0174/,        
     8M(37)/19.2808/,M(38)/.6446/,M(39)/16.6885/,M(40)/7.4726/,M(41)/4.8        
     9045/,M(42)/24.6605/,M(43)/1.0463/,M(44)/99.8156/,M(45)/5.1790/,M(4        
     $6)/19.1812/,M(47)/.646179/,M(48)/15.9719/,M(49)/7.19123/,M(50)/5.2        
     $7475/,M(51)/21.7326/,M(52)/.357534/,M(53)/66.1147/,M(54)/5.21572/,        
     $M(55)/19.1643/,M(56)/.645643/,M(57)/16.2456/,M(58)/7.18544/,M(59)/        
     $4.37090/,M(60)/21.4072/,M(61)/0.0/,M(62)/0.0/,M(63)/5.21404/,M(64)        
     $/19.2214/,M(65)/.5946/,M(66)/17.6444/,M(67)/6.9089/,M(68)/4.4610/,        
     $M(69)/24.7008/,M(70)/1.6029/,M(71)/87.4825/,M(72)/5.0694/                 
      DATA N(1)/19.1514/,N(2)/.597922/,N(3)/17.2535/,N(4)/6.80639/,N(5)/        
     14.47128/,N(6)/20.2521/,N(7)/0.0/,N(8)/0.0/,N(9)/5.11937/,N(10)/19.        
     21624/,N(11)/.5476/,N(12)/18.5596/,N(13)/6.3776/,N(14)/4.2948/,N(15        
     3)/25.8499/,N(16)/2.0396/,N(17)/92.8029/,N(18)/4.9391/,N(19)/19.104        
     45/,N(20)/.551522/,N(21)/18.1108/,N(22)/6.32470/,N(23)/3.78897/,N(2        
     54)/17.3595/,N(25)/0.0/,N(26)/0.0/,N(27)/4.99635/,N(28)/19.1889/,N(        
     629)/5.8303/,N(30)/19.1005/,N(31)/.5031/,N(32)/4.4585/,N(33)/26.890        
     79/,N(34)/2.4663/,N(35)/83.9571/,N(36)/4.7821/,N(37)/19.1094/,N(38)        
     8/.5036/,N(39)/19.0548/,N(40)/5.8378/,N(41)/4.5648/,N(42)/23.3752/,        
     9N(43)/.4870/,N(44)/62.2061/,N(45)/4.7861/,N(46)/18.9333/,N(47)/5.7        
     $640/,N(48)/19.7131/,N(49)/.4655/,N(50)/3.4182/,N(51)/14.0049/,N(52        
     $)/.0193/,N(53)/-.7583/,N(54)/3.9182/,N(55)/19.6418/,N(56)/5.3034/,        
     $N(57)/19.0455/,N(58)/.4607/,N(59)/5.0371/,N(60)/27.9074/,N(61)/2.6        
     $827/,N(62)/75.2825/,N(63)/4.5909/,N(64)/18.9755/,N(65)/.467196/,N(        
     $66)/18.9330/,N(67)/5.22126/,N(68)/5.10789/,N(69)/19.5902/,N(70)/.2        
     $88753/,N(71)/55.5113/,N(72)/4.69626/                                      
      DATA O(1)/19.8685/,O(2)/5.44853/,O(3)/19.0302/,O(4)/.467973/,O(5)/        
     12.41253/,O(6)/14.1259/,O(7)/0.0/,O(8)/0.0/,O(9)/4.69263/,O(10)/19.        
     29644/,O(11)/4.81742/,O(12)/19.0138/,O(13)/.420885/,O(14)/6.14487/,        
     3O(15)/28.5284/,O(16)/2.52390/,O(17)/70.8403/,O(18)/4.35200/,O(19)/        
     420.1472/,O(20)/4.3470/,O(21)/18.9949/,O(22)/.3814/,O(23)/7.5138/,O        
     5(24)/27.7660/,O(25)/2.2735/,O(26)/66.8776/,O(27)/4.0712/,O(28)/20.        
     62332/,O(29)/4.3579/,O(30)/18.9970/,O(31)/.3815/,O(32)/7.8069/,O(33        
     7)/29.5259/,O(34)/2.8868/,O(35)/84.9304/,O(36)/4.0714/,O(37)/20.293        
     83/,O(38)/3.9282/,O(39)/19.0298/,O(40)/.3440/,O(41)/8.9767/,O(42)/2        
     96.4659/,O(43)/1.9900/,O(44)/64.2658/,O(45)/3.7118/,O(46)/20.3892/,        
     $O(47)/3.5690/,O(48)/19.1062/,O(49)/.3107/,O(50)/10.6620/,O(51)/24.        
     $3879/,O(52)/1.4953/,O(53)/213.904/,O(54)/3.3352/,O(55)/20.3524/,O(        
     $56)/3.5520/,O(57)/19.1278/,O(58)/.3086/,O(59)/10.2821/,O(60)/23.71        
     $28/,O(61)/.9615/,O(62)/59.4565/,O(63)/3.2791/,O(64)/20.3361/,O(65)        
     $/3.2160/,O(66)/19.2970/,O(67)/.2756/,O(68)/10.8880/,O(69)/20.2073/        
     $,O(70)/2.6959/,O(71)/167.202/,O(72)/2.7731/                               
C-----FORTH PART                                                                
      DATA P(1)/20.1807/,P(2)/3.21367/,P(3)/19.1136/,P(4)/.283310/,P(5)/        
     110.9054/,P(6)/20.0558/,P(7)/.773634/,P(8)/51.7460/,P(9)/3.02902/,P        
     2(10)/20.5780/,P(11)/2.94817/,P(12)/19.5990/,P(13)/.244475/,P(14)/1        
     31.3727/,P(15)/18.7726/,P(16)/3.28719/,P(17)/133.124/,P(18)/2.14678        
     4/,P(19)/20.2489/,P(20)/2.92070/,P(21)/19.3763/,P(22)/.250698/,P(23        
     5)/11.6323/,P(24)/17.8211/,P(25)/.336048/,P(26)/54.9453/,P(27)/2.40        
     6860/,P(28)/21.1671/,P(29)/2.81219/,P(30)/19.7695/,P(31)/.226836/,P        
     7(32)/11.8513/,P(33)/17.6083/,P(34)/3.33049/,P(35)/127.113/,P(36)/1        
     8.86264/,P(37)/20.8036/,P(38)/2.77691/,P(39)/19.5590/,P(40)/.231540        
     9/,P(41)/11.9369/,P(42)/16.5408/,P(43)/.612376/,P(44)/43.1692/,P(45        
     $)/2.09013/,P(46)/20.3235/,P(47)/2.65941/,P(48)/19.8186/,P(49)/.218        
     $850/,P(50)/12.1233/,P(51)/15.7992/,P(52)/.144583/,P(53)/62.2355/,P        
     $(54)/1.59180/,P(55)/22.0440/,P(56)/2.77393/,P(57)/19.6697/,P(58)/.        
     $222087/,P(59)/12.3856/,P(60)/16.7669/,P(61)/2.82428/,P(62)/143.644        
     $/,P(63)/2.05830/,P(64)/21.3727/,P(65)/2.64520/,P(66)/19.7491/,P(67        
     $)/.214299/,P(68)/12.1329/,P(69)/15.3230/,P(70)/.975180/,P(71)/36.4        
     $065/,P(72)/1.77132/                                                       
      DATA Q(1)/20.9413/,Q(2)/2.54467/,Q(3)/20.0539/,Q(4)/.202481/,Q(5)/        
     112.4668/,Q(6)/14.8137/,Q(7)/.296689/,Q(8)/45.4643/,Q(9)/1.24285/,Q        
     2(10)/22.6845/,Q(11)/2.66248/,Q(12)/19.6847/,Q(13)/.210628/,Q(14)/1        
     32.7740/,Q(15)/15.8850/,Q(16)/2.85137/,Q(17)/137.903/,Q(18)/1.98486        
     4/,Q(19)/21.9610/,Q(20)/2.52722/,Q(21)/19.9339/,Q(22)/.199237/,Q(23        
     5)/12.1200/,Q(24)/14.1783/,Q(25)/1.51031/,Q(26)/30.8717/,Q(27)/1.47        
     6588/,Q(28)/23.3405/,Q(29)/2.56270/,Q(30)/19.6095/,Q(31)/.202088/,Q        
     7(32)/13.1235/,Q(33)/15.1009/,Q(34)/2.87516/,Q(35)/132.721/,Q(36)/2        
     8.02876/,Q(37)/22.5527/,Q(38)/2.41740/,Q(39)/20.1108/,Q(40)/.185769        
     9/,Q(41)/12.0671/,Q(42)/13.1275/,Q(43)/2.07492/,Q(44)/27.4491/,Q(45        
     $)/1.19499/,Q(46)/24.0042/,Q(47)/2.47274/,Q(48)/19.4258/,Q(49)/.196        
     $451/,Q(50)/13.4396/,Q(51)/14.3996/,Q(52)/2.89604/,Q(53)/128.007/,Q        
     $(54)/2.20963/,Q(55)/23.1504/,Q(56)/2.31641/,Q(57)/20.2599/,Q(58)/.        
     $174081/,Q(59)/11.9202/,Q(60)/12.1571/,Q(61)/2.71488/,Q(62)/24.8242        
     $/,Q(63)/.954586/,Q(64)/24.6274/,Q(65)/2.3879/,Q(66)/19.0886/,Q(67)        
     $/.1942/,Q(68)/13.7603/,Q(69)/13.7546/,Q(70)/2.9227/,Q(71)/123.174/        
     $,Q(72)/2.5745/                                                            
      DATA R(1)/24.0063/,R(2)/2.27783/,R(3)/19.9504/,R(4)/.173530/,R(5)/        
     111.8034/,R(6)/11.6096/,R(7)/3.87243/,R(8)/26.5156/,R(9)/1.36389/,R        
     2(10)/23.7497/,R(11)/2.22258/,R(12)/20.3745/,R(13)/.163940/,R(14)/1        
     31.8509/,R(15)/11.3110/,R(16)/3.26503/,R(17)/22.9966/,R(18)/.759344        
     4/,R(19)/25.0709/,R(20)/2.25341/,R(21)/19.0798/,R(22)/.181951/,R(23        
     5)/13.8518/,R(24)/12.9331/,R(25)/3.54545/,R(26)/101.398/,R(27)/2.41        
     6960/,R(28)/24.3466/,R(29)/2.13553/,R(30)/20.4208/,R(31)/.155525/,R        
     7(32)/11.8708/,R(33)/10.5782/,R(34)/3.71490/,R(35)/21.7029/,R(36)/.        
     8645089/,R(37)/25.8976/,R(38)/2.24256/,R(39)/18.2185/,R(40)/.196143        
     9/,R(41)/14.3167/,R(42)/12.6648/,R(43)/2.95354/,R(44)/115.362/,R(45        
     $)/3.58324/,R(46)/24.9559/,R(47)/2.05601/,R(48)/20.3271/,R(49)/.149        
     $525/,R(50)/12.2471/,R(51)/10.0499/,R(52)/3.77300/,R(53)/21.2773/,R        
     $(54)/.691967/,R(55)/26.5070/,R(56)/2.18020/,R(57)/17.6383/,R(58)/.        
     $202172/,R(59)/14.5596/,R(60)/12.1899/,R(61)/2.96577/,R(62)/111.874        
     $/,R(63)/4.29728/,R(64)/25.5395/,R(65)/1.98040/,R(66)/20.2861/,R(67        
     $)/.143384/,R(68)/11.9812/,R(69)/9.34972/,R(70)/4.50073/,R(71)/19.5        
     $810/,R(72)/.689690/                                                       
      DATA S(1)/26.9049/,S(2)/2.07051/,S(3)/17.2940/,S(4)/.197940/,S(5)/        
     114.5583/,S(6)/11.4407/,S(7)/3.63837/,S(8)/92.6566/,S(9)/4.56796/,S        
     2(10)/26.1296/,S(11)/1.91072/,S(12)/20.0994/,S(13)/.139358/,S(14)/1        
     31.9788/,S(15)/8.80018/,S(16)/4.93676/,S(17)/18.5908/,S(18)/.852795        
     4/,S(19)/27.6563/,S(20)/2.07356/,S(21)/16.4285/,S(22)/.223545/,S(23        
     5)/14.9779/,S(24)/11.3604/,S(25)/2.98233/,S(26)/105.703/,S(27)/5.92        
     6046/,S(28)/26.7220/,S(29)/1.84659/,S(30)/19.7748/,S(31)/.137290/,S        
     7(32)/12.1506/,S(33)/8.36225/,S(34)/5.17379/,S(35)/17.8974/,S(36)/1        
     8.17613/,S(37)/28.1819/,S(38)/2.02859/,S(39)/15.8851/,S(40)/.238849        
     9/,S(41)/15.1542/,S(42)/10.9975/,S(43)/2.98706/,S(44)/102.961/,S(45        
     $)/6.75621/,S(46)/27.3083/,S(47)/1.78711/,S(48)/19.3320/,S(49)/.136        
     $974/,S(50)/12.3339/,S(51)/7.96778/,S(52)/5.38348/,S(53)/17.2922/,S        
     $(54)/1.63929/,S(55)/28.6641/,S(56)/1.98890/,S(57)/15.4345/,S(58)/.        
     $257119/,S(59)/15.3087/,S(60)/10.6647/,S(61)/2.98963/,S(62)/100.417        
     $/,S(63)/7.56672/,S(64)/28.1209/,S(65)/1.78503/,S(66)/17.6817/,S(67        
     $)/.159970/,S(68)/13.3335/,S(69)/8.18304/,S(70)/5.14657/,S(71)/20.3        
     $900/,S(72)/3.70983/                                                       
      DATA T(1)/27.8917/,T(2)/1.73272/,T(3)/18.7614/,T(4)/.138790/,T(5)/        
     112.6072/,T(6)/7.64412/,T(7)/5.47647/,T(8)/16.8153/,T(9)/2.26001/,T        
     2(10)/28.9476/,T(11)/1.90182/,T(12)/15.2208/,T(13)/9.98519/,T(14)/1        
     35.1000/,T(15)/.261033/,T(16)/3.71601/,T(17)/84.3298/,T(18)/7.97628        
     4/,T(19)/28.4628/,T(20)/1.68216/,T(21)/18.1210/,T(22)/.142292/,T(23        
     5)/12.8429/,T(24)/7.33727/,T(25)/5.59415/,T(26)/16.3535/,T(27)/2.97        
     6573/,T(28)/29.1440/,T(29)/1.83262/,T(30)/15.1726/,T(31)/9.59990/,T        
     7(32)/14.7586/,T(33)/.275116/,T(34)/4.30013/,T(35)/72.0290/,T(36)/8        
     8.58154/,T(37)/28.8131/,T(38)/1.59136/,T(39)/18.4601/,T(40)/.128903        
     9/,T(41)/12.7285/,T(42)/6.76232/,T(43)/5.59927/,T(44)/14.0366/,T(45        
     $)/2.39699/,T(46)/29.2024/,T(47)/1.77333/,T(48)/15.2293/,T(49)/9.37        
     $046/,T(50)/14.5135/,T(51)/.295977/,T(52)/4.76492/,T(53)/63.3644/,T        
     $(54)/9.24354/,T(55)/29.1587/,T(56)/1.50711/,T(57)/18.8407/,T(58)/.        
     $116741/,T(59)/12.8268/,T(60)/6.31524/,T(61)/5.38695/,T(62)/12.4244        
     $/,T(63)/1.78555/,T(64)/29.0818/,T(65)/1.72029/,T(66)/15.4300/,T(67        
     $)/9.22590/,T(68)/14.4327/,T(69)/.321703/,T(70)/5.11982/,T(71)/57.0        
     $560/,T(72)/9.88750/                                                       
C-----FIFTH PART                                                                
      DATA U(1)/29.4936/,U(2)/1.42755/,U(3)/19.3763/,U(4)/.104621/,U(5)/        
     113.0544/,U(6)/5.93667/,U(7)/5.06412/,U(8)/11.1972/,U(9)/1.01074/,U        
     2(10)/28.7621/,U(11)/1.67191/,U(12)/15.7189/,U(13)/9.09227/,U(14)/1        
     34.5564/,U(15)/.350500/,U(16)/5.44174/,U(17)/52.0861/,U(18)/10.4720        
     4/,U(19)/28.1894/,U(20)/1.62903/,U(21)/16.1550/,U(22)/8.97948/,U(23        
     5)/14.9305/,U(24)/.382661/,U(25)/5.67589/,U(26)/48.1647/,U(27)/11.0        
     6005/,U(28)/30.4190/,U(29)/1.37113/,U(30)/15.2637/,U(31)/6.84706/,U        
     7(32)/14.7458/,U(33)/.165191/,U(34)/5.06795/,U(35)/18.0030/,U(36)/6        
     8.49804/,U(37)/27.3049/,U(38)/1.59279/,U(39)/16.7296/,U(40)/8.86553        
     9/,U(41)/15.6115/,U(42)/.417916/,U(43)/5.83377/,U(44)/45.0011/,U(45        
     $)/11.4722/,U(46)/30.4156/,U(47)/1.34323/,U(48)/15.8620/,U(49)/7.10        
     $909/,U(50)/13.6145/,U(51)/.204633/,U(52)/5.82008/,U(53)/20.3254/,U        
     $(54)/8.27903/,U(55)/30.7058/,U(56)/1.30923/,U(57)/15.5512/,U(58)/6        
     $.71983/,U(59)/14.2326/,U(60)/.167252/,U(61)/5.53672/,U(62)/17.4911        
     $/,U(63)/6.96824/,U(64)/27.0059/,U(65)/1.51293/,U(66)/17.7639/,U(67        
     $)/8.81174/,U(68)/15.7131/,U(69)/.424593/,U(70)/5.78370/,U(71)/38.6        
     $103/,U(72)/11.6883/                                                       
      DATA V(1)/29.8429/,V(2)/1.32927/,V(3)/16.7224/,V(4)/7.38979/,V(5)/        
     113.2153/,V(6)/.263297/,V(7)/6.35234/,V(8)/22.9426/,V(9)/9.85329/,V        
     2(10)/30.9612/,V(11)/1.24813/,V(12)/15.9829/,V(13)/6.60834/,V(14)/1        
     33.7348/,V(15)/.168640/,V(16)/5.92034/,V(17)/16.9392/,V(18)/7.39534        
     4/,V(19)/16.8819/,V(20)/.4611/,V(21)/18.5913/,V(22)/8.6216/,V(23)/2        
     55.5582/,V(24)/1.4826/,V(25)/5.8600/,V(26)/36.3956/,V(27)/12.0658/,        
     6V(28)/28.0109/,V(29)/1.35321/,V(30)/17.8204/,V(31)/7.73950/,V(32)/        
     714.3359/,V(33)/.356752/,V(34)/6.58077/,V(35)/26.4043/,V(36)/11.229        
     89/,V(37)/30.6886/,V(38)/1.21990/,V(39)/16.9029/,V(40)/6.82872/,V(4        
     91)/12.7801/,V(42)/.212867/,V(43)/6.52354/,V(44)/18.6590/,V(45)/9.0        
     $9680/,V(46)/20.6809/,V(47)/.5450/,V(48)/19.0417/,V(49)/8.4484/,V(5        
     $0)/21.6575/,V(51)/1.5729/,V(52)/5.9676/,V(53)/38.3246/,V(54)/12.60        
     $89/,V(55)/25.0853/,V(56)/1.39507/,V(57)/18.4973/,V(58)/7.65105/,V(        
     $59)/16.8883/,V(60)/.443378/,V(61)/6.48216/,V(62)/28.2262/,V(63)/12        
     $.0205/,V(64)/29.5641/,V(65)/1.21152/,V(66)/18.0600/,V(67)/7.05639/        
     $,V(68)/12.8374/,V(69)/.284738/,V(70)/6.89912/,V(71)/20.7482/,V(72)        
     $/10.6268/                                                                 
      DATA W(1)/27.5446/,W(2)/.655150/,W(3)/19.1584/,W(4)/8.70751/,W(5)/        
     115.5380/,W(6)/1.96347/,W(7)/5.52593/,W(8)/45.8149/,W(9)/13.1746/,W        
     2(10)/21.3985/,W(11)/1.47110/,W(12)/20.4723/,W(13)/.517394/,W(14)/1        
     38.7478/,W(15)/7.43463/,W(16)/6.82847/,W(17)/28.8482/,W(18)/12.5258        
     4/,W(19)/30.8695/,W(20)/1.10080/,W(21)/18.3841/,W(22)/6.53852/,W(23        
     5)/11.9328/,W(24)/.219074/,W(25)/7.00574/,W(26)/17.2114/,W(27)/9.80        
     6270/,W(28)/31.0617/,W(29)/.6902/,W(30)/13.0637/,W(31)/2.3576/,W(32        
     7)/18.4420/,W(33)/8.6180/,W(34)/5.9696/,W(35)/47.2579/,W(36)/13.411        
     88/,W(37)/21.7886/,W(38)/1.33660/,W(39)/19.5682/,W(40)/.488383/,W(4        
     91)/19.1406/,W(42)/6.77270/,W(43)/7.01107/,W(44)/23.8132/,W(45)/12.        
     $4734/,W(46)/32.1244/,W(47)/1.00566/,W(48)/18.8003/,W(49)/6.10926/,        
     $W(50)/12.0175/,W(51)/.147041/,W(52)/6.96886/,W(53)/14.7140/,W(54)/        
     $8.08428/,W(55)/33.3689/,W(56)/.7040/,W(57)/12.9510/,W(58)/2.9238/,        
     $W(59)/16.5877/,W(60)/8.7937/,W(61)/6.4692/,W(62)/48.0093/,W(63)/13        
     $.5782/,W(64)/21.8053/,W(65)/1.23560/,W(66)/19.5026/,W(67)/6.24149/        
     $,W(68)/19.1053/,W(69)/.469999/,W(70)/7.10295/,W(71)/20.3185/,W(72)        
     $/12.4711/                                                                 
      DATA X(1)/33.5364/,X(2)/.916540/,X(3)/25.0946/,X(4)/.039042/,X(5)/        
     119.2497/,X(6)/5.71414/,X(7)/6.91555/,X(8)/12.8285/,X(9)/-6.7994/,X        
     2(10)/34.6726/,X(11)/.700999/,X(12)/15.4733/,X(13)/3.55078/,X(14)/1        
     33.1138/,X(15)/9.55642/,X(16)/7.02588/,X(17)/47.0045/,X(18)/13.6770        
     4/,X(19)/35.3163/,X(20)/.685870/,X(21)/19.0211/,X(22)/3.97458/,X(23        
     5)/9.49887/,X(24)/11.3824/,X(25)/7.42518/,X(26)/45.4715/,X(27)/13.7        
     6108/,X(28)/35.5631/,X(29)/.6631/,X(30)/21.2816/,X(31)/4.0691/,X(32        
     7)/8.0037/,X(33)/14.0422/,X(34)/7.4433/,X(35)/44.2473/,X(36)/13.690        
     85/,X(37)/35.9299/,X(38)/.646453/,X(39)/23.0547/,X(40)/4.17619/,X(4        
     91)/12.1439/,X(42)/23.1052/,X(43)/2.11253/,X(44)/150.645/,X(45)/13.        
     $7247/,X(46)/35.7630/,X(47)/.616341/,X(48)/22.9064/,X(49)/3.87135/,        
     $X(50)/12.4739/,X(51)/19.9887/,X(52)/3.21097/,X(53)/142.325/,X(54)/        
     $13.6211/,X(55)/35.2150/,X(56)/.604909/,X(57)/21.6700/,X(58)/3.5767        
     $0/,X(59)/7.91342/,X(60)/12.6010/,X(61)/7.65078/,X(62)/29.8436/,X(6        
     $3)/13.5431/,X(64)/35.6597/,X(65)/.589092/,X(66)/23.1032/,X(67)/3.6        
     $5155/,X(68)/12.5977/,X(69)/18.5990/,X(70)/4.08655/,X(71)/117.020/,        
     $X(72)/13.5266/                                                            
      DATA Y(1)/35.1736/,Y(2)/.579689/,Y(3)/22.1112/,Y(4)/3.41437/,Y(5)/        
     18.19216/,Y(6)/12.9187/,Y(7)/7.05545/,Y(8)/25.9443/,Y(9)/13.4637/,Y        
     2(10)/35.5645/,Y(11)/.563359/,Y(12)/23.4219/,Y(13)/3.46204/,Y(14)/1        
     32.7473/,Y(15)/17.8309/,Y(16)/4.80703/,Y(17)/99.1722/,Y(18)/13.4314        
     4/,Y(19)/35.1007/,Y(20)/.555054/,Y(21)/22.4418/,Y(22)/3.24498/,Y(23        
     5)/9.78554/,Y(24)/13.4661/,Y(25)/5.29444/,Y(26)/23.9533/,Y(27)/13.3        
     6760/,Y(28)/35.8847/,Y(29)/.547751/,Y(30)/23.2948/,Y(31)/3.41519/,Y        
     7(32)/14.1891/,Y(33)/16.9235/,Y(34)/4.17287/,Y(35)/105.251/,Y(36)/1        
     83.4287/,Y(37)/36.0228/,Y(38)/.5293/,Y(39)/23.4128/,Y(40)/3.3253/,Y        
     9(41)/14.9491/,Y(42)/16.0927/,Y(43)/4.1880/,Y(44)/100.613/,Y(45)/13        
     $.3966/,Y(46)/35.5747/,Y(47)/.520480/,Y(48)/22.5259/,Y(49)/3.12293/        
     $,Y(50)/12.2165/,Y(51)/12.7148/,Y(52)/5.37073/,Y(53)/26.3394/,Y(54)        
     $/13.3092/,Y(55)/35.3715/,Y(56)/.516598/,Y(57)/22.5326/,Y(58)/3.050        
     $53/,Y(59)/12.0291/,Y(60)/12.5723/,Y(61)/4.79840/,Y(62)/23.4582/,Y(        
     $63)/13.2671/,Y(64)/34.8509/,Y(65)/.507079/,Y(66)/22.7584/,Y(67)/2.        
     $89030/,Y(68)/14.0099/,Y(69)/13.1767/,Y(70)/1.21457/,Y(71)/25.2017/        
     $,Y(72)/13.1665/                                                           
C-----SIXTH PART                                                                
      DATA Z(1)/36.1874/,Z(2)/.511929/,Z(3)/23.5964/,Z(4)/3.25396/,Z(5)/        
     115.6402/,Z(6)/15.3622/,Z(7)/4.18550/,Z(8)/97.4908/,Z(9)/13.3573/,Z        
     2(10)/35.0136/,Z(11)/.489810/,Z(12)/22.7286/,Z(13)/2.81099/,Z(14)/1        
     34.3884/,Z(15)/12.3300/,Z(16)/1.75669/,Z(17)/22.6581/,Z(18)/13.1130        
     4/,Z(19)/36.5254/,Z(20)/.499384/,Z(21)/23.8083/,Z(22)/3.26371/,Z(23        
     5)/16.7707/,Z(24)/14.9455/,Z(25)/3.47947/,Z(26)/105.980/,Z(27)/13.3        
     6812/,Z(28)/35.7074/,Z(29)/.502322/,Z(30)/22.6130/,Z(31)/3.03807/,Z        
     7(32)/12.9898/,Z(33)/12.1449/,Z(34)/5.43227/,Z(35)/25.4928/,Z(36)/1        
     83.2544/,Z(37)/35.5103/,Z(38)/.498626/,Z(39)/22.5787/,Z(40)/2.96627        
     9/,Z(41)/12.7766/,Z(42)/11.9484/,Z(43)/4.92159/,Z(44)/22.7502/,Z(45        
     $)/13.2116/,Z(46)/35.8400/,Z(47)/.484938/,Z(48)/22.7169/,Z(49)/2.96        
     $118/,Z(50)/13.5807/,Z(51)/11.5331/,Z(52)/5.66016/,Z(53)/24.3992/,Z        
     $(54)/13.1991/,Z(55)/35.6493/,Z(56)/.481422/,Z(57)/22.6460/,Z(58)/2        
     $.89020/,Z(59)/13.3595/,Z(60)/11.3160/,Z(61)/5.18831/,Z(62)/21.8301        
     $/,Z(63)/13.1555/,Z(64)/35.1736/,Z(65)/.473204/,Z(66)/22.7181/,Z(67        
     $)/2.73848/,Z(68)/14.7635/,Z(69)/11.5530/,Z(70)/2.28678/,Z(71)/20.9        
     $303/,Z(72)/13.0582/                                                       
      DATA Z1(1)/36.6706/,Z1(2)/.483629/,Z1(3)/24.0992/,Z1(4)/3.20647/,Z        
     11(5)/17.3415/,Z1(6)/14.3136/,Z1(7)/3.49331/,Z1(8)/102.273/,Z1(9)/1        
     23.3592/,Z1(10)/36.6488/,Z1(11)/.465154/,Z1(12)/24.4096/,Z1(13)/3.0        
     38997/,Z1(14)/17.3990/,Z1(15)/13.4346/,Z1(16)/4.21665/,Z1(17)/88.48        
     434/,Z1(18)/13.2887/,Z1(19)/36.7881/,Z1(20)/.451018/,Z1(21)/24.7736        
     5/,Z1(22)/3.04619/,Z1(23)/17.8919/,Z1(24)/12.8946/,Z1(25)/4.23284/,        
     6Z1(26)/86.0030/,Z1(27)/13.2754/,Z1(28)/36.9185/,Z1(29)/0.437533/,Z        
     71(30)/25.1995/,Z1(31)/3.00775/,Z1(32)/18.3317/,Z1(33)/12.4044/,Z1(        
     834)/4.24391/,Z1(35)/83.7881/,Z1(36)/13.2674/,Z1(37)/4.758/,               
     9Z1(38)/7.831/,Z1(39)/3.637/,Z1(40)/30.05/,Z1(41)/0./,Z1(42)/0./,          
     XZ1(43)/0./,Z1(44)/0./,Z1(45)/1.594/,Z1(46)/0./,Z1(47)/0./,                
     XZ1(48)/0./,Z1(49)/0./,Z1(50)/0./,Z1(51)/0./,Z1(52)/0./,Z1(53)/0./,        
     XZ1(54)/1./                                                                
      END                                                                       
      BLOCK DATA BLKDT2                                                        
C-----CONTAINS LITERAL DATA FOR LAZY                                            
      COMMON /ND/ NM/WAVEL/ M/BRAF/IB,CT /FLOR/ LPF,CV                          
C      integer CV,CT,NM,M
      DIMENSION IB(8),LPF(6)
      character*4 CT(8),M(20),CV(6), NM(20)
      DATA  NM(1)/'1'/, NM(2)/'2'/, NM(3)/'3'/, NM(4)/'4'/, NM(5)/'5'/,
     1NM(6)/'6'/,NM(7)/'A'/,NM(8)/'B'/,NM(9)/'C'/,NM(10)/'D'/,NM(11)/'M'
     2/,NM(12)/'N'/,NM(13)/'P'/,NM(14)/'CU  '/,NM(15)/'H'/,NM(16)/'H-'/,
     3NM(17)/' '/, NM(18)/'  '/,NM(19)/'    '/,NM(20)/'SP'/
      DATA LPF(1)/0/,LPF(2)/1/,LPF(3)/2/,LPF(4)/3/,LPF(5)/4/,LPF(6)/0/          
      DATA CV(1)/'DS'/,CV(2)/' 1'/,CV(3)/'NE'/,CV(4)/'GN'/,CV(5)/'GH'/,C
     1V(6)/'  '/
      DATA IB(1)/1/,IB(2)/1/,IB(3)/2/,IB(4)/3/,IB(5)/4/,IB(6)/5/,IB(7)/6        
     1/,IB(8)/7/                                                                
      DATA CT(1)/' '/,CT(2)/'P'/,CT(3)/'I'/,CT(4)/'R'/,CT(5)/'F'/,CT(6)/
     1'A'/,CT(7)/'B'/,CT(8)/'C'/
      DATA M(1)/'CRA1'/,M(2)/'CRA2'/,M(3)/'CRB '/,M(4)/'CR  '/,M(5)/
     1'FEA1'/,M(6)/'FEA2'/,M(7)/'FEB '/,M(8)/'FE  '/,M(9)/'CUA1'/,M(10)/
     2'CUA2'/,M(11)/'CUB '/,M(12)/'CU  '/,M(13)/'MOA1'/,M(14)/'MOA2'
     3/,M(15)/'MOB '/,M(16)/'MO  '/,M(17)/'AGA1'/,M(18)/'AGA2'/,M(19)/
     4'AGB '/,M(20)/'AG  '/
C
C
      END                                                                       
                                                                                
