C
C  Copyright (c) 1998 L. D. Marks
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
C
       FUNCTION TMASK (IH, K, NREF, SYIN, NHK, C, M, TOL, IOPTT )
C
         PARAMETER (NHK2 = 900, NLIMIT = 65536)
         LOGICAL PRINTF
         COMMON /PRINTS/PRINTF
         DIMENSION WINWTS(NHK2)
         COMMON /FOM5/WINWTS
         LOGICAL PWMASK, EOPT, PWACC, PMACC
         COMMON /WALSH/PWMASK, EOPT, PWACC, PMACC
         LOGICAL CENTRO
         COMMON /CCENTR/CENTRO
C     data centro /.false./
         COMMON /ERRTRY/NWOPT
         COMMON /ENTC2D/RAD1, RAD2
 
C     For tuning
         LOGICAL TLOG(6)
         DIMENSION FTUNE(4)
         COMMON /TUNING/TLOG, FTUNE
         LOGICAL WTSON, WT2ON
         DIMENSION WTS(NHK2), EWTS(NHK2), MULTI(NHK2)
         DIMENSION WPOS(NHK2)
         COMMON /WPOSC/WPOS
         COMMON /WCOM/WTS, WTSON, MODE
         COMMON /WCOM2/EWTS, WT2ON
         COMMON /MPCOMM/MULTI
         COMMON /ECALC/SFERR1, ANGERR, SFERR2
         COMMON /PADCMM/NPAD
         COMMON /FOMALL/ER1, EI1, EC1, F0PASS
C
C     generate an approximate mask in wts
C     Note: the entropy weight is rather delicate !
C     For the moment, leave as 1, although 0.75 may be better
C
         DIMENSION IH(*), K(*)
         INTEGER M(3)
         COMPLEX C(*)
         CHARACTER*4 SYMM, SYIN
C     Common block containing the multiplicity of each beam
         COMMON /ANGLEMAX/RMAX
         SAVE /FOMALL/ , /MPCOMM/ , /WCOM2/ , /WCOM/ 
 
C     Let us use the Patterson symmetry for the aperture calculation
C     This skips issues with glide planes etc
         SYMM = SYIN
C         CALL PATTS (SYIN,SYMM)
         IOPT = 12
 
C     Get the sizes and initialize FFT
         CALL FINDSZ (IH,K,NREF,SYMM,M,IOPT)
C     Units for reciprocal space
         AA = 1.D0 / (M(1) * M(1))
         BB = 1.D0 / (M(2) * M(2))
         AB = 0.
C     Trap for p3-type case
         IF (SYMM(1:2) .EQ. 'p3' .OR. SYMM(1:2) .EQ. 'p6') THEN
           AA = 1.
           BB = 1.
           AB = 1.
         END IF
 
C     Pad the aperture to include all beams in entropy
         NPAD = NREF
         CALL PADAP (IH,K,NREF,SYMM,NPAD,RAD1,RAD2,M,MULTI)
C
C     Find the maximum reciprocal space sampling
C     At the same time, find smallest two for interpolation
         SMALL1 = 1D6
         SMALL2 = 1D7
         IS1 = (-1)
         IS2 = (-1)
         RMAX = (-1.)
         DO   J=1,NPAD
           RR = IH(J) * IH(J) * AA + K(J) * K(J) * BB + IH(J) * K(J) *
     X        AB
           IF (RR .GT. RMAX) RMAX = RR
           IF (IH(J) .NE. 0 .OR. K(J) .NE. 0) THEN
             IF (RR .LT. SMALL1) THEN
               IS2 = IS1
               SMALL2 = SMALL1
               IS1 = J
               SMALL1 = RR
             ELSE IF (RR .GT. SMALL1 + 1.D-4 .AND. RR .LT. SMALL2) THEN
               IS2 = J
               SMALL2 = RR
             END IF
           END IF
         END DO
 
C     Linear decay extrapolation - sawtooth is close to real
         SMALL1 = SQRT (SMALL1)
         SMALL2 = SQRT (SMALL2)
C     Double check above terms
C     write(6,*)'Found ',is1,is2,small1,small2
C     Comment:
C     We will simply use here a line decay
C     A value of 1-sqrt(UU/RMAX) is not bad as a start
C     These vary slightly with data set!
         SCL = 1.15D0
         RBASE = RMAX / 0.94D0
         RMAX = RMAX * SCL * SCL
 
C     write(6,*)'Form is 1-U/',rt,']'
 
C     Line Mask
         DO   J=1,NPAD
           RR = IH(J) * IH(J) * AA + K(J) * K(J) * BB + IH(J) * K(J) *
     X        AB
           WTS(J) = 1 - SQRT (RR / RMAX)
           WINWTS(J) = 1.D0 / WTS(J)
         END DO
 
C     Adjust the Gaussian term -- better
C
         IF (PMACC .OR. PWACC) THEN
C     Try adjusting the gaussian term if the window is
C     giving us trouble
           RM0 = RMAX
           RSTEP = RMAX * 0.01D0
           R0 = TONE (IH,K,NPAD,SYMM,NHK,C,M,TOL,RMAX,AA,BB,AB,IOPT)
           IF (PRINTF) THEN
             WRITE (10, *) 'Adjusting Linear Fit Constant'
             WRITE (10, *) 'Initial error ', R0
           END IF
           RM = RMAX + RSTEP
           RD = TONE (IH,K,NPAD,SYMM,NHK,C,M,TOL,RM,AA,BB,AB,IOPT)
C        write(10,*)'Down step, Error ',RD,' rmax ',rm
           IF (PRINTF) WRITE (10, *) 'Down step, Error ', RD
           IF (RD .GT. R0) THEN
             RSTEP = -RSTEP
             RESB = R0
             RM = RM0
           ELSE
             RESB = RD
           END IF
  901      RM = RM + RSTEP
           RD = TONE (IH,K,NPAD,SYMM,NHK,C,M,TOL,RM,AA,BB,AB,IOPT)
C        write(10,*)'Iteration step, Error ',RD,' rmax ',rm
           IF (PRINTF) WRITE (10, *) 'Iteration step, Error ', RD
           IF (RD .LT. RESB) THEN
             RESB = RD
             RSTEP = RSTEP * 1.1D0
             GO TO 901
           END IF
           RBEST = RM - RSTEP
           RMAX = RBEST
           IF (PRINTF) WRITE (10, *) 'Best Residual with Line', RESB
C     Line Mask
           IF (RBEST .LT. RBASE) RMAX = RBASE
           DO   J=1,NPAD
             WTS(J) = 1 - SQRT ((IH(J) * IH(J) * AA + K(J) * K(J) * BB +
     X           IH(J) * K(J) * AB) / RMAX)
             WINWTS(J) = 1.D0 / WTS(J)
           END DO
         END IF
 
C
         TMASK = 0.
         IF (PWACC) THEN
           TOLN=TOL*0.025D0
           WRITE (6, *) 'Iterating mask for higher accuracy'
           TMASK = TACC (IH,K,NPAD,SYMM,NHK,C,M,TOLN,IS1,IS2,SMALL1,
     X        SMALL2,IOPT)
           DO   J=1,NPAD
             WINWTS(J) = 1.D0 / WTS(J)
           END DO
         END IF
 
         RETURN
       END
 
