C
C  Copyright (c) 1998 L. D. Marks
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
C
       SUBROUTINE CNTRD (SYMM )
C     Small utility routine to check if
C     the space group has a center of symmetry
         LOGICAL CENTRO
         COMMON /CCENTR/CENTRO
         CHARACTER*4 SYMM
         CENTRO = .FALSE.
         IF (SYMM(1:2) .EQ. 'p2') THEN
           CENTRO = .TRUE.
         ELSE IF (SYMM .EQ. 'p3mt' .OR. SYMM .EQ. 'p6mm') THEN
           CENTRO = .TRUE.
         ELSE IF (SYMM .EQ. 'p4mm') THEN
           CENTRO = .TRUE.
         ELSE IF (SYMM(1:2) .EQ. 'c2') THEN
           CENTRO = .TRUE.
         END IF
         RETURN
       END
       SUBROUTINE EQUIV2 (HE, KE, ISE, H, K, NE, SYMM )
C     generate equivalent positions
C     in fact, call a set of subroutines for different symmetry types
         INTEGER H
         INTEGER HE(*), KE(*), ISE(*)
         CHARACTER*4 SYMM
C     h,k input
C     he, ke output; ise is -ve for a conjg symm spot
C     ise > 2 for +ve or -ve values only allowed
C     simple trap for 0,0
         IF (H .EQ. 0 .AND. K .EQ. 0) THEN
           ISE(1) = 1
           HE(1) = 0
           KE(1) = 0
           NE = 1
           RETURN
         END IF
 
C     Standard x-glide
         IF (SYMM .EQ. 'p11g') THEN
           CALL PGS (HE,KE,ISE,H,K,NE,SYMM)
C     Standard y-glide
         ELSE IF (SYMM .EQ. 'p1g1' .OR. SYMM .EQ. 'pg  ') THEN
           CALL PGS (KE,HE,ISE,K,H,NE,SYMM)
         ELSE IF (SYMM .EQ. 'c11m' .OR. SYMM .EQ. 'p11m') THEN
           CALL MS (KE,HE,ISE,K,H,NE,SYMM)
         ELSE IF (SYMM(1:2) .EQ. 'p1') THEN
           CALL P1SYMM (HE,KE,ISE,H,K,NE,SYMM)
C     Non-standard y-glide, switch h & k
C     else if(symm(1:3).eq.'pyg')then
C           call pygs(he,ke,ise,h,k,ne,symm)
C     p2mg
         ELSE IF (SYMM(1:4) .EQ. 'p2mg') THEN
           CALL P2MGS (HE,KE,ISE,H,K,NE,SYMM)
C     p2gm, switch h & k
         ELSE IF (SYMM(1:4) .EQ. 'p2gm') THEN
           CALL P2MGS (KE,HE,ISE,K,H,NE,SYMM)
         ELSE IF (SYMM(1:2) .EQ. 'p3' .OR. SYMM .EQ. 'p6mm') THEN
           CALL P3SYMM (HE,KE,ISE,H,K,NE,SYMM)
         ELSE IF (SYMM(1:2) .EQ. 'p6') THEN
           CALL P6SYMM (HE,KE,ISE,H,K,NE,SYMM)
         ELSE IF (SYMM(2:2) .EQ. 'm' .OR. SYMM .EQ. 'p1m1' .OR. SYMM
     X       .EQ. 'c1m1') THEN
           CALL MS (HE,KE,ISE,H,K,NE,SYMM)
         ELSE IF (SYMM(1:4) .EQ. 'p2gg') THEN
           CALL P2GGS (HE,KE,ISE,H,K,NE,SYMM)
         ELSE IF (SYMM(1:2) .EQ. 'p2' .OR. SYMM(1:2) .EQ. 'c2') THEN
           CALL P2SYMM (HE,KE,ISE,H,K,NE,SYMM)
         ELSE IF (SYMM(1:2) .EQ. 'f2') THEN
           CALL F2SYMM (HE,KE,ISE,H,K,NE,SYMM)
         ELSE IF (SYMM(1:4) .EQ. 'p4mg' .OR. SYMM(1:4) .EQ. 'p4gm') THEN
           CALL P4MG (HE,KE,ISE,H,K,NE)
         ELSE IF (SYMM(1:2) .EQ. 'p4' .OR. SYMM(1:2) .EQ. 'c4') THEN
           CALL P4SYMM (HE,KE,ISE,H,K,NE,SYMM)
         ELSE
           WRITE (6, *) 'Unknown symmtery, dying gracelessly....'
           WRITE (6, *) 'Symmetry was ', SYMM
           CALL EXIT    (0)
         END IF
         RETURN
       END
       SUBROUTINE F2SYMM (HE, KE, ISE, H, K, NE, SYMM )
C     generate equivalent positions for 2-fold symmetry
         INTEGER H
         INTEGER HE(*), KE(*), ISE(*)
         CHARACTER*4 SYMM
C     h,k input
C     he, ke output; ise is -ve for a conjg symm spot
C     ise > 2 for +ve or -ve values only allowed
C     simple trap for 0,0
         IF (H .EQ. 0 .AND. K .EQ. 0) THEN
           ISE(1) = 1
           HE(1) = 0
           KE(1) = 0
           NE = 1
           RETURN
         END IF
         HE(1) = H
         KE(1) = K
         ISE(1) = 1
         IF (SYMM .EQ. 'f2  ') THEN
C     2-fold rotational symmetry only
           NE = 2
           HE(2) = -H
           KE(2) = -K
           ISE(2) = 1
           ISE(1) = 1
         ELSE IF (SYMM .EQ. 'f2mm') THEN
           ISE(1) = 1
           HE(2) = -H
           KE(2) = -K
           ISE(2) = 1
           NE = 2
           IF (H .NE. 0 .AND. K .NE. 0) THEN
             HE(3) = -H
             KE(3) = K
             ISE(3) = 1
             HE(4) = H
             KE(4) = -K
             ISE(4) = 1
             NE = 4
           END IF
         ELSE
           WRITE (6, *) 'Unknown symmtery, dying gracelessly....'
           CALL EXIT    (0)
         END IF
         RETURN
       END
       SUBROUTINE MS (HE, KE, ISE, H, K, NE, SYMM )
C     generate equivalent positions for symmetry pm and cm
         INTEGER H
         INTEGER HE(*), KE(*), ISE(*)
         CHARACTER*4 SYMM
C     h,k input
C     he, ke output; ise is -ve for a conjg symm spot
C     ise > 2 for +ve or -ve values only allowed
C     simple trap for 0,0
         IF (H .EQ. 0 .AND. K .EQ. 0) THEN
           ISE(1) = 1
           HE(1) = 0
           KE(1) = 0
           NE = 1
           RETURN
         END IF
         HE(1) = H
         KE(1) = K
         ISE(1) = 1
C     mirror is along y axis
         HE(2) = -H
         KE(2) = -K
         ISE(2) = (-1)
         IF (K .EQ. 0) THEN
           ISE(1) = 3
           ISE(2) = 3
           NE = 2
         ELSE IF (H .EQ. 0) THEN
           NE = 2
         ELSE
           HE(3) = -H
           KE(3) = K
           ISE(3) = 1
           HE(4) = H
           KE(4) = -K
           ISE(4) = (-1)
           NE = 4
         END IF
         RETURN
       END
       SUBROUTINE P1SYMM (HE, KE, ISE, H, K, NE, SYMM )
C     generate equivalent positions for p1 symmetry
         INTEGER H
         INTEGER HE(*), KE(*), ISE(*)
         CHARACTER*4 SYMM
C     h,k input
C     he, ke output; ise is -ve for a conjg symm spot
C     ise > 2 for +ve or -ve values only allowed
C     simple trap for 0,0
         IF (H .EQ. 0 .AND. K .EQ. 0) THEN
           ISE(1) = 1
           HE(1) = 0
           KE(1) = 0
           NE = 1
           RETURN
         END IF
         HE(1) = H
         KE(1) = K
         ISE(1) = 1
         HE(2) = -H
         KE(2) = -K
         ISE(2) = (-1)
         NE = 2
         RETURN
       END
       SUBROUTINE P2GGS (HE, KE, ISE, H, K, NE, SYMM )
         INTEGER H, K
         INTEGER HE(*), KE(*), ISE(*)
         CHARACTER*4 SYMM
         IF (H .EQ. 0 .AND. K .EQ. 0) THEN
           ISE(1) = 1
           HE(1) = 0
           KE(1) = 0
           NE = 1
           RETURN
         END IF
         HE(1) = H
         KE(1) = K
         ISE(1) = 3
         HE(2) = -H
         KE(2) = -K
         ISE(2) = 3
         IF (K .EQ. 0 .OR. H .EQ. 0) THEN
           NE = 2
 
         ELSE IF ((H / 2) * 2 .EQ. H) THEN
           IF ((K / 2) * 2 .EQ. K) THEN
             HE(3) = H
             KE(3) = -K
             ISE(3) = 3
             HE(4) = -H
             KE(4) = K
             ISE(4) = 3
             NE = 4
           ELSE
             HE(3) = H
             KE(3) = -K
             ISE(3) = 1000
             HE(4) = -H
             KE(4) = K
             ISE(4) = 1000
             NE = 4
           END IF
 
         ELSE
           IF ((K / 2) * 2 .EQ. K) THEN
             HE(3) = H
             KE(3) = -K
             ISE(3) = 1000
             HE(4) = -H
             KE(4) = K
             ISE(4) = 1000
             NE = 4
           ELSE
             HE(3) = H
             KE(3) = -K
             ISE(3) = 3
             HE(4) = -H
             KE(4) = K
             ISE(4) = 3
             NE = 4
           END IF
         END IF
         RETURN
       END
 
       SUBROUTINE P2MGS (HE, KE, ISE, H, K, NE, SYMM )
C     generate equivalent positions for glide symmetry along y-axis
C     Mirror along x axis (not at origin!)
         INTEGER H
         INTEGER HE(*), KE(*), ISE(*)
         CHARACTER*4 SYMM
C     h,k input
C     he, ke output; ise is -ve for a conjg symm spot
C     ise > 2 for +ve or -ve values only allowed
C     simple trap for 0,0
         IF (H .EQ. 0 .AND. K .EQ. 0) THEN
           ISE(1) = 1
           HE(1) = 0
           KE(1) = 0
           NE = 1
           RETURN
         END IF
         HE(1) = H
         KE(1) = K
         ISE(1) = 3
         HE(2) = -H
         KE(2) = -K
         ISE(2) = 3
         IF (K .EQ. 0 .OR. H .EQ. 0) THEN
           NE = 2
         ELSE IF ((H / 2) * 2 .EQ. H) THEN
           HE(3) = H
           KE(3) = -K
           ISE(3) = 3
           HE(4) = -H
           KE(4) = K
           ISE(4) = 3
           NE = 4
         ELSE
           HE(3) = H
           KE(3) = -K
           ISE(3) = 1000
           HE(4) = -H
           KE(4) = K
           ISE(4) = 1000
           NE = 4
         END IF
         RETURN
       END
       SUBROUTINE P2SYMM (HE, KE, ISE, H, K, NE, SYMM )
C     generate equivalent positions for 2-fold symmetry
         INTEGER H
         INTEGER HE(*), KE(*), ISE(*)
         CHARACTER*4 SYMM
C     h,k input
C     he, ke output; ise is -ve for a conjg symm spot
C     ise > 2 for +ve or -ve values only allowed
C     simple trap for 0,0
         IF (H .EQ. 0 .AND. K .EQ. 0) THEN
           ISE(1) = 1
           HE(1) = 0
           KE(1) = 0
           NE = 1
           RETURN
         END IF
         HE(1) = H
         KE(1) = K
         ISE(1) = 1
         IF (SYMM .EQ. 'p2  ' .OR. SYMM .EQ. 'c2  ') THEN
C     2-fold rotational symmetry only
           NE = 2
           HE(2) = -H
           KE(2) = -K
           ISE(2) = 3
           ISE(1) = 3
         ELSE IF (SYMM .EQ. 'p2mm' .OR. SYMM .EQ. 'c2mm') THEN
           ISE(1) = 3
           HE(2) = -H
           KE(2) = -K
           ISE(2) = 3
           NE = 2
           IF (H .NE. 0 .AND. K .NE. 0) THEN
             HE(3) = -H
             KE(3) = K
             ISE(3) = 3
             HE(4) = H
             KE(4) = -K
             ISE(4) = 3
             NE = 4
           END IF
         ELSE
           WRITE (6, *) 'Unknown symmtery, dying gracelessly....'
           CALL EXIT    (0)
         END IF
         RETURN
       END
       SUBROUTINE P3SYMM (HE, KE, ISE, H, K, NE, SYMM )
C     generate equivalent positions for 3-fold symmetry
         INTEGER H
         INTEGER HE(*), KE(*), ISE(*)
         CHARACTER*4 SYMM
         LOGICAL CHECK
         INTEGER II1, II2, II3, II4, II5, II6, II7, II8, II9, II10
C     h,k input
C     he, ke output; ise is -ve for a conjg symm spot
C     ise > 2 for +ve or -ve values only allowed
C     simple trap for 0,0
         IF (H .EQ. 0 .AND. K .EQ. 0) THEN
           ISE(1) = 1
           HE(1) = 0
           KE(1) = 0
           NE = 1
           RETURN
         END IF
         HE(1) = H
         KE(1) = K
         ISE(1) = 1
         IF (SYMM .EQ. 'p3  ') THEN
C     3-fold rotational symmetry only
           NE = 6
           HE(2) = K
           KE(2) = -(H + K)
           ISE(2) = 1
           HE(3) = -(H + K)
           KE(3) = H
           ISE(3) = 1
           HE(4) = -H
           KE(4) = -K
           ISE(4) = (-1)
           HE(5) = -K
           KE(5) = H + K
           ISE(5) = (-1)
           HE(6) = H + K
           KE(6) = -H
           ISE(6) = (-1)
         ELSE IF (SYMM .EQ. 'p3m1') THEN
C     3-fold rotational symmetry and mirror through 220 (for rt3)
           NE = 6
           HE(2) = K
           KE(2) = -(H + K)
           ISE(2) = 1
           HE(3) = -(H + K)
           KE(3) = H
           ISE(3) = 1
           HE(4) = -H
           KE(4) = -K
           ISE(4) = (-1)
           HE(5) = -K
           KE(5) = H + K
           ISE(5) = (-1)
           HE(6) = H + K
           KE(6) = -H
           ISE(6) = (-1)
           CHECK = .FALSE.
           DO   J=1,6
             IF (HE(J) - KE(J) .EQ. 0) CHECK = .TRUE.
           END DO
           IF (CHECK) THEN
             DO   J=1,6
               ISE(J) = 3
             END DO
           ELSE
             CHECK = .TRUE.
             DO   J=1,6
               IF (HE(J) .EQ. 0 .OR. KE(J) .EQ. 0) CHECK = .FALSE.
             END DO
             IF (CHECK) THEN
               NE = 12
               DO   J=7,12
                 II2 = HE(J-6)
                 II1 = KE(J-6)
                 II3 = ISE(J-6)
                 HE(J) = II2 + II1
                 KE(J) = -II1
                 ISE(J) = II3
               END DO
             END IF
           END IF
         ELSE IF (SYMM .EQ. 'p31m') THEN
C     3-fold rotational symmetry and mirror along 1x1 (for rt3)
           NE = 6
           HE(2) = K
           KE(2) = -(H + K)
           ISE(2) = 1
           HE(3) = -(H + K)
           KE(3) = H
           ISE(3) = 1
           HE(4) = -H
           KE(4) = -K
           ISE(4) = (-1)
           HE(5) = -K
           KE(5) = H + K
           ISE(5) = (-1)
           HE(6) = H + K
           KE(6) = -H
           ISE(6) = (-1)
           CHECK = .FALSE.
           DO   J=1,6
             IF (HE(J) .EQ. 0 .OR. KE(J) .EQ. 0) CHECK = .TRUE.
           END DO
           IF (CHECK) THEN
             DO   J=1,6
               ISE(J) = 3
             END DO
           ELSE
             CHECK = .TRUE.
             DO   J=1,6
               IF (HE(J) - KE(J) .EQ. 0) CHECK = .FALSE.
             END DO
             IF (CHECK) THEN
               NE = 12
               DO   J=7,12
                 II4 = KE(J-6)
                 II6 = HE(J-6)
                 II7 = ISE(J-6)
                 II5 = II4
                 KE(J) = II6
                 ISE(J) = II7
                 HE(J) = II5
               END DO
             END IF
           END IF
         ELSE IF (SYMM .EQ. 'p3mt' .OR. SYMM .EQ. 'p6mm') THEN
C     Inversion + 3-fold rotational symmetry and mirror through 220 (for rt3)
           ISE(1) = 3
           NE = 6
           HE(2) = K
           KE(2) = -(H + K)
           ISE(2) = 3
           HE(3) = -(H + K)
           KE(3) = H
           ISE(3) = 3
           HE(4) = -H
           KE(4) = -K
           ISE(4) = 3
           HE(5) = -K
           KE(5) = H + K
           ISE(5) = 3
           HE(6) = H + K
           KE(6) = -H
           ISE(6) = 3
           CHECK = .FALSE.
           DO   J=1,6
             IF (HE(J) - KE(J) .EQ. 0) CHECK = .TRUE.
           END DO
           IF (CHECK) THEN
             DO   J=1,6
               ISE(J) = 3
             END DO
           ELSE
             CHECK = .TRUE.
             DO   J=1,6
               IF (HE(J) .EQ. 0 .OR. KE(J) .EQ. 0) CHECK = .FALSE.
             END DO
             IF (CHECK) THEN
               NE = 12
               DO   J=7,12
                 II9 = HE(J-6)
                 II8 = KE(J-6)
                 II10 = ISE(J-6)
                 HE(J) = II9 + II8
                 KE(J) = -II8
                 ISE(J) = II10
               END DO
             END IF
           END IF
         ELSE
           WRITE (6, *) 'Unknown symmtery, dying gracelessly....'
           CALL EXIT    (0)
         END IF
         RETURN
       END
       SUBROUTINE P4 (HE, KE, ISE, H, K, NE, SYMM )
C     generate equivalent positions for 4-fold symmetry
         INTEGER H, K
         INTEGER HE(*), KE(*), ISE(*)
         INTEGER NE
         CHARACTER*4 SYMM
C     simple trap for 0,0
         IF (H .EQ. 0 .AND. K .EQ. 0) THEN
           HE(1) = 0
           KE(1) = 0
           NE = 1
           ISE(1) = 1
           RETURN
         END IF
         HE(1) = H
         KE(1) = K
         ISE(1) = 3
         HE(2) = -K
         KE(2) = H
         ISE(2) = 3
         HE(3) = -H
         KE(3) = -K
         ISE(3) = 3
         HE(4) = K
         KE(4) = -H
         ISE(4) = 3
         NE = 4
         RETURN
       END
       SUBROUTINE P4MG (HE, KE, ISE, H, K, NE )
C     to give (h,k) -> (k,h) for symm p4gm
         INTEGER H, K
         INTEGER HE(*), KE(*), ISE(*)
         INTEGER II1, II2
         IF (H .EQ. 0 .AND. K .EQ. 0) THEN
           HE(1) = 0
           KE(1) = 0
           NE = 1
           ISE(1) = 1
           RETURN
         END IF
         HE(1) = H
         KE(1) = K
         ISE(1) = 3
         HE(2) = K
         KE(2) = H
         ISE(2) = 1000
         HE(3) = -K
         KE(3) = H
         ISE(3) = 3
         HE(4) = -H
         KE(4) = K
         ISE(4) = 1000
         HE(5) = -H
         KE(5) = -K
         ISE(5) = 3
         HE(6) = -K
         KE(6) = -H
         ISE(6) = 1000
         HE(7) = K
         KE(7) = -H
         ISE(7) = 3
         HE(8) = H
         KE(8) = -K
         ISE(8) = 1000
         NE = 8
         IF (((H + K) / 2) * 2 .EQ. H + K) THEN
           DO   J=1,8
             ISE(J) = 3
           END DO
         END IF
         NE = 0
         DO 2000 I=1,8
           II1 = KE(I)
           II2 = HE(I)
           DO 1000 J=I+1,8
             IF (HE(J) .EQ. II2 .AND. KE(J) .EQ. II1) GO TO 2000
 1000        CONTINUE
           NE = NE + 1
           HE(NE) = HE(I)
           KE(NE) = KE(I)
 2000      CONTINUE
         RETURN
       END
       SUBROUTINE P4SYMM (HE, KE, ISE, H, K, NE, SYMM )
C       generate equivalent positions for 4-fold symmetry
         INTEGER H, K
         INTEGER HE(*), KE(*), ISE(*)
         INTEGER NE
         CHARACTER*4 SYMM
         INTEGER II1, II2
C       h,k input
C       he, ke output; ise is -ve for a conjg symm spot
C       ise > 2 for +ve or -ve values only allowed
C       simple trap for 0,0
         IF (SYMM .EQ. 'p4mm' .OR. SYMM .EQ. 'c4mm') THEN
           IF (H .EQ. 0 .AND. K .EQ. 0) THEN
             HE(1) = 0
             KE(1) = 0
             NE = 1
             ISE(1) = 1
             RETURN
           END IF
           HE(1) = H
           KE(1) = K
           HE(2) = -H
           KE(2) = -K
           HE(3) = -H
           KE(3) = K
           HE(4) = H
           KE(4) = -K
           HE(5) = K
           KE(5) = H
           HE(6) = -K
           KE(6) = -H
           HE(7) = -K
           KE(7) = H
           HE(8) = K
           KE(8) = -H
           NE = 8
           DO 20 I=1,8
             ISE(I) = 3
   20        CONTINUE
           NE = 0
           DO 2000 I=1,8
             II1 = KE(I)
             II2 = HE(I)
             DO 1000 J=I+1,8
               IF (HE(J) .EQ. II2 .AND. KE(J) .EQ. II1) GO TO 2000
 1000          CONTINUE
             NE = NE + 1
             HE(NE) = HE(I)
             KE(NE) = KE(I)
 2000        CONTINUE
         ELSE IF (SYMM .EQ. 'p4  ') THEN
           HE(1) = H
           KE(1) = K
           ISE(1) = 3
           HE(2) = -K
           KE(2) = H
           ISE(2) = 3
           HE(3) = -H
           KE(3) = -K
           ISE(3) = 3
           HE(4) = K
           KE(4) = -H
           ISE(4) = 3
           NE = 4
         ELSE
           WRITE (6, *) 'Unknown symmtery, dying gracelessly....'
           CALL EXIT    (0)
         END IF
         RETURN
       END
       SUBROUTINE P6SYMM (HE, KE, ISE, H, K, NE, SYMM )
         INTEGER H, K
         INTEGER HE(*), KE(*), ISE(*)
         CHARACTER*4 SYMM
         IF (H .EQ. 0 .AND. K .EQ. 0) THEN
           ISE(1) = 1
           HE(1) = 0
           KE(1) = 0
           NE = 1
           RETURN
         END IF
         HE(1) = H
         KE(1) = K
         ISE(1) = 3
         HE(2) = K
         KE(2) = -(H + K)
         ISE(2) = 3
         HE(3) = -(H + K)
         KE(3) = H
         ISE(3) = 3
         HE(4) = -H
         KE(4) = -K
         ISE(4) = 3
         HE(5) = -K
         KE(5) = H + K
         ISE(5) = 3
         HE(6) = H + K
         KE(6) = -H
         ISE(6) = 3
         NE = 6
         RETURN
       END
       SUBROUTINE PGS (HE, KE, ISE, H, K, NE, SYMM )
C     generate equivalent positions for glide symmetry along x-axis
C     (Note, not conventional ??)
         INTEGER H
         INTEGER HE(*), KE(*), ISE(*)
         CHARACTER*4 SYMM
C     h,k input
C     he, ke output; ise is -ve for a conjg symm spot
C     ise > 2 for +ve or -ve values only allowed
C     simple trap for 0,0
         IF (H .EQ. 0 .AND. K .EQ. 0) THEN
           ISE(1) = 1
           HE(1) = 0
           KE(1) = 0
           NE = 1
           RETURN
         END IF
         HE(1) = H
         KE(1) = K
         ISE(1) = 1
         HE(2) = -H
         KE(2) = -K
         ISE(2) = (-1)
         IF (K .EQ. 0) THEN
           NE = 2
C           if(2*(h/2).eq.h)then
C              ise(1)=3
C              ise(2)=3
C           endif
         ELSE IF (H .EQ. 0) THEN
           NE = 2
           ISE(1) = 3
           ISE(2) = 3
         ELSE IF ((H / 2) * 2 .EQ. H) THEN
           HE(3) = H
           KE(3) = -K
           ISE(3) = 1
           HE(4) = -H
           KE(4) = K
           ISE(4) = (-1)
           NE = 4
         ELSE
           HE(3) = H
           KE(3) = -K
           ISE(3) = 200
           HE(4) = -H
           KE(4) = K
           ISE(4) = 300
           NE = 4
         END IF
         RETURN
       END
       SUBROUTINE PYGS (HE, KE, ISE, H, K, NE, SYMM )
C     generate equivalent positions for glide symmetry along x-axis
C     (Note, not conventional ??)
         INTEGER H
         INTEGER HE(*), KE(*), ISE(*)
         CHARACTER*4 SYMM
C     h,k input
C     he, ke output; ise is -ve for a conjg symm spot
C     ise > 2 for +ve or -ve values only allowed
C     simple trap for 0,0
         IF (H .EQ. 0 .AND. K .EQ. 0) THEN
           ISE(1) = 1
           HE(1) = 0
           KE(1) = 0
           NE = 1
           RETURN
         END IF
         HE(1) = H
         KE(1) = K
         ISE(1) = 1
         HE(2) = -H
         KE(2) = -K
         ISE(2) = (-1)
         IF (H .EQ. 0) THEN
           NE = 2
           IF ((K / 2) * 2 .EQ. K) THEN
             ISE(1) = 3
             ISE(2) = 3
           END IF
         ELSE IF (K .EQ. 0) THEN
           NE = 2
         ELSE
           HE(3) = -H
           KE(3) = K
           ISE(3) = 100
           HE(4) = H
           KE(4) = -K
           ISE(4) = 200
           NE = 4
         END IF
         RETURN
       END
