C 
C  Copyright (c) 1998 L. D. Marks
C 
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C 
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C 
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
C 
C
      subroutine refseed(fw,h,k,l,nat,x,y,z,itype,nr2,
     $  symm,n1,n2,n3,errg,wts,ntimes,fgot,zatom)
      dimension x(*),y(*),z(*),wts(*),itype(*)
      dimension fw(*),fgot(*),zatom(*),work(200),iwork(200)
      integer h(*),k(*),l(*)
      character*4 symm,sftemp
        include 'SeedDef.h'
        dimension xb(Nsatm1),yb(Nsatm1),zb(Nsatm1),ib(Nsatm1)
        dimension xw(Nsatm1,60),yw(Nsatm1,60),zw(Nsatm1,60)
        dimension iw(Nsatm1,60),nw(Nsatm1),fomw(Nsatm1)
        include 'Sfacts.h'
        logical there
C
C       Go through the seeds and compare against current
C       First, purge the seeds
        ijk=1
        call pseed(ijk,symm)
        if(nsd.lt.2)return
        nsd2=min(nsd,60)
        nsd=nsd2
        write(6,*)'Refining top ',nsd2,' seeds of ',nsd
        write(10,*)'Refining top ',nsd2,' seeds of ',nsd
C        write(6,*)'Debug ',nat
C        write(6,*)'Debug ',nr2
C       Next, check input
        call refine3Dd(fw,h,k,l,nat,x,y,z,itype,nr2,
     $  symm,n1,n2,n3,errg,wts,ntimes)
        ebest=errg
        do j=1,nat
                xb(j)=x(j)
                yb(j)=y(j)
C               zb(j)=z(j)
                zb(j)=0
                ib(j)=itype(j)
C               write(6,*)x(j),y(j),z(j),itype(j)
                enddo
        nbest=nat
        f0=errg
C
C       Now loop through the seeds
        do i=1,nsd2
                isbad=-1
                nat=ntsd(i)
C                write(10,*)'Seed ',i,' nat ',nat
                do j=1,nat
                        x(j)=xsd(j,i)
                        y(j)=ysd(j,i)
                        z(j)=zsd(j,i)
                        itype(j)=isd(j,i)
C                       write(10,*)x(j),y(j),z(j),itype(j)
                        if(itype(j).eq.0)then
                                isbad=1
                                itype(j)=1
                                isd(j,i)=1
                        endif
                enddo
        if(isbad.gt.0)then
                errg=1000
                goto 200
        endif
        call only2D(z,nat)
        call refine3Dd(fw,h,k,l,nat,x,y,z,itype,nr2,
     $  symm,n1,n2,n3,errg,wts,ntimes)
C
200             fomseed(i)=errg
                do j=1,nat
                        xsd(j,i)=x(j)
                        ysd(j,i)=y(j)
                        zsd(j,i)=z(j)
                        isd(j,i)=itype(j)
                enddo
                if(errg.lt.ebest)then
                        write(6,*) 'Better seed with ',nat,' atoms',errg
                        write(10,*)'Better seed with ',nat,' atoms',errg
                        ebest=errg
                        do j=1,nat
                                xb(j)=x(j)
                                yb(j)=y(j)
                                zb(j)=z(j)
                                ib(j)=itype(j)
                        enddo
                        nbest=nat
                endif
        enddo
C
C       Replace output
        do j=1,nbest
                x(j)=xb(j)
                y(j)=yb(j)
                z(j)=zb(j)
                itype(j)=ib(j)
                fgot(j)=zatom(itype(j))
        enddo
        nat=nbest
        errg=ebest
C       Sort the seeds into order
        do j=1,nsd
           work(j)=fomseed(j)
           iwork(j)=j
C           write(10,*)j,work(j)
        enddo
        call sortag(work,nsd,iwork)
C       Remove search.lst
        inquire(file='search.lst',exist=there)
        if(there)call unlink('search.lst',istatus)
        open(unit=13,file='search.lst')
        do ii=1,nsd
                i=iwork(ii)
                natt=ntsd(i)
                write(13,30)'REM Test ',ii,' G-of-Fit ',work(ii),
     X          fomseed(i)
                write(10,30)'REM Seed ',ii,' G-of-Fit ',work(ii),
     X          fomseed(i)
30              format(a,i3,a,2f10.4,4f12.7)
                do j=1,natt
                        xw(j,ii)=xsd(j,i)
                        yw(j,ii)=ysd(j,i)
                        zw(j,ii)=zsd(j,i)
                        iw(j,ii)=isd(j,i)
                        itmp=iw(j,ii)
                        sftemp=sfacts(itmp)
                        isf2=2
                        if(sftemp(2:2).eq.' ')isf2=1
            if((sftemp(3:3).eq.'+').or.(sftemp(3:3).eq.'-').or.
     1      (sftemp(4:4).eq.'+').or.(sftemp(4:4).eq.'-'))then
                write(13,121)sftemp,x(j),y(j),z(j),zatom(itmp),0.05
                        else if(j.lt.10)then
                          write(13,101)sftemp(1:isf2),j,xw(j,ii),
     1                    yw(j,ii),zw(j,ii),zatom(itmp),0.05
                        else
                          write(13,111)sftemp(1:isf2),j,xw(j,ii),
     1                    yw(j,ii),zw(j,ii),zatom(itmp),0.05
                        endif
                enddo
                nw(ii)=ntsd(i)
                fomw(ii)=fomseed(i)
        enddo

        do i=1,nsd
                natt=nw(i)
                do j=1,natt
                        xsd(j,i)=xw(j,i)
                        ysd(j,i)=yw(j,i)
                        zsd(j,i)=zw(j,i)
                        isd(j,i)=iw(j,i)
                enddo
                ntsd(i)=nw(i)
                fomseed(i)=fomw(i)
        enddo
C        write(6,*)'Refseed ',nbest
        close(unit=13)
        return
101     format(a,i1,'  1 ',4f10.6,2x,2f8.3)
111     format(a,i2,' 1 ',4f10.6,2x,2f8.3)
121     format(a,   ' 1 ',4f10.6,2x,2f8.3)
        end

