C	General 3D trim code
C
C  Copyright (c) 2003 L. D. Marks
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
C
	program trim(filen)
	character*60 filen
	integer h(5000),k(5000),l(5000),hmax
	dimension ifixh(5),ifixk(5),ang(5)
	dimension f(5000)
	logical p3
	p3=.false.
	open(unit=11,file=filen)
        open(unit=12,file='trim.hkl')
	  open(unit=13,file='skip.hkl')
        write(6,*)'Enter cell axes'
        read(5,*)a,b,c,al,be,ga
        cc=1./(c*c) 
        if(abs(ga-120).lt.1)p3=.true.
C	Convert to reciprocal
	angr=180-ga
C	Convert to radians
	pi2=asin(1.0d0)
	angr=angr*pi2/90
C	Reciprocal space units
C	A.a = B.b = 1 ; A.b=B.a=0
C	A.a = |A||a|cos(pi/2-angr)
	arec=1./(cos(pi2-angr)*a)
	brec=1./(cos(pi2-angr)*b)
	aa=arec*arec
	bb=brec*brec
	ab=2.*cos(angr)*arec*brec
        fmax=0
	  r2d=0
	  r3d=0
	  lmax=0
	  hmax=0
	  kmax=0
	  rmax=0
        n=0
C	Read in data an find ranges
        do j=1,9999
        read(11,*,err=201,end=201)h(j),k(j),l(j),f(j)
        if(f(j).gt.fmax)fmax=f(j)
        r2=h(j)*h(j)*aa+k(j)*k(j)*bb+h(j)*k(j)*ab
	  if(r2.gt.r2d)r2d=r2
	  r3=r2+l(j)*l(j)*cc
	  if(abs(h(j)).gt.hmax)hmax=abs(h(j))
	  if(abs(k(j)).gt.kmax)kmax=abs(k(j))
	  if(abs(l(j)).gt.lmax)lmax=abs(l(j))
	  if(r3.gt.r3d)r3d=r3
	  if(r3.gt.rmax)rmax=r3
        n=n+1
        enddo
201	write(6,*)'Max values along h,k,l are',hmax,kmax,lmax
	r2=sqrt(r2)
	r3=sqrt(r3)
	write(6,*)'Maximum 2D sampling',1./r2,' Angstroms'
	write(6,*)'Maximum 3D sampling',1./r3,' Angstroms'	
	write(6,*)'Maximum L sampling',c/lmax,' Angstroms'
	write(6,700)' Enter subsampling (-ve for none)'
700	format(a,'_',$)

	read(5,*)izs
	if(izs.lt.0)izs=1
C	Shuffle c
	c=c/izs
	cc=1./(c*c)
	write(6,700)' Enter 2D and L resolutions'
	read(5,*)res2,resl
C	Size
	ix=nint(3*a/res2)+1
	iy=nint(3*b/res2)+1
	iz=nint(3*c/resl)+1
	write(6,*)'Will give FFT sizes of',ix,iy,iz
	if(p3)write(6,*)'In p3 ',nint(sqrt(3.)*iy),iy,iz
	write(6,700)' Enter FFT sizes (-ve to use current)'
	read(5,*)iix,iiy,iiz
	if(p3)iix=iiy
	if(iix.lt.0.or.iiy.lt.0.or.iiz.lt.0)goto 200
		ix=iix
		iy=iiy
		iz=iiz
C
C
200	continue
C	Fix beams ?
	write(6,700)' Number of 2D beams (-ve=none)'
	read(5,*)n2d
	n2d=min(n2d,5)
	if(n2d.gt.0)then
		do j=1,n2d
			write(6,*)'For beam number ',j
			write(6,700)' Enter H,K and Angle'
			read(5,*)ifixh(j),ifixk(j),ang(j)
		enddo
	endif
C       Proper limits for padap
        i1=ix/3.
        i2=iy/3.
        i3=iz/3.
        r1=1./(i1+0.5)
        r2=1./(i2+0.5)
        r3=1./(i3+0.5)
        aa=r1*r1
        bb=r2*r2
        cc=r3*r3

	num=0
	num1=0
	do j=1,n
D	write(16,*)'Doing ',j
C	Include subsampling
	if(izs*(l(j)/izs).eq.l(j))then
	ll=l(j)/izs
	r=h(j)*h(j)*aa+k(j)*k(j)*bb+h(j)*k(j)*ab+ll*ll*cc
	ag=0
	if(n2d.gt.0.and.ll.eq.0)then
		do jj=1,n2d
		if(h(j).eq.ifixh(jj).and.k(j).eq.ifixk(jj))ag=ang(jj)
		enddo
	endif
      if(r.le.1.)then
		write(12,1)h(j),k(j),ll,f(j),ag
		num=num+1
	else
		write(13,1)h(j),k(j),ll,f(j),0
		num1=num1+1

	endif
	endif
1	format(3i5,f13.7,f7.1,4f12.3)
	enddo
	write(6,*)'Number of reflections ',num
	write(6,*)'Skipped ',num1
	end

	
