C
C  Copyright (c) 1998 L. D. Marks
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
C
       SUBROUTINE EIMG2D (C, FF, IH, K, FHK, AHK, NREF, SYMM, TITLE )
C     THIS PROGRAM EXPANDS THE PHASS OF A 3-D DATA SET TO AN IMAGE
 
         include 'Nlimit.h'
C         PARAMETER (NHK2 = 900, NLIMIT = 65536)
         LOGICAL PRINTF
         COMMON /PRINTS/PRINTF
C         DIMENSION WINWTS(NHK2)
C         COMMON /FOM5/WINWTS
         LOGICAL PWMASK, EOPT, PWACC, PMACC
         COMMON /WALSH/PWMASK, EOPT, PWACC, PMACC
         LOGICAL CENTRO
         COMMON /CCENTR/CENTRO
C     data centro /.false./
         COMMON /ERRTRY/NWOPT
         COMMON /ENTC2D/RAD1, RAD2
 
C     For tuning
         LOGICAL TLOG(6)
         DIMENSION FTUNE(4)
         COMMON /TUNING/TLOG, FTUNE
         LOGICAL WTSON, WT2ON
         DIMENSION WTS(NHK2), EWTS(NHK2), MULTI(NHK2)
         DIMENSION WPOS(NHK2)
         COMMON /WPOSC/WPOS
         COMMON /WCOM/WTS, WTSON, MODE
         COMMON /WCOM2/EWTS, WT2ON
         COMMON /MPCOMM/MULTI
         COMMON /ECALC/SFERR1, ANGERR, SFERR2
         COMMON /PADCMM/NPAD
         COMMON /FOMALL/ER1, EI1, EC1, F0PASS
         INTEGER NCONT(20)
         DIMENSION CELL(6), TEMPF(20), AOCC(20), ZATOM(20)
         INCLUDE 'Sfacts.h'
         LOGICAL FORIG, FSEMP, BROWNF, DMULT, DMLT, FOM2
         COMMON /SFCOM1/TEMPF, NCONT, NATOM, CELL
         COMMON /SFCOM2/AOCC, ZATOM, FORIG, BROWNF, DMULT, DMLT
         COMMON /MVIS/WIDTH, HEIGHT, TIMES, FSEMP
         COMMON /COPT/ATNUM, PATTC, ACTERM, FOM2
         DIMENSION FSTEST(20)
         COMMON /COPT2/FSTEST
         INTEGER LAT(2)
         COMMON /CLAT/LAT
 
         DIMENSION IH(*), K(*), WORK(NHK2), FHK(*), AHK(*)
         INTEGER HE(30), KE(30), ISE(30), M(3)
         COMPLEX C(*)
         DIMENSION FF(*)
         CHARACTER*4 SYMM
         CHARACTER*8 FILEN
         CHARACTER*50 FORMT
         CHARACTER*78 TITLE
         SAVE FILEN, /COPT2/ , /COPT/ , /MVIS/ , /SFCOM2/ , /SFCOM1/ ,
     X      /FOMALL/ , /MPCOMM/ , /WCOM2/ , /WCOM/ 
         INTEGER II1, II2, II3, II4, II5
         REAL RR1
         LOGICAL LL1
         COMPLEX CC1, CC2, CC3, CC4, CC5, CC6, CC7, CC8, CC9, CC10
 
C     Origin for arrays (for consistency with FFT's)
         CALL FINDSZ (IH,K,NREF,SYMM,M,IOPT)
         N1 = M(1)
         N2 = M(2)
C     Pixels per Angstrom
         A = CELL(1)
         IF (SYMM(1:2) .EQ. 'p3' .OR. SYMM(1:2) .EQ. 'p6') THEN
           A = CELL(1) * SQRT (3.D0)
         END IF
         PX = FLOAT (M(1)) / A
         PY = FLOAT (M(2)) / CELL(2)
         PA = MAX (PX, PY)
C	Check size is not too small
	IDX=PA*TIMES*WIDTH*A
	IDY=PA*TIMES*HEIGHT*CELL(2)
	IDD=max(IDX,IDY)
	IF(IDD.LT.120)TIMES=TIMES*120/IDD
         IF (ABS (TIMES - 1) .GT. 1D-2) THEN
           WRITE (6, *) 'Requested Magnification of ', TIMES
           WRITE (10, *) 'Requested Magnification of ', TIMES
           PA = PA * TIMES
         END IF
771      I1 = NINT (PA * A)
         I2 = NINT (PA * CELL(2))
         CALL BESIZE (I1,I2,N1,N2)
C     Trap size too large
         IF(N1*N2 .gt. NLIMIT)then
                PA=PA/1.1
                GOTO 771
         ENDIF
         WRITE (6, *) 'FFT Sizes Used for Output: ', N1, N2
         WRITE (10, *) 'FFT Sizes Used for Output: ', N1, N2
         WRITE (6, *) 'Pixels per Angstrom ', PA
         WRITE (10, *) 'Pixels per Angstrom ', PA
         M(1) = N1
         M(2) = N2
C     remove fft tables
         CALL DPLN2D
         CALL PBUF2 (M)
         DO   J=1,N1*N2
           C(J) = (0., 0.)
         END DO
 
C     setup in fo and ag the symmetry related values
         PI = ASIN (1.D0) * 2.D0
         RR1 = PI * 2
         II4 = N1 / 2
         II5 = N2 / 2
         DO   J=1,NREF
           IHH = IH(J)
           IKK = K(J)
           CALL EQUIV2 (HE,KE,ISE,IHH,IKK,NE,SYMM)
           F = FHK(J)
           ANG = AHK(J)
           IF (ISE(1) .EQ. 3 .AND. ABS (AHK(J)) .GT. 1D-4) THEN
C     truncate angle to moduli pi provided that > a cutoff
C           write(10,*)'Fixing input ',ihh,ikk
             IA = NINT (AHK(J) / PI)
             IF (NINT (AHK(J) / PI) .EQ. 0) IA = 2
             ANG = PI * IA
             AHK(J) = PI * IA
           END IF
           IF (IHH .EQ. 0 .AND. IKK .EQ. 0) THEN
             F = 1.
             ANG = RR1
           END IF
           IF (ABS (ANG) .GT. 1D-4 .OR. (IHH .EQ. 0 .AND. IKK .EQ. 0)
     X        ) THEN
 
 
C     Information about symmetry coding of phases
             LL1 = SYMM(1:2) .EQ. 'p3' .OR. SYMM(1:2) .EQ. 'p6'
             II2 = II4
             II3 = II5
             CC1 = CMPLX (COS (ANG) * F, -SIN (ANG) * F)
             CC2 = CMPLX (COS (ANG) * F, 0.D0)
             CC3 = CMPLX (0.D0, SIN (ANG) * F)
             CC4 = CMPLX (COS (ANG) * F, SIN (ANG) * F)
             CC5 = -CC4
             CC6 = -CC1
             CC7 = -CC2
             CC8 = CMPLX (0.D0, -SIN (ANG) * F)
             DO   JJ=1,NE
C     trap problems with p3 symmetry to give rectangular axes
               IF (LL1) THEN
                 CALL P3EXP (IHJJ,IKJJ,HE(JJ),KE(JJ))
C             ihjj=2*he(je)+n1c
C             ikjj=2*ke(je)+he(je)+n2c
                 IHJJ = IHJJ + II2 + 1
                 IKJJ = IKJJ + II3 + 1
               ELSE
                 IHJJ = HE(JJ) + II2 + 1
                 IKJJ = KE(JJ) + II3 + 1
               END IF
               IND = (IKJJ - 1) * N1 + IHJJ
C       write(10,*)'PUT TO ',ihjj,ikjj,he(jj),ke(jj),
C     $     ihjj-n1c,ikjj-n2c,ise(jj),ind
               IF (ISE(JJ) .LT. 0) THEN
                 C(IND) = CC1
               ELSE IF (ISE(JJ) .EQ. 3) THEN
                 C(IND) = CC2
               ELSE IF (ISE(JJ) .EQ. 6) THEN
                 C(IND) = CC3
               ELSE IF (ISE(JJ) .LT. 8) THEN
                 C(IND) = CC4
               ELSE IF (ISE(JJ) .LT. 110) THEN
                 AWORK = ANG + HE(1) * PI
                 C(IND) = F * CMPLX (COS (AWORK), SIN (AWORK))
 
C     X or Y-glide
               ELSE IF (ISE(JJ) .LT. 210) THEN
                 C(IND) = CC5
               ELSE IF (ISE(JJ) .EQ. 300) THEN
                 C(IND) = CC6
 
C     p2mg case
               ELSE IF (ISE(JJ) .EQ. 1000) THEN
                 C(IND) = CC7
               ELSE IF (ISE(JJ) .EQ. 2000) THEN
                 C(IND) = CC8
               END IF
             END DO
 
           END IF
         END DO
C     For p3 case, move the origin down
         IF (SYMM(1:2) .EQ. 'p3' .OR. SYMM(1:2) .EQ. 'p6') THEN
           IF ((N2 / 2 + 1) / 2 * 2 .EQ. N2 / 2 + 1) THEN
             I1 = 1
           ELSE
             I1 = 2
           END IF
           DO   J=I1,N2-2,2
             DO   JJ=(J-1)*N1+1,(J-1)*N1+N1
               CC9 = C(JJ)
               C(JJ) = -CC9
             END DO
           END DO
         END IF
 
C     Do a FFT
         CALL FFT2DN (C)
C           Correction for the origin shift
C           Quench any imaginary component as a rounding error
C     Also find max, min and mean at the same time
         XMEAN = 0.
         VMAX = (-100.)
         VMIN = 1000.
         JK = 0
         MF = (-1)
         DO   I=1,N2
           MF = -MF
           NF = (-1)
           DO   J=1,N1
             NF = -NF
             JK = JK + 1
C
             X = C(JK) * (NF * MF)
             C(JK) = X
             XMEAN = XMEAN + X
             IF (X .GT. VMAX) VMAX = X
             IF (X .LT. VMIN) VMIN = X
           END DO
         END DO
 
         FORMT = '((20e10.3))     '
         XMEAN = XMEAN / FLOAT (N1 * N2)
C     write(10,*)'Mean, max, min: ',xmean,vmax,vmin
C     Shuffle down the title a little to fit cleanly in semper
         DO   J=56,68
           TITLE(J:J) = TITLE(J + 10:J + 10)
         END DO
         IF (FSEMP) THEN
           OPEN (UNIT=11, FILE='Solution')
           WRITE (11, 140) N1, N2, 1, 1, 2, 68, FORMT
           WRITE (11, 141) TITLE(1:68)
           JK = 0
           DO   I=1,N2
C     Output a line
             DO   II1=1,N1
               CC10 = C(II1+JK)
               WORK(II1) = CC10 / XMEAN
             END DO
             JK = JK + N1
             WRITE (11, 30) (WORK(J), J=1,N1)
           END DO
         END IF
   30    FORMAT(20E10.3)
  140    FORMAT(6I6,1X,A20)
  141    FORMAT(A)
C
         FILEN = 'EDMs.gif'
C     output a tif picture
         CALL TIFPIC (N1,N2,C,VMAX,VMIN,FILEN,FF)
 
         RETURN
       END
 
 
       SUBROUTINE TIFPIC (NCOL, NROW, C, VMAX, VMIN, FILEN2, CBUF )
         COMPLEX C(*)
         CHARACTER*1 CBUF(*)
         CHARACTER*8 FILEN2
         CHARACTER*8  FILEN
         INTEGER IX(1), IY(1)
         INTEGER NCONT(20)
         DIMENSION CELL(6), TEMPF(20), AOCC(20), ZATOM(20)
         LOGICAL FORIG, FSEMP, BROWNF, DMULT, DMLT, FOM2
         Include 'Sfacts.h'
         COMMON /SFCOM1/TEMPF, NCONT, NATOM, CELL
         COMMON /SFCOM2/AOCC, ZATOM, FORIG, BROWNF, DMULT, DMLT
         COMMON /MVIS/WIDTH, HEIGHT, TIMES, FSEMP
         COMMON /COPT/ATNUM, PATTC, ACTERM, FOM2
         DIMENSION FSTEST(20)
         COMMON /COPT2/FSTEST
         INTEGER LAT(2)
         COMMON /CLAT/LAT
         SAVE /COPT2/ , /COPT/ , /MVIS/ , /SFCOM2/ , /SFCOM1/ 
     X   , FILEN
         INTEGER II1, II2, II3, II4, II5, II6, II7
C     Try and overcome size problems
	  FILEN='EDMs.tif'
C          FILEN(1:4) = FILEN2(1:4)
C          FILEN(5:8) = '.tif'
C	  FILEN='EDMs.tif'
C     write(10,*)'Max/Min: ',vmax,vmin
 
C Set up coefficients to transform intensity range
         A = 255.D0 / (VMAX - VMIN)
         IW = MAX (NINT (WIDTH), 1)
         IH = MAX (NINT (HEIGHT), 1)
C     read everything from the input picture
         JJ = 0
         II6 = MAX0 (NCOL, 0)
         II7 = NCOL * (MAX0 (IW, 0) - 1)
         DO   JH=1,IH
           II4 = II6
           II5 = II7
           DO   J=1,NROW
             II1 = JJ
             II3 = (J - 1) * NCOL
             DO   JW=1,IW
               II2 = II3
               DO   K=1,NCOL
                 JJ = JJ + 1
                 P = C(II2+K)
                 P = (P - VMIN) * A
                 IF (P .LT. 1D-2) THEN
                   IP = 0
                 ELSE IF (P .GT. 255) THEN
                   IP = 255
                 ELSE
                   IP = NINT (P)
                 END IF
                 CBUF(JJ) = CHAR (IP)
               END DO
             END DO
             JJ = II1 + II5 + II4
           END DO
         END DO
    3    FORMAT(16I4)
         IX(1) = NCOL * IW
         IY(1) = NROW * IH
C	Retire Gif files - replace by Tif ?
C         CALL MKGIF (FILEN,CBUF,IX,IY)
	     CALL MKTIFF(FILEN,CBUF,IX,IY)
         WRITE (6, *) 'Saved current as ', FILEN
         RETURN
       END
