C 
C  Copyright (c) 1998 L. D. Marks
C 
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C 
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C 
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C 
C
      subroutine scalecalc(f1,f2,f3,n,sin,err)
      real*8 f1(*),f2(*),f3(*),errval,sin
      double precision scale,e1,e2,e3,fa,fb,fc,est
C     initial estimate
      scale=sin
      e1=scale
      e2=scale*1.02d0
      step=scale*0.02d0
      fa=errval(f1,f2,f3,n,e1)
C     Try on one side
      fb=errval(f1,f2,f3,n,e2)
      niter=0
10      if(fb.le.fa)then
         e3=e2+step
         fc=errval(f1,f2,f3,n,e3)
         if(fc.gt.fb)then
C           It is bracketed between the three   
            v1=fa
            v2=fb
            v3=fc
            goto 100
         else
C           We are walking down
            e1=e2
            fa=fb
            e2=e3
            fb=fc
            goto 10
         endif
      else
C     We went up, so flip around and try other side
         step=-step
         temp=fa
         tempe=e1
         e1=e2
         fa=fb
         e2=tempe
         fb=temp
         goto 10
      endif
      
100      continue
C     We now have the minimum bracketed between 
C     e1,e2,e3 with corresponding values v1,v2,v3
      err=goldsearch(e1,e2,e3,est,f1,f2,f3,n,iter)
C     write(10,*)'Iterations to fit ',iter
C     write(6,*)'Iterations to fit ',iter
      sin=est
      return
      end
