      subroutine fweight1(NSET,NRNG,BIFACT,rmode)
C
C     Update weights using multiple measurements
C     Input
C            F          Array of measurements
C            NSET       Number of Sets
C            NRNG       Range to scan
C            SCL        Scaling
C
C     Output
C            WT         Array of relative weights for each pt
C
C
      implicit real*8 (a-h,o-z)
      include 'msizes.h'
      dimension PTS(500),W(500)
      integer rmode
C
      DO n=1,nset
         WSET(N)=0
      enddo
      do j=-NXMAX,NXMAX
           do k=-NYMAX,NYMAX
              N=0
              do i=1,NSET
                if( F(i,j,k).gt.-1)then
                        N=N+1
                        PTS(N)=F(i,j,k)*scl(i)
                endif
              enddo
C             Robust estimation if there are enough pts
              IF(N.GE.4)THEN
                IOPT=rmode
                ITER=-100
                P1TAIL=1
                N1=1
                if(rmode.gt.0)iopt=rmode
                CALL CENSCL(PTS,W,N1,N,IOPT,ITER,P1TAIL,FROB,FRERR,
     1               IFAIL,BIFACT)
C               calculate the bi-weights
                do i=1,NSET
                      if( F(i,j,k).gt.0)then
                          T=F(i,j,k)*scl(i)
                          U=(T-FROB)/(BIFACT*FRERR)
                          IF(U.LT.1.D0)then
                              U= (1.D0-U*U)**2
                          else
                              U=0.D0
                          endif
                          U=U+ubase
                          WSET(I)=WSET(I)+U
                          wt(i,j,k)=U
C                          write(13,*)wset(i),u,i,j,k,t,frob,frerr,n
                      endif
                enddo
              else
C             Not enough pts, set wt to zero
                do i=1,nset
                      wt(i,j,k)=0
                enddo
              ENDIF
           enddo
      enddo
C      write(6,*)'1: ',(Wset(n),n=1,nset)
      return
      end
