C
C  Copyright (c) 1998 L. D. Marks
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
C
C     Run this program to generate reduced set of
C     unique solutions after running sort.sh
C     If desired, edit sort.sh to get a larger set
       PROGRAM XFOM
         PARAMETER (NSOL = 30)
         IMPLICIT REAL*8 (A-H,O-Z)
         CHARACTER*30 LINE
         CHARACTER*100 FNAME
         DIMENSION F(80), A(80,30), A2(80), A3(80)
         LOGICAL THERE
         DOUBLEPRECISION DD1
         PARAMETER (DD1 = 1.D0 / 90.D0)
         DOUBLEPRECISION DD2, DD3
         LOGICAL LL1
         DOUBLE PRECISION DD4, DD5
         LOGICAL LL2
         NUMBER = 1
         CALL GETARG (NUMBER,FNAME)
         LN = 0
         DO   J=1,100
           IF (FNAME(J:J) .EQ. ' ') GO TO 22
           LN = LN + 1
         END DO
         WRITE (6, *) 'File name is too long'
         CALL EXIT    (0)
   22    CONTINUE
C     Open units
         FNAME(LN + 1:LN + 4) = '.hkl'
         INQUIRE (FILE=FNAME(1:LN + 4), EXIST=THERE)
         IF (.NOT.THERE) THEN
           WRITE (6, *) 'File ', FNAME(1:LN + 4), ' does not exist'
           CALL EXIT    (0)
         END IF
         OPEN (UNIT=10, FILE=FNAME(1:LN + 4))
         OPEN (UNIT=11, FILE='sorted')
         OPEN (UNIT=12, FILE='xfoms.dat')
         OPEN (UNIT=13, FILE='solutions.tran')
         OPEN (UNIT=16, FILE='solutions.calc2')
         OPEN (UNIT=14, FILE='sortedc')
         OPEN (UNIT=15, FILE='xfom2.lst')
         WRITE (6, 111) 'Number to search '
  111    FORMAT(A,'_',$)
         READ (5, *) NSEARCH
         WRITE (6, 111) 'Tolerance level '
         READ (5, *) TOL
    1    FORMAT(A)
         F0 = 0.D0
         OPEN (UNIT=1, FILE='control')
         READ (1, *) NBEAM
         CLOSE (UNIT=1)
         DO   J=1,NBEAM
           READ (10, *) X, I2, Z, F(J), A3(J)
           F0 = F0 + F(J)
         END DO
         CON = ASIN (1.D0) * DD1
         READ (11, *) IP, FOM, (A3(J), J=1,NBEAM)
         WRITE (12, 2) '1st Solution ', FOM, 1., ' # ', 1
         DO   J=1,NBEAM
           DD4 = A3(J)
           A(J,1) = DD4
         END DO
         READ (14, *) IP, FOMZ, (A3(J), J=1,NBEAM)
         WRITE (13, 41) 1, (A3(J), J=1,NBEAM)
   41    FORMAT('ind  ',I1,':',' ',80F9.4,' ')
  410    FORMAT('ind ',I2,':',' ',80F9.4,' ')
         NGOT = 1
         WRITE (15, 100) FOM, 0.D0, 0.D0
         DO 10 J=2,NSEARCH
    3      FORMAT(5F10.4)
           READ (11, *, ERR=999, END=999) IP, FOM, (A2(I), I=1,NBEAM)
           READ (14, *, ERR=999, END=999) IP, FOMZ, (A3(I), I=1,NBEAM)
           CFOM = 1D9
           LL2 = NGOT .EQ. 1
           DO   NG=1,NGOT
             CTHIS = 1D9
             CTOM = 0.D0
             DO   K=1,NBEAM
               CTOM = CTOM + F(K) * (1.D0 - COS ((A2(K) - A(K,NG)) * CON
     X            ))
             END DO
             IF (CTOM .LT. 1D9) CTHIS = CTOM
             IF (CTOM .LT. CFOM) THEN
               CFOM = CTOM
C              if(cfom.lt.tol*f0/0.5)goto 10
             END IF
C       Invert
             CTOM = 0.D0
             DO   K=1,NBEAM
               CTOM = CTOM + F(K) * (1.D0 - COS ((A2(K) + A(K,NG)) * CON
     X            ))
             END DO
             IF (CTOM .LT. CTHIS) CTHIS = CTOM
             IF (CTOM .LT. CFOM) THEN
               CFOM = CTOM
C               if(cfom.lt.tol*f0/0.5)goto 10
             END IF
 
             IF (NG .EQ. 1) CFF = CTHIS * 0.5D0 / F0
             IF (LL2) THEN
               WRITE (15, 100) FOM, CFF, 0.D0
             ELSE IF (NG .EQ. 2) THEN
               WRITE (15, 100) FOM, CFF, CTHIS * 0.5D0 / F0
             END IF
  100        FORMAT(3F12.7)
           END DO
 
           CFOM = CFOM * 0.5D0 / F0
           IF (CFOM .GT. TOL) THEN
             NGOT = NGOT + 1
             WRITE (12, 2) 'New Solution ', FOM, CFOM, ' # ', J
             IF (NGOT .LT. 10) THEN
               WRITE (13, 41) NGOT, (A3(I), I=1,NBEAM),FOM,CFOM
               WRITE (16, 41) NGOT, (A2(I), I=1,NBEAM),FOM,CFOM
             ELSE
               WRITE (13, 410) NGOT, (A3(I), I=1,NBEAM),FOM,CFOM
               WRITE (16, 410) NGOT, (A2(I), I=1,NBEAM),FOM,CFOM
             END IF
             WRITE (6, 2) 'New Solution ', FOM, CFOM, ' # ', J
             IF (NGOT .GT. 30) THEN
               WRITE (6, *) 'Found 31 solutions, exiting'
               CALL EXIT    (0)
             END IF
             DO   K=1,NBEAM
               DD5 = A2(K)
               A(K,NGOT) = DD5
             END DO
           END IF
    2      FORMAT(A,2F12.4,A,I4)
   10    END DO
    4    FORMAT(A,2F8.3,A,2F8.3)
   40    FORMAT(A8,200F9.4)
         CALL EXIT    (0)
  999    WRITE (6, *) 'Error in input'
       END
 
