/*
 * data_out.c
 */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include "mbconfig.h"
#include "fitting.h"
#include "mb_input.h"
#include "data_out.h"
extern DEBUG_INFO dbg;
extern EPS_CTRL	epsilon;

/* =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= */

void print_complexvec(int n, complex *v)
{
	int i;

	for(i=0; i<n; i++){
		printf("%d\t%lf\t%lf\n",i,v[i].re, v[i].im);
	}
}


void fprint_complexvec(FILE *fp, int n, complex *v)
{
	int i;

	for(i=0; i<n; i++){
		fprintf(fp, "%d\t%lf\t%lf\n", i, v[i].re, v[i].im);
	}
}


void print_doublevec(int n, double *v)
{
	int i;

	for(i=0; i<n; i++){
		printf("%d\t%lf\n",i,v[i]);
	}
}


void fprint_doublevec(FILE *fp, int n, double *v)
{
	int i;

	for(i=0; i<n; i++){
		fprintf(fp, "%d\t%lf\n", i, v[i]);
	}
}


void print_complexmat(int n, complex **a)
{
	int i,j;
	for(j=0; j<n; j++){
		for(i=0; i<n; i++){
			printf("%d\t%d\t%lf\t%lf\n", i, j, a[i][j].re, a[i][j].im);
		}
	}
}


void fprint_complexmat(FILE *fp, int n, complex **a)
{
	int i,j;
	for(j=0; j<n; j++){
		for(i=0; i<n; i++){
			fprintf(fp, "%d\t%d\t%lf\t%lf\n", i, j, a[i][j].re, a[i][j].im);
		}
	}
}


void print_doublemat(int n, double **a)
{
	int i,j;
	for(j=0; j<n; j++){
		for(i=0; i<n; i++){
			printf("%d\t%d\t%lf\n", i, j, a[i][j]);
		}
	}
}


void fprint_doublemat(FILE *fp, int n, double **a)
{
	int i,j;
	for(j=0; j<n; j++){
		for(i=0; i<n; i++){
			fprintf(fp, "%d\t%d\t%lf\n", i, j, a[i][j]);
		}
	}
}



