/*
 fitfunc.h
 */

void calc_avrpix_wt(int num_avrpix, double **pix_wt, double gaussian_par);
void alloc_csd(
  int num_sym_op, int n_atom, int num_low_order_g, CRYSTAL_STRCT_DATA *csd_new
  );
/*
void alloc_csd_sub(
  int n_atom, int num_low_order_g, int lof_type, CRYSTAL_STRCT_DATA *csd_new
  );
 */
void alloc_csd_sub_cstr(
  int n_atom, int num_low_order_g, int lof_type, CRYSTAL_STRCT_DATA *csd_new
  );
void cpy_csd(CRYSTAL_STRCT_DATA *csd, CRYSTAL_STRCT_DATA *csd_new);
void free_csd(CRYSTAL_STRCT_DATA *csd);
void alloc_ed(
  BEAM_SEARCH_PAR beam_search, int nr, int ng, int nt, int nk[],
  FIT_EXP_DATASET *ed
  );
void cpy_fed(int num_exp_dataset, FIT_EXP_DATASET *fed, FIT_EXP_DATASET *fed_new);
void free_fed_vector(int num_exp_dataset, FIT_EXP_DATASET *fed);
void free_fei_vector(int num_exp_dataset, FIT_EXP_INTSET *fei);
void free_ed(FIT_EXP_DATASET *ed);
void free_ei(FIT_EXP_INTSET *ei);
void chk_fitpar(int idx, int *nth_fitpar, int *ct_fitpar);
void count_num_fitpar(
  CRYSTAL_STRCT_DATA *csd, int num_exp_dataset, FIT_EXP_DATASET *fed,
  int *num_fitpar, int *num_par, int *num_perturb
  );
/*
  void assign_fitpar_name(
    int num_fitpar, char **fitpar_name,
    CRYSTAL_STRCT_DATA *csd, int num_exp_dataset, FIT_EXP_DATASET *fed
    );
 */
void csd_fed_to_fitpar(
  CRYSTAL_STRCT_DATA *csd, int num_exp_dataset, FIT_EXP_DATASET fed[],
  int num_fitpar, double fitpar[]
  );
void fitpar_to_csd_fed(
  CRYSTAL_STRCT_DATA *csd, int num_exp_dataset, FIT_EXP_DATASET fed[],
  int num_fitpar, double fitpar[]
  );
double eval_step( double par );
void thickness_step(FIT_EXP_DATASET *ed, double *tmp_thickness );
void thickness_set(
  FIT_EXP_DATASET *ed, int num_thickwidth, double *tmp_thickness
  );
void thickweight_set( int num_thickwidth, double *thickness_weight );
double thickness_average(
  int num_thickwidth, double thickwidth, double *tv_intensity,
  double *thickness_weight
  );
void scale_and_average_2d(
  int num_thickwidth, double scale_factor, double thickwidth,
  int it, int nt, int ig, int ik, int num_perturb, double *thickness_weight, 
  double **tmp_intensity, double ***tmp_perturb_intensity,
  double ***intensity, double ****p_intensity
  );
/*
void scale_and_av(
  int num_thickwidth, double scale_factor, double thickwidth,
  int it, int nt, int tmp_g, int num_perturb, double *thickness_weight, 
  double **tmp_intensity, double ***tmp_perturb_intensity,
  double **t_intensity, double ***tp_intensity
  );
*/
void set_csd_fed_step(
  CRYSTAL_STRCT_DATA *csd, int num_exp_dataset, FIT_EXP_DATASET fed[]
  );
void ith_csd_prtb(
  int ith_par, int nth, double *par_perturb, double par, double step
  );
void make_csd_perturb(
  int ith_prtb, CRYSTAL_STRCT_DATA *csd, CRYSTAL_STRCT_DATA *csd_prtb
  );
double ****alloc_jacobian(
  int num_thickness, int num_rg, int *num_data_points, int num_fitpar
  );
void free_jacobian(int num_fitpar, FIT_EXP_DATASET *ed, double ****jacobian);
void init_jacobian(
  int num_fitpar, int ng, int nt, int *nk_g, double ****jacobian
  );
double ***alloc_jacobian_j(
  int num_rg, int num_thickness, int *num_data_points
  );
void free_jacobian_j(double ***jacobian);
void init_jacobian_j(int ng, int nt, int *nk_g, double ***jacobian);
double cubic_intrpl(double x[], double xx, double f[]);
double bicubic_intrpl(
  double xx, double yy, int nx, int ny, double *x, double *y, double **val
  );
void gaussian_convolution(
  int npix, double **intensity, int num_avrpix, double **pixwt
  );
void interpolation_2d(
  double *itp_intensity, double *intensity, R_HKL *k_xy, HGPIX *k_pix,
  double H_shift, double G_shift, double *obs_H, double *obs_G,
  int obs_num_points, int npixels, int nkcal,
  int num_avrpix, double **avrpix_wt
  );
void interpolate2d_of_1d_array(
  /* orginal intensity (1D) ==> input */
  double *org_intensity, int org_num_k_points, int *org_hpix, int *org_gpix,
  int nx_pixels, int ny_pixels, double *org_H, double *org_G,
  /* interpolated intensity (1D) ==> output */
  double *itp_intensity, int itp_num_k_points, double *itp_H, double *itp_G, 
  /* shift and averaging parameters */
  double H_shift, double G_shift, int num_avrpix, double **avrpix_wt
  );
void print_int_ratio(
  FILE *fo, int num_exp_dataset, FIT_EXP_DATASET *fed, FIT_EXP_INTSET *fei
  );
void fit_intensity_output(
  int num_exp_dataset, FIT_EXP_DATASET *fed, FIT_EXP_INTSET *fei,
  char *outfile
  );
void print_scaled_r_factors(
  FILE *fo, int num_exp_dataset, FIT_EXP_DATASET *fed, FIT_EXP_INTSET *fei
  );
double rf_r_factor(double *obs, double *cal, int num_points);
void print_r_factors(
  FILE *fo, int num_exp_dataset, FIT_EXP_DATASET *fed, FIT_EXP_INTSET *fei
  );
/*
void calc_r_factors(
  FILE *fo, int num_exp_dataset, FIT_EXP_DATASET *fed, FIT_EXP_INTSET *fei,
  double *R_total, double *R_
  );
  */
/*
void shift_output(
  int num_exp_dataset, FIT_EXP_DATASET *fed, FIT_EXP_INTSET *fei, char *infile
  );
  */
void par_output_short(
  CRYSTAL_STRCT_DATA *csd, int num_exp_dataset, FIT_EXP_DATASET *fed,
  FILE *fp_log
  );
void output_result_parfile(
  char *out_parfile, CRYSTAL_STRCT_DATA *csd,
  int maxnum_iter, int num_exp_dataset, 
  FIT_EXP_DATASET *fed, FIT_EXP_INTSET *fei
  );
