/*
 * mb_input.h
 */
void chk_data(const char *str, FILE *fp);
void chk_data_info(const char *str, char *info, FILE *fp);

void fget_element( char *element, FILE *fp );
char *fget_1s( char *str, FILE *fp );
char *fget_2s( char *str1, char *str2, FILE *fp );
double fget_d(FILE *fp);
int  fget_i(FILE *fp);
void fget_5d( double *v, double *w, double *x, double *y, double *z, FILE *fp );
void fget_4d( double *w, double *x, double *y, double *z, FILE *fp );
void fget_3d( double *x, double *y, double *z, FILE *fp );
void fget_2d( double *x, double *y, FILE *fp );
void fget_3i( int *i, int *j, int *k, FILE *fp);
void fget_2i( int *i, int *j, FILE *fp);
double fget_d_and_i(int *i, FILE *fp);
/*
void fget_di(double *x, int *i, FILE *fp);
void fget_did(double *x1, int *i, double *x2, FILE *fp);
void fget_didd(double *x1, int *i, double *x2, double *x3, FILE *fp);
  */
void fget_str_and_i(char *str, int *i, FILE *fp);
void fget_str_and_dii(char *str, double *x, int *i, int *j, FILE *fp);

/* void fget_name_cstr_idx(char *name, char *cstr, int *idx, FILE *fp);*/
HKL   fget_hkl(FILE *fp);
R_HKL fget_r_hkl(FILE *fp);
UVW   fget_uvw(FILE *fp);
void fget_hkl_weight( HKL *g, double *weight, FILE *fp );
/* ======================================================================== */
/* ======================================================================== */
BEAM_SEARCH_PAR fget_beam_search(FILE *fi);
void fget_beam_search_wg(FILE *fi, BEAM_SEARCH_PAR *beam_search);
void fget_beam_search_sg(FILE *fi, BEAM_SEARCH_PAR *beam_search);
void fget_beam_search_sg_multi(FILE *fi, BEAM_SEARCH_PAR *beam_search);

void fget_ed_beams(FIT_EXP_DATASET *ed, FILE *fi);
/*
void fget_low_g(
	FILE *fi, int n_atom, int num_low_order_g, HKL *g_lo, int *lof_type,
	LO_FG *fg_lo, LO_FG_IDX *fg_lo_i
);
void fget_low_g_cst(
	FILE *fi, int n_atom, int num_low_order_g, HKL *g_lo, int lof_type,
	LO_FG *fg_lo, LO_FG_IDX *fg_lo_i, CST_LO_FG *cl
);
 */
int find_n_g( int nr, HKL g, HKL *reflex );
void fget_inc_wave(
  double *acc_voltage, UVW *incidence, UVW *surf_norm,
  R_HKL *zolzbase1, FILE *fp
  );
void fget_calc_par(
  int *calc_type, int *num_points, int *num_points_x, int *num_points_y,
  double *H_begin, double *H_end, double *G_begin, double *G_end,
  char *hg_file, FILE *fp
  );
void fget_beams(int num_exact, int num_bethe, HKL *reflex, FILE *fp );

void beam_merge(
  int num_exact, int num_bethe, HKL *g_exact, HKL *g_bethe, HKL *reflex
  );
void fget_cal_g(
  int num_cal_g, int num_exact, int num_bethe, 
  int *nth_g, HKL *reflex, FILE *fp
  );
void fget_cal_thick(int num_cal_thick, double *thickness, FILE *fp );
void marge_cal_gt(
  int num_cal_g, int num_cal_thick,
  int *nth_g, double *thickness, int *gt_nth_g, double *gt_thickness
  );
/*void dbg_g_filein(
  FILE *fp, int nglim, int *ne, int *nb, HKL *tg_exact, HKL *tg_bethe
  );*/
/*void dbg_vg_filein( FILE *fp, int ne, int nb, HKL *reflex, complex **vg );*/

/* void input_crystal_strct_data(FILE *fi, CRYSTAL_STRCT_DATA *csd); */
void par_transval(int idx, char *str, double *arg);

void fget_fitpar(FIT_CTRL *fc, double *val, FILE *fp);
void input_csd_cstr(CRYSTAL_STRCT_DATA *csd, FILE *fi, char *infile);
