/*
 * mbconfig.h for mbfit
 *  configuration parameters
 */
/*#define MPI_MODE*/  /* MPI mode */

#define SCFACT 1.0  /* 1.0e+4 *//* Scaling factor for matrix elements */
#define SIZE_GTABLE 300 /* size of g-table */
#define EPS		1e-12
#define XIGMAX	1e+10


typedef struct {
	double	eps,
			eigen,
			inv,
			degeneracy,
			perturb_step,
			tol_chisq_abs, tol_chisq_rel, tol_parameter,
			intensity_scaling,
			bc_accuracy,
			corr_threshold,
		/*	w_a, w_b, w_c, w_d, w_e, w_f,*//* weight parameters (not in use) */
			w_sq_coef, w_exp_coef, w_exp 	/* weight parameters */
		/*,	hbgn, hend, gbgn, gend	*/	/* calc. range parameters for CBED disk fit.*/
			;	
	int 	/* atomf_flag_bk, */
			vg_select_flag,
			diagonalize_func,	/* diagonalization func, 0:Eispack, 1:Numpack */
			svd_flag,
			no_fitting_flag,
			num_thickwidth,		/* Number of calc. points for thick-av. (one side) */
			thickwidth_type,	/* 0:rectangle, 1:triangle, 2:Gaussian */
			cal_range_flag,		/* 0:manual */
			command_line_flag,	/* 1:command line input, 0:menu input */
			message_exit_flag,	/* 1:exit with a message, 0:no message */
			numh,				/* num. calc. points for HG, sq(numh) is num_HG */
			auto_multiplicity_off	/* 0:auto_multiplicity, 1:manual */
			;
} EPS_CTRL ;
