#ifndef CResultTable_h
#define CResultTable_h
#include "TFile.h"
#include "CTable.h"
#include "TImage.h"

#ifdef __MAIN__
TableReference  gMatchingResultTable = 0;
WindowPtr		gMatchingResultWindow = nil;
#else
extern TableReference  gMatchingResultTable ;
extern WindowPtr		gMatchingResultWindow ;
#endif

class CResultTable : public CTable {

public:
	CResultTable(void) ;
	CResultTable(TImage *image) ; // load the table with the result image
	CResultTable(Int16 width,Int16 height,Int16 cellSize,Int16 cellWidth,Int16 cellHeight) ; 
	~CResultTable() ;
	
	void	DrawColLabelText(Int16 colNumber) ;
	void	DrawRowLabelText(Int16 colNumber) ;
	virtual void 	DrawCellValue(TableCellT &inCell,Rect &cellFrame) ;
	void	SetDefocusLabel(short col,float value) ;
	void	SetThicknessLabel(short row,float value) ;
	virtual void	Save(short refNum) ;
	virtual void	SetSuccessValues(float exactMatch,float goodMatch) ;
	
	float	mExactMatch ;
	float	mGoodMatch ;
	TableCellT	mBestCell ;
	TImage	*mImage ;		// only used in SetSuccessValues
} ;

TableReference 	ShowImageMatchingResult(TImage *image,WindowPtr *window) ;
void	  		HandleResultableEvent(TableReference table,EventRecord *inEvent) ;
void			HandleResultTableMouseDown(TableReference table,EventRecord *inEvent) ;
void			HandleResultTableGrow(TableReference table,EventRecord *inEvent) ;
void	  		UpdateResultTable(TableReference table) ;
Boolean			DisposeResultTable(TableReference table,Boolean forceDispose) ;
void			SaveResultTable(TableReference theTable) ;
int 			AskSaveResult(char *text) ;

void			PrintResultTable(TableReference theTable) ;
#endif	// CResultTable

