#ifndef TAtom_h
#define TAtom_h


#include "types.h"

class CCrystal ;

#define kRefineX	0x01
#define kRefineY	0x02
#define kRefineZ	0x04
#define kRefineDW	0x08
#define kRefineOCC	0x10			
typedef enum {kNormalState,kSelectedState,kHighlightedState,kDeSelectedState} DrawingState ;

class TAtom {
	public:
		TAtom(void) ;
		~TAtom(void) ;
		char 	*name ;
		unsigned short	tag ;
		short	no ;
		short	type ;	// We need this tag to keep track of the type of atom
		float 	xc ;
		float 	yc ;
		float 	zc ;
		float	dw ;
		float	occ ;		
		float	rad;  // if less than zero then use default
		RGBColor color ;
		DrawingState state ;
		long		groupnumber ;
		unsigned char	refine ;
		TAtom& operator=(const TAtom&) ;
} ;

class SAtom {
	public:
		SAtom(void) ;
		~SAtom(void) ;
		SAtom& operator=(const SAtom&) ;
		friend class TCrystal ;
	private:
		
		TAtom			atom ;		// Atom as it appears within the "Unit Cell"	
		long			index ;		// index to the original atom in the mAtomList
		Point3D			location ;	// Location on the screen
		FPoint3D		position ;	// Position in Angstrom from the arbitrary origin
		short			rad ;
		DrawingState	state ;
		long				groupnumber ;	//
} ;

const short _maxTagLength = 5;

#endif //TAtom_h

