#ifndef __TResidualImageDisplay
#define __TResidualImageDisplay
#include <stdio.h>
#include <math.h>

#include "TWindow.h"
#include "TImage.h"
#include "TFile.h"

class TResidualImageDisplay : public TWindow {
	public:
					TResidualImageDisplay(long imageWidth,long imageHeight,
							long numImagesHoriz,long numImagesVert) ;
					~TResidualImageDisplay() ;
		Boolean 	AddImageToDisplay(TImage *image) ;
		void		SetPseudoColor(Boolean state) { mPseudoColor = state ; } ;
		void		SetModified(Boolean state) { mIsDirty = state ; } ;
		Boolean		IsModified() {  return mIsDirty ; } ;
		void		Save() ;
		void		Close() ;
		void		Update(XEvent *event) ;
		void		DoMouseDown(XEvent *event) ;
		void		DoWMRequestDelete() ;
	private:
		
		long 		mWidth ;
		long 		mHeight ;
		long		mImageWidth ;
		long		mImageHeight ;
		short		mNumHorizontalImages ;
		short		mNumVerticalImages ;
		short		mCurrentImageNumber ;
		Boolean		mPseudoColor ;
		Boolean		mIsDirty ;
		Rect		mImageRect ;
} ;
#endif

