#ifndef __TStructureRefinementProgressPage_h_
#define __TStructureRefinementProgressPage_h_
#include "TPage.h"

#include "TImage.h"
#include "ProjCellRecord.h"
#include "TCrystal.h"

class TStructureRefinementProgressPage : public TPage {
	public:
		TStructureRefinementProgressPage(TWindow *window,ProjCellRecord * nucell) ;
		~TStructureRefinementProgressPage() ;

		void		Draw() ;
		void		DoMouseDownInObject(TObject *obj,Point *pt) ;
		void		UpdateComputedImage(TImage *) ;
		void		UpdateCurrentParameters() ;
		void		DisplayLatestParameters() ;
		void		SetLogFileName(char *text) ;

		TCrystal	*GetCrystal() { return mCrystal ; } ;

	private:

		void		Initialize() ;
		void		DrawExperimentalImage() ;
		void		DrawCurrentComputedImage() ;
		void		DrawCurrentModel() ;
		void		DrawEnergyWindow() ; 
		void		UpdateCurrentEnergy(float energy) ;

		TUserRect 	*mExperimentalImageFrame;
		TUserRect 	*mCurrentImageFrame;
		TUserRect 	*mModelFrame;
		TUserRect 	*mEnergyFrame ;

		TStaticText *mCurrentEnergy;
		TStaticText *mCurrentStatus;
		TStaticText *mCurrentTemperature;
		TStaticText	*mCurrentChangeInStructure ;

		TButton 	*mReturn;
		TButton 	*mSaveReturn;
		TStaticText *mLogFileName;


		long		mNumDisplayIndex ;
		float		mMaxValueOfEnergy ;
		float		mMinValueOfEnergy ;
		float		mScaleFactor ;
		TImage		*mExperimentalImage ;
		TImage		*mComputedImage ;
		TCrystal	*mCrystal ;

		TOffscreen	*mOffscreen ;

		Point		mCurrentEnergyPt ;

};

#endif // __TStructureRefinementProgressPage_h_

