// -----------------------------------------------------------------------------
//  Copyright (c) 2001 Roar Kilaas
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// -----------------------------------------------------------------------------
#include "header.h"
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "funcdefs.h"
#include "numbers.h"
#define EOS '\0'
#define NEWLINE '\n'


long gSecondSetting,gAlternateSetting,gCentroSymmetric ;
long generators[] = 			{ 040201,0442201,0440211,042211,010402,
                            0114402,014422,0110422,020104,0220144,
                            0221104,021144,020411,012204,0440102,
                            0224411,0112244,0441122,0220401,010244,
                            041102,024401,0110204,040122,0442211,
                            040211,042201,0440201,0114422,010422,
                            0110402,014402,0221144,021104,020144,
                            0220104,0224401,0110244,041122,020401,
                            010204,040102,024411,0112204,0440122,
                            0220411,012244,0441102,0222601,0464401,
                            0260401,024601,0262211,0444611,0460211,
                            042611,024611,0260411,0464411,0222611,
                            0460201,042601,0262201,0444601} ;
struct TranslationRec {
	float value ;
	char  *symbol ;
} translations[] = { 
	{1./2.,"1/2"},{1./3.,"1/3"},
	{2./3.,"2/3"},{1./4.,"1/4"},
	{3./4.,"3/4"},{1./6.,"1/6"},
	{5./6.,"5/6"},{1./8.,"1/8"},
	{3./8.,"3/8"},{5./8.,"5/8"},
	{7./8.,"7/8"}
} ;

char spacegroup[132] ;
static char symb[] = {'x','y','z'} ;
struct GENERATOR {
         float matr[4][4] ;
       } gen[20],temp_sym,temp_gen ;
extern struct GENERATOR symop[200] ;
extern char symop_txt[200][40] ;
extern char *txtptr_symop[200] ;
struct GENERATOR inv_gen = {-1.,0.,0.,0.,0.,-1.,0.,0.,0.,0.,-1.,0.,
                            0.,0.,0.,1.} ;
struct GENERATOR identity_matr = {1.,0.,0.,0.,0.,1.,0.,0.,0.,0.,1.,0.,
                                  0.,0.,0.,1.} ;
struct GENERATOR p_matr,q_matr ;
extern long gNumSymops ;
extern char *NcemssDir, stext[] ;


typedef struct GeneratorRec {
				long generators[64] ;
				} *GenPtr ;
#ifdef __VMS
#pragma message disable typnolnkvarlnk
#endif
GenPtr GP = (GenPtr)generators ;
#ifdef __VMS
#pragma message enable typnolnkvarlnk
#endif

long get_spcgrp_number() {
	long spcgrp_number,resp,setting ;
	char buffer[40],*cp ;

	ReadString(buffer,40) ;
	if (strlen(buffer) == 0)
		strcpy(buffer,"1") ;
	gSecondSetting = FALSE ;
	if ((cp=strchr(buffer,'-'))!=NULL) {
		*cp++ = EOS ;
		setting = atoi(cp) ;
		if (setting==2)
		gSecondSetting = TRUE ;
	}
	spcgrp_number = atoi(buffer) ;
	if (spcgrp_number > 0 && spcgrp_number <=230)
		return(spcgrp_number) ;
	else
		return(0) ;    
}

void assm_spcgrp(long spcgrp_number) {
	FILE *fp ;
	char SpcgrpFile[255] ;
	long i ;

	strcpy(SpcgrpFile,NcemssDir) ;
#ifdef VMS
	strcat(SpcgrpFile,"spcgrp.dat") ;
#else
	strcat(SpcgrpFile,"/spcgrp.dat") ;
#endif
	if ((fp=fopen(SpcgrpFile,"r")) == NULL) {
		eraser(0,0,1000,32) ;
		sprintf(stext,"Unable to open the file %s , Using Group # 1 !",
		SpcgrpFile) ;
		temdtx(0,10,stext) ;
		strcpy(spacegroup,"1 0 1 1 0 0") ;
		generate_spcgrp(spacegroup) ;
		return ;
	}
	for (i=0;i<spcgrp_number;i++)
		fgets(spacegroup,132,fp) ;
	fclose(fp) ;
	i = 0 ;
	while (spacegroup[i++] != NEWLINE && i < 132) ;
	spacegroup[--i] = EOS ;

	generate_spcgrp(spacegroup) ;
}

void generate_spcgrp(char  *spacegroup) {
	long i,j,k,num_gen,number ;
	long inversion,new_gen,num_sym ;
	long ione ;

	symop[0] = identity_matr ;
	gNumSymops = 1 ;
	decode_spcgrp(spacegroup,&num_gen,&inversion) ;
	for (i=0;i<num_gen;i++) {
		num_sym = gNumSymops ;
		temp_gen = gen[i] ;
		do {
			for (j=0;j< num_sym;j++) {
				apply_gen(&temp_gen,&symop[j],&temp_sym) ;
				if (new_symop(&temp_sym,gNumSymops))
					symop[gNumSymops++] = temp_sym ;
			}
			apply_gen(&gen[i],&temp_gen,&temp_sym) ;
			if (!(ione=ident(&temp_sym)))
				temp_gen = temp_sym ;
		} while (!ione) ;
	}
	num_sym = gNumSymops ;
	gCentroSymmetric = FALSE ;
	if (inversion) {
		gCentroSymmetric = TRUE ;
		for (j=0;j< num_sym;j++) {
			apply_gen(&inv_gen,&symop[j],&temp_sym) ;
			symop[gNumSymops++] = temp_sym ;
		}
	}
	for (k=0;k< gNumSymops;k++) {
		encode_symop(&symop_txt[k][0],&symop[k]) ;
		txtptr_symop[k] = &symop_txt[k][0] ;
	}
}

void encode_symop(char *string,struct GENERATOR *sym_op) {
	long first,i,j,k ;
	float test ;
	char *cp ;

	cp = string ;
	for (i=0;i<3;i++) {
		first = TRUE ;
		for (j=0;j<3;j++) {
			test = sym_op->matr[i][j] ;
			if (test != 0.) {
				if (first) {
					if (test < 0.) sprintf(cp++,"-") ;
						sprintf(cp++,"%c",symb[j]) ;
					first = FALSE ;
				}
				else {
					if (test < 0.) 
						sprintf(cp++,"-%c",symb[j]) ;
					else
						sprintf(cp++,"+%c",symb[j]) ;
					cp++ ;
				}
			}
		}
		if (sym_op->matr[i][3] != 0.) {
			j = 0 ;
			do {
				test = sym_op->matr[i][3] - translations[j++].value ;
				test = (test >= 0. ? test : -test) ;
			}
			while ( test > 0.001 && j < 11) ;
			sym_op->matr[i][3] = translations[--j].value ;
			sprintf(cp++,"+%s",translations[j].symbol) ;
			cp += 3 ;
		}
		if (i!=2) sprintf(cp++,",") ;
	}
	*cp = EOS ;
}

void apply_gen(struct GENERATOR *oper,struct GENERATOR *source,struct GENERATOR *dest) {
	long i,j,k ;


	for (i=0;i<4;i++)
		for (j=0;j<4;j++) {
			dest->matr[i][j] = 0. ;
			for (k=0;k<4;k++)
				dest->matr[i][j] += (oper->matr[i][k]*source->matr[k][j]) ;
		}
	for (k=0;k<3;k++) {
		dest->matr[k][3] = one(dest->matr[k][3]) ;
		if (dest->matr[k][3] < 0.001 || dest->matr[k][3] > 0.999)
			dest->matr[k][3] = 0. ;
	}
}

long ident(struct GENERATOR *p_sym) {
	long i ; 
	float *p1,*p2 ;

	p1 = &p_sym->matr[0][0] ;
	p2 = &symop[0].matr[0][0] ;
	for (i=0;i<16 && *p1++ == *p2++;i++) ;
	if (i==16)
		return(TRUE) ;
	else 
		return(FALSE) ;
}   

long new_symop(struct GENERATOR *p_symop,long num_symop) {
	long i,j,new_gen ;
	float *p_sym,*p_old_sym,test ;

	new_gen = TRUE ;
	for (i=0;i< num_symop;i++) {
		p_sym = &p_symop->matr[0][0] ;
		p_old_sym = &symop[i].matr[0][0] ;
		for(j=0; j < 16 ;j++) {
			test = *p_sym - *p_old_sym ;
			test = (test >= 0. ? test : -test) ;
			if (test > 0.001) 
				break ;
			p_sym++ ;
			p_old_sym++ ;
		}
		if (j==16) {
			new_gen = FALSE ;
			break ;
		}
	}
	return(new_gen) ;
}

#define BLANK ' '
#include <math.h>
void decode_spcgrp(char *string,long *pnum_gen,long *pinversion) {
	long num_gen,inversion ;
	long i,j,k,spcgrp_number,p_transl,p_rot ;
	long ndx,rot[20],trnsl[20] ;
	char *cp,buf[80] ;

	cp = string ;
	/* skip first blanks */
	while (*cp==BLANK) cp++ ;
	i=0 ;
	while(*cp != BLANK)
		buf[i++] = *cp++ ;
	buf[i] = EOS ;
	spcgrp_number = atoi(buf) ;
	/* skip first blanks */
	while (*cp==BLANK) cp++ ;
	i=0 ;
	while(*cp != BLANK)
		buf[i++] = *cp++ ;
	buf[i] = EOS ;
	inversion = atoi(buf) ;
	/* skip first blanks */
	while (*cp==BLANK) cp++ ;
	i=0 ;
	while(*cp != BLANK)
		buf[i++] = *cp++ ;
	buf[i] = EOS ;
	num_gen = atoi(buf) ;

	for (k=0;k<num_gen;k++) 
		for (j=0;j<2;j++) {
			/* skip first blanks */
			while (*cp==BLANK) cp++ ;
			i=0 ;
			while(*cp != BLANK)
				buf[i++] = *cp++ ;
			buf[i] = EOS ;
			if (j==0)
				rot[k] = atoi(buf) ;
			else
				trnsl[k] = atox(buf) ;
		}               

	/* Check to see if there is a second setting */
	/* skip first blanks */
	while (*cp==BLANK) cp++ ;
	i=0 ;
	while(*cp != BLANK && *cp != EOS)
		buf[i++] = *cp++ ;
	buf[i] = EOS ;
	gAlternateSetting = atoi(buf) ;

	/* If there is a second setting, then get the P and the Q matrix */
	if (gAlternateSetting) {
		for (j=0;j<2;j++) {
			/* skip first blanks */
			while (*cp==BLANK) cp++ ;
			i=0 ;
			while(*cp != BLANK && *cp != EOS && i < 132)
				buf[i++] = *cp++ ;
			buf[i] = EOS ;
			if (j)
				p_transl = atox(buf) ;
			else
				p_rot = atoo(buf) ;
		}
		/* Now we have to set the values in the p and q matrices */
		decode_gen(p_rot,p_transl,&p_matr) ;
		get_inverse(&p_matr,&q_matr) ;
	}
	for (i=0;i<num_gen;i++)
		decode_gen(generators[rot[i]-1],trnsl[i],&gen[i]) ;
	*pnum_gen = num_gen ;
	*pinversion = inversion ;
}

void get_inverse(struct GENERATOR *source,struct GENERATOR *dest) {
	long i ;
	float det ;

	det = source->matr[0][0]*(source->matr[1][1]*source->matr[2][2] -
	                  source->matr[1][2]*source->matr[2][1]) +
	source->matr[0][1]*(source->matr[2][0]*source->matr[1][2] -
	                  source->matr[1][0]*source->matr[2][2]) +
	source->matr[0][2]*(source->matr[1][0]*source->matr[2][1] -
	                  source->matr[2][0]*source->matr[1][1]) ;
	dest->matr[0][0] = (source->matr[1][1]*source->matr[2][2] -
	            source->matr[2][1]*source->matr[1][2])/det ;
	dest->matr[0][1] = (source->matr[2][1]*source->matr[0][2] -
	            source->matr[0][1]*source->matr[2][2])/det ;
	dest->matr[0][2] = (source->matr[0][1]*source->matr[1][2] -
	            source->matr[1][1]*source->matr[0][2])/det ;
	dest->matr[1][0] = (source->matr[2][0]*source->matr[1][2] -
	            source->matr[1][0]*source->matr[2][2])/det ;
	dest->matr[1][1] = (source->matr[0][0]*source->matr[2][2] -
	            source->matr[2][0]*source->matr[0][2])/det ;
	dest->matr[1][2] = (source->matr[1][0]*source->matr[0][2] -
	            source->matr[0][0]*source->matr[1][2])/det ;
	dest->matr[2][0] = (source->matr[1][0]*source->matr[2][1] -
	            source->matr[2][0]*source->matr[1][1])/det ;
	dest->matr[2][1] = (source->matr[2][0]*source->matr[0][1] -
	            source->matr[0][0]*source->matr[2][1])/det ;
	dest->matr[2][2] = (source->matr[0][0]*source->matr[1][1] -
	            source->matr[1][0]*source->matr[0][1])/det ;
	for (i=0;i<3;i++) {
		dest->matr[i][3] = - source->matr[i][3] ;
		dest->matr[3][i] = source->matr[3][i] ;
	}
	dest->matr[3][3] = source->matr[3][3] ;
}

void decode_gen(long rot,long trnsl,struct GENERATOR *sym_op) {
	long i,j,k,ndx,den[3],num[3] ;
	float t[16],*p_float ;

	for (i=0;i<16;t[i++]=0.) ;
	/* decode the rotation part */
	for (k=0;k<3;k++)
		for (j=0;j<2;j++)
			for (i=0,ndx=10-k*4;i<3;i++,ndx--) {
				if (rot%2) {
					if (j)
						t[ndx] = - t[ndx] ;
					else
						t[ndx] = 1. ;
				}
				rot >>= 1 ;
			}
	/* decode the translation part */
	den[2] = trnsl & 0x0000000F ;
	num[2] = (trnsl & 0x000000f0) >> 4 ;
	if (num[2] > 8) num[2] = 8 - num[2] ;
	den[1] = (trnsl & 0x00000f00) >> 8 ;
	num[1] = (trnsl & 0x0000f000) >> 12 ;
	if (num[1] > 8) num[1] = 8 - num[1] ;
	den[0] = (trnsl & 0x000f0000) >> 16 ;
	num[0] = (trnsl & 0x00f00000) >> 20 ;
	if (num[0] > 8) num[0] = 8 - num[0] ;
	for (i=0;i<3;i++)
		if (den[i] != 0)
			t[3+i*4] = (float)num[i]/den[i] ;
	t[15] = 1. ;
	p_float = &sym_op->matr[0][0] ;
	for (i=0;i<16;*p_float++=t[i++]) ;
	if (sym_op != &p_matr) {
		if (gSecondSetting && gAlternateSetting) {
			apply_gen(sym_op,&q_matr,&temp_sym) ;
			apply_gen(&p_matr,&temp_sym,sym_op) ;
		}
	}
}
