// -----------------------------------------------------------------------------
//  Copyright (c) 2001 Roar Kilaas
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// -----------------------------------------------------------------------------
#include <string.h>
#include "header.h"
#include "symops.h"

void decode_symop(long j) ;
// -------------------------------------------------------------
// Routine to decode the symmetry operator stored as an 
// ascii string.                                   
// -------------------------------------------------------------
void decode_symop(long j) {
	char buffer[3][20],*cp,*cp1,c ;
	long  i,k,n,ndx,number_1,number_2 ;

	k = 0 ;
	i = 0 ;
	n = 0 ;
	cp = txtptr_symop[j] ;
	
	do {
		c = *cp++ ;
		if (c != EOS) {
			if (c==COMMA) {
				buffer[k++][i] = EOS ;
				i = 0 ;
			}
			else if (c != BLANK)
				buffer[k][i++] = c ;
		}
	}
	while (c != EOS) ;
	
	buffer[k][i] = EOS ;
	for (k=0;k<3;k++)
		{
		if ((cp=strpbrk(&buffer[k][0],"xX")) != NULL) {
			if (cp == &buffer[k][0])
				symop[j].matr[k][0] = 1. ;
			else {
				if (*(--cp) == MINUS)
					symop[j].matr[k][0] = -1. ;
				else
					symop[j].matr[k][0] = 1. ;
			}
		}
		else
			symop[j].matr[k][0] = 0. ;
			
		if ((cp=strpbrk(&buffer[k][0],"yY")) != NULL) {
			if (cp == &buffer[k][0])
				symop[j].matr[k][1] = 1. ;
			else {
				if (*(--cp) == MINUS)
					symop[j].matr[k][1] = -1. ;
				else
					symop[j].matr[k][1] = 1. ;
			}
		}
		else
			symop[j].matr[k][1] = 0. ;
			
		if ((cp=strpbrk(&buffer[k][0],"zZ")) != NULL) {
			if (cp == &buffer[k][0])
				symop[j].matr[k][2] = 1. ;
			else {
				if (*(--cp) == MINUS)
					symop[j].matr[k][2] = -1. ;
				else
					symop[j].matr[k][2] = 1. ;
			}
		}
		else
			symop[j].matr[k][2] = 0. ;
	}
	/* sort out the translation vectors */
	for (k=0;k<3;k++) {
		number_1 = 0 ;
		number_2 = 0 ;
		if ((cp=strpbrk(&buffer[k][0],"1234567890/")) != NULL) {
			/* there is a translation vector */
			/* Check to see if it is written as a fraction */
			if ((cp1=strpbrk(&buffer[k][0],"/")) != NULL) {  /* It is */
				number_1 = *(--cp1) - '0' ;
				/* check for the sign */
				if (cp1 != &buffer[k][0])
					if ((c = *(cp1-1)) == MINUS)
						number_1 = -number_1 ;
				cp1 += 2 ;
				while (*cp1 >= '0' && *cp1 <= '9') {
					number_2 = number_2*10 + *cp1 - '0' ;
					cp1++ ;
				}
				symop[j].matr[k][3] = (float)number_1/number_2 ;
			}
			else {  /* It is written with just the denominator */
				number_1 = 1 ;
				/* First get the sign */
				if ( cp != &buffer[k][0])
					if (( c = *(cp-1)) == MINUS)
						number_1 = -number_1 ;
				while (*cp >= '0' && *cp <= '9') {
					number_2 = number_2*10 + *cp - '0' ;
					cp++ ;
				}
				symop[j].matr[k][3] = (float)number_1/number_2 ;
			}
		}
		else
			symop[j].matr[k][3] = 0. ;
	}
	for (k=0;k<2;k++)
		symop[j].matr[3][k] = 0. ;
	symop[j].matr[3][3] = 1. ;
}

