// -----------------------------------------------------------------------------
//  Copyright (c) 2001 Roar Kilaas
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// -----------------------------------------------------------------------------
#include "header.h"
#include "menudef.h"
#include "menu_index.h"
#include "funcdefs.h"
#include "storage.h"
#include "devices.h"
#include "globals.h"
extern GDevice *OutDevice ;
extern float RANGE ;
extern char stext[] ;
// -------------------------------------------------
// Plot the histogram distribution to the screen.  
// -------------------------------------------------
void displ_hist(long *np,long *mp) {

	long imax,i,hist[256],xlo,ylo,xhi,yhi,max_value ;
	float xl,yh,dx,xwidth ;

	if (OutDevice->type != WS)
		return ;

	imax = (*np)*(*mp) ;
	for (i=0;i<=(long)RANGE;hist[i++] = 0) ;
	
	/* set the histogram distribution */
	for (i=0;i<imax;hist[(long)gWorkSpace[i++]]++) ;
	max_value = hist[0] ;
	for (i = 1 ; i <=(long)RANGE ; i++)
		if (hist[i] > max_value) max_value = hist[i] ;

	SetOffscreenPort(gOffscreenPtr) ;
	ClearDisplay() ;
	/* draw the axes */
	Rect	theHisogramRect ;
	SetRect(&theHisogramRect,OutDevice->xres/2-100,
		OutDevice->yres/2-130,OutDevice->xres/2+100,
		OutDevice->yres/2+130) ;
	xlo = theHisogramRect.left ;
	ylo = theHisogramRect.bottom ; 
	xhi = theHisogramRect.right ; 
	yhi = theHisogramRect.top ;
	DrawLine(xlo,ylo,xhi,ylo) ;
	DrawLine(xlo,ylo,xlo,yhi) ;
	sprintf(stext,"%.0f ('255')",RANGE) ;
	DrawText(xlo,ylo+15,"0") ;
	DrawText(xhi,ylo+15,stext) ;
	dx = (xhi-xlo)/RANGE ;
	xwidth = 0.2*dx ;
	/* Output the histogram to the "DISPLAY" regardless of output-display */
	Rect	theRect ;
	for (i=0,xl=xlo;i<=(long)RANGE;i++,xl += dx) {
		yh = ylo+(yhi-ylo)*hist[i]/max_value ;
		SetRect(&theRect,(long)xl,(long)yh,(long)(xl+dx),ylo) ;
		FillRect(&theRect) ;
		//DrawLine((long)xl,ylo,(long)xl,(long)yh) ; 
	}
	UnSetOffscreenPort(gOffscreenPtr) ;
	UpdateImageScreen() ;
	SetPort(gControlWindow) ;
}      

