// -----------------------------------------------------------------------------
//  Copyright (c) 2001 Roar Kilaas
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// -----------------------------------------------------------------------------
#include "globals.h"
#include "funcdefs.h"
 
void UpdateFromOffscreen(GrafPtr dest,GrafPtr source) {
	Rect sourceRect = source->GetPortRect() ;
	CopyBits(source,dest,&sourceRect,&sourceRect) ;
}

void UpdateFromOffScreenRect(GrafPtr dest,GrafPtr source,Rect *tRect) {
	CopyBits(source,dest,tRect,tRect) ;
}

void UpdateImageScreen() {
	GrafPtr	tPort ;
	GetPort(&tPort) ;
	SetPort(gDisplayWindow) ;
    	UpdateFromOffscreen(gDisplayWindow,gOffscreenPtr) ;
    	XFlush(gDisplay) ;
	SetPort(tPort) ;
}

void DrawCommandLine() {
	Rect tRect ;
	unsigned long oldFg ;

	tRect = gCommandLineRect ;
	InsetRect(&tRect,1,1) ;
	EraseRect(&tRect) ;
	PenSize(2,2) ;
	SetFgColor(gBlackPixel) ;
	DrawLine(tRect.left,tRect.bottom,tRect.left,tRect.top) ;
	DrawLine(tRect.left,tRect.top,tRect.right,tRect.top) ;
	SetFgColor(gWhitePixel) ;
	DrawLine(tRect.right,tRect.top,tRect.right,tRect.bottom) ;
	DrawLine(tRect.right,tRect.bottom,tRect.left,tRect.bottom) ;
	SetFgColor(gBlackPixel) ;
	DrawText(tRect.left+5,tRect.bottom-5,gCurrentText) ; 
}
