// -----------------------------------------------------------------------------
//  Copyright (c) 2001 Roar Kilaas
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// -----------------------------------------------------------------------------
#include "header.h"
#include "errors.h"
#include "funcdefs.h"
void err(long i) {
  /********************************************************************/
  /* Display error messages that might occur during activation of the */
  /* menu associated with atom coordinates and unit cells             */
  /********************************************************************/

    eraser(0,60,960,100) ;
    REVERSE_VIDEO ;
    switch(i)
             {
             case 0 :
                     temdtx(0,70," Function not yet implemented ") ;
                     break ;
             case 1 : 
                     temdtx(0,70," No more atoms in the structure ") ;
                     break ;
             case 2 : 
                      temdtx(0,70," Backup past the first atom ");
                      break ;
             case 3 :
                      temdtx(0,70," Illegal entry !  REENTER !! ") ;
                      break ;
             case 4 :
                      temdtx(0,70,
                      " The argument for the sqrt is negative in V ") ;
                      break ;
             case 5 :
                      temdtx(0,70,
                     " The argument for the sqrt is negative in VST ") ;
                      break ;
             case 6 : 
                     temdtx(0,70," No more Symmetry operators ") ;
                     break ;
             case 7 : 
                      temdtx(0,70,
                     " Backup past the first Symmetry Operator ");
                      break ;
             }
             NORMAL_VIDEO ;
             BELL ;
}

void err_disp(long i){
  /**************************************************************************/
  /* Displays error messages in conjunction with the Display menus          */
  /* The menus in question are brought up by invoking the "DISPLAY" command */
  /*  from the control-menu                                                 */
  /**************************************************************************/

    eraser(0,0,1020,32) ;
    REVERSE_VIDEO ;
    switch(i) 
            {
             case 0 :
                     temdtx(0,10," Function not yet implemented ") ;
                     break ;
             case 1 :
                     temdtx(0,10," No operation active !!  Choose one ! ") ;
                     break ;
             case 2 :
                     temdtx(0,10," Illegal sequence of commands !! ") ;
                     break ;
             case 3 :
                     temdtx(0,10," Cannot attach to IP0 !! ") ;
                     break ;
             case 4 :
                     temdtx(0,10," Cannot attach to IP1 !! ") ;
                     break ;
             case 5 :
                     temdtx(0,10,
                     " Exceeding allocated array space, CANCEL !") ;
                     break ;
            }
    NORMAL_VIDEO ;
    BELL ;
}  

void err_seq(long i) {
  /****************************************************************************/
  /* Displays error messages associated with the control-menu                 */
  /****************************************************************************/

    eraser(0,120,1020,160) ;
    REVERSE_VIDEO ;
    switch(i)
           {
            case 0 :
                     temdtx(0,130," Phase grating file already exists !") ;
                     break ;
            case 1 : 
                     temdtx(0,130," Multi slice file already exists ! ") ;
                     break ;
            case 2 :
                     temdtx(0,130," Image file already exists ! ") ;
                     break ;
            case 3 :
                     temdtx(0,130," Function not yet implemented !") ;
                     break ;
            case 4 : temdtx(0,130," No amplitudes output for plotting ! ") ;
                     break ;
            case 5 : temdtx(0,130," Image has already been calculated !") ;
                     break ;
            case 6 :
                     temdtx(0,130,
                     " No image contrast ! Only central beam contributes ");
                     break ;
            case 7 :
                     /* Let return messages from the program itself handle 
                        this one, so comment out the message in here 
                       temdtx(0,130,
                       " File cannot be opened! Probably does not exists ! ") ;
                     */
                     break ;
            case 8 : temdtx(0,130,
                     " gPhsgrtRec. must be computed individually for each layer !") ;
                     break ;
            case 10 : temdtx(0,130," Run the PHSGRT program first !!!") ;
                     break ;
            case 11 : temdtx(0,130," Run the MSLICE program first !!!") ;
                     break ;
            }
    NORMAL_VIDEO ;
    BELL ;
}

void err_io(long i) {
  /**************************************************************************/
  /* Displays io_error messages associated with the control-menu            */
  /**************************************************************************/

    eraser(0,120,1020,160) ;
    REVERSE_VIDEO ;
    switch(i)
           {
            case ERR_RD :
                     temdtx(0,130,
           " Error during read. Redo calculation with current param. !") ;
                     break ;
            case ERR_WR : 
                     temdtx(0,130,
           " Error during write. File space probably exceeded, PURGE ! ") ;
                     break ;
            case ERR_OP :
                     temdtx(0,130,
           " Can't open the file ! Probably doesn't exist ! ") ;
                     break ;
            case ERR_CL :
                     temdtx(0,130,
           " Error closing file. File space probably exceeded, PURGE ! ") ;
                     break ;
            }
    NORMAL_VIDEO ;
    gIOError = FALSE ;
    InitCursor() ;
    BELL ;
}

void err_io_ds(long i) {
  /**************************************************************************/
  /* Displays io_error messages associated with the "DISPLAY" menu          */
  /**************************************************************************/

    eraser(0,0,1020,32) ;
    REVERSE_VIDEO ;
    switch(i)
           {
            case ERR_RD :
                     temdtx(0,10,
       " Error during read. CANCEL and redo calculation with curr. param .!") ;
                     break ;
            case ERR_WR : 
                     temdtx(0,10,
      " Error during write. File space probably exceeded, CANCEL & PURGE ! ") ;
                     break ;
            case ERR_OP :
                     temdtx(0,10,
     " Can't open the file ! Probably doesn't exist ! CANCEL & redo calcul. ") ;
                     break ;
            case ERR_CL :
                     temdtx(0,10,
     " Error closing file. File space probably exceeded, CANCEL & PURGE ! ") ;
                     break ;
            }
    NORMAL_VIDEO ;
    gIOError = FALSE ;
    InitCursor() ;
    BELL ;
  }

