// -----------------------------------------------------------------------------
//  Copyright (c) 2001 Roar Kilaas
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// -----------------------------------------------------------------------------
#include <stdio.h>
#include <forms.h>
#include "funcdefs.h"
#include "menudef.h"
#include "devices.h"
#include "dfpdspl.h"
#include "menu_index.h"
#include "globals.h"
#include "atoms.h"
extern short DONEFLAG ;
extern short gMenuNumber ;
static short HasAdvertised = 0,gInitWindow2=0 ;
extern MENUS gMenuList[] ;
void GetXEvents() {
	XEvent event ;
	Rect tRect ;
	GrafPtr tPort ;
	XRectangle clipRect,*rectangles ;
	FL_OBJECT	*obj ;

	while (!DONEFLAG) {
		obj = fl_do_forms() ;
		if (obj == FL_EVENT) {
			/*XNextEvent(gDisplay,&event) ;*/
			fl_XNextEvent(&event) ;
			switch(event.type) {
				case ConfigureNotify:
					ChangeWindowSize((XConfigureRequestEvent *)&event) ;
					break ;
				case Expose:    
					if (event.xexpose.window==gControlWindow->GetXWindow()) {
						GetPort(&tPort) ;
						SetPort(gControlWindow) ;
						clipRect.x = event.xexpose.x ;
						clipRect.y = event.xexpose.y,
						clipRect.width = event.xexpose.width ;
						clipRect.height = event.xexpose.height ;
						rectangles = &clipRect ;
						XSetClipRectangles(gDisplay,gCurrentPort->GetGC(),
							0,0,rectangles,1,Unsorted) ;
						ClearDisplay() ;
						if (!HasAdvertised) {
							XMapRaised(gDisplay,
								gControlWindow->GetXWindow()) ;
							DoAdvertise() ; 
							HasAdvertised = 1 ;
						}
						if (gCurrentMenu == &gMenuList[SEL_OLD_FL] ||
								gCurrentMenu == &gMenuList[SEL_SNGL_STR] ||
								gCurrentMenu == &gMenuList[SEL_LAY_STR] )
							displ_files() ;
						else if (gCurrentMenu == &gMenuList[MAIN_SNGL_STR] ||
								gCurrentMenu == &gMenuList[CH_MAIN_PAR])
							displ_var() ;
						else if (gCurrentMenu == &gMenuList[DSPL_SOURCE]) {
							set_menu(DSPL_OPER) ;
							displ_menu() ;
							set_menu(DSPL_SOURCE) ;
						}
						else if (gCurrentMenu == &gMenuList[VIEW_ATOMS]) 
							displ_atoms(atom) ;
						else if (gCurrentMenu == &gMenuList[VIEW_BASIS]) 
							displ_atoms(basis) ;
						else if (gCurrentMenu == &gMenuList[VIEW_SYMOP]) 
							displ_symop() ;
						displ_menu() ;
						XSetClipMask(gDisplay,gCurrentPort->GetGC(),None) ;
						SetPort(tPort) ;
					}
					else if (event.xexpose.window == gDisplayWindow->GetXWindow()) {
						if (!gInitWindow2) {
							gInitWindow2 = 1 ;
							GetPort(&tPort) ;
							SetPort(gDisplayWindow) ;
							ClearDisplay() ;
							SetPort(tPort) ;
						}
						else {
							UpdateImageScreen() ;
						}
					}
					break ;
				case ButtonPress:
					DoMouseDown(&event) ;
					break ;
			}
		}
	}
}

void DoMouseDown(XEvent *event) {
	long x,y,i ;

	/* Check to see which window it is */
	if (event->xexpose.window == gControlWindow->GetXWindow()) {
		/* This is the control window  				*/
		/* Check to see if the mouse is in one of the controls	*/
		x = event->xbutton.x ;
		y = event->xbutton.y ;
		x *= 2 ;
		y *= 2 ;
		y = Terminal.yres - y ;
		for (i=0,gCurrentButton = (*gCurrentMenu);*gCurrentButton!=&null;i++,gCurrentButton++) {
			if (x>=(*gCurrentButton)->xl && x <= (*gCurrentButton)->xh &&
					y>=(*gCurrentButton)->yl && y <= (*gCurrentButton)->yh) {
				/* We have to put in a check here to see which	*/
				/* button got pressed. We want to provide for	*/
				/* a help message to be output as well		*/
					gCurrentCommand = gCurrentButton ;
				if (!(*gCurrentButton)->status) { /* Do A Visual Highlight */
						on_highlight() ;
						off_highlight() ;
				}
				(*(*gCurrentButton)->action)(i) ;
				break ;
			}
		}
	}
}

void ChangeWindowSize(XConfigureRequestEvent *eventP) {
    if (eventP->window == gControlWindow->GetXWindow()) {
		Terminal.xres = eventP->width ;
		Terminal.yres = eventP->height ;
		displ_menu() ;
    }
    else if (eventP->window == gDisplayWindow->GetXWindow()) {
	WorkStation.xres = eventP->width ;
  	WorkStation.yres = eventP->height ;
	dfpdspl.xcenter = WorkStation.xres/2 ;
	dfpdspl.ycenter = WorkStation.yres/2 ;
    	OutDevice->xres = eventP->width ;
    	OutDevice->yres = eventP->height ;
    }
}
