// -----------------------------------------------------------------------------
//  Copyright (c) 2001 Roar Kilaas
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// -----------------------------------------------------------------------------
#define __MAIN__
#define TRUE 1
#define FALSE 0
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <forms.h>

#include "header.h"
#include "ttypes.h"
#include "types.h"
#include "window.h"
#include "globals.h"

/* Define different menu-associated items */
#include "funcdefs.h"
#include "graphics.h"
#include "menudef.h"
#include "devices.h"
#include "commands.h"
#include "menu_index.h"

#include "dfpdspl.h"
#include "errors.h"
#include "microscopes.h"
#include "xtal.h"
#include "params.h"
#include "atoms.h"
#include "ProjCellRecord.h"
#include "PhasegratingRecord.h"
#include "MslicRecord.h"
#include "displ.h"
#include "filenames.h"
#include "storage.h"
#include "layers.h" 


#ifdef ALPHA
#define ALIGN64BYTE_BOUNDARY 
#endif
#ifdef IBM
#define ALIGN64BYTE_BOUNDARY
#endif
#ifdef SGI 
#define ALIGN64BYTE_BOUNDARY
#endif
#ifdef VMS
#include <decw$include/cursorfont.h>
#else
#include <X11/cursorfont.h>
#endif

Cursor gWatchCursor ;
FILE *psfile ;
FILE *semout ;
/*
#define gFontName "-adobe-new century schoolbook-medium-r-normal--*-100-*-*-p-*"
*/


struct 	{
	long status ;
	long oldstatus ;
} calculation = {0,0} ; 
char stext[256] ;      
char *POSTSCRIPT_FILE = "laserprinter.ps" ;
short gSliceThreeD = false ;
struct { 
	float wavel ;
	long nslice ;
	float sigma ;
} gMSRec ;
struct {
        long xpos ;
        long ypos ;
} cursor ;

short DONEFLAG = false ;
struct {
	long ipot ;
	long icmplx ;
} flag = {0,0} ;
struct {
	long num_pot ;
	long num_wf ;
	long num_image ;
} whichOne = {1,1,1} ;

char title[40] ;
char name[256] ;
char micname[10] ;
char plots[4] ;   
long istart,istop ;
long so_start,so_stop ;
char *chemsymb[] = {"H","He","Li","Be","B","C","N","O","F","Ne","Na",
                     "Mg","Al","Si","P","S","Cl","Ar","K","Ca","Sc","Ti",
                     "V","Cr","Mn","Fe","Co","Ni","Cu","Zn","Ga","Ge","As",
                     "Se","Br","Kr","Rb","Sr","Y","Zr","Nb","Mo","Tc","Ru",
                     "Rh","Pd","Ag","Cd","In","Sn","Sb","Te","I","Xe","Cs",
                     "Ba","La","Ce","Pr","Nd","Pm","Sm","Eu","Gd","Tb","Dy",
                     "Ho","Er","Tm","Yb","Lu","Hf","Ta","W","Re","Os","Ir",
                     "Pt","Au","Hg","Tl","Pb","Bi","Po","At","Rn","Fr","Ra",
                     "Ac","Th","Pa","U"} ;


char *message[] = {" Enter The Title ",
" Enter the number of the space group according to the Intern. Tables ! ",
                    " Enter Lattice Parameter in Angstrom ! ",
                    " Enter Lattice Parameter in Angstrom ! ",
                    " Enter Lattice Parameter in Angstrom ! ",
                    " Enter Angle in Degrees ! ",                           
                    " Enter Angle in Degrees ! ",                           
                    " Enter Angle in Degrees ! ",                           
                    " Enter The Default Value of 2.0 ! ",
                    " Enter the indices u v w for the Foil Normal ! ",
" Enter the number of Symmetry operators to be applied to the basis atoms ! ",
                    " Enter The Value of 1 ! ",
                    " Enter The Number of Atoms in The Basis ! ",
                    " Enter The Value of :  ",
                    " Enter Name of Microscope !  ",
                    " Enter spherical abberation coeff Cs(mm). ",
                    " Enter spread of defocus DEL (Angstrom)  ",
                    " Enter divergence angle (half-angle) (mrad) ", 
                    " Enter voltage in kV ! ",
                    " Enter Center of Laue Circle in Units of h ! ",
                    " Enter Center of Laue Circle in Units of k ! ",
                    " Enter the Foil Thickness in Angstrom ! ",
                    " Answer YES or NO ! ",
                    " Enter objective Lens Defocus in A-1 ! ",
                    " Enter Objective Lens Aperture in Units of A-1 ! ",
                    " Enter Center of Obj. Apert. in units of h ! ",
                    " Enter Center of Obj. Apert. in units of k ! ",
                    " Enter Center of Optic Axis in units of h ! ",
                    " Enter Center of Optic Axis in units of k ! "
                     } ;
                    

FPV funcpntrs[10] ;
short gObjectiveAperture = true ;
long gNumUnitCellAtoms,DIFFRPT,IMAGE_MODE,no_cmnd,gCalculationIsChanged,gPGisChanged,gMSisChanged,gIMisChanged ;
long gNumBasisAtoms,gSpacegroupNumber,gNumSymops,gSymopsAreChanged,gBasisIsChanged=FALSE ;
struct GENERATOR {
	float matr[4][4] ;
} symop[200] ;
char *txtptr_symop[200];
char symop_txt[200][40] ;
static char *ident_symop = "x,y,z" ;
long SCREEN_BUILD = FALSE ;
long HISTOGRAM,SCALED,EXIT_WAVEF=FALSE ;
float BRITE = 0.5 ;
float CNTRST = 1. ;

long DSPLY_X_LOC,DSPLY_Y_LOC ;
                            
long ERASE=TRUE ;           
long DIS_ATOM_INITIAL=TRUE ;
long DIS_SO_INITIAL=TRUE ;  
long LAYERED=FALSE ;       
long NUM_ACELL=1   ;      
long NUM_BCELL=1   ;     
long NUM_THICK     ;    
long NUM_DEFOC     ;   
long MONTAGE=FALSE ;  
                    
long REQ_POS=FALSE ; 
long ZOOMUPDWN = 1 ; 
float ZOOMFACT = 1. ; 
long MULTIPLE_CTF = FALSE ; 
#define IDY 5             
struct {
         long SPACE ;      
         long X_SIZE ;    
         long Y_SIZE ;   
} MONT = {FALSE,0,0} ;
MENUS cmndptrs[10],ptr_add_cells,ptr_zoom ;
struct {
       float plot ;
} semtab = {0.} ;


#include "TNCEMSSApp.h"
TNCEMSSApp *gTheApp ;

Boolean gNoGUI = false ;
char	gStructureFileName[256] ;

void	AddWindow(TWindow *window) ;
void	RemoveWindow(TWindow *window) ;
void	ProcessModalEvent(XEvent *event) ;

void	AddWindow(TWindow *window) {
	gTheApp->AddWindow(window) ;
}

void	RemoveWindow(TWindow *window) {
	gTheApp->RemoveWindow(window) ;
}

void	ProcessModalEvent(XEvent *event) {
	gTheApp->ProcessModalEvent(event) ;
}
extern  Boolean	load_batch_structure_file(char *structname) ;
typedef enum {kRunPhasegrating,kRunMultislice,kRunImage,kRunAll} BatchProcessMode ;
BatchProcessMode gBatchProcessMode ;

#define PG_MASK	1
#define MS_MASK	2
#define IM_MASK	4
extern Boolean	FileExists(char *filename) ;
extern float RANGE ;

int main(long argc,char *argv[]) {
	int i ;
	if (argc > 1) {
	    for (i=1;i<argc;i++) {
			if (strcmp(argv[i],"-nogui") == 0) {
				gNoGUI = true ;
				break ;
			}
	    }
    }
	
	gTheApp = new TNCEMSSApp(argc,argv) ;
	if (!gNoGUI) {
		gTheApp->MainLoop() ;
		delete gTheApp ;
		ExitX() ; 
	}
	else {
		// Process the input file and calculate from the specified starting point
		// Get the file name
		Boolean hasInputFile = false ;
		gBatchProcessMode = kRunAll ;
		if (argc > 1) {
			for (i=1;i<argc;i++) {
				if (strcmp(argv[i],"-file") == 0) {
					if (argc < i+1) {
						fprintf(stderr,"Missing input file name\n") ;
					}
					else {
						strcpy(gStructureFileName,argv[i+1]) ;
						hasInputFile = true ;
						fprintf(stderr,"\nInput file is: %s\n",gStructureFileName) ;
					}
				}
				else if (strcmp(argv[i],"-pg") == 0) {
					gBatchProcessMode = kRunPhasegrating ;
				}
				else if (strcmp(argv[i],"-ms") == 0) {
					gBatchProcessMode = kRunMultislice ;
				}
				else if (strcmp(argv[i],"-im") == 0) {
					gBatchProcessMode = kRunImage ;
				}
			}
		}	
		if (hasInputFile) {
			if (load_batch_structure_file(gStructureFileName)) {
				// Run the calculation from the starting point specified
				setup_trnsf() ;
				long nobeam,ierr ;
				float sum ;
				switch(gBatchProcessMode) {
					case kRunPhasegrating:
						CalculatePhasegrating(&ierr) ;
						if (ierr == 0)
							calculation.status |= PG_MASK ;
						break ;
					case kRunMultislice:
						if (!FileExists(flname.pout)) {
							fprintf(stderr,"\nError: The potential file %s does not exist\n",flname.pout) ;
							break ;
						}
						DoMultisliceCalculation() ;
						if (ierr == 0)
							calculation.status |= MS_MASK ;
						break ;
					case kRunImage:
						if (!FileExists(flname.mout)) {
							fprintf(stderr,"\nError: The exit wavefunction fle %s does not exist\n",flname.mout) ;
							break ;
						}
						CalculateImages(&nobeam,&sum,&RANGE,&ierr) ;
						if (ierr == 0)
							calculation.status |= IM_MASK ;
						break ;
					case kRunAll:
						CalculatePhasegrating(&ierr) ;
						if (ierr == 0) {
							calculation.status |= PG_MASK ;
							DoMultisliceCalculation() ;
							if (ierr == 0) {
								calculation.status |= MS_MASK ;
								CalculateImages(&nobeam,&sum,&RANGE,&ierr) ;
								if (ierr == 0)
									calculation.status |= IM_MASK ;
							}
						}
						break ;
				}
			}
		}
		delete gTheApp ;
	}
	
    return 0 ;
}


char *Allocate(long numBytes){
	char *ptr ;
	ptr = new char[numBytes] ;
	if (ptr == NULL) {
		fprintf(stderr,"Failed to allocate requested memory !\n") ;
		fflush(stderr) ;
		ExitX() ;
	}
	return(ptr) ;
}

void button1() {
	DONEFLAG = TRUE ;
}

void r_unass() {
}

