// -----------------------------------------------------------------------------
//  Copyright (c) 2001 Roar Kilaas
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// -----------------------------------------------------------------------------
#include "numbers.h"
#include <ctype.h>
#include <string.h>
#include <math.h>
#define	SIGN(x)	((x) < 0. ? -1 : 1)

// Ascii to octal number
long atoo(char *cp){
	long n ;
	n = 0 ;
	while (*cp >='0' && *cp <= '7') {
		n = 8*n + *cp - '0' ;
		cp++ ;
	} ;
	return(n) ;
}
// ascii to hex number
long atox(char *cp) {
	long n ;

	n = 0 ;
	while (*cp != '\0' && *cp != ' ') {
		if (*cp >= '0' && *cp <= '9')
			n = 16*n + *cp - '0' ;
		else if (toupper(*cp) >= 'A' && toupper(*cp) <= 'F')
			n = 16*n + *cp - 55 ;
		cp++ ;
	} ;
	return(n) ;
}
// -----------------------------
// Round real to nearest integer
// -----------------------------
long near(float x) {
	float y ;
	long i ;

	y = x+.5 ;
	i = (long) y ;
	if (y < 0.) i-- ;
	return(i) ;
}
// --------------------------------------- 
// Reduce real number to values < 1. >= 0.
// ---------------------------------------
float one(float x) {
	float y ;
	y = x ;
	y = y - (long)y + 1. ;
	y = y - (long)y ;
	if (1.-y < 0.000001)
	y = 0. ;
	return(y) ;
}

float	CheckZeroOne(float x) {
	float	delta = 0.000001 ;

	if (fabs(x) < delta)
		return 0. ;
	if (fabs(1.0-x) < delta)
		return 1. ;
	if (fabs(1.0+x) < delta)
		return -1. ;
	return x ;
}

void	DegreeToRad(float *degree) {
	double pi = 2.0*asin(1.0) ;
	*degree = (*degree)*pi/180. ;
}

void	RadToDegree(float *degree) {
	double pi = 2.0*asin(1.0) ;
	*degree = (*degree)*180/pi ;
}

Boolean	NumberIsInteger(float x) {
	long 	ival,sign ;
	float	tval,fracPart,ftol=0.00001 ;

	sign = SIGN(x) ;
	tval = fabs(x)+0.5 ;
	ival = (long)tval ;

	fracPart = fabs(tval-ival-0.5) ;
	if (fracPart < ftol) 
		return true ;
	else
		return false ;
}
