// -----------------------------------------------------------------------------
//  Copyright (c) 2001 Roar Kilaas
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// -----------------------------------------------------------------------------
#include <stdio.h>
#include "funcdefs.h"
#include "header.h"
#include "menudef.h"
#include "PhasegratingRecord.h"
#include "MslicRecord.h"
#include "displ.h"
#include "atoms.h"
#include "symops.h"
#include "params.h"
#include "layers.h"
extern char title[] ;
extern long gSpacegroupNumber,gNumSymops,gNumBasisAtoms ;
extern long LAYERED ;
extern short gSliceThreeD ;
extern struct	{ long status ; } calculation ;
// --------------------------------------------------------------------------
// Update the data-file  --.at upon exit from the program if there are 
//                       --.lay if LAYERED         
//  changes to the file                                 
// --------------------------------------------------------------------------
void rewrite_file(char *fl_name) {

	FILE *fp ;
	long i,j ;
 
	if ((fp = fopen(fl_name,"w")) == NULL) {
		ReportFileOpenError(fl_name) ;
		return ;
	}
	fprintf(fp,"%s\n",title) ;
	fprintf(fp,"%d\n",gSpacegroupNumber) ;
	fprintf(fp,"%f %f %f %f %f %f\n",gPhsgrtRec->a,gPhsgrtRec->b,gPhsgrtRec->c
                                    ,gPhsgrtRec->alpha,gPhsgrtRec->beta,gPhsgrtRec->gamma) ;
	fprintf(fp,"%f\n",gInputParameter[8].fv) ; /* GMAX */
	fprintf(fp,"%d %d %d\n",gPhsgrtRec->iuvw[0],gPhsgrtRec->iuvw[1],gPhsgrtRec->iuvw[2]) ;
	if (!LAYERED) {
		if (gPhsgrtRec->nz != 1)
 			fprintf(fp,"%d %d %d\n",gPhsgrtRec->nsymop,gPhsgrtRec->nz,
                                gSliceThreeD) ;
		else
			fprintf(fp,"%d %d\n",gPhsgrtRec->nsymop,gPhsgrtRec->nz) ;
		fprintf(fp,"%d %d\n",gNumBasisAtoms,gPhsgrtRec->iatom) ;
		for (j=0;j<gNumBasisAtoms;j++)
			fprintf(fp,"%d %s %f %f %f %f %f\n",
				basis[j].type.val.iv,basis[j].name.val.cv,
				basis[j].xc.val.fv,basis[j].yc.val.fv,
				basis[j].zc.val.fv,basis[j].dw.val.fv,
				basis[j].occ.val.fv) ;
	}
	else {
		fprintf(fp,"%d %d\n",gLayerRec.num_pg,gLayerRec.num_slc) ;
		for (j=0; j< gLayerRec.num_pg;j++)
			fprintf(fp,"%f %s\n",gLayerRec.slcth[j],&gLayerRec.pg[j][0]) ;
		for (j=0; j< gLayerRec.num_slc ; j++) {
			if (j != 0 && j%30 == 0) fprintf(fp,"\n") ;
				fprintf(fp,"%d ",gLayerRec.phgr_seq[j]) ;
		}
		fprintf(fp,"\n") ;
	}
	fprintf(fp,"%s %f %f %f\n",gInputParameter[14].cv,
		gDisplayRec.cs,gDisplayRec.del,gDisplayRec.div) ;
	fprintf(fp,"%f\n",gMsliceRec.volt) ;
	fprintf(fp,"%f %f\n",gMsliceRec.kxin,gMsliceRec.kyin) ;

	if (gMsliceRec.tts) {
		fprintf(fp,"%f,%f,%f\n",gMsliceRec.t1,gMsliceRec.t2,gMsliceRec.dt) ;
	}
	else {
		fprintf(fp,"%f\n",gMsliceRec.thick) ;
	}
	if (gMsliceRec.iplot) {
		fprintf(fp,"YES\n") ;
		fprintf(fp,"%d\n",gMsliceRec.nw) ;
		for(j=0;j<gMsliceRec.nw;j++)
 			fprintf(fp,"%d %d %d\n",gMsliceRec.ihw[j],gMsliceRec.ikw[j],gMsliceRec.ilw[j]) ;
	}
	else
		fprintf(fp,"NO\n") ;

	if (gDisplayRec.tfs)
		fprintf(fp,"%f,%f,%f\n",gDisplayRec.f1,gDisplayRec.f2,gDisplayRec.df) ;
	else
		fprintf(fp,"%f\n",gDisplayRec.dfocus) ;

	fprintf(fp,"%f\n %f %f %f %f\n",gDisplayRec.aprtrd,
		gDisplayRec.hc,gDisplayRec.kc,gDisplayRec.ho,gDisplayRec.ko) ;
	if (!LAYERED)
		for (i=0;i<gNumSymops;fprintf(fp,"%s\n",txtptr_symop[i++])) ;

	fprintf(fp,"\n%d",calculation.status) ;
	fclose(fp) ;
}

