// -----------------------------------------------------------------------------
//  Copyright (c) 2001 Roar Kilaas
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// -----------------------------------------------------------------------------
#include <stdio.h>
#include <sys/file.h>
#include <stdlib.h>
#include <string.h>
#include "funcdefs.h"
#include "devices.h"
#include "globals.h"
#define TRUE	1
#define FALSE	0
extern char stext[],*NcemssDir ;
#define MAX(x,y) ((x) > (y) ? (x) : (y))
#define MIN(x,y) ((x) < (y) ? (x) : (y))

void send_to_laser(char *out,long ncol,long nrow) {
    char shcommand[256],buffer[80],
	  file[132],outfile[132] ;
    char bb[80],*outp ;
    static char *linefeed = "\n" ;
    long i,j,width,height,maxDim ;
    long mode,bytes_left,num_bytes ;
    FILE *fp_out,*fp_prolog ; 
    float scale ;

    /* Open the output */
/*
flags = O_WRONLY | O_CREAT | O_TRUNC ;
*/

    mode = 0666 ;
    strcpy(outfile,"laserprinter.ps") ;
    if ((fp_out=fopen(outfile,"w"))== NULL) {
	eraser(0,0,1020,32) ;
	sprintf(stext,"Unable to open the file %s",outfile) ;
	temdtx(0,10,stext) ;
    }
    else {
    	/* Open the prolog file and send it to the OutDevice */
	strcpy(file,NcemssDir) ;
#ifdef VMS
	strcat(file,"lprint.ps") ;
#else
	strcat(file,"/lprint.ps") ;
#endif
    	if((fp_prolog = fopen(file,"r"))!= NULL) {
    		while(fgets(bb,80,fp_prolog)!=NULL)
    			fwrite(bb,strlen(bb),1,fp_out) ;
    		fclose(fp_prolog) ;
    	}
	else {
		sprintf(stext,"\nUnable to open %s",file) ;
		eraser(0,0,1020,32) ;
		temdtx(0,10,stext) ;
		return ;
	}
	sprintf(stext,"Writing Postscript File for Image (Size %d by %d)....",
		ncol,nrow) ;
	eraser(0,0,1020,32) ;
	temdtx(0,10,stext) ;
    	sprintf(buffer,"\n/cbitWidth %d def \n/cbitHt %d def",
    		ncol,nrow) ;
    	fwrite(buffer,strlen(buffer),1,fp_out) ;
    	sprintf(buffer,"\nCenterPage") ;
    	fwrite(buffer,strlen(buffer),1,fp_out) ;
    	if (ncol > nrow) {
    		sprintf(buffer,"\nLandscape") ;
    		fwrite(buffer,strlen(buffer),1,fp_out) ;
    	}
    	maxDim = MAX(ncol,nrow) ;
    	if (maxDim > 756) {
    		scale = 756./maxDim ;
    		width = scale*ncol ;
    		height = scale*nrow ;
    		maxDim = MIN(width,height) ;
    		if (maxDim > 576) {
    			scale = 576./maxDim ;
    			width *= scale ;
    			height *= scale ;
    		}
    	}
    	else {
    		width = ncol ;
    		height = nrow ;
    	}
    	sprintf(buffer,"\n/cWidth %d def \n/cHeight %d def",
    		width,height) ;
    	fwrite(buffer,strlen(buffer),1,fp_out) ;
    	sprintf(buffer,"\nCenterImage\n%d %d scale\nDoit",width,height) ;
    	fwrite(buffer,strlen(buffer),1,fp_out) ;
    	/* Read the rows and transmit */
    	for(j=0;j<nrow;j++) {
		outp = out+j*ncol ;
		sprintf(stext,"Writing row # %d of %d",j+1,nrow) ;
		eraser(0,0,1020,32) ;
		temdtx(0,10,stext) ;
    		for(i=0;i<ncol;i++) {
    			*(outp+i) = (*(outp+i)*95)/OutDevice->range+32 ;
		}
		/* If we are writing to a postscript file */
		/* then write out no more than 64 	  */
		/* characters at a time			  */
		for(bytes_left=ncol;bytes_left > 0 ;) {
			num_bytes = 
					(bytes_left > 64 ? 64 : bytes_left) ;
			bytes_left -= num_bytes ;
			fwrite(linefeed,strlen(linefeed),1,fp_out) ;
    			fwrite(outp,num_bytes,1,fp_out) ;
			if (bytes_left > 0) outp += num_bytes ;
		}
    	}
    	/* Complete with a showpage command */
    	sprintf(buffer,"\nshowpage\n") ;
    	fwrite(buffer,strlen(buffer),1,fp_out) ;
    	fclose(fp_out) ;
    }    		
    /* Now create a seperate process to handle the printing on */
    /* the LaserPrinter. The environment needs to be set up    */
    /* correctly beforehand to choose the correct printer      */
    /* One can define "setenv PRINTER at173" to chose at173    */
    eraser(0,0,1020,32) ;
    if (gPostscriptToFile) {
	sprintf(shcommand,"mv laserprinter.ps %s",gPostscriptFileName) ;
	system(shcommand) ;
    }
    else {
    	temdtx(0,10,"Transferring File to Printer....") ;
    	system("lpr laserprinter.ps") ;
    }
}
