// -----------------------------------------------------------------------------
//  Copyright (c) 2001 Roar Kilaas
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// -----------------------------------------------------------------------------
#include "header.h"
#include "menudef.h"
#include "PhasegratingRecord.h"
#include "MslicRecord.h"
#include "displ.h"
#include "atoms.h"
#include "layers.h"
#include "params.h"
extern long LAYERED,gNumUnitCellAtoms ;
extern char title[] ;
void setup_trnsf() ;
void setup_trnsf() {

    long i ;

    strcpy(gPhsgrtRec->title,title) ;
    gPhsgrtRec->a = gInputParameter[2].fv ;
    gPhsgrtRec->b = gInputParameter[3].fv ;
    gPhsgrtRec->c = gInputParameter[4].fv ;
    gPhsgrtRec->alpha = gInputParameter[5].fv ;
    gPhsgrtRec->beta = gInputParameter[6].fv ;
    gPhsgrtRec->gamma = gInputParameter[7].fv ;
    gPhsgrtRec->gmax = gInputParameter[8].fv ;
    gLayerRec.layrd = LAYERED ;        /* Flag for setting layered/nolayered */
    if (!LAYERED) {
		gPhsgrtRec->nsymop = gInputParameter[10].iv ;
		gPhsgrtRec->nz = gInputParameter[11].iv ;
		gPhsgrtRec->natom = gNumUnitCellAtoms ;
		gPhsgrtRec->iatom = gInputParameter[13].iv ;
		for (i=0;i<gNumUnitCellAtoms;i++) { 
			gPhsgrtRec->ntype[i] = atom[i].type.val.iv ;
			gPhsgrtRec->atno[i] = atom[i].no.val.iv  ;
			gPhsgrtRec->x[i] = atom[i].xc.val.fv ;
			gPhsgrtRec->y[i] = atom[i].yc.val.fv ;
			gPhsgrtRec->z[i] = atom[i].zc.val.fv ;
			gPhsgrtRec->dw[i] = atom[i].dw.val.fv ;
			gPhsgrtRec->occf[i] = atom[i].occ.val.fv ;
		}
	}
    gMsliceRec.volt = gInputParameter[18].fv ;
    gMsliceRec.kxin = gInputParameter[19].fv ;
    gMsliceRec.kyin = gInputParameter[20].fv ;
    gMsliceRec.thick = gInputParameter[21].fv ;
    gDisplayRec.cs = gInputParameter[15].fv ;
    gDisplayRec.div = gInputParameter[17].fv ;
    gDisplayRec.del = gInputParameter[16].fv ;
    gDisplayRec.dfocus = gInputParameter[23].fv ;
    gDisplayRec.aprtrd = gInputParameter[24].fv ;
    gDisplayRec.hc = gInputParameter[25].fv ;
    gDisplayRec.kc = gInputParameter[26].fv ;
    gDisplayRec.ho = gInputParameter[27].fv ;
    gDisplayRec.ko = gInputParameter[28].fv ;
}

