// -----------------------------------------------------------------------------
//  Copyright (c) 2001 Roar Kilaas
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// -----------------------------------------------------------------------------
#include "header.h"
#include "funcdefs.h"
#include "menudef.h"
#include "devices.h"
extern COMMAND c_terminal,c_lp,c_semper ;
extern float RANGE ;
/**************************************************/
/* sets the output device to the Work Station     */
/**************************************************/
void r_terminal() {
    switch(OutDevice->type) {
		case WS:
			return ;
			break ;
		case LP:
			on_off(&c_lp);
			break ;
		case FS:
			on_off(&c_semper) ;
			break ;
    }
    on_off(&c_terminal) ;
    OutDisplay = WorkStation ;
    OutDevice = &WorkStation ;
    RANGE = OutDevice->range ;
}

/**************************************************/
/* sets the output device to the Laser Printer    */
/**************************************************/
void r_lp() {
    switch(OutDevice->type) {
		case WS : 
			on_off(&c_terminal) ;
			break ;
		case LP : 
			return ;
			break ;
		case FS : 
			on_off(&c_semper) ;
			break ;
    }
    on_off(&c_lp) ;
    OutDisplay = LaserPrinter ;
    OutDevice = &LaserPrinter ;
    RANGE = OutDevice->range ;
}

/************************************/
/* Sets the output to a Semper file */
/************************************/
void r_semper() {
    switch(OutDevice->type) {
		case WS : 
			on_off(&c_terminal) ;
			break ;
		case LP : 
			on_off(&c_lp) ;
			break ;
		case FS : 
			return ;
			break ;
	}
    on_off(&c_semper) ;
    OutDevice = &FrameStore ;
    RANGE = OutDevice->range ;
    OutDisplay = *OutDevice ;
}
