#include <string.h>
#include "PhasegratingRecord.h"
#include "MslicRecord.h"
#include "displ.h"
#include "devices.h"
#include "ttypes.h"
#include "funcdefs.h"
#include "menudef.h"
#include "params.h"
#define TRUE 1
#define EOS '\0'
#define EOL '\n'
#define SPACE ' '
extern CharRecord CharRc ;
extern struct {
       long ipot ;  /* flag to set if we are manipulating the proj. pot.   */
       long icmplx ;/* flag to set if data are real or complex in fft-calc */
       } flag  ;
long TRUNCATE ;
extern struct {
	long num_pot ;      /* Signals which potential to use if nz != 1 */
  	long num_wf ;       /* Signals which exit wavef. to use when we store
                        more than one thickness in a single file, e.g.
                        a through thickness series.
                     */
  	long num_image ;    /* Signals which image to use when multiple images
                        are stored in a single file. Thru-focus,thru-thick
                     */
} whichOne ;  
extern long NUM_DEFOC ;
extern long NUM_THICK ;

// ------------------------------------------------------------------------	
// Routine to try out various titling of images 
// The coordinates in this routine is relative to 
// 0,0 being upper left corner.		     
// ------------------------------------------------------------------------	
void titles(long *np,long icx,long iy) {
  
    extern long EXIT_WAVEF ;

    char buf[132],temp[132] ;
    char line[512] ;         /* Maximum line */
    long iline[512],oldend ;
    long i,ix,width_char ;
    long linepos,width,length,end,nchar,num_char,char_left ;
    static char *proj_pot="PROJECTED POTENTIAL" ;
    float thickness,defocus ;

    if (gMsliceRec.tts)   /* Need to find the correct thickness */
    	thickness = gMsliceRec.t1+gMsliceRec.dt*(long)((whichOne.num_image-1)/NUM_DEFOC) ;
    else
    	thickness = gInputParameter[21].fv ;
    if (gDisplayRec.tfs)   /* Find the correct defocus */
    	defocus = gDisplayRec.f1 + gDisplayRec.df*((whichOne.num_image-1)%NUM_DEFOC) ;
    else
    	defocus = gInputParameter[23].fv ;

    if (flag.ipot)
        sprintf(line,"%s: %s Gmax=%3.1fA-1",proj_pot,gInputParameter[0].cv,
                gInputParameter[8].fv) ;
    else if (EXIT_WAVEF)
        sprintf(line,"IMAGE AT EXIT PLANE: %s T=%4.0fA",
                gInputParameter[0].cv,thickness) ;
    else {
        sprintf(line,"%s Z=%d%d%d",gInputParameter[0].cv,gPhsgrtRec->iuvw[0],
                 gPhsgrtRec->iuvw[1],gPhsgrtRec->iuvw[2]) ;
        sprintf(buf,
                 " V=%5.0fKEV T=%4.0fA Df=%5.0fA Cs=%4.1fmm DEL=%3.0fA",
                 gInputParameter[18].fv,thickness,defocus,
                 gInputParameter[15].fv,gInputParameter[16].fv) ;
         strcat(line,buf) ;
         sprintf(buf," DIV=%3.1fmr R=%4.2f",gInputParameter[17].fv,gInputParameter[24].fv) ;
         strcat(line,buf) ;
	}
    num_char = strlen(line) ;
    width = *np*OutDevice->pixpoint ;
    switch(OutDevice->type) {
		case WS:
			width_char = StringWidth("TESTings")/8 ;
			break ;
		case FS:
			width_char = 6 ;
			break ;
		case LP:
			width_char = CharRc.fontsize/2 ;
			iy += 10 ;
			break ;
	}
    length = width/width_char;  /* Number of characters to fit underneath */
    char_left = num_char ;
    linepos = 0 ;
    while (linepos < num_char) {
		while (line[linepos]==SPACE)
                 linepos++ ;
        end = linepos+length-1 ;
        end = (end >= num_char ? num_char-1 : end) ;
        oldend = end ;

        /* Backspace until we find a break between words or an = sign*/
        if (line[end+1] != SPACE && line[end+1] != EOS)
        while(line[end]!=SPACE && line[end]!='=' && end > linepos)
                    end-- ;

        if (end==linepos)  /* Unsuccessful */ {
        	/* Truncate the line by setting end=oldend */
           	end = oldend ;
        }
        nchar = end-linepos+1 ;
        ix = icx + (nchar-1)*3+3 ;
        if (nchar != 0) {
        	while (line[linepos]==SPACE)
                     linepos++ ;
            for(i=0;i<nchar;i++) {
                   iline[i]=line[linepos+i] ;
                   temp[i] = line[linepos+i] ;
            }
	       	temp[nchar] = EOS ;
	       	switch(OutDevice->type) {
				case WS:
                   	temp[i] = EOS ;
                   	DrawText(icx,iy,temp) ;
                   	iy += 12 ;
					break ;
				case FS:
                   	semdtx(iline,&nchar,&ix,&iy) ; 
                   	iy += 8 ;
					break ;
				case LP:
					gDrawText(icx,iy,temp) ;
					iy += CharRc.fontsize ;
					break ;
			}
            linepos = end+1 ;
		}
	}
}
