#ifndef __TTYPES__
#define __TTYPES__
typedef struct 	{
		unsigned short red ;
		unsigned short green ;
		unsigned short blue ;
} Color ;
typedef struct	{
		long index ;
		Color RGB ;
} ColorSpec ;
typedef struct	{
		ColorSpec CTab[256] ;
} ColorTable ;
#define SOLID 	0
#define DOT	1
#define DASH	2
#define DOTDASH 3
typedef struct	{
		long style ;
		long width ;
		Color color ;
} LineRecord,*LinePtr ;
typedef struct	{
		char 	*fontname ;		
		long  	fontsize ;
		long 	width ;
		Color 	color ;
} CharRecord,*CharPtr ;
typedef struct {
    short left ;
    short top ;
    short right ;
    short bottom ;
} Rect ;
typedef enum CursorMode {
    kNormalCursor,kDefineUCell,kPickAtom,kDefineIF 
} CursorMode ;

typedef	long			SInt32 ;
typedef unsigned long	UInt32 ;
typedef	short			SInt16 ;
typedef	unsigned short	UInt16 ;

typedef short int		Int16 ;
typedef long			Int32 ;
typedef	long			TableReference ;
typedef	unsigned char	Pattern[8] ;

typedef enum { srcCopy,srcOr,srcXOr
} CopyMode ;
typedef enum {
	kNothing=0,kOriginDefined=1,kADefined=2
} PtDefined ;
typedef enum {
	kFirstAtom=0,kSecondAtom=1
} AtomDef ;

typedef	enum {kLeftJustified,kCenterJustified,kRightJustified} JustificatonType ;
typedef 	unsigned char Pattern[8] ;
typedef enum GrayLevel 	{kBlack=0,kWhite=255} 	GrayLevel ;
typedef enum OrRelation { kDirPlane,kAxisAngle} OrRelation ;
#ifdef __MAIN__
CharRecord CharRc 	= {"Times-Roman",8,8} ;
GrayLevel gGrayLevel 	= kWhite  ;
OrRelation gOrRelation 	= kDirPlane ;
CursorMode gCursorMode	= kNormalCursor ;
#else
extern CharRecord 	CharRc ;
extern GrayLevel 	gGrayLevel ;
extern OrRelation 	gOrRelation ;
extern CursorMode 	gCursorMode ;
#endif
#endif /* __TTYPES__ */

